#!/usr/bin/perl
#simusol_sceptre.pl
use strict;
use warnings;
BEGIN {
    my $perllibdir = "/usr/local/share/simusol";
    unshift @INC, (split ':', $perllibdir);
}
use Getopt::Long;
use Pod::Usage;
use Data::Dumper;
use Simusol::Ayudas;
use Simusol::Auxiliares;
use Simusol::Prograf;
use Simusol::Sceptre;
use Simusol::GlobalesSimusol;
$0 =~ m!/([^/]+)\s*$!;
$progname = $1;
#print STDERR "Estoy en $progname @ARGV\n";
crear_tmp_simusol();
my($coderr,$mensaje,$PROPIOSIN) = atender_argumentos_ss();# puede no volver
$coderr and parars($coderr,$mensaje);
#----------------------------------------------------------------------------
parars(200,' Pidio no simular') if $opt_hash{nosimul};
# ---------------------------------------------------------------------------
($coderr,$mensaje) = controlar_reservdirs(1);#  1 para crear si no existen
$coderr and parars($coderr,$mensaje);
# ---------------------------------------------------------------------------
chdir $outdir;
impr_debug(__LINE__.' sims',"\n\n          ya cambiado a \$outdir $outdir");
# -----------------------------------------------------------------------------
# -----------------------------------------------------------------------------
$coderr  = aprontar('.d',$PROPIOSIN);
impr_debug(__LINE__.' sims $outdir,$PROPIOSIN,$dirsal{d}'
  ,[$outdir,$PROPIOSIN,$dirsal{d}]);
# -----------------------------------------------------------------------------
$coderr and parars($coderr);
# -----------------------------------------------------------------------------
if ($dirsal{d} ne '') {
    chdir $dirsal{d};
    impr_debug(__LINE__.' sims ',"\n\n          ya cambiado a \$dirsal{d} $dirsal{d}");
};
our $refsim = {};
my $rcodes = simular();
#chdir $outdir; ya se hizo el cambio dentro de simular
#impr_debug(__LINE__.' sims ',"\n\n          ya cambiado a \$outdir $outdir");
if ($rcodes) {
    parars(30);
} else {
   parars(0);
};
#termina el principal
#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
sub ac{
  comfin('comS ac', @_);
  my ($refvaloresls2) = @_;
  while (<ENTRADAls2>) {
     last if /RUN\/RERUN NUMBER\D+(\d+)/;
  };
  # en lo anterior no queda asignado $1;
  my ($rerun) = /RUN\/RERUN NUMBER\D+(\d+)/;
  my $refval = $refvaloresls2->[$rerun] = {};
  while (<ENTRADAls2>) {
      last if /^0S C E P T R E\s*post/; 
      if (/^\s*$/) {
          $_ = <ENTRADls2>;
          next;
      };    
      my ($key,$value) = /^.(.{33})(.+)$/;
      $refval->{$key} = $value;
      $_ = <ENTRADls2>;
  };#while
  comfin('finS ac');
  return $_; 
}#ac
#----------------------------------------------------------------------------
sub analizar_error2{
  comfin('coms analizar_error2', @_);
  my $cosa  = $_[0]; my $textosal = '';
  if ($cosa =~ /(IMPLICIT integration cancelled)/i) {
     $textosal .= "El metodo de integración IMPLICIT fue cancelado;\n"
           . "(podría deberse a circuito con sólo resistencias)\n"  
	   . "   Pruebe a agregar en un cuadro CONTROLES\n"
	   . "       INTEGRATION ROUTINE = TRAP\n";
  } elsif ($cosa =~ /(SMALLER MINIMUM STEP SIZE REQUIRED)/i) { 
      $textosal .=  "    Pruebe a agregar en un cuadro CONTROLES\n"
	            . "        INTEGRATION ROUTINE = IMPLICIT\n"
	            . "          o bien \n"
	            . "        MINIMUM STEP SIZE = ....\n"
		    . "      o bien pida un tiempo de simulación más pequeño\n"
                    . "      o que sus variables varíen menos bruscamente\n";
  };
  comfin('fins analizar_error2');
  return  $cosa,$textosal;
} #analizar_error2
# -----------------------------------------------------------------------------
sub atender_argumentos_ss{#no tiene argumentos 
  #fija $outdir y determina, $dirdeseda (a partir de outdir) y $PROPIOSIN
  my ($coderr,$PROPIOSIN) = ('',''); 
  my $largo = 60 - length($progname); 
  my $opc_arg = paraimpr3puntos($largo,@ARGV);
# -----------------------------------------------------------------------------
  GetOptions(\%opt_hash, 'help','noclas','d','version','adsim' 
    ,'nopausa','noverb','outdir=s')
    or pod2usage(2);
  print STDERR ".....  coms atender_argumentos_ss @ARGV \n" if $opt_hash{d};
  help() if defined $opt_hash{help};
  version() if defined $opt_hash{version};
# -----------------------------------------------------------------------------
  $debug = $opt_hash{d}; $noverb = $opt_hash{noverb};
# -----------------------------------------------------------------------------
  $curdirori = `pwd`; chomp $curdirori; $curdirori.='/';
 # -----------------------------------------------------------------------------
  if ($opt_hash{noclas}) {
      foreach my $key (keys %dirsalida) {
          substr($dirsalida{$key},0,1) ne 'c' and
            $dirsalida{$key} = '';
      };
  };
  calcular_dirsal();
  resolver_outdir();
# -----------------------------------------------------------------------------
#  impr_debug(__LINE__.' sims @ARGV',\@ARGV);  
# -----------------------------------------------------------------------------
  my $textoARGV = $ARGV[0];
  if (defined $textoARGV and $textoARGV =~ /[\*\?\ ]/ or @ARGV >1) {
      push @MENSAJES, " Debe concretar mas su pedido";
      parars(250," Debe concretar mejor su pedido");
  };
# -----------------------------------------------------------------------------
  if (@ARGV == 1) {
      (my $outdirfinal,$PROPIOSIN) = interpretar_outdir();
  } elsif (@ARGV == 0)  {
#      impr_debug(__LINE__.' sims $dirsal{d}',$dirsal{d});
      my @listarch = `ls $outdir$dirsal{d}*.d 2>/dev/null`; chomp @listarch;
      impr_debug(__LINE__.' sims @listarch',\@listarch);
      if (@listarch > 1) { 
          push @MENSAJES, " Hay mas de un archivo .d posible
          @listarch\n;         agregue el que le interese al comando";
          $coderr = 250;
      } elsif (@listarch == 1) {
          if ($listarch[0] =~ /^(.*\/)(\w+)\.d$/) {
	      $PROPIOSIN = $2;
            } elsif ($listarch[0] =~ /^(\w+)\.d$/) {
              $PROPIOSIN = $1;
            };
      } else {#@listarch == 0
          push @MENSAJES, " No hay archivos para simular";
          $coderr = 252;
      }   
  } else {# $@ARGV > 1
      push @MENSAJES," Debe pedir un solo archivo .d y no 
         @ARGV";
      $coderr = 250;
  };
  impr_debug(__LINE__.' sims $outdir,$PROPIOSIN', [$outdir,$PROPIOSIN]);
  my $mensaje = textear_MENSAJES();
  if (not $coderr and $PROPIOSIN) {
      comfin('fins atender_argumentos_ss',$coderr,$mensaje,$PROPIOSIN);
      return $coderr,$mensaje,$PROPIOSIN;
  } elsif (not $PROPIOSIN) {
      $coderr = 254;
  };
  comfin('fins atender_argumentos_ss',$coderr,$mensaje);
  return $coderr,$mensaje;
}#atender_argumentos_ss
# -----------------------------------------------------------------------------
sub escr_res{
  comfin('coms escr_res', @_);
  my ($refls2,$refsim,$tiempostop) = @_; my $coderr = '';
  my @listaSIMULADOs = keys %$ref_arch;
#  impr_debug(__LINE__.' sims @listaSIMULADOs', Dumper \@listaSIMULADOs);
  my $SIMBARCHPRINC;
#  impr_debug(__LINE__.' sims $refsim', Dumper $refsim);
  while ($SIMBARCHPRINC = shift @listaSIMULADOs) {
      my $archivosin = my $archivo = $ref_arch->{$SIMBARCHPRINC}->{archivo};
      if ($opt_hash{noclas}) {
         $archivosin =~ s/^(\w+)\.\w+$/$1/;
      } else { 
         $archivosin =~ s/^.*\w+\/([\w]+)\.\w+$/$1/;
      };
#      impr_debug(__LINE__.' sims $SIMBARCHPRINC,$archivo,$archivosin,$PROPIOSIN'
#        ,[$SIMBARCHPRINC,$archivo,$archivosin,$PROPIOSIN]);
      last if $archivosin eq $PROPIOSIN;
  };
  my $conarchivo= '';
  if (not $SIMBARCHPRINC) {
#      impr_debug(__LINE__.' sims $refsim',Dumper $refsim);
#      parars(40," No hay datos, en el archivo paraplot para un archivo simul");
  } else {
#      impr_debug(__LINE__.' sims $ref_arch->{$SIMBARCHPRINC}'
#        ,Dumper $ref_arch->{$SIMBARCHPRINC});
        $conarchivo =  "   con archivo   "
        ." $mutuodir$dirsal{paraplot}$PROPIOSIN.paraplot de fecha "
        . "$fechamarcas{paraplot}\n";
  }; 
  my $formato =  "%4s%18s%14s%14s%13s%13s\n";
  my @inicialestime;
  my $cuantosrerun = @{$refsim->{archress}};
  open SALIDAcache, ">>$dirsal{cache}$PROPIOSIN.cache" or
      die " No pude escribir $dirsal{cache}$PROPIOSIN.cache";
  print SALIDAcache 
    "Archivos numéricos resumen producidos en  $mutuodir$dirsalida{res}/ :\n";
#  impr_debug(__LINE__.' sims $ref_arch',Dumper $ref_arch);
  for(my $rerun = 0; $rerun < $cuantosrerun; $rerun ++) {
      my $rr = $refsim->{res}->[$rerun]->{marcarerun};
      open SALIDAres, ">$dirsal{res}$refsim->{archress}->[$rerun]" or
      parars(230,"No puedo abrir $dirsal{res}$refsim->{archress}->[$rerun]"); 
      print SALIDAres 
"# Archivo $refsim->{archress}->[$rerun] $marca_Simusol (simusol_sceptre.p)l\n";
      print SALIDAres 
         " Resumen de simulacion de $mutuodir$dirsal{d}$PROPIOSIN.d "
           ."de fecha $fechamarcas{d}\n";
      print SALIDAres $conarchivo;
#      impr_debug(__LINE__.' sims $refsim->{nsceptres}',Dumper $refsim->{nsceptres});
      my @rsceptres = my @nsceptres = @{$refsim->{nsceptres}};
      if ($SIMBARCHPRINC and $ref_arch->{$SIMBARCHPRINC}->{varcomp}) {
           @rsceptres = @{$ref_arch->{$SIMBARCHPRINC}->{varcomp}};
      }; 
      if ($cuantosrerun >1) {
          print SALIDAres " -  RERUN $rerun/",($cuantosrerun-1),"\n";
      };
      printf SALIDAres $formato,
'No.',  ,'variable ','val. inicial ','val. final ','val.minimo ','val maximo ';
      my $i = 0; my $id = $refls2->{cual}-1;
      foreach (@rsceptres) {
          my $varcomp = $rsceptres[$i];
          my $sceptre = $nsceptres[$i];
          $i ++; $id ++;
#          impr_debug(__LINE__.' sims $sceptre,$varcomp',[$sceptre,$varcomp]);
          my @lista = @{$refsim->{res}->[$rerun]->{$sceptre}}
            {'ini','fin','min','max'};
          push @lista,$id;
          map(do{defined $_ or $_ = ' '},@lista);
          printf SALIDAres "%3s%18s%14s%14s%13s%13s (%2s)\n"
            ,$i, $varcomp,$lista[0] ,$lista[1], $lista[2], $lista[3], $lista[4];
      };#foreach
      print SALIDAres "    $refsim->{points}->[$rerun]";
      print SALIDAres " puntos de la solucion calculados; ";
      my $termcond = $refls2->{termconds}->[$rerun];
      print SALIDAres "$termcond\n";
      if ($termcond =~/NORMAL STOP/) {  
      } elsif ($termcond =~ /OPTIONAL TERMINATION/) {
          my $refterna = shift @{$refls2->{opt_code}};
#          impr_debug(__LINE__.' sims $refterna',$refterna);
          print SALIDAres "      Condicion:  $refterna->[2]\n";
      } else {
          my $numero = sprintf("%-12.3G",$refls2->{times}->[$rerun]);
          my $textosal = revisar_ls2($PROPIOSIN,$numero,$tiempostop);
#          impr_debug(__LINE__.' sims $textosal',$textosal);
          print SALIDAres "    Tiempo pedido: $tiempostop; alcanzado $numero\n";
          $numero = sprintf("%-12.3G",$refls2->{stepsizes}->[$rerun]);
          print SALIDAres "    Ultimo paso (last step size): $numero\n";
          $numero = sprintf("%-12.3G",$refls2->{passcounters}->[$rerun]);
          print SALIDAres "    Pasos de integracion: $numero\n";
          print SALIDAres 
            "    Rutina de integracion: $refls2->{intes}->[$rerun]\n";
      };
      close SALIDAres;
      system "cat $dirsal{res}$PROPIOSIN$rr.res" if $opt_hash{d};
      print SALIDAcache "  $refsim->{archress}->[$rerun]\n"; 
  };#for my $rerun
  close SALIDAcache;
  comfin('fins escr_res',@inicialestime);
  return $coderr,$SIMBARCHPRINC;
} #escr_res
# -----------------------------------------------------------------------------
sub escr_simul{
  comfin('coms escr_simul', @_);
  my ($refsim,$SIMBARCHPRINC) = @_; my $coderr = '';
  my $cuantosrerun = @{$refsim->{nam}}; my $cuantossimul = $cuantosrerun;
  if ($SIMBARCHPRINC) {
      $cuantossimul = @{$ref_arch->{$SIMBARCHPRINC}->{arch_var}};
  };
  my $juntarsimuls = 1; $cuantossimul > 1 and $juntarsimuls = '';
  my @palabras = ('sim','paraplot');
  my @lista;
#  impr_debug(__LINE__.' sims $PROPIOSIN',$PROPIOSIN);
  foreach my $palabra (@palabras) { 
      my $arch = "$dirsal{$palabra}$PROPIOSIN.$palabra";
      if (-e $arch) {
          my $fecha =   scalar localtime((stat $arch)[9]);
          push @lista, sprintf "#     %-24s  de fecha %30s"
            ,"$mutuodir$dirsal{$palabra}$PROPIOSIN.$palabra",$fecha;
      };
  };
  my $resto = "#   a partir de archivos calculados por Sceptre y Simusol:\n"
      . join ("\n",@lista) ."\n";
  my @renglones;
  my $textoparasimusol = '#  para Simusol: ';
#  impr_debug(__LINE__.' sims $ref_arch',Dumper $ref_arch);
  if ($SIMBARCHPRINC and $ref_arch->{$SIMBARCHPRINC}) {
      $textoparasimusol .= "sceptrevars, variables, magnitudes, unidades";
      foreach my $palabra (qw(sceptre variable magn unidad)) {
#          impr_debug(__LINE__.' sims $ref_arch->{$SIMBARCHPRINC}->{$palabra}'
#            ,$ref_arch->{$SIMBARCHPRINC}->{$palabra}); 
 	  if ($ref_arch->{$SIMBARCHPRINC}->{$palabra}) {
              push @renglones,$ref_arch->{$SIMBARCHPRINC}->{$palabra};
          };
      };    
  } else {
      $textoparasimusol .= "sceptrevars";
      push @renglones,$refsim->{nsceptres};
  }; 
#  impr_debug(__LINE__.' sims @renglones',Dumper \@renglones);
  $resto .= $textoparasimusol;
  foreach my $ref (@renglones) {
      $resto .= "\n#"; map(do{$resto .= sprintf("%12s ",$_)},@$ref);
  };
  open SALIDAcache, ">>$dirsal{cache}$PROPIOSIN.cache" or
      die " No pude escribir $dirsal{cache}$PROPIOSIN.cache";
  print SALIDAcache 
"Archivos numéricos completos producidos en $mutuodir$dirsalida{simul}/ :\n";
  open ENTRADAsim,"$dirsal{d}$PROPIOSIN.sim" 
    or die "No pude abrir $PROPIOSIN.sim";
  my ($refinf,$refnan) = ([],[]);
#   impr_debug(__LINE__.' sims $refsim', Dumper $refsim);
  my @listasimul = ("$dirsal{simul}$PROPIOSIN.simul");
  while (@listasimul) { 
      my $archsimul = shift @listasimul;   
      (my $propioarchsimul = $archsimul) =~ s/^.*\/([^\/]+)$/$1/;
      open SALIDAsimul,">$archsimul" or
          die "No pude abrir para escritura $archsimul"; 
      print SALIDAsimul 
"#   Archivo $propioarchsimul; $marca_Simusol; (simusol_sceptre)\n$resto\n";
#      $coderr = interpretar_sim($juntarsimuls,$refnan,$refinf);
      while (my $renglon =<ENTRADAsim>) { 
          if ($renglon =~ /^#RUN\/RERUN NUMBER\s+(\d+)$/) {
	      $juntarsimuls and next  or last;
          } else {
              if ($renglon !~ /^#/) {
                  my @listavalores = split /\s+/,$renglon;
                  @listavalores = grep ($_ ne '',@listavalores);
                  my $aimprimir = '';
                  for (my $i= 0; $i < @listavalores; $i ++) {
                      my $valor = $listavalores[$i];
                      if ($valor =~ /(INF|NAN)/i) {
                          $aimprimir
                             = procesar_nan_inf($i,$valor,$refnan,$refinf);
                      } else {
                          $aimprimir .= sprintf " %12.5g", $valor;
                      };
                  }; #for   
                  
                  print SALIDAsimul "$aimprimir\n"; 
              };
          };
      }; #while
      close SALIDAsimul;
      print SALIDAcache "  $archsimul\n";
  };
  comfin('fins escr_simul');
}#escr_simul
#----------------------------------------------------------------------------
sub extraer_sim{
  comfin('coms extraer_sim',@_);
  my ($refls2) = @_; my $coderr = '';
  my $refsim = {};
  my @palabras = ('nam','ini','fin','min','max','no. of solution points:');
  my @abrs = ('nam','ini','fin','min','max','points'); 
  foreach my $abr (@abrs) {
      my $palabra = shift @palabras;
      my @algos = `grep  "\#$palabra" $dirsal{d}$PROPIOSIN.sim`;chomp @algos;
#      impr_debug(__LINE__.' sims @algo',\@algos);
      my $rerun = 0;
      foreach (@algos) {
          s/^#$palabra\s*(.*\w)\s*$/$1/;
#          impr_debug(__LINE__.' sims $algo',$_);
          if ($abr ne 'points') {
              $refsim->{$abr}->[$rerun] = [split /\s+/,$_];
	  } else {
              s/$palabra\s+//;
              $refsim->{$abr}->[$rerun] = $_;
          };
          $rerun ++;
      };
  };
  $refsim->{nsceptres} = $refsim->{nam}->[0];
#  impr_debug(__LINE__.' sims $refsim',Dumper $refsim);
  my $cuantosrerun = scalar @{$refsim->{nam}};
  my $marcarerun = '';
  for (my $rerun = 0; $rerun < $cuantosrerun; $rerun++) { 
      my $i = 0; $rerun and $marcarerun = "_$rerun";
      $refsim->{res}->[$rerun]->{marcarerun} = $marcarerun;
      push @{$refsim->{archress}},"$PROPIOSIN$marcarerun.res";
#      push @{$refsim->{archsimuls}},"$PROPIOSIN$marcarerun.simul"
#	  if $rerun < $cuantossimul;
      for my $nombre (@{$refsim->{nam}->[0]}) {
          for my $palabra ('ini','fin') {
              $refsim->{res}->[$rerun]->{$nombre}->{$palabra}
                 = $refsim->{$palabra}->[$rerun]->[$i];
          };
          for my $palabra ('min','max') {
              my $valor
                = sprintf ("%10.4E", $refsim->{$palabra}->[$rerun]->[$i]);
              $refsim->{res}->[$rerun]->{$nombre}->{$palabra} = $valor;
          };
          $i ++;
      };
  };
#  impr_debug(__LINE__.' sims $refsim',Dumper $refsim);
  comfin('fins extraer_sim $coderr',$coderr);
  return $coderr,$refsim;
}#extraer_sim
#----------------------------------------------------------------------------
sub identificar_terminate{
  comfin('coms identificar_terminate',@_);
  my $code = $_[0];
#  my $renglon =  `grep OPTIONAL.TERMINATION.CODE $PROPIOSIN.ls2`;chomp $renglon;
#  my @lista = split /\s+/,$renglon; my $code = $lista[-1];
  my @terminates =  `grep TERMINATE $dirsal{d}$PROPIOSIN.d`;chomp @terminates;
  impr_debug(__LINE__.' sims @terminates',Dumper \@terminates);
  my $textoterminate = $terminates[$code-1]; 
  comfin('fins identificar_terminate',$textoterminate);
  return $textoterminate;
}#identificar_terminate  
#----------------------------------------------------------------------------
sub parars{
  comfin('coms parars',@_);
  my ($codigo,$mensaje) = @_;
  if ($mensaje) {
      explic( ' '.'=' x 70);mensajear($mensaje);
  };
  explic( ' '.'=' x 70) if $codigo;
  if (not $codigo and $debug) { 
      my @archres = @{$refsim->{archress}};
      my $archres = join ("  ",@archres);
      explic(
        "Resumen de resultados de la simulación en: \n" 
           .' 'x12 ."$dirsal{res}$archres") if -e "$dirsal{res}$PROPIOSIN.res"; 
  };
  system "rm $gnusdir/* 2>/dev/null; rmdir $gnusdir 2>/dev/null" if -d $gnusdir;
  if ($debug) {
      if ($PROPIOSIN) { 
          mensajear(
           " código sc: $codigo para $PROPIOSIN, en $curdirori, desde $outdir");
      } else {
          mensajear(" código sc: $codigo,en $curdirori, desde $outdir");
      };
  } else {
      mensajear (" código sc: $codigo");
  };
  exit $codigo; 
}#parars
#----------------------------------------------------------------------------
sub parars_ver{
  comfin('coms parars_ver', @_);
  my ($cod,$archls,$mens) = @_;
  exit $cod if $opt_hash{nopausa}; 
  mensajear($mens) if $mens;
  explic("   Puede ver todos los mensajes del Sceptre 
          en el archivo $archls; 
       vealos ahora, pulsando ENTER-RETURN
          (y  avance con barra espaciadora y salga con q)
       o interrumpa el procesamiento de este archivo pulsando q");
  my $dummy = <STDIN>; 
  if (defined $dummy and $dummy =~ /q/) {
      parars($cod) if $dummy eq 'q';
  } elsif (-e $archls) {
      impr_debug(__LINE__.' sims $archls',$archls);
      system "less $archls";
  } else {
      mensajear(" Pero el archivo $archls no existe!");
  };
  comfin('fins parars_ver');
  parars($cod); 
}
#----------------------------------------------------------------------------
sub procesar_nan_inf{
  comfin('coms procesar_nan_inf',@_);
  my ($i,$valor,$refinf,$refnan) = @_; my $aimprimir= '';
  #$valor = '   ';el nuevo gnuplot trata "bien"
  if ($valor =~ /INF/i) {
      $refinf->{$i+1} ++;
      $aimprimir .= sprintf " %12s",$valor;
  } elsif (uc($valor) eq 'NAN'){
      $refnan->{$i+1} ++; 
      $aimprimir .= sprintf "%10s%3s", '',$valor;
  };
  comfin('fins procesar_nan_inf');
  return $aimprimir;
}
#procesar_nan_inf
#----------------------------------------------------------------------------
sub revisar_ls1{
  # si no ha habido problemas, devuelve tiempos; si hubo problemas..parars_ver
  comfin('coms revisar_ls1 ', @_);
  my $PROPIOSIN = $_[0]; my $rcode = '';
  my $archls1 = $PROPIOSIN . '.ls1';
  my @lista = `cat $archls1`; chomp @lista;
  my @listiempo = grep (/STOP\s*TIME/, @lista);
  map (s/\s*STOP\s*TIME\s*=\s*(\S.*\S)\s*$/$1/i, @listiempo);
  my $tiempostop = join '    ',@listiempo;
  @listiempo = grep (/START\s*TIME/, @lista);
  map (s/\s*START\s*TIME\s*=\s*(\S.*\S)\s*$/$1/i, @listiempo);
  my $tiempostart = join '    ',@listiempo;
  my @listawarning = grep /WARNING/,@lista;
  if (@listawarning) {
      my $texto = join "\n",@listawarning; 
      mensajear("- - - Aviso de Sceptre de posibles problemas:\n$texto");
  };
  my @listarefer = grep /0\'(\w+)\s*\'\s*IS REFERENCED BY/ ,@lista;
  if (@listarefer) {
      my $texto = join "\n",@listarefer; 
      mensajear("- - - Aviso de Sceptre de problema serio:\n$texto");
      avgrav("Variable o función no definida para Sceptre");
      comfin('fins revisar_ls1 ',66);
      parars(66);
  };
  my @condiciones =  `tail -n3 $archls1`; 
  my $condicionls1 = $condiciones[-1];
  if ($condicionls1 =~ /SYSTEM NOW ENTERING SIMULATION/) {
      print "SYSTEM NOW ENTERING SIMULATION\n" if $opt_hash{noverb};
      my @condiciones =  `tail -n3 $archls1`; 
      if ($condiciones[1] !~ /\s+END/ and $condiciones[1] =~ /\w/) {
          avgrav(" sceptre no aceptó todo el archivo $PROPIOSIN.d");
          $rcode = 5;
      };
      comfin('fins revisar_ls1 $tiempostart,$tiempostop '
        ,$tiempostart,$tiempostop);
      return ($rcode,$tiempostart,$tiempostop,@condiciones);
  };
  my ($antant,$ant,$pres) = ('0','0','0');
  avgrav(" sceptre no aceptó el archivo $PROPIOSIN.d");
  explic ("........ Selección de mensajes de Sceptre; 
                  (todos están en $archls1)");
  my $raras = 0;
  foreach (@lista) {
      if (/PRECEDING UNRECOGNIZABLE CARD IGNORED/
           or /INCORRECT DELIMITER/ 
           or /VARIABLE NAME EXCEEDS/){
          $raras ++;last if $raras >5;
      };
      ($antant,$ant,$pres) = ($ant, $pres, $_);
      ($antant =~ /^0/  or $ant !~ /^0\S/) and next;
      print "$antant\n" 
        unless ($antant =~ /^\s*$/ or $antant =~ /^\s*END\s*/); 
      if ($ant =~ /ERROR MESSAGE/) {
          $pres =~ s/^0//; 
          print "$pres\n";$pres = '';
      } else {
          $ant =~ s/^0//; 
          print "$ant\n";$ant = '';
      };
  };
  $pres =~ s/^0//;
  mensajear("$pres") if $pres ne '';
  #impr_debug(__LINE__.' sims $pres', $pres);
  my $ultima = $lista[-1];
  my $mensparar='';
  if ($raras) {
      # $mensparar = " El archivo $CORTOSIND.d no parece adecuado\n";
      $rcode = 249; 
  };
  if ($ultima =~ /E\/C loop/) {
      $mensparar .= "====== Sceptre no acepta ciclos con solo 
          elementos E o C"; 
      $rcode = 252;
  } elsif ($lista[-2] =~ /AN ILLEGAL PROCESSING SEQUENCE HAS BEEN REQUESTED/){
      $mensparar = 
            "===== Error de sintaxis en $PROPIOSIN.d; quizás muy incompleto";
      $rcode = 250;
  } elsif ($ultima =~ /CURRENT SOURCE CUT SET/) {
      $mensparar = "===== No es posible un elemento J fuera de un ciclo,
                    ni dos elementos J en serie";
      $rcode = 251;
  } elsif ($ultima =~ /PROGRAM CAPACITY HAS BEEN EXCEEDED/) {
      $mensparar = "$lista[-3]\n$lista[-2]
       Se agotó la memoria para Sceptre; si es
          por tablas dependientes del tiempo puede conseguir partir 
          la ejecucion en dos o más intervalos";
      $rcode = 253;
  };
  comfin('fins revisar_ls1 ');
  impr_debug(__LINE__. ' sims $rcode, $archls1,$mensparar'
    ,[$rcode, $archls1,$mensparar]);
  parars_ver($rcode,$archls1,$mensparar);
}#revisar_ls1
#----------------------------------------------------------------------------
sub simular{
  comfin('coms simular',@_);
# ----------------------------------------------------------------------------
  my $FC = 'gfortran -fno-automatic'; # para compilar FORTRAN
  my $BINDIR = "/usr/local/bin";
  my $LIBDIR = "/usr/local/lib";
  my $LIBX2 = "$LIBDIR/libsceptre.a";
  my $LIBX3 = "$LIBDIR/libsceptreaux.a";
  my $SCEPTRE = "$BINDIR/sceptre";
  if ( ! -d "$HOME/lib") {mkdir "$HOME/lib"};
  if ( ! -e "$HOME/lib/modellib.dat") {
      system "cp $LIBDIR/modellib.dat $HOME/lib/modellib.dat"
  }; 
  if (! -e "$HOME/lib/usrlib.a") {
      system "cp $LIBDIR/usrlib.a  $HOME/lib/usrlib.a"
  }; 
  my $USRLIB = "$HOME/lib/usrlib.a";
  my $MODELLIB = "$HOME/lib/modellib.dat";
  if (-e "modellib.dat") {system "rm modellib.dat 2>/dev/null"};
  system "ln -s ${MODELLIB} modellib.dat 2>/dev/null"; 
  explic(
    "======= Si parece que se \"quedó\" el Sceptre, interrumpa con CTRL_C");
  my $rcode ='';
#  impr_debug(__LINE__.' sims $dirsal{for}',"$dirsal{for}");
#  impr_debug(__LINE__.' sims $opt_hash{noclas}',$opt_hash{noclas});
  if (not $opt_hash{noclas} and -e "$dirsal{for}$PROPIOSIN.for") {
      system "cp $dirsal{for}$PROPIOSIN.for  $dirsal{d}funciones.for";
  }; 
  if ($noverb) {
      $rcode = system "$SCEPTRE $PROPIOSIN >/dev/null" 
  } else {
      $rcode =   system "$SCEPTRE $PROPIOSIN";
  };
#  impr_debug(__LINE__.' sims $rcode,$rcode/256',[$rcode,$rcode/256]);
#  puede haber aparecido un cat de $PROPIOSIN.lso
  print "error code $SCEPTRE ",$rcode/256,"\n" if $rcode;
  my ($tiempostart,$tiempostop);
  if (not -f "$PROPIOSIN.ls1") {
      parars(20,'No se pudo ejecutar sceptre, primera parte');  
  } else {
      if (not $rcode) {
          ($coderr,$tiempostart,$tiempostop,my @condiciones)
             = revisar_ls1($PROPIOSIN);
          if ($coderr eq '5') {
              my $archls1 = $PROPIOSIN . '.ls1';
              print "   Tres ultimos renglones del archivo $archls1:
 @condiciones" unless $opt_hash{noverb};
          };
      } else {
          if (not -s "$PROPIOSIN.for") {
              mensajear(" sceptre no pudo generar un buen programa simulador
          para el circuito dado en $PROPIOSIN.d");
              parars_ver(21,"$PROPIOSIN.ls1"
               ,"\n         ===== $PROPIOSIN.for no generado"); 
          };
          if (not -e "${PROPIOSIN}_run") {
              my @renglones
                = `grep undefined ${PROPIOSIN}.ls4`; chomp @renglones;
              impr_debug(__LINE__.' sims @renglones', \@renglones);
              my @renglonesundef = @renglones;
              map (do {$_ =~ s/^.+undefined reference to .(\w+)_.$/$1/}
	        ,@renglonesundef);
              map (do {not $_ =~ /^.+undefined reference to .(\w+)_.$/}
	        ,@renglones);
              if (@renglonesundef) {
                  mensajear( 
                  "Hay referencias indefinidas en el programa FORTRAN:\n      "
                  . join (" ",@renglonesundef));
              } else {
                  mensajear(
                  "Hay problemas en el programa FORTRAN:\n      "
                  .join (' ',@renglones));
              }; 
	  };
          parars(29,'El programa simulador resulto con errores');
      };
  };
  if ($rcode == 256) {
    parars(30,"Ejecución de Sceptre (${PROPIOSIN}_run) interrumpida");
  };
  mensajear(" Código de error del sceptre  $rcode") if $rcode != 0;
  system("rm -f pri.o exec2 acsave.dat datasave.dat 2>/dev/null"); 
  if (-s "$PROPIOSIN.ls2") {
      if (not system "grep  IMPLICIT.integration.cancelled $PROPIOSIN.ls2") {
          comfin('fins simular',22);
          parars(22, 
      "El método de integración IMPLICIT no sirve para este circuito");
      } elsif ((not -f "$PROPIOSIN.dirac" and not -f "$PROPIOSIN.sim")
        or system 
     "grep 'TRANSIENT SOLUTION' $PROPIOSIN.ls2 2>/dev/null >/dev/null") {
          comfin('fins simular',23);
          parars(23, "Sceptre no ha calculado transitorio para $PROPIOSIN.d");
      }
  } else {
      comfin('fins simular',28);
      parars(28, "Sceptre no dejo rastros de la ejecución de exec2
        habrá habido violacion de segmento?");
  };
  impr_debug(__LINE__.' sims $outdir',$outdir);
  chdir $outdir; 
  impr_debug(__LINE__.' sims ',"\n\n          ya cambiado a \$outdir $outdir\n");
  my ($refls2,$rcodes) = ({},'');
  my $archparaplot = "$dirsal{paraplot}$PROPIOSIN.paraplot";
  if (-e $archparaplot) {
      $fechamarcas{paraplot} = scalar localtime((stat "$archparaplot")[9]);   
      my $coderr = paraplotear($archparaplot);
      $coderr and mensajear("Hubo problemas con $archparaplot");
  } else {
      system "ls tests/*.paraplot";
     mensajear("No existe $archparaplot");
  };
  $refls2 = revisar_ls2($PROPIOSIN,$tiempostart,$tiempostop);
  ($rcodes,$refsim) = extraer_sim($refls2);
#  impr_debug(__LINE__.' sims',[scalar keys %$refls2,scalar keys %$refsim]); 
  if ($rcodes) {
      mensajear(" Hubo problemas para extraer_sim");
  } else {
     ($rcodes,my $SIMBARCHPRINC) = escr_res($refls2,$refsim,$tiempostop);
     #tambien disponen de $ref_arch
     if ($rcodes) {
         mensajear (" Hubo problemas para preparar $PROPIOSIN.res");
     } else {
        if ($opt_hash{adsim}) {
             system "scripts/adsim";

        }; 
        $rcodes = escr_simul($refsim,$SIMBARCHPRINC);
        $rcodes and mensajear("Hubo problemas para preparar $PROPIOSIN.simul");
     };
  };
  comfin('fins simular',$rcodes);
  return $rcodes
}#simular
# ---------------------------------------------------------------------------
sub revisar_ls2{
  comfin('coms revisar_ls2', @_);
  my ($propio,$tiempostart,$tiempostop) = @_;
  my $archls2 = "$dirsal{d}$propio.ls2";
  if (not system("grep 'INITIAL CONDITION SOLUTION' $archls2 >/dev/null")) { 
      system ("$BINDIR/asa $archls2");
      parars(0);
  };
  open ENTRADAls2,"<$archls2" or die "No existe el archivo $propio.ls2";

  my ($condicionls2,$menserror) = ('','');
  my $refls2 = {};
  my $rerun = 0;
  while (<ENTRADAls2>) {     
      chomp;
      s/D([\+\-])/e$1/;
      if (s/^0RUN.RERUN NUMBER \s*(\d+)$/$1/) {
	  push @{$refls2->{reruns}},$_; $rerun = $1;
      } elsif (s/^0INTEGRATION ROUTINE \s*(\w+)\s*$/$1/) {
	  push @{$refls2->{intes}},$_;
      } elsif (s/^0LAST STEP SIZE \s*(.+)$/$1/) {
          push @{$refls2->{stepsizes}},$_;
      } elsif (s/^0CURRENT SIMULATION TIME \s*(.+)$/$1/) {
          push @{$refls2->{times}},$_;
      } elsif (s/^0INTEGRATION STEP COUNTER \s*(.+)$/$1/) {
          push @{$refls2->{stepcounters}},$_;
      } elsif (s/^0INTEGRATION PASS COUNTER \s*(.+)$/$1/) {
          push @{$refls2->{passcounters}},$_;
      } elsif (s/^0TERMINATION CONDITION \s*(.+\S)\s*$/$1/) {
          push @{$refls2->{termconds}},$_;
      } elsif (/^0OPTIONAL TERMINATION CODE IS\s*(\d+)/) {
          my $code = $1;
          my $terminate = identificar_terminate($code);
          push @{$refls2->{opt_code}},[$rerun,$code,$terminate];
      } elsif (/^0directory of/) {
          last;
      };
  };
  if (/^0directory of/) {
      while (<ENTRADAls2>) {
          if(/_0\s+\d\s+\d+\s+(\d)/) {
              $refls2->{cual} = $1;last;
          };
      };
  };
  while (<ENTRADAls2>) {last if s/^0//};
  $refls2->{condicionls2} = $_;
#  impr_debug(__LINE__.' sims $refls2',Dumper $refls2);
  comfin('fins revisar_ls2');
  return $refls2;
}#revisar_ls2
#----------------------------------------------------------------------------
sub help{
    pod2usage({-verbose => 0
           ,-exit => 0
	   ,-message => "   $progname  $version
       es parte del conjunto de scripts de S I M U S O L
            más ayuda con   
	       man $progname
	    y luego salga con   q\n"   
            })
}
#----------------------------------------------------------------------------
sub version{
   print "\n       $progname  $version\n\n";
   exit 0  
}
__END__


=head1 NAME

simusol_sceptre.pl - forma parte de Simusol

Simula un circuito con ayuda de B<sceptre> 

=head1 SYNOPSIS

B<simusol_sceptre.pl> [I<opciones>]  [I<archivo>]

opciones:  

B<-help -version  -nopausa> (o abreviaturas distinguibles)
	   
B<-d>
         	           
para las opciones, no importan mayúsculas o minúsculas;
para nombres de  archivos,  sí importan.

=head1 OPTIONS/ARGUMENTS

=over 15

=item B<-h  --help>

Muestra este mensaje de ayuda 

=item B<-v  --version>

Muestra versión.

=item B<-d>

Produce algunos mensajes para depuración de errores del programa

=item B<-nop --nopausa>

No hay pausa para avisar que se han producido errores en el llamado a sceptre

=item B<-nov --noverb>

Disminuye la cantidad de información no esencial que se da al ususrio.

=back

=head1 DESCRIPTION 

Utiliza B<sceptre> para simular I<archivo>B<.d>,  producir archivos ascii
y un archivo binario  con los resultados.

Su uso suele ser consecuencia de la ejecución de B<simusol>. Se usa 
también cuando se ha decidido que en la preparación del archivo con datos para 
B<sceptre>, no participen B<dia> ni B<simusol1.pl>.


=head1 AUTHORS

Dolores Alia de Saravia <loli@unsa.edu.ar>

Luis R. Saravia <saravia@unsa.edu.ar>

Diego Saravia <dsa@unsa.edu.ar> 

=cut

