package Auxiliares;
use warnings;
use strict;
use GlobalesSimusol;
use Ayudas;
use Algebraico;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&analice
                &backupear &comparar_todo
		&depurar_lis_archivos &depurar_lis_nombres_archivos    
                &seleccionar_archivo   &analice
                &elegir_archivos
                )
}     
END();
# ---------------------------------------------------------------------------
sub elegir_archivos{
  #se pide sin argumentos; conoce $ARGV y $progname
  comfin('comfin elegir_archivo', @_);
  my $ext = $_[0];
  defined $ext or error_progr(0,__LINE__.' Auxi');
  #impr_debug(__LINE__.' Auxi @ARGV ','Hay '. scalar @ARGV); 
  my @conocidos = ('simusol', 'simusol_sceptre'
    ,'simusol1.pl', 'simusol2.pl', 'simusol3.pl'
		   ,'sim_renback');
  my (%multiples, %ext_usadas, %conamp);;
  map (do{$multiples{$_} = ''}, values %extension);
  $multiples{dia} = 1;
  map ($ext_usadas{$_} = 1, values %extension);
  map ($conamp{$_} = '',@conocidos);
  $conamp{simusol} = $conamp{'simusol1.pl'} = 1;
  $buscar = ''; defined $opt_hash{buscar} and $buscar = 1;
  if ($opt_hash{impr} or $opt_hash{backup} or $opt_hash{notrad}) {
      $conamp{simusol} = $conamp{'simusol1.pl'} = 0;
  };
# --------------------------------------------------------------------------
  my $multiple = $multiples{$ext};
  #$multiple = '' if $opt_hash{graf};
  if ($opt_hash{comp}) {$ext = 'dia'};
  my $conamp = $conamp{$progname}; 
  my $coderr;
  my $buscar = $opt_hash{buscar};
  my @pedidos = @ARGV; my $niveles = 1;
  #impr_debug(__LINE__.' sim0 @pedidos ',\@pedidos);
  my $path = './';
  if (defined $buscar) {
      @pedidos = ($buscar);
      $niveles = undef;
      $path = $opt_hash{path} if defined $opt_hash{path};
      $path !~ /^\// and  $path !~ /^\.\// and $path = "./$path";   
  };  
  my @listaconblancos;
  @listaconblancos = grep(/\w\s\w/,@ARGV);
  if (@pedidos == 0) {@pedidos = ('*');
  } else {
      my @listaast = grep (/\*/,@ARGV);
      my @listanoastnoblanco = grep (/^[^\*\s]+$/,@ARGV);
      @listaconblancos = grep(/\w\s\w/,@ARGV);
      my @listaexisconblancos = grep (-e "$_",@listaconblancos);
      if (@listaexisconblancos) {
          die "Simusol no trabaja si hay archivos con espacios en su nombre:\n"
	      . join ("\n", @listaexisconblancos) ."\n";
      };
      #impr_debug(__LINE__.' @listaast',Dumper \@listaast);
      #impr_debug(__LINE__.' @listaconblancos',Dumper \@listaconblancos); 
      #impr_debug(__LINE__.' @listaexisconblancos'
      #		 ,Dumper \@listaexisconblancos) if @listaexisconblancos;
      
      if (@listaast >1 or @listaast and @listanoastnoblanco
         or @listaconblancos >1 or @listaconblancos  and @listanoastnoblanco) {
          die 'Simusol no trabaja con pedidos tan complicados; no mezcle
              pedidos con asterisco entre comillas con otros;
              ni pedidos con blancos entre comillas con otros
              y no pida más de uno con asteriscos entre comillas;
               o uno con blancos
              ejemplos de permitidos: 
                tanque* cuadro*juan
                \'tanque*\'   
                \'tanque*uno*\' 
                \'tanque Termico6.ele\' '."\n";               
      };
  };
  if (@listaconblancos) {
      @pedidos = split /\s+/, $listaconblancos[0];
  }
  #impr_debug(__LINE__.' Auxi @listaconblancos ', \@listaconblancos);
  my $refpedidos = mejorar_regnombres(\@pedidos,\%ext_usadas,$ext);
  #impr_debug(__LINE__.' Auxi @$refpedidos ', \@$refpedidos);
  my @conast = grep(/\*/,@$refpedidos); # son todos o ninguno
  my @dirarray;
  if (@conast == 0 and not $opt_hash{buscar}){
      #impr_debug(__LINE__.' Auxi @$refpedidos ', \@$refpedidos);
      @dirarray = grep(do{-f $_ and -s $_},@$refpedidos);
      #impr_debug(__LINE__.' Auxi @dirarray ', \@dirarray);
  } else {
      foreach my $pedido (@$refpedidos) {    
          my $pathaum = $path; my $propio = $pedido;
          if ($pedido =~ /^(.*\/)([^\/]+)$/) {          
              $pathaum = "$path$1"; $propio = $2;
          }; 
          #impr_debug(__LINE__.' Auxi $pedido $path $pathaum $niveles $propio '
          #  , [$pedido,$path,$pathaum,$niveles, $propio]);
          my $comando;
          if ($niveles) {
             $comando 
                = "find $pathaum -maxdepth $niveles -type f -name '$propio'";
          } else {
              explic('Buscando archivos en todos los subdirectorios');
              $comando = "find $pathaum -type f -name '$propio'";
          };
          push @dirarray, `$comando`; chomp @dirarray;
          map( s/$path//, @dirarray); 
          #impr_debug(__LINE__.' Auxi @dirarray ', 'Hay '. scalar @dirarray);
      };
  } 
     
  explic(' Hay '. scalar @dirarray . ' para revisar') unless $niveles;
  #impr_debug(__LINE__.' Auxi @dirarray ', \@dirarray); 

  my ($reff,$refhash);
  if ($ext eq 'dia') {
      $reff = depurar_lis_nombres_archivos(\@dirarray);
      #impr_debug(__LINE__.' Auxi $reff ', Dumper $reff);
      explic(' Quedan '. scalar @$reff . ' para revisar') unless $niveles;
      if($opt_hash{impr}) {
          $reff = depurar_lis_archivos_impr($reff,'0') if scalar @$reff >1;
      } else {
          $reff = depurar_lis_archivos($reff,'O') if scalar @$reff > 1 ; 
      };
  } else {
      #impr_debug(__LINE__.' Auxi $ext ', $ext);
      #impr_debug(__LINE__.' Auxi @dirarray ', \@dirarray);
      @$reff = grep(/\.$ext$/, @dirarray); 
  }; 
  #impr_debug(__LINE__.' Auxi $reff ', Dumper $reff);
  #impr_debug(__LINE__.' Auxi @listaconblancos ', Dumper \@listaconblancos);
  #impr_debug(__LINE__.' Auxi $reff ', Dumper $reff);
  if (@$reff == 1) {
      return @$reff; 
  } elsif (@$reff >1 ) {
      map (do{-f $_ and -s $_ and $refhash->{$_} = 1},@$reff);
      #impr_debug(__LINE__.' Auxi $refhash',Dumper $refhash);
      $multiple = '' if $opt_hash{comp};
      my @archivos 
          = seleccionar_archivo($multiple,$ext,$refhash,$conamp);
      #impr_debug(__LINE__.' Auxi @archivos ', \@archivos);
      @archivos == 0 and do{
	  explic("No eligio nada"); exit;
      };  
      my @archivosn = sort @archivos;
      #impr_debug(__LINE__.' Auxi @archivosn ', \@archivosn);
      return @archivos;
  } elsif (keys %$refhash == 0) {
      explic("No quedan archivos para procesar por $progname"); 
      exit;
  };
} #elegir_archivo
# ---------------------------------------------------------------------------
sub mejorar_regnombres{
  comfin('com mejorar_regnombres',@_);
  my ($reflistareg,$refext_usadas,$ext) = @_; my @mejorada;
  #aqui llegan las $reg tengan o no  algun '*'; no vienen ancladas
  #impr_debug(__LINE__.' Auxi $reflistareg ', $reflistareg);
  foreach (@$reflistareg) {
      next if /~$/;
      my ($elcondia,$elsinext,$elconext) = ('',$_,'');
      if (/^(.*)\.(\w+)$/) {
          my ($uno,$dos) = ($1,$2);
          $dos =~ s/\d+$//;
          next if $no_ext{$dos};
          if ($refext_usadas->{$dos}){
              $elsinext = $uno;
          } else {
              $elsinext = $_;
          };
      };
      if (/\*$/) {$elcondia = $_
      } else {$elcondia = "$elsinext.dia";
      };
      $elconext = "$elsinext.$ext";
      if ($ext eq 'dia') {
          push @mejorada, ($elsinext, $elcondia); 
      } else {
          push @mejorada, $elconext;
      };  
      #impr_debug(__LINE__.' Auxi $el,$elsinext,$elcondia,$elconext '
      #		 ,[$_,$elsinext,$elcondia,$elconext]);
  };
  @mejorada = union_conjunto(@mejorada);
  comfin('fin mejorar_regnombres', 'Hay '. scalar @mejorada.' '
                . paraimpr3puntos(30,@mejorada));
  return \@mejorada;
}; #mejorar_regnombres 
# ---------------------------------------------------------------------------
sub depurar_lis_nombres_archivos{
  comfin('com depurar_lis_nombres_archivos',@_);
  # dado la ref a lista de archivos, $dir, elimina de la lista a todos
  # los archivos con ciertos nombres
  #que se espera no son diagramas; lo usa simusol y simusol1.pl
  #devuelve referencia a lista
  my ($dir) = @_; my @buenos; 
    #mensaje (__LINE__.' Auxi final' .join("\n",@buenos[1..10])."\n");
  my %no_arc;
  my @extonsiones = ('ls1', 'ls2','GNU', 'GPI'
                    , 'dirac', 'gra', 'gnu', 'gnu1'  
                    , 'res', 'res1', 'simul', 'simul1', 'caj', 'caj1'
                    , 'd', 'd1', 'paraplot', 'paraplot1', 'lss1', 'lss11'
                    , 'eps','png','ps','for'
		    , 'shape', 'sheet', 'autosave','log', 'dump'
		    , 'creci', 'html', 'svg');
  my @archivos =  ('modellib.dat', 'acsave.dat', 'dirac.dat'
                  , 'pgmsave.f', 'pgmsave.for', 'pri.for'
                  , 'gnus', 'diagramas.tar.gz'); 
  push @archivos, 
       ('loli', 'loli2', 'loli3', 'loli4', 'simusol.listadiff', 'resumen')
                   if $ENV{USER} eq 'loli';
  #map($no_ext{$_} = 1,@extensiones);
  map($no_arc{$_} = 1,@archivos);
  #impr_debug(__LINE__.' Auxi $dir ', $dir);
  foreach my $file (@$dir) {    
     next if $file =~ /\/\.[\w\-]/; #archivos ocultos
     next if $file =~ /~$/; #backup    
     next if -d $file;
     my $propio = '';
     my $barrafile = '/' . $file;
     next if $barrafile =~ /\/gnus\//;
     $barrafile =~ /\/([^\/]+)$/ and $propio = $1;
     next unless $propio;
     next if $propio =~ /^\./;
     next if $propio =~ /^\#.+\#$/; #backup del emacs
     next if $no_arc{$propio};
     my ($ext) = ($propio =~ /\.([\w]+)$/);
     if ($ext) {
         next if $no_ext{$ext};
     }
     push(@buenos, $file);
  };
  $dir = \@buenos;
  #impr_debug(__LINE__.' Auxi $dir ', $dir);
  my @lista_ignorar = ();my @lista_incluir = (); 
  if ($opt_hash{patronno}) {
      @lista_ignorar = split /\s+/, $opt_hash{patronno};
  };
  if ($opt_hash{patronsi}) {
      @lista_incluir = split /\s+/, $opt_hash{patronsi};
  };
  #impr_debug(__LINE__. ' Auxi @lista_incluir', [@lista_incluir]);
  my (@dir_no_posibles,%hash_no_posibles);
  if (scalar @lista_ignorar) {
      foreach my $pattern (@lista_ignorar) {
         push(@dir_no_posibles,grep(/$pattern/,@$dir))
      };
      map($hash_no_posibles{$_}= 1,@dir_no_posibles);
  };
  my @dirposibles; 
  @dirposibles = grep(do{not $hash_no_posibles{$_}}, @$dir);
  #impr_debug(__LINE__.' Auxi @dirposibles ', \@dirposibles);  
  if (scalar @lista_incluir) {
     foreach my $pattern (@lista_incluir) {
	  #impr_debug(__LINE__. ' Auxi patron  si', $pattern);
          push(@dirposibles, 
               grep(do{/$pattern/ and not defined $hash_no_posibles{$_}},
                    @$dir));  
     }
  };
  #impr_debug(__LINE__.' Auxi @dirposibles ', \@dirposibles);  
  my @conblancos = grep( /[ \"\']/, @buenos);
  if (@conblancos) {
       print STDERR " Por favor, si  archivos como\n\""
       . $conblancos[0]. "\"
       son  archivos-diagramas, cámbieles el nombre para que no tengan 
       espacios ni comillas; de otro modo no podré interpretarlos\n";
       explic('Sigo buscando');      
       @buenos = grep($_ !~ /[\s\"\']/, @buenos);
   };
  comfin('fin depurar_lis_nombres_archivos', 'Hay '. scalar @buenos.' '
                . paraimpr3puntos(30,@buenos));
  return \@buenos; 
}; #depurar_lis_nombres_archivo
# ---------------------------------------------------------------------------
sub depurar_lis_archivos{
  comfin('com depurar_lis_archivos',@_);
  # controla que sean diagramas los archivos referenciados por reflista
  # modo: '0', '1' controla que haya cuadros de 
  # DATOS, PARAMETROS o GRAFICOS  
  # devuelve lista de archivos que son presumiblemente diagramas
#impr_debug(__LINE__.' Auxi @_ ', $_[0]);
  explic('Revisando posibles diagramas en todos los subdirectorios')
       if $opt_hash{buscar};
  my ($reflista,$modo) = @_;
  my %nombredia;
  my @listaarchs=  grep(do{
         not -d $_ and -e $_ and -f $_  and $_ !~ /~$/}
         , @$reflista);
 # impr_debug(__LINE__.' Auxi @_ ', $_[0]);
 # impr_debug(__LINE__.' Auxi @listaarchs ', \@listaarchs);
  my @buenos = grep (/\.dia$/,@listaarchs);
   if (@buenos) {
      comfin('fin depurar_lis_archivos', 'Hay '. scalar @buenos . ' '
        . paraimpr3puntos(30,@buenos));
      return \@buenos;
  };
  @listaarchs = sort @listaarchs;
  my $condicionsimple1 = "head -1 ";
  my $condicionsimple2 = " |grep -l ?xml  >/dev/null 2>/dev/null"; 
  my $condicioncompr1 = "zcat ";
  my $condicioncompr2 = " 2>/dev/null | "
	              . "head -1 | grep -l ?xml >/dev/null 2>/dev/null";
  my $condicionsimplemas1 = "grep -l -i ";
  my $condicionsimplemas2 = " >/dev/null 2>/dev/null";
  my $condicioncomprmas1 = "zcat ";
  my $condicioncomprmas2 = " 2>/dev/null | grep -i ";;
  my $condicioncomprmas3 = ">/dev/null 2>/dev/null";
  my @lists;
  # '"  "'  para evitar problemas con los newline

  my $quebuscar
      = '"dia:object type=.*nodo.*version"';
  my @palabras = ('PARAMETRO', 'GRAFICO', '.\*COMPLEM', 'USO','DEFINICION'
                   ,'UNIDAD');
  map (s/^(.*)$/dia:string.\#\[\\ \]\*$1/, @palabras);
  foreach my $archivo (@listaarchs) {
      my $posible = ''; 
      if (not system "$condicionsimple1 $archivo $condicionsimple2") {
          if (not system ("$condicionsimplemas1 $quebuscar "
              . "$archivo $condicionsimplemas2")) {
              $posible = 1; 
          } else {
	      impr_debug(__LINE__.' Auxi $posible',$posible);
              foreach my $palabra (@palabras) {
                 if (not system "$condicionsimplemas1 $palabra "
                      . "$archivo $condicionsimplemas2")  {
                      $posible = 1; last;
		  };
	      };
          };
      } elsif (not system "$condicioncompr1 $archivo $condicioncompr2") {
          if (not system "$condicioncomprmas1 $archivo $condicioncomprmas2 "
	   . "$quebuscar $condicioncomprmas3") {
              $posible = 1;
          } else {
              foreach my $palabra (@palabras) {
                  if (not system 
                      "$condicioncomprmas1 $archivo $condicioncomprmas2 "
                      . "$palabra $condicioncomprmas3")  {
                      $posible = 1; last;
		  };
              };
          };
      };
      next unless $posible;
      push(@lists,$archivo);
      if ($archivo =~ /\.dia$/) {$nombredia{$archivo} = 1
      } else { $nombredia{$archivo} = ''};
  }; #foreach
  my @keys = grep (/\.dia$/, keys %nombredia);
  impr_debug( __LINE__ . ' Auxi @keys', \@keys );
  foreach (@keys) {
      my $ori = $_;
      $ori=~ s/\.dia$//;
      defined $nombredia{$ori} and do{
           avgrav("Simusol no trabaja bien si hay dos diagramas 
              cuyos nombres  difieren solo en .dia
               $_            $ori
            Cambie el nombre a uno de ellos");
           $nombredia{$_} = 'mal'; $nombredia{$ori} = 'mal';
      };
  };
  $avisosgrav and exit; 
  #impr_debug( __LINE__ . ' Auxi lista',Dumper \%nombredia );
  @lists = grep($nombredia{$_} ne 'mal', @lists);
  comfin('fin depurar_lis_archivos', 'Hay '. scalar @lists . ' '
        . paraimpr3puntos(30,@lists));
  return \@lists;
} #depurar_lis_archivos
# ---------------------------------------------------------------------------
sub depurar_lis_archivos_impr{
  comfin('com depurar_lis_archivos_impr',@_);
  explic('Revisando posibles diagramas en todos los subdirectorios')
       if $opt_hash{buscar};
  my ($reflista,$modo) = @_;
  my %nombredia;
  my @listaarchs =  grep(do{
         not -d $_ and -e $_ and -f $_  and $_ !~ /~$/ and $_ !~ /^\./}
         , @$reflista);
  @listaarchs = sort @listaarchs;
  my @lists;
  # '"  "'  para evitar problemas con los newline
  my $quebuscar
      = 'dia:diagram';
print "$quebuscar\n";
  foreach my $archivo (@listaarchs) {
      next if $archivo =~ /[\(\)]/;
      my $coderr = system "zcat $archivo >gnus/llll 2>/dev/null";
      system "cp $archivo gnus/llll" if $coderr;
      my $primero = `head -n 2 gnus/llll`; 
      $primero =~ tr/\n\<\>/   /; 
      $primero = substr($primero,0,80);
      if($primero =~ /$quebuscar/){
           push @lists, $archivo;
      };
  };
  comfin('fin depurar_lis_archivos_impr', 'Hay '. scalar @lists . ' '
#	 . paraimpr3puntos(30,@lists));
	 );
  return \@lists;
}
# ---------------------------------------------------------------------------
sub seleccionar_archivo{# seleccion por usuario
  #devuelve lista de archivos; elementos con espacios corresponden a 
  #varios archivos a procesar juntos 
  #el tercer argumento puede ser hash o array
  comfin('com seleccionar_archivo',@_);
  my ($multiple,$ext,$refhash,$conamp) = @_;
  #impr_debug(__LINE__.' Auxi $multiple,$ext,$refhash,$conamp '
  #       ,[$multiple,$ext,$refhash,$conamp]); 
  my @dirarray;
  if ($refhash =~ /^HASH/) {
      if ($multiple) {
          foreach (@{$opt_hash{elementos}}, @{$opt_hash{modelos}}) {
             delete $refhash->{$_};
          };
      };    
      @dirarray = keys %$refhash;
  } elsif ($refhash =~ /^ARRAY/) { 
      @dirarray = @$refhash;
  } else {
      return ($refhash)
  }; 
  #impr_debug(__LINE__.' Auxi ',\@dirarray); 
  return (@dirarray) if @dirarray == 1;
  @dirarray = sort @dirarray;
  my $ultimo = scalar @dirarray;
  my $cualtipo = 'archivos-diagramas (Dia)';
  not $multiple  and $cualtipo = "archivos procesables por $progname";
  my $premenu = " ==== Posibles $cualtipo, desde esta carpeta";
  $premenu .= "  y siguientes" if $opt_hash{buscar}; 
  my $noespe = ": Respuesta no esperada; rectifique elección: ";
  my %ofrecidos;
  print STDERR "$premenu\n";
  for(my $i = 0;$i < @dirarray; $i++) {
      my $nombre = $dirarray[$i];
      printf STDERR "%3s: %1s\n", $i+1,$nombre;
      my ($nombresinext, $nombreconext) = ($nombre,$nombre);
      $nombresinext =~ s/\.$ext$//;
      if ($nombresinext eq $nombre) {$nombreconext .= ".$ext"};
      $ofrecidos{$nombre} = $nombre;
      $ofrecidos{$nombresinext} = $nombre; 
      $ofrecidos{$nombreconext} = $nombre;
      $ofrecidos{$nombresinext.".dia"} = $nombre;
      $ofrecidos{$i+1} = $nombre;
      $numarch{$nombreconext} = $i+1;
      $numarch{$nombresinext} = $i+1; 
  };
  #impr_debug(__LINE__.' Auxi %ofrecidos ',Dumper \%ofrecidos);
  if (not $multiple) {
      print STDERR '
   Indique número del archivo a procesar (o su nombre): ';
  } elsif ($conamp) {#solo se da junto con $multiple
      print STDERR '
  Indique número o nombre de los archivos que interesen;
      separados por & si deben procesarse juntos (mod o ele);
      separados por "," si deben procesarse por separado;
      "0": ninguno; "*"; todos de a uno; 
         n1..n2  : todos de a uno entre entre n1 y n2)
            número(s) o nombre(s): ';
  } else {
      print STDERR '
  Indique números o nombres de los archivos que interese;
      (números separados por ",");
      "0": ninguno; "*"; todos de a uno; 
         n1..n2  : todos de a uno entre entre n1 y n2)
            número(s) o nombre(s): ';
  };
  my (@listaplana,@listaconamp,$nombresmal);
  my $bien = 1;
  while (0 == 0)  {
      (@listaplana,@listaconamp) = (); $nombresmal = '';
      my $ilistita = <STDIN>; chomp $ilistita;       
      if ($ilistita =~ /^\s*\*\s*$/) {@listaplana = @dirarray; last;};
      $ilistita =~ s/\s*\.\.\s*/\.\./g;
      $ilistita =~ s/\s*\&\s*/\&/g;
      $ilistita =~ s/^\s*//; 
      $ilistita =~ s/\s*$//;
      # los espacios que quedan se cambian a coma:
      my $ilistitacoma = $ilistita; $ilistitacoma =~ s/\s+/\,/g; 
      my @listachunk = split /\,+/,$ilistitacoma;
      #impr_debug(__LINE__.' Auxi @listachunk',\@listachunk);
      foreach my $chunk (@listachunk) { 
          #impr_debug(__LINE__.' Auxi ',$chunk);
          if ($chunk =~ /\.\./) {
              #impr_debug(__LINE__.' Auxi ',$chunk);
              if ($chunk =~ /^(.+)\.\.(.+)$/) {
                  #impr_debug(__LINE__.' Auxi ',[$chunk,$1,$2]);
                  my $pri = $1; my $ult = $2;
                  $pri = $numarch{$ofrecidos{$pri}};
                  $ult = $numarch{$ofrecidos{$ult}};
                  if ($pri <= $ult and $pri >0 and $ult <= @dirarray) { 
                      push @listaplana, ($pri .. $ult);
                      next; 
                  };
              };
              $nombresmal = '***';next
          } elsif ($chunk =~ /\&/) { 
              push @listaconamp, split '&', $chunk; next;
          } else {
              push @listaplana, $chunk;
          };
      };#foreach
      #impr_debug(__LINE__.' Auxi @listaplana ','Hay '. scalar @listaplana);
      @listaplana = union_conjunto(@listaplana);
      @listaconamp = union_conjunto(@listaconamp);
      foreach my $nom (@listaplana) {
          $nom eq '0' and return ();
          if (not defined $ofrecidos{$nom}) {
              $nombresmal = '***';
          } else {
              $nom =$ofrecidos{$nom};
          };
      }; #foreach
      #impr_debug(__LINE__.' Auxi @listaplana ',\@listaplana); 
      if (@listaconamp and not $conamp or
          @listaconamp and @listaplana) {
          print STDERR "\"$ilistita\"$noespe"; next;
      } elsif ($conamp) {
          foreach  my $nom (@listaconamp) {
              if (not defined $ofrecidos{$nom}) {
                  $nombresmal = '***';
              } else {
                  $nom = $ofrecidos{$nom};
              };
          }; #foreach
      };#elsif $conamp  
      $nombresmal eq '***' and do{
          print STDERR "\"$ilistita\"$noespe"; next;
      };
      
      push (@listaplana, join (' ', @listaconamp)) if @listaconamp;
      last;
  }; #while 0==0 
  print STDERR "\n";
  $ext ne 'dia' and map (s/\.$ext//,@listaplana);
  comfin('fin seleccionar_archivo', @listaplana);
  return @listaplana;
}# seleccionar_archivo
# ---------------------------------------------------------------------------
sub asignar_comp{
   my ($texto,$refcirc,$noerror)=@_;
   # en $refcirc->{refvalores}->{$texto} estan  los renglones tal cual
   #  se distribuiran a partir $refcirc->{$texto} interpretados  
   # en $refcirc->{"val$texto"} se acumulan para hacer control de repetidos
   if (defined ($refcirc->{refvalores}->{$texto})){
      my %hash = ();my $cuantasdefi = 0;
      my @lista = juntar_por_signos_y_paren(' '
                      ,@{$refcirc->{refvalores}->{$texto}});
      foreach my $renglonori (@lista){
         next unless defined $renglonori;
         #una primer "," se interpreta como = ; las comas ahi son obsoletas
         my $renglon = uc($renglonori);
	 if ($renglon =~ /[=,]$/) {
	   avgrav("\"$renglonori\" en "
	   . descripcion_nombre("O$texto", $refcirc->{cualobjcuadro})
	   . " no define nada") unless $noerror;
	   next;
	 } 
         my @listita = split (/\s*=\s*/, $renglon);
         @listita = juntar_por_signos_y_paren('',@listita);
         #listita tiene todos los elementos que recibiran valor         
         if (@listita>1){
              my $valor = uc(pop(@listita));
              if (not defined $valor) {
                  avgrav(
       "valor a asignar no definido para  \"$renglonori\" en cuadro $texto") 
	               unless $noerror;  
                next;
	      }; 
	      foreach (@listita) {  
                 $refcirc->{$texto}->{uc($_)} = $valor;

                 push(@{$refcirc->{"val$texto"}->{uc($_)}},$valor);
                push(@{$hash{uc($_)}},$valor);$cuantasdefi ++;
	      }
         } elsif (not $noerror) {
	   avgrav("\"$renglonori\" en "
	   . descripcion_nombre("O$texto", $refcirc->{cualobjcuadro})
	   . " no define nada") unless $noerror;
         }      
      }; #$renglonori
      # control de repetidos
      do{avgrav(
        "Elementos que han recibido más de un valor en cuadro $texto"); 
	  foreach my $key (sort keys %hash) {
            next if @{$hash{$key}} == 1;

            mensaje( "valores para  $key:\n" . ' ' x 35
	      .join ("\n" . ' ' x 35, @{$hash{$key}})); 
          };
      } if ($cuantasdefi > scalar keys %hash and not $noerror);
   } else { $refcirc->{$texto} = {};
   };
   #impr_datos(__LINE__.' Auxi', ['MEZCLA'], $refcirc);
   do {
    porparar1(173,$refcirc,'Definiciones incorrectas');
     }if $avisosgrav;      
   return 173;
 } #asignar_comp
# ---------------------------------------------------------------------------
sub ponerraya{
  #para poder atender las indicaciones de nodos como parte de nombre
  my $algo = $_[0];
  $algo=~ s/^\s*//;
  $algo=~ s/\s*$//;
  $algo=~ s/\s+/ /g;
  while ($algo =~ s/\-(.+)=/_$1=/){}; 
  $algo=~ s/,\s/___/;
  $algo =~ s/\((.*)\)(.*)=/__$1__$2=/; 

  return $algo;
}
# ---------------------------------------------------------------------------
sub sacarraya{
  my $algo = $_[0];
  #print "Auxi 98 sacarraya $algo ....";
  $algo =~ s/___/, /;
  $algo =~ s/__(.*)__(.*)=/($1)$2=/;
  while ($algo =~ s/_(.+)=/-$1=/){}; 
  #print " $algo\n";
  return $algo;
}
# ---------------------------------------------------------------------------
sub limpiar_comp{
   comfin("com limpiar, @_");
   #hace algunos cambios para evitar problemas y llama a Guar
   #como tipo devuelve algunos  definitivos: 
   # (algunos 'e' determinados sin ayuda de evaluar)
   # n a p e z
   #y tipos provisorios 
   # x ?
   my ($lisque,$ref) = @_; my @lisque = @$lisque;
   my $sepa = '[\(\)\+\-\*\/\,]';
   my $operparcoma = '[\(\)\+\-\*\/\,]\s*';
   my $todos = '[\(\)\+\-\*\/\,\w\s\.]';
   foreach my $que (@lisque) {
     my @liskeys= sort keys %{$ref->{$que}};
     # para poder agregar para una segunda vuelta
     foreach my $key (@liskeys) {    
       my $datoori = $ref->{$que}->{$key};
       #$datoori =~ tr/\t/ /; 
       #los \t ya están incluidos en \s (equiv. para diff -b)
       if ($que ne 'MEZCLA' and $que ne 'RESULTADOS' 
            and $datoori !~ /^$todos*$/) {
         avgrav("Símbolos no válidos en $key = $datoori");
          $ref->{'TIP' .$que}->{$key} = 'e';
	  next;
       }; 
       if ($datoori =~ /^\s*$/) {
          $ref->{'TIP' .$que}->{$key} = 'z';
	  next;
       }; 

       while ($datoori =~ s/^\(([^\(\)]+)\)$/$1/) {};
       #saca parentesis exteriores si adentro no los hay 
       
       $datoori =~ s/\s+($sepa)/$1/g; $datoori =~ s/($sepa)\s+/$1/g;
       #saca espacios que no revelan  errores 

       my $dato = $datoori;
       $dato =~ s/($operparcoma)X\w+\(/$1\(/g; #molestan las X.. interiores

       $dato = '(' . $dato. ')';

       $dato =~ s/($operparcoma)TEMP\s*\(\s*(\w+)\s*\)/$1TEMP&$2/ig;
       $dato =~ s/($operparcoma)TEMP\s*(\w+)\s*/$1TEMP&$2/ig;

       $dato =~ s/($operparcoma)FLUJO\s*\(\s*(\w+)\s*\)/$1FLUJO&$2/ig;
       $dato =~ s/($operparcoma)FLUJO\s*(\w+)\s*/$1FLUJO&$2/ig;

       $dato =~ s/&/_/g;  #   _ es un \w
       $dato =~ s/($operparcoma)\s*TIME\s*/$1TIEMPO/gi;
       $dato =~ s/($operparcoma)TABL[EA]\s*(\w+)\s*\(/$1T$2\(/gi;
       $dato =~ s/($operparcoma)E[CQ]UA[TC]ION\s*(\w+)\s*\(/$1Q$2\(/ig;
       $dato =~ s/($operparcoma)EXPRES{1,2}ION\s*(\w+)\s*\(/$1X$2\(/ig;

       #con el modificador g no consigo hacer lo que quiero
       while ($dato =~ s/\s+($operparcoma)/$1/){}; 
       while ($dato =~ s/($operparcoma) +/$1/) {};
       $dato =~ s/^\((.+)\)$/$1/;#saca parentesis agregados anteriormente 

       $dato =~ s/\*(\w)/\* $1/g; # para evitar ambiguedades 
       (my $valorcaret = $dato) =~ s/\*\*/^/g; 
       #todos los operadores seran de un solo simbolo 

       my $noparentm = '[^\(\)]+';

       while ($valorcaret =~ s/\($noparentm\)/w/g) {};
       # lo anterior elimine parentesis con algo adentro bien apareados


       if ($valorcaret eq 'w') {# habia parentesis exteriores eliminables 
           $dato =~ s/^\((.+)\)$/$1/; 
       }; 
       
      

       (my $valorminimo = $valorcaret) =~ s/$noparentm//;

       $ref->{$que}->{$key} = $dato;
     }; #$key  
   }; #$que  
   comfin('fin limpiar');
} #limpiar_comp
# ---------------------------------------------------------------------------
sub analice{
# para analizar archivos  .d y tambien .paraplot
  comfin('com analice',@_);
  my ($archivod,$refff,$ignorarsinigual) = @_;
  open ARCHIVO,$archivod or return;
  my @lista = <ARCHIVO>;
  @lista = grep ($_ !~ /^\s*\#/,@lista);
  close ARCHIVO;
  chomp @lista;
  my $listacual ={};
  my $cual = 'asig';
  if ($archivod =~ /\.d\d*$/) {
      $cual = 'nada';
      map( s/\;.*$//,@lista); 
  };
 ;# $cual valdra 'asige','listao','asigi,'asigq','listat','asigf' o 'nada'
  my $refasi = $refff->{$archivod} = {};
  my $lista = "lista0";
  foreach (@lista) {
    next if $_ =~ /^\s*$/;
    if (/^\s*;/) {
	next;
    } elsif (/^\s*ELEMENTS\s*$/ or /^\s*DEFINED\s*PARAMETERS\s*$/) { 
       $cual = 'asige';
    } elsif (/^\s*OUTPUTS\s*$/) {
      $cual = 'listao';
      push (@{$listacual->{lista}},$_);
    } elsif (/^\s*DEFINED\s*PARAMETERS\s*$/) {
      $cual = 'asige'
    } elsif (/^\s*INITIAL\s*CONDITIONS\s*$/) {
      $cual = 'asigi'; 
    } elsif (/^\s*FUNCTIONS\s*$/) {
      $cual = 'asige';
    } elsif (/^\s*T/ and $cual eq 'asige') {
      $cual ='listat';  s/\s/_/;
      push (@{$listacual->{listat}},$_);
    } elsif (/^\s*RUN/ or /^\s*RERUN/) {
      $cual = 'asigf';
    } elsif (/^\s*EQUATION/ or /^\s*Q/) {
      $cual = 'asigq';
      my $algo = $_;
      $algo = ponerraya($algo);
      push @{$listacual->{asig}},$_;
      push @{$refasi->{refvalores}->{MEZCLA}},$algo;
    } elsif (/^\s*END\s*$/) {
      $cual = 'nada';
    } elsif ( /echo/i) {
    } elsif (/ejes/i) {    
      s/=(.+)$/=listalis($1)/;
      push @{$refasi->{refvalores}->{MEZCLA}}, $_;
    } elsif (/nomostrar/i) {
      s/nomostrar(.*)$/nomostrar = listalis($1)/i;
      push @{$refasi->{refvalores}->{MEZCLA}}, $_;
    } elsif (/variaciones/) {
      $cual = 'asigv';
      push @{$refasi->{asigv}},$_;
    } else {
      #print 'Aux '.__LINE__," $cual, a guardar:  $_\n";
     if ($cual =~ /asig/) {
         my $algo = $_;
         $algo = ponerraya($algo);
	 push(@{$listacual->{asig}},$_);
         push(@{$refasi->{refvalores}->{MEZCLA}},$algo);
      } elsif ($cual eq 'listao'){
         my @listita = split(/\s*,\s*/,$_);
         push(@{$listacual->{listao}},@listita); 
      } elsif ($cual eq 'listat') {
         push(@{$listacual->{listat}},$_); 
      };
    }; 
  };
  my $outputs = $listacual->{listao};
  defined $outputs 
    and push @{$refasi->{refvalores}->{MEZCLA}}
              , "listao = " .join (',', @$outputs);
  my $tablas = $listacual->{listat};
  defined $tablas 
    and push @{$refasi->{refvalores}->{MEZCLA}} 
              , "listat = " .join (',',@$tablas);
  #print 'Aux '.__LINE__,' reff ', Dumper $refff; 
  my $coderr = asignar_comp('MEZCLA',$refasi,1);
  # el 1 final para que ignore renglones 
		 $coderr> 0 and print "en $archivod\n";
  #impr_datos(__LINE__.' Auxi fin analice', ['MEZCLA'], $refasi,'testeo');
  comfin('fin analice');
} #analice
# ---------------------------------------------------------------------------
sub analizar_todo{
   comfin('com analizar_todo',@_);
   my ($arch, $cod1, $cods, $cod2, $cod3) = @_;
   my $archSINDIA = $arch; $archSINDIA =~ s/\.dia$//;
   my $archd = "$archSINDIA.d";
   #print 'Aux '.__LINE__," $archd\n";
   my $reff = {};
   foreach my $ext ('d','paraplot') { #para despues comparar con los viejos
      my $archd = "$archSINDIA.$ext";
      #print 'Aux '.__LINE__," $archd\n";
      $reff->{$archd} = {};
      my $refd = $reff->{$archd};
      analice ($archd,$reff,0);
   }; 
   #print 'Aux ',__LINE__,' (.d .paraplot) ', Dumper $reff;
   my $refd ={}; my $refcaj = {};
   my $num = 1; 
   my $archd1 = "$archSINDIA.d$num";
   my $archcaj = "$archSINDIA.caj";
   my $archcaj1 = "$archSINDIA.caj$num";
   my $difest = '';
   my %codd = ('res'=>$cods,'simul'=>$cod2,'caj'=> 0);
   while (-e $archcaj1) { 
      system "rm $archSINDIA.difes 2>/dev/null";
      foreach my $ext ('res', 'simul', 'caj') {  
          my $cod = $codd{$ext};
          $difest .= ' ' . compara($archSINDIA, $num, $ext, $cod);
      }
      foreach my $ext('d', 'paraplot') {
        my $archd = "$archSINDIA.$ext";
        my $archd1 = "$archSINDIA.$ext$num";
        if (-e $archd and -e $archd1) {
           $reff->{$archd1} = {};
           analice($archd1,$reff,0);
           my $difes = compare($archd, $archd1,$reff);  
           $difest .= sprintf " %2s",  $difes;
        } elsif (not -e $archd and not -e $archd1) {
           $difest .= "  -"
	} elsif (not -e $archd) {
           $difest .= "  v"
	} elsif (not -e $archd1) {
           $difest .= "  n"
        };      
      };#foreach
      $num++;
      $archd1 = "$archd$num";
      $archcaj1 = "$archcaj$num";
      $difest .= ' ||';
   };# while
   comfin('fin analizar_todo');
   return $difest;
} #analizar_todo
# ---------------------------------------------------------------------------
sub compara{ # compara .caj, .res, .simul
  comfin('comfin compara',@_);
  my ($arch, $num, $ext, $cod) = @_;
  my $archSINDIA = $arch; $archSINDIA =~ s/\.dia$//;
  if ($cod < 10  and -e "$archSINDIA.$ext") {
      if (-e "$archSINDIA.$ext$num") {
          if ($ext eq 'res' or $ext eq 'simul') {
              system 
               "sed -e 's/INF/Infinite/g' <$archSINDIA.$ext >gnus/arch.$ext";
              system "sed -e 's/NAN/Nan/g' <gnus/arch.rxt >$archSINDIA.$ext"
                 if -e "gnus/arch.rxt"; 
          };
          my $diftext =
              `diff -b -B -i -I fecha $archSINDIA.$ext  $archSINDIA.$ext$num`;
          if (not  $diftext) {
	      return '0';
          } else {    
              return 'x';
          };
      } else  {
          return 'n';
      };
  } else {
      if( not  -e "$archSINDIA.$ext$num") {
          return '-'
      } else { 
          return 'v';
      };
  }; 
}
#----------------------------------------------------------------------------
sub compare{
   comfin('com compare',@_);
   my ($archivod,$archivod1,$refff) = @_;#se usa no solo para .d tambien
   # para .paraplot;
   if (not -e "$archivod" and not  -e "$archivod1") {
     return '-'
   } elsif (not -e $archivod) { 
       return 'v';
   } elsif (not -e $archivod1) { 
       return 'v'
   };
   my $print = 'print ';
   my %hash = ( %{$refff->{$archivod}->{MEZCLA}}
               ,%{$refff->{$archivod1}->{MEZCLA}});
   my $ref;  
   $ref->{MEZCLA} = \%hash; 
   limpiar_comp(['MEZCLA'],$ref);
   my $difes = 0;
   #imprhash("$archivod ", %{$refff->{$archivod}->{MEZCLA}});
   #imprhash("$archivod1 ", %{$refff->{$archivod1}->{MEZCLA}});
   foreach my $key (sort keys %hash) {
      my $keyigual = sacarraya("$key = ");
      my ($dato,$dato1) = ($refff->{$archivod}->{MEZCLA}->{$key} 
                           , $refff->{$archivod1}->{MEZCLA}->{$key});
     defined $dato1 and  $dato1 = sacarraya($dato1);
      defined $dato and  $dato = sacarraya($dato);
      if (not defined $dato) {
         $dato1 = paraimpr3puntos(40,$dato1);
         eval($print . "\"en $archivod1: $keyigual$dato1\n\"");$difes ++;
      } elsif (not defined $dato1) {
         $dato = paraimpr3puntos(40,$dato);
         eval($print . "\"en $archivod : $keyigual$dato\n\""); $difes ++;
      } else {
         (my $dato1_sinb = $dato1) =~ s/\s//g;
         (my $dato_sinb = $dato) =~ s/\s//g;
#para poder ignorar diferencias por. finales en numeros
#la comparacion es por caracters, no importa si deja de tener sentido
	 $dato_sinb =~ s/(\d)$/$1\./; $dato_sinb =~ s/(\d)(\W)/$1\.$2/;
	 $dato1_sinb =~ s/(\d)$/$1\./; $dato1_sinb =~ s/(\d)(\W)/$1\.$2/;
         if ($dato1_sinb ne $dato_sinb)  {
	    $dato = paraimpr3puntos(40,$dato);
	    $dato1 = paraimpr3puntos(40,$dato1);
            eval($print . "\"en $archivod : $keyigual$dato\""); $difes ++;
            eval($print . "\"en $archivod1: $keyigual$dato1\"");
         };
      };
   }; 	 
   if ($archivod =~ /paraplot$/) {
       my (@listad,@listad1); my $dif = 0;
      if (defined $refff->{$archivod}->{asigv}) {
         @listad = sort @{$refff->{$archivod}->{asigv}};
      };
      if (defined $refff->{$archivod1}->{asigv}) {
         @listad1 = sort @{$refff->{$archivod1}->{asigv}};
      };
      if (@listad - @listad1) {
          $difes += 10 ; # simplemente grande;
          print "En $archivod: ",    paraimpr3puntos(40,@listad);
          print "En $archivod1: ",    paraimpr3puntos(40,@listad1);
#          print join ("\n","en $archivod:", @listad
#                       ,"en $archivod1",@listad1,\"n");
      } else {
         for (my $i=0; $i < @listad; $i++) {
            if ($listad[$i] ne $listad1[$i])  {
               print "$listad[$i] en $archivod\n"; $difes ++;
               print "$listad1[$i] en $archivod1\n"; 
            };
        };
     };
   };
   #print 'Aux '.__LINE__," $difes\n";
   comfin('fin compare');
   return $difes;
} #compare 
#----------------------------------------------------------------------------
sub comparar_todo{
  comfin('com comparar_todo',@_);
  my ($refsim1, $refsceptre, $refsim2, $refsim3, @dirarray) = @_;
  if ($imprlog) {
      open COMPLOG,">simusol_comp.log";
      print COMPLOG
    "e         Comparación de archivos .res .simul .caj .d .paraplot 
e               'v' significa que sólo el viejo archivo existe;
e               'n' sólo el nuevo archivo existe 
e               '-' ninguno de los dos existe
e               'x' hay diferencias pero no se han contado;
f               '0' no hay diferencias esenciales 
f Cod. error|
f S1 Sc S2 S3|\n";
  };

  my $i=0;
  #impr_debug(__LINE__.' Auxi $refsceptre ', $refsceptre);
  my $COMPLOGS; 
  foreach my $archivo (@dirarray) {
      explic("Comparando para archivo $archivo");
      $i++; 
      my $archivosindia = $archivo; $archivosindia =~ s/\.dia$//;
      my $cod1 = $refsim1->{$archivo};
      my $cods = $refsceptre->{$archivosindia}; 
      my $cod2 = $refsim2->{$archivo};
      my $cod3 = $refsim3->{$archivo};
      defined $cods or $cods = $refsceptre->{$archivo}; 
      #defined $cods or $cods ='?';
      my $codigos = sprintf "g%3s%3s%3s%3s|", $cod1, $cods, $cod2, $cod3;
      if (-e "$archivosindia.caj1") {
	  my $difest = analizar_todo($archivo, $cod1, $cods, $cod2, $cod3);
          $difest eq '' and $difest = ' z z z  z  z ||';
          $COMPLOGS .= "$codigos Dif.gen.: $difest $archivo\n";
      } elsif (-e "$archivosindia.caj") {
          my $difest = '     n       ||';
          $COMPLOGS .= "$codigos Dif.gen.: $difest $archivo\n"; 
      } else {
	  $COMPLOGS .= "$codigos No corr.: sin los .caj*|| $archivo\n";
      };   
  };
  if ($imprlog) {
      print COMPLOG $COMPLOGS;
      print COMPLOG `date`; 
      close COMPLOG;
  } else {
      print $COMPLOGS;
  };
  comfin('fin comparar_todo');
  return '';
}
#----------------------------------------------------------------------------
sub backupear{
    my @extensiones = qw(.d  .caj  .paraplot  .res  .simul .lss1);
    foreach my $archtob (@_) {
      my $archtobSINDIA = $archtob; $archtobSINDIA =~ s/\.dia$//;
      next  unless -s "$archtobSINDIA.caj";
      my $n = 1;
      while (-e "$archtobSINDIA.caj$n"){$n++};
      foreach my $ext (@extensiones) {
         system  "cp $archtobSINDIA$ext $archtobSINDIA$ext$n" 
             if -e "$archtobSINDIA$ext";
      };
   };
   print 'Únicamente se hizo "backup"s de archivos 
       '. join(' ',@extensiones),"\n";
}
#----------------------------------------------------------------------------
1
