package Simusol::Desdexml;
#Para interpretar y adaptar XML
#usados por simusol1.pl
use Simusol::GlobalesSimusol;
use Simusol::TraAbrev;
use Simusol::Ayudas;
use Simusol::Elementos;
use Simusol::Algebraico;
use Simusol::Ampliaciones;
use Simusol::Auxiliares;
use Simusol::Controles;
use Simusol::Prograf;
use Simusol::Sceptre;
use Simusol::Tablasfuncq;
use Simusol::Topologia;
use Simusol::Tiempos;

use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
our %cuadro2clase = ('AGREGAR_GRAFICOS'=>'graficos'
                    ,'ARCHIVOS'=>'archivos'
                    ,'ARCHIVOS_COMPLEMENTARIOS'=>'compl'
                    ,'CONTROLES'=>'circuito'
                    ,'COMENTARIOS'=>'comen'
                    ,'DATOS'=>'circuito'
                    ,'DEFINICION'=>'modelo'
                    ,'DIAGRAMAS_COMPLEMENTARIOS'=>'compl'
                    ,'FUNCIONES'=>'funciones'
		    ,'GRAFICOS'=>'graficos'
                    ,'INICIALES'=>'circuito'
                    ,'PARAMETROS'=>'parametros'
                    ,'DPARAMETROS'=>'circuito'
                    ,'RESULTADOS'=>'circuitor'
                    ,'TABLAS'=>'tablasd'
                    ,'TABLAS_ARCHIVOS'=>'tablasa'
                    ,'TIEMPO'=>'circuito'
                    ,'UNIDADES'=>'unidades'
                    ,'USO_DEF'=>'elementos'
                    ,'USO'=>'modelo'
                   );
#cambie  CONTROLES y TIEMPO  porque CONTROLES lo parto en dos CONTR_NOTIEMPOS
# y TIEMPOS y TIEMPO lo mando a TIEMPOS
# en registrar_crudo, (en realidad duplico y luego descarto)
# a TIEMPOS le correspondera 'tiempos' y a CONTROLES 'circuito'

BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT = qw(&completar_traduccion_capas
                  &completar_traduccion_circ_mod
                  &continuar_traduccion 
                  &deszetar
                  &preparar_cuadros
                  &refinar_seleccion_archivos
                  &refinar_por_nombre
                  &traducir &traducirxml
                  &tratar_refvalores_USO_DEFINICION
	         );
};
END();
our @listaCORTOA;
# ---------------------------------------------------------------------------
sub cajear_crudo{
  comfin('comd cajear_crudo',@_);
  my ($reflay,$texto,$crudo) = @_;
  my $archivo = $reflay->{ARCHIVOCAPA};
  impr_debug(__LINE__.' Desd $archivo',$archivo);
  $CAJAS->{$ARCHIVOA} .= ' ' x 24 . " Cuadro   $texto\n"; 
  (my $cortof = $archivo) =~ s/$BASEARCHA//;
  if ($archivo ne $ARCHIVOA) {
#     $CAJAS->{$ARCHIVOA} .= "#                         (en archivo $cortof)\n";
      $CAJAS->{$ARCHIVOA} .=  "# (en archivo $archivo)\n"; 
 };
  $CAJAS->{$ARCHIVOA} .="$crudo\n";
  comfin('find cajear_crudo');
  return;
}#cajear_crudo 
# ----------------------------------------------------------------------------
sub completar_eles{
  comfin('comd completar_eles',@_);
  my ($ref, $refarchele, $reffalta_pcs, $reffalta_plantilla) = @_;
  #impr_debug(__LINE__.' Desd',Dumper $_[2]);
  #impr_debug(__LINE__.' Desd $reffalta_pcs', $reffalta_pcs);
  #impr_debug(__LINE__.' Desd $reffalta_plantilla}', $reffalta_plantilla);
  my @archeleposibles = @$refarchele; 
  impr_debug(__LINE__.' Desd @archeleposibles', \@archeleposibles);
  foreach my $plantilla (keys %{$reffalta_plantilla}) {
      my $nomplantilla = $nombreplantilla->[$plantilla];
      #impr_debug(__LINE__.' Desd $nomplantilla', $nomplantilla);
      push @archeleposibles, 
          conseguir_nombres_ele_mod_uni($ref,$nomplantilla,'ele');
  };
  impr_debug(__LINE__.' Desd @archeleposibles', \@archeleposibles);
  foreach my $archele (@archeleposibles) {
      if (defined $reffiele{$archele}) {
           next;
      } else {       
          my ($coderr)  = traducirsubxml($archele);     
          $coderr and do {porparar1($coderr,$ref); next};
          defined $reffiele{$archele}  or next;
      };
      my $refele = $reffiele{$archele};
      my @pcseles = keys  %{$refele->{tienepcs}};
      #impr_debug(__LINE__.' Desd @pcseles', [$archele,@pcseles]);
      my $ya = '';
      foreach (@pcseles) {
          $reffalta_pcs->{$_} and do{ $ya = 1; last};
      };
      not $ya  and  next;
      my $coderr = completar_traduccion_capas($archele,$reffalta_pcs); # eles
      $coderr and porparar1($coderr,$ref,$archele);
  };
  comfin('find completar_eles');
  return ;
}#completar_eles 
# ----------------------------------------------------------------------------
sub completar_traduccion_capas_elemod{
  comfin('comd completar_traduccion_capas_elemod', @_);
  my @capas = @_; my $coderr = '';
  foreach my $ilayer (@capas) {
      my $reflay = $reflayers[$ilayer];
      my $clasecapa = $reflay->{clasecapa};
      impr_debug(__LINE__.' Desd $ilayer,$clasecapa'
		 ,[$ilayer,$clasecapa]);
  };
  comfin('comd completar_traduccion_capas_elemod', $coderr);
  return $coderr;
 ; 
}#completar_eles 
# ----------------------------------------------------------------------------
sub conseguir_nombres_ele_mod {
  comfin('comd conseguir_nombres_ele_mod', @_);
  my ($ref,$nombrev,$ext,$modo) = @_; my $extra = '\w*'; 
  my ($largo2,$largo3);
  my $case = 'i'; 
  $case = '' if $modo;
  if ($ext eq 'ele') {
      $largo2 = 'elementos';$largo3 = 'elements';
  } elsif ($ext eq 'mod') {
      $largo2 = 'modelos'; $largo3 = 'models'
  } elsif ($ext eq 'uni') {
      $largo2 = 'unidades';$largo3 = 'elements' 
  } elsif ($ext eq '') {
      $largo2 = 'archivos'; $largo3 = 'files';
  };
    my $precomando = '/^$nombrev$extra\.{0,1}$ext'; my $comando;
  if ($ext ne '') {
     $comando = $precomando . '$/' . $case . '  or  ' 
              . $precomando . '\.dia$/' . $case;
  } else {
     $comando = $precomando . '$/' . $case ;
  };
  impr_debug(__LINE__.' Desd $nombrev $ext $largo2'
            ,[$nombrev, $ext, $largo2]);
  impr_ARCHIVOS(__LINE__.' Desd');
  my $BASEARCH = $ref->{BASEARCH};
  # se trabaja, si es posible, con el nombre propio 
  # (del mismo directorio que el circuito)
  my @lugares = ($BASEARCH,"$BASEARCH/$largo3/","$HOME/.simusol/$largo3/"
      ,"$HOME/share/simusol/$largo3/","/usr/local/share/simusol/$largo3/"
           ,"/usr/share/simusol/$largo3/");  
  my @lista;
  foreach my $lugar (@lugares) {
      if (-d $lugar) {
          opendir TRABAJO, $lugar or die " No pude abrir $lugar";
          my @dirarray = readdir TRABAJO; closedir TRABAJO;
          @dirarray = grep (do {eval($comando)},@dirarray);
          map( $_ = "$lugar$_",@dirarray);
          push @lista,@dirarray;
      };
  };
  explic("Buscamos definición de $largo2  $nombrev (mayúsc. o minúsc) en:\n"
       . join ("\n",@lista) )
       if (@lista);
  comfin('find conseguir_nombres_ele_mod', @lista);
  return @lista;
}#conseguir_nombres_ele_mod
# ----------------------------------------------------------------------------
sub continuar_traduccion{  
  comfin('comd continuar_traduccion', @_);
  my ($archivo,$numfile) = @_; my $coderr = '';
  impr_refall(__LINE__.' Desd'); 
  my $refarch = $refarchers[$numfile];
  ($ARCHIVOA,$BASEARCHA,$PROPIOA,$PROPIOASIN,$CORTOA,$CORTOASIN) 
    = @{$refnombres[$numfile]}{
	'archivo','BASEARCH','PROPIO','PROPIOSIN','CORTO','CORTOSIN'};
  my $PROPIOSINGUARDAR = $PROPIOASIN;
  if ($refarch->{clasearch} eq 'circuito' and $opt_hash{todas}) {
      my $agre = $opt_hash{todas}; $agre =~ s/\s+/_/g;
      $PROPIOSINGUARDAR .= $agre;
  };
  $refnombres[$numfile]->{PROPIOSINGUARDAR} = $PROPIOSINGUARDAR;
  impr_ARCHIVOS(__LINE__.' Desd');
  impr_debug(__LINE__.' Desd $reffes',[$refarch,$refall]);
  if ($refarch->{lisobjcuadrosdescon}) {
      mensajear(
          "==== CUIDADO ==== : si cambió algún nombre de cuadro sin querer,  
              puede recibir mensajes de error incomprensibles");     
  };
 impr_debug(__LINE__.' Desd $refall->{cualobjele}',Dumper $refall->{cualobjele});
  comfin('find continuar_traduccion', $coderr);
  return $coderr;
}#continuar_traduccion
# ---------------------------------------------------------------------------
sub controlar_eles_nodos_repetidos{
  comfin('comd controlar_eles_nodos_repetidos',@_);
  my ($refarch) = @_; 
  my ($coderr1,$coderr2,$coderr) = ('','','');
  my (@repetidoseles,@repetidosnodos,@objseles,@objsnodos);
  foreach my $ele (keys %{$refarch->{cualobjele}} ) {
      if (scalar @{$refarch->{cualobjele}->{$ele}} >1) {
          foreach my $obj (@{$refarch->{cualobjele}->{$ele}}) {
	      push @repetidoseles,descripcion_objeto($obj);
              push @objseles,$obj;
          };
      };
  };
  foreach my $nodo (keys %{$refarch->{cualobjtextonodo}} ) {
     next if $nodo eq '0';
     my @objs = @{$refarch->{cualobjtextonodo}->{$nodo}};
     @objs = grep(do {$codlista->[$_] eq 'N'},@objs);
     if (@objs >1) {
	 foreach my $obj (@objs) {
	     push @repetidosnodos,descripcion_objeto($obj) ;
             push @objsnodos,$obj;
         };
     };
  };
  if (@repetidoseles) {
      @objseles = sort @objseles;
      unshift  @repetidoseles
        ," Hay elementos con identificación repetida; objetos: @objseles";
      mensajear ( join ("\n",sort @repetidoseles)) if @repetidoseles;
      $coderr1 = 1;
  };
  if (@repetidosnodos) {
      @objsnodos = sort @objsnodos;
      unshift @repetidosnodos
        ," Hay nodos con identificacion repetida; objetos: @objsnodos;
         Sólo uno puede ser simple ";
      mensajear ( join ("\n",sort @repetidosnodos)) if @repetidosnodos;
      $coderr2 = 1
  };
  comfin('find controlar_eles_nodos_repetidos',$coderr);
  ($coderr1 or $coderr2) and $coderr = 247;  
return $coderr;
}#controlar_eles_nodos_repetidos
# ----------------------------------------------------------------------------
sub desagrupar{
  comfin('comd desagrupar');
  #se da la referencia a la lista arbolada y cada grupo que contenga, se
  # sustituye por su lista de agrupados
  my $ref=$_[0];
  # imprlisarb("lisantes",$ref);
  # impr_debug(__LINE__.' Desd desagrupar $ref antes', $ref); 
  my $nuevo = $ref->[1];
  # impr_debug(__LINE__.' Desd desagrupar $nuevo antes ', $nuevo); 
  my $indice=selec0("dia:group",$nuevo); 
  # impr_debug(__LINE__.' Desd desagrupar $indice',$indice);
  while ($indice>0) {
      my @lisobj=@{$nuevo->[$indice+1]};
      splice(@lisobj,0,3);
      splice(@{$nuevo},$indice,2,@lisobj);
      $indice=selec0("dia:group",$nuevo);
      # impr_debug(__LINE__.' Desd desagrupar $indice',$indice);
  };
  # impr_debug(__LINE__.' Desd desagrupar $nuevo despues ', $nuevo);
  @$ref = ($ref->[0],@$nuevo);
  # impr_debug(__LINE__.' Desd desagrupar $ref despues',$ref);
  comfin('find desagrupar');
  return '';
}#desagrupar
# ---------------------------------------------------------------------------
sub determinar_clase_capa {
  comfin('comd determinar_clase_capa',@_);
  my ($reflay,$ilayer) = @_;
  my $refgraf = $refgrafers[$ilayer];
  #se supone que no vienen juntos mas de uno entre 
  # 'elementos', 'modelo', 'circuitod'
  my ($clase,$coderr) = ('','');
  impr_debug(__LINE__.' Desd reflay cualnumclasenum $ilayer '.$ilayer
    ,Dumper $reflay->{cualnumclasenum});
  my (%hashclase,%hashclasegr);
  %hashclase = %{$reflay->{cualnumclasenum}} if $reflay->{cualnumclasenum};
  impr_debug(__LINE__.' Desd  %hashclase $ilayer '.$ilayer
    ,Dumper \%hashclase);
  %hashclasegr =  %{$refgraf->{hashclasegr}} if $refgraf->{hashclasegr};
  impr_debug(__LINE__.' Desd $refgraf->{hashclasegr}'
	     , Dumper  $refgraf->{hashclasegr});
  if ($hashclase{elementos} and $hashclase{modelo}){
      $coderr = 230;
      porparar1($coderr,$reflay
         ," Una capa no puede definir elementos y modelos simultáneamente");
      return $coderr;
  };
  if ($hashclase{elementos}) { 
     if ($hashclasegr{iconos}) {
          # se ignoraran cuadros(parc o todo) que choquen
          $clase = 'elementos';
          push @{$refall->{cualcapaele}},$ilayer;
          push @{$refall->{capasele}},$ilayer;
     } else {mensajear(" Faltan iconos para completar cuadros 'USO_DEF'");
          $clase = 'nada'
     };
  } elsif ($hashclase{modelo}) {
      if ($hashclasegr{iconosT}) {
           # se ignoraran cuadros(parc o todo) que choquen
           $clase = 'modelo';
           push @{$refall->{cualcapamod}},$ilayer;
           push @{$refall->{capasmod}},$ilayer;
      } else {mensajear(
		  " Faltan iconos para completar cuadros USO y DEFINICION");
           $clase = 'nada'; 
     };
  } elsif ( 
     $hashclase{circuito} or $hashclase{circuitor} or $hashclase{parametros}
      or $hashclase{tiempos} or $hashclase{controles}) {
      $clase = 'circuito';
      push @{$refall->{capascir}},$ilayer;
  } elsif ($hashclase{graficos}) {
      push @{$refall->{capasgra}},$ilayer;
      $clase = 'graficos'; 
  } elsif ($hashclase{funciones} or $hashclase{tablasd} 
	     or $hashclase{tablasa} or $hashclase{unidades}) {
      $clase = 'complementario';
  } elsif ($hashclase{compl}) {
      push @{$refall->{capasDIAGR}},$ilayer;
      $clase = 'compl';
  } elsif (scalar keys %hashclasegr) {
      $clase = 'circuitogr';
  } else {
      $clase = 'nada';
  };
  impr_debug(__LINE__.' Desd $clase',$clase);
  $clase !~ /elementos|modelo|circuito|graficos|nada/
     and push @{$refall->{capasresto}},$ilayer; 
  if ($clase ne 'nada') {
      push @{$refall->{capas}},$ilayer;
      $reflay->{clasecapa} = $clase;
      my $numfile = $reflay->{numfile};
      $refarchers[$numfile]->{clasearch} = $clase;
  };  
  impr_refall(__LINE__.' Desd');
  comfin('find determinar_clase_capa',$coderr,$clase);
  return $coderr,$clase;  
}#determinar_clase_capa
# ---------------------------------------------------------------------------
sub elegir_principal{# sin argumentos
  comfin('comd elegir_principal',@_);
  my ($coderr,$mensaje) = ('','');
  my @archs = @{$refall->{archivos}}; 
  impr_debug(__LINE__.' Desd @archs',\@archs);
  my ($numcapaPRINCIPAL,$reflayPRINCIPAL);
 # impr_debug(__LINE__.' Desd $refall',Dumper $refall);
  impr_refall(__LINE__.' Desd');
  my @capaselemod = (@{$refall->{capasele}},@{$refall->{capasmod}});
  my @capasDIAGR = @{$refall->{capasDIAGR}};
  if (@{$refall->{capascir}}) {
      $numcapaPRINCIPAL = $refall->{capascir}->[0];
      $reflayPRINCIPAL = $reflayers[$numcapaPRINCIPAL];
      if (@{$refall->{capascir}} > 1) { 
          foreach my $numcapa (@{$refall->{capascir}}) {
              my $archcapa = $reflayers[$numcapa]->{ARCHIVOCAPA};
              if ($archcapa ne $PRINCIPAL) {
                  push @{$refall->{capasnosirven}},$numcapa;
                  $numcapa = undef;
              }; 
          };
          @{$refall->{capascir}} = grep (defined $_, @{$refall->{capascir}});
          if (@{$refall->{capasnosirven}}) {
              my $stringarch = $PRINCIPAL;
              foreach my $numcapa (@{$refall->{capasnosirven}}) {
                  $stringarch 
                    .= "\n   ".$nombrefile->[$reflayers[$numcapa]->{numfile}];
              };
              $mensaje=" Queda más de un archivo para simular:\n   $stringarch
               Interrumpimos la traduccion";
              mensajear ($mensaje);
              $coderr = 253;
              comfin('find elegir_principal linea $coderr',__LINE__,$coderr); 
              return $coderr;  
          };
      };
  } elsif (@capasDIAGR) {
      $numcapaPRINCIPAL = $capasDIAGR[0];
  } elsif (@capaselemod) {
      $numcapaPRINCIPAL = $capaselemod[0];
  } elsif (@{$refall->{capasgra}}) {
      $numcapaPRINCIPAL = $refall->{capasgra}->[0];
  } elsif (@{$refall->{capasresto}}) {
      $numcapaPRINCIPAL = $refall->{capasresto}->[0];
  } else {
      $NUMPRINCIPAL = undef;
      $CLASEPRINCIPAL = 'nada';
      $mensaje = "No hay diagrama para simular";
  };
  if (defined $numcapaPRINCIPAL) {
      my $reflayPRINCIPAL = $reflayers[$numcapaPRINCIPAL];
      impr_debug(__LINE__.' Desd reflayPRINCIPAL',Dumper $reflayPRINCIPAL);  
      $NUMPRINCIPAL = $reflayPRINCIPAL->{numfile};
      $PRINCIPAL = $refnombres[$NUMPRINCIPAL]->{ARCHIVO};
      $CLASEPRINCIPAL = $reflayPRINCIPAL->{clasecapa};
      impr_debug(__LINE__.' Desd $NUMPRINCIPAL,$PRINCIPAL,$CLASEPRINCIPAL'
	     ,[$NUMPRINCIPAL,$PRINCIPAL,$CLASEPRINCIPAL]);
  };
  comfin('find elegir_principal,linea $coderr',__LINE__,$coderr); 
  return $coderr;  
}#elegir_principal
# ---------------------------------------------------------------------------
sub eliminar_capa{
  comfin('comd eliminar_capa',@_);  
  my ($ilayer,$clase)= @_; my $coderr = '';
  my $reflay = $reflayers[$ilayer];
  my ($numfile,$archivo) = @$reflay{'numfile','ARCHIVOCAPA'};
  my $refarch = $refarchers[$numfile];
  #@{$refarch->{capas}} = grep ($_ != $ilayer,@{$refarch->{capas}}); 
  #se marca como eliminada, pero no se borra de {capas}
  impr_debug(__LINE__.' Desd $archivo',$archivo);
  map(do{$laylista->[$_] == $ilayer and $codlista->[$_] = 'z'}
      ,(1..@$codlista-1));
  #  'z' codigo para objetos borrados
  push @{$reftrabajo->{$archivo}->{viejasclases}}, $clase;
  impr_debug(__LINE__.' Desd viejasclases'
         ,$reftrabajo->{$archivo}->{viejasclases});
  $reflayers[$ilayer]->{eliminada} = 1; 
  my $descr_capa = descripcion_capa($ilayer);
  if ($descr_capa eq '()') {# era la unica capa
      $PRINCIPAL = $archivo; $CLASEPRINCIPAL = 'nada';
      aprontar('',$PRINCIPAL,'',$CLASEPRINCIPAL);
      mensajear(" No quedo nada util del diagrama");
      $coderr = 7;
      parar1($coderr,$refarch);
  } else {
      mensajear(" Ignoramos la $descr_capa");
  };
  comfin('find eliminar_capa',$coderr);
  return $coderr;
}#eliminar_capa
#------------------------------------------------------------------------------
sub interpretar_archivos_complementarios{
  comfin('comd Interpretar_archivos_complementarios',@_);
  #Archivos de texto que pueden contener parte o toda la informacion
  #textual de un diagrama de clase circuito
  my ($ilayer,$corto) = @_; my $mensaje = '';
  my $reflay = $reflayers[$ilayer];
  my $refarch = $refarchers[$reflay->{numfile}];
  my %valores = %{$reflay->{refvalores}->{ARCHIVOS_COMPLEMENTARIOS}};
  foreach my $numobj (keys %valores) {
      my @archivos = @{$valores{$numobj}}; 
      foreach my $arch (@archivos) {
          my $archbue = $arch;
	  $archbue =~ /^\// or $archbue = $refarch->{BASEARCH} . $archbue;
          -e $archbue or do{avnoseent("No existe el archivo\n         $arch");
               next;
	  };
          my $texto = `cat $archbue`;
          my @renglones;my $refrenglones = \@renglones; 
          (my $mensaje,$refrenglones)
             = depurar_crudo($texto);# en int.arch.compl
	  $mensaje and mensajear("$mensaje;\n    en $archbue"); 
#          impr_debug(__LINE__.' Desd @renglones',\@renglones); 
          while (@renglones) {
              my $cuadro = shift @renglones;
              if ($cuadro =~ /^cuadro\s*(\S+)/i) {
                  my $que = $locale{uc($1)}; 
                  $refarch->{hashCUADROS}->{$que} = 1;
	          $CAJAS->{$corto}  .= ' ' x 10
			      . " Cuadro   $que #(en $arch)\n"; 
                  while (@renglones) {
                       my $ren = shift @renglones;
                       if ($ren =~ /^cuadro/i) {
                           unshift @renglones, $ren;last;
                       };
		       $CAJAS->{$corto} .= "$ren\n";
                       push @{$reflay->{refvalores}->{$que}->{$numobj}}, $ren; 
                       push @{$refarch->{refvalores}->{$que}->{$numobj}},$ren; 
                  };
		  push @{$refarch->{USAARCHIVOS}}, $arch;
              } else {
                  avnoseent("En el archivo \n           $arch,
                       debe haber un primer renglón indicando  CUADRO .....
                       en lugar de \"$cuadro\"");
	          @renglones = ();
              };
          };#while @renglones
      }; #foreach my $arch
  }; #foreach my $numobj
  comfin('find Interpretar_archivos_complementarios');
  return '';
}# interpretar_archivos_complementarios 
# ---------------------------------------------------------------------------
sub llevar_a_refarchs{#sin argumentos
  comfin('comd llevar_a_refarchs',@_);
  my %clase2donde = ('circuito'=>'capascir','graficos'=>'capasgra'
                    ,'elementos'=>'capasele','modelo'=>'capasmod'
		    ,'complementario'=>'capasresto');
  impr_refall(__LINE__.' Desd');
  impr_debug(__LINE__.' Desd %refboxes',Dumper \%refboxes);
  my @capas = @{$refall->{capas}};
#  impr_debug(__LINE__.' Desd$refall @capas',Dumper \@capas);
  foreach my $numcapa (@capas) {
      my $reflay = $reflayers[$numcapa];
      my $numfile = $reflay->{numfile};
      my $clasecapa = $reflay->{clasecapa};
      $clasecapa !~ /elementos|modelo/ and $numfile = $NUMPRINCIPAL;
      my $refarch = $refarchers[$numfile];
      my $arch = $refnombres[$numfile]->{ARCHIVO};
#      push @{$refarch->{capas}},$numcapa;
      my $refgraf = $refgrafers[$numcapa];
      if ($clasecapa
         =~ /circuito|graficos|elementos|modelo|complementario/) {
           push @{$refarch->{$clase2donde{$clasecapa}}},$numcapa;
      };
      if ($clasecapa =~ /circuito|elementos|modelo|circuitogr/) {
         llevar_refvalores($reflay,$refarch);
         if ($refgraf->{hashclasegr}) {
             llevar_refgraf_refarch($numcapa,$numfile);  
             llevar_iconos($numcapa,$refarch);
         };
      } else {
          llevar_refvalores($reflay,$refarchers[$NUMPRINCIPAL]);
          llevar_iconos($numcapa,$refarchers[$NUMPRINCIPAL]);
      };
  };
  my $refarch = $refarchers[$NUMPRINCIPAL];
  llevar_FUNCIONES_refarchs();
  llevar_TABLAS_refarchs();
  impr_debug(__LINE__.' Desd $refarch->{capas} ',Dumper $refarch->{capas});
  comfin('find llevar_a_refarchs');
  return;
}#llevar_a_refarchs;
# ---------------------------------------------------------------------------
sub llevar_FUNCIONES_refarchs{
  comfin('comd llevar_FUNCIONES_refarch',@_);
  my $refarch = $refarchers[$NUMPRINCIPAL]; 
  foreach my $func (keys %{$refall->{sobreFUNCIONES}}) {
      my $numobj = $refall->{sobreFUNCIONES}->{$func}->[0];
      my $refcuadro = $refboxes{$numobj};
      my $numcapa = $refcuadro->{numcapa};
 #     my $numfile = $reflayers[$numcapa]->{numfile};
     copiar_datos($refcuadro,'FUNCIONES',$func
           ,$refarch,'FUNCIONES',$func);
  };
  impr_datos(__LINE__.' Desd refarchPRINCIPAL',['FUNCIONES']
    ,$refarchers[$NUMPRINCIPAL]);   
  comfin('find llevar_FUNCIONES_refarch');
}#llevar_FUNCIONES_refarch;
# ---------------------------------------------------------------------------
sub llevar_TABLAS_refarchs{
  comfin('comd llevar_TABLAS_refarch',@_);
  my $refarch = $refarchers[$NUMPRINCIPAL];
  foreach my $Tidtabla (keys %{$refall->{sobreTABLAS}}) {
      impr_debug(__LINE__.' Desd refall->{sobreTABLAS}->{$Tidtabla}'
        ,Dumper $refall->{sobreTABLAS}->{$Tidtabla});
      my %hash = %{$refall->{sobreTABLAS}->{$Tidtabla}};
      my $numcapa  = $hash{numcapa};
      my $reflay = $reflayers[$numcapa];
      impr_datos(__LINE__.' Desd $reflay',['TABLAS'],$reflay);
      foreach my $key (@{$reflay->{listaTABLAS}}) {
          copiar_datos($reflay,'TABLAS',$key
		       ,$refarch,'TABLAS',$key);
      };
      foreach my $key (@{$reflay->{listaZPARAMETROS}}) {   
          copiar_datos($reflay,'ZPARAMETROS',$key
		       ,$refarch,'ZPARAMETROS',$key);
      };
      defined $reflay->{sobreTABLAS}->{$Tidtabla} and
        $refarch->{sobreTABLAS}->{$Tidtabla}
          = copiar_valor($reflay->{sobreTABLAS}->{$Tidtabla});
#        %{$refarch->{sobreTABLAS}->{$Tidtabla}}
#          = %{$reflay->{sobreTABLAS}->{$Tidtabla}};
      impr_debug(__LINE__.' Desd refarch->{sobreTABLAS}->{$Tidtabla}'
        ,Dumper $refarch->{sobreTABLAS}->{$Tidtabla});
  };
  impr_datos(__LINE__.' Desd',['TABLAS'],$refarch);  
  comfin('find llevar_TABLAS_refarchs');
}#llevar_TABLAS_refarchs;

# ---------------------------------------------------------------------------
sub llevar_refgraf_refarch{
  comfin('comd llevar_refgraf_refarch',@_);
  my ($numcapa,$numfile) = @_;
  my $refgraf = $refgrafers[$numcapa];
  impr_debug(__LINE__.' Desd $refgraf',Dumper $refgraf);
  impr_debug(__LINE__.' Desd keys %refgraf',[sort keys %$refgraf]); 
  my $refarch = $refarchers[$numfile];
  foreach my $key1 (qw(enganches lughandles cualobjtextonodo)) {
      foreach my $cosa (keys %{$refgraf->{$key1}}) {
          push @{$refarch->{$key1}->{$cosa}},@{$refgraf->{$key1}->{$cosa}}; 
      };
  };
  foreach my $key1 (qw(tieneplantilla tienepcs)) {
     foreach my $cosa (keys %{$refgraf->{$key1}}) {
         not $refarch->{$key1}->{$cosa} and
             $refarch->{$key1}->{$cosa} = $refgraf->{$key1}->{$cosa};
     };
  };
  foreach my $key1 (qw( lisobjelemTs lisobjnodos lisramascrudas )) {
      push @{$refarch->{$key1}}, @{$refgraf->{$key1}} if $refarch->{$key1};
  };
# objobj   
  impr_debug(__LINE__.' Desd $refarch',Dumper $refarch); 
  comfin('find llevar_refgraf_refarch');
  return;
}#llevar_refgraf_refarch';
 
# ---------------------------------------------------------------------------
sub llevar_refvalores{
  comfin('comd llevar_refvalores',@_);
  my ($reflay,$refarch) = @_;
#  impr_debug(__LINE__.' Desd reflay->refvalores',Dumper $reflay->{refvalores});
  foreach my $cuadro (keys %{$reflay->{refvalores}}) {
      next if $cuadro eq 'COMENTARIOS';
      foreach my $numobj (keys %{$reflay->{refvalores}->{$cuadro}}) {
#          impr_debug(__LINE__.' Desd $reflay'
#             ,Dumper $reflay->{refvalores}->{$cuadro}->{$numobj}); 
          @{$refarch->{refvalores}->{$cuadro}->{$numobj}}
            = @{$reflay->{refvalores}->{$cuadro}->{$numobj}};
#          impr_debug(__LINE__.' Desd $refarch'
#             ,Dumper $refarch->{refvalores}->{$cuadro}->{$numobj}); 
       };  
   };
#   impr_debug(__LINE__.' Desd $refarch->{refvalores}'
#	      ,Dumper $refarch->{refvalores});
  comfin('find llevar_refvalores');
}#llevar_refvalores
# ---------------------------------------------------------------------------
sub llevar_iconos{
  comfin('comd llevar_iconos',@_);
  my ($numcapa,$refarch) = @_;
  my $reflay = $reflayers[$numcapa]; 
  my $refgraf = $refgrafers[$numcapa];
#  impr_debug(__LINE__.' Desd $refarch', Dumper $refarch);
#  impr_debug(__LINE__.' Desd $reflay', [sort keys %$reflay]);
#  impr_debug(__LINE__.' Desd $reflay', Dumper $reflay);
#  impr_debug(__LINE__.' Desd $refarch', [sort keys %$refarch]);
  foreach my $cod ('C','L') {
      push @{$refarch->{"lista$cod"}}, @{$refgraf->{"lista$cod"}}
          if $refgraf->{"lista$cod"};
  };
  foreach my $algo (qw(cualobjmod tienemodeloparTpcs tienepcs 
                       ELESPLANT uniuni objobj)) {
      next unless defined $refgraf->{$algo};
      foreach my $key (keys %{$refgraf->{$algo}}) {
          $refarch->{$algo}->{$key} = $refgraf->{$algo}->{$key};
      };
  };
  foreach my $algo (qw(lisobjtodos lisobjnodos lisobjelems lisobjelemTs)) {
      next unless $refgraf->{$algo} and @{$refgraf->{$algo}};
      impr_debug(__LINE__.' Desd $refgraf '.$algo,Dumper $refgraf->{$algo});
      push @{$refarch->{$algo}}, @{$refgraf->{$algo}};
      impr_debug(__LINE__.' Desd $refarch '.$algo,Dumper $refarch->{$algo});
 };
  impr_debug(__LINE__.' Prog NODOSPLANT', Dumper $refgraf->{NODOSPLANT});
  foreach my $algo (qw(NODOSPLANT cualobjtextonodo cualobjele)) {
      next unless  $refgraf->{$algo}; 
      foreach my $key (keys %{$refgraf->{$algo}}) {
          push @{$refarch->{$algo}->{$key}}, @{$refgraf->{$algo}->{$key}};
      };
  };
  if ($refgraf->{NODOSPLANT}) {
      foreach my $numplant (keys %{$refgraf->{NODOSPLANT}}) {
          foreach my $obj (@{$refgraf->{NODOSPLANT}->{$numplant}}) {
              my $nodo = $textolista->[$obj];
              $refarch->{TIPOTOK}->{$nodo} = 'm';
          };
      };
  };  
#  impr_debug(__LINE__.' Desd $refarch',Dumper $refarch);
#  comfin('find llevar_iconos linea ',__LINE__);
  return '';
}#llevar_iconos
# ---------------------------------------------------------------------------
sub llevar_ramas{
  comfin('comd llevar_ramas',@_);
  my ($reflay,$refarch) = @_;
  comfin('find llevar_ramas',@_);
}#llevar_ramas
# ---------------------------------------------------------------------------
sub marcar_coment_sceptre{
  comfin('comd marcar_coment_sceptre',@_);
# se usa junto con ubicar_coment_sceptre; con juntar_por_   entre ellos
# para que posibles simbolos luego del ;  no interfieran
  my @listain = @_; 
  #impr_debug(__LINE__.' Desd com marcar @listain',Dumper \@listain);
  my @coment;
  foreach (@listain) {
      if (s/\s*;\s*(.+)$/&/) {
          push @coment,$1;
      };
  };
  #impr_debug(__LINE__.' Desd com marcar @coment',Dumper \@coment);
  impr_debug(__LINE__.' Desd com marcar @listain',Dumper \@listain);
  comfin('find marcar_coment_sceptre $refcoment,@listout'
    ,@coment,'||',@listain);
  return \@coment,@listain; 
}#marcar_coment_sceptre
# ---------------------------------------------------------------------------
sub mejorar_crudo{
  comfin('comd mejorar_crudo',@_);
  my ($texto,$refcrudo) = @_; my $coderr = '';
  my @crudo =  @$refcrudo;
  my @crudoin = @crudo;
  if ($texto =~ /^(TABL|ARCH|FUNCION|DATOS|PARAM|INIC|CONT|RESULTADOS|TIEMPO)/
     or  $texto =~ /^(GRAFICO|AGREGAR_GRAFICO)/) {
      impr_debug(__LINE__.' Desd @crudo antes de marcar',\@crudo); 
      (my $refcoment,@crudo) = marcar_coment_sceptre(@crudo);
      impr_debug(__LINE__.' Desd @crudo luego de marcar',\@crudo);
      impr_debug(__LINE__.' Desd $refcoment',$refcoment);
      ($coderr, @crudoin)
         = juntar_por_signos_y_paren('',@crudo);# en mejorar_crudo;
          # no siempre se guarda el resultado
      $coderr and push @MENSAJES,$coderr; 
      impr_debug(__LINE__.' Desd $coderr',$coderr);
      impr_debug(__LINE__.' Desd @crudoin luego de juntar',\@crudoin);
      if ($texto eq 'TIEMPO') {
          my $crudo = join (' ',@crudoin);
          impr_debug(__LINE__.' Desd $crudo',$crudo);
          while ($crudo =~ s/&,/,/) {
          };
          impr_debug(__LINE__.' Desd $crudo',$crudo);
          @crudoin = ($crudo);
          @$refcoment = (join (';  ',@$refcoment));
      };
      impr_debug(__LINE__.' Desd $refcoment',Dumper $refcoment);
      impr_debug(__LINE__.' Desd @crudoin antes ubicar',\@crudoin); 
      not $coderr and @crudoin = ubicar_coment_sceptre($refcoment,@crudoin);
      impr_debug(__LINE__.' Desd @crudoin luego ubicar',\@crudoin); 
  };
  impr_debug(__LINE__.' Desd @crudoin',Dumper \@crudoin);
  comfin('find mejorar_crudo',$coderr,@crudoin);
  return $coderr,\@crudoin;
}#mejorar_crudo 
# ----------------------------------------------------------------------------
sub mejorar_lugar{
  #recibe referencia a hash con key 'val'....
  #lo que sigue simplfica, corta decimales de la coordenadas de un string 
  #lugares
  my $lug = sprintf ("(%.1f, %.1f)",split(/,/,$_[0]->{val}));
  return $lug; 
}#mejorar_lugar
# ----------------------------------------------------------------------------
sub modelos_requeridos{
  comfin('comd modelos_requeridos',@_);
  my $ref = $_[0]; my $coderr = '';
  my ($reffalta_modelo,$reffalta_nombre) = ({},{});
  foreach my $il (@{$ref->{capas}}) {
      my $reflay = $reflayers[$il];
      foreach my $numobj (keys %{$reflay->{refvalores}->{DATOS}}) {
          $coderr = '';
          my @renglones = @{$reflay->{refvalores}->{DATOS}->{$numobj}};
	  impr_debug(__LINE__.' Desd @renglones',Dumper \@renglones);
          (my $coderr,@renglones) = juntar_por_signos_y_paren('',@renglones);
          if ($coderr) {
              $coderr = 241;
              porparar1($coderr,$ref);
              next;
	  };
          impr_debug(__LINE__.' Desd $ref->{cualobjmodelo}'
                , Dumper  $ref->{cualobjmodelo});
	  impr_debug(__LINE__.' Desd @renglones',Dumper \@renglones);
          foreach my $renglon (@renglones) {
              next if $renglon =~ /^s*;/;
              $renglon =~ s/^(\w+)\s*,/$1=/;
	      impr_debug(__LINE__.' Desd $renglon', $renglon);
             my @partes = split /\s*=\s*/, $renglon;
              if ($partes[0] =~ /^(T\w+)\s*/i
                   and  $partes[-2]=~ /^(T\w+)\s*/i) {
	              my $obj = $ref->{cualobjmodelo}->{uc($1)};
                      defined $obj or do{
			  explic(" Falta un icono para el modelo $1");
                          parar1(250,$ref);
                      };
                      my $pcs
                         = $plantillalista->[$obj].'c'.$shapelista->[$obj];
                      $partes[-1] =~ s/^\s*,//;
                      my @partecitas = split /\s*,\s*/, $partes[-1];
                      my $nombre = uc($partecitas[0]);
                      $reffalta_modelo->{$pcs}->{$nombre} = 1;
                      $reffalta_nombre->{$nombre} = 1;
	       } elsif ($partes[0] =~ /^(T\w+)\s*/i) {
                  parar1(66,$ref,
                    "En cuadro DATOS hay renglones mezcados\n $renglon\n
             quizás se pegaron renglones que terminaban erroneamente en coma");

	      }; #if
          };
      };
  };
  #impr_debug(__LINE__.' Desd $reffalta_nombre', Dumper $reffalta_nombre);
  comfin('find modelos_requeridos');
  return $reffalta_modelo,$reffalta_nombre; 
}#modelos_requeridos
# ----------------------------------------------------------------------------
sub ordenar_nodos{
   my ($obj,@listanodosfull) = @_;
   my @listanodosord=();my %hash; my @otro_orden;
   my $shapeobj = $nombreshape->[$shapelista->[$obj]];   #if ($shapeobj eq 'modelo') {
       for (my $i = 0; $i < @orden_nodos_mod; $i ++) {
           my $bueno = $orden_nodos_mod[$i];
           my $objnodo =  $listanodosfull[$bueno];
           defined $objnodo and push @listanodosord, $objnodo or
           push @listanodosord, 'x';  
       };
   #} else {
   #    @listanodosord = @listanodosfull
   #};
   @listanodosord = grep($_ ne 'x', @listanodosord);
   map ($_ = $textolista->[$_],@listanodosord); 
   my $unibue = join ('-',@listanodosord); 
   return $unibue; 
}#ordenar_nodos
# ----------------------------------------------------------------------------
sub partir_refgraf{ # en relacion a cualobjele y cualobjtextonodo 
  #separa lo correspondiente a capas de clase elementos o modelo
  # y deja en $refall el resto
  comfin('comd partir_refgraf');
  # impr_debug(__LINE__.' Desd $refarch', [sort keys %$refarch]);
  my $refgraf = {};
  impr_debug(__LINE__.' Desd $refgraf', [sort keys %$refgraf]);
  if ((not defined $refall->{capasele} or  @{$refall->{capasele}} == 0) and
      (not defined $refall->{capasmod} or  @{$refall->{capasmod}} == 0))  {
  } else { 
      foreach my $capa (@{$refall->{capas}}) {
          my @objeles = grep (do {$laylista->[$_] == $capa},(1..@$laylista-1));
          impr_debug(__LINE__.' Desd @objeles',\@objeles); 
          foreach my $objele (@objeles) {
              my $cod = $codlista->[$objele];
              my $texto = $textolista->[$objele];
              if ($cod =~ /$codelemTs/) {
                  $refgraf->{reflay}->{cualobjele}->{"$cod$texto"}
	            = $refgraf->{cualobjele}->{"$cod$texto"};
                  delete $refgraf->{cualobjele}->{"$cod$texto"};
              } elsif ($cod =~ /^[Nnt]$/) {  
                  $refgraf->{reflay}->{cualobjtextonodo}->{$texto}
                    = $refgraf->{cualobjele}->{"$cod$texto}"};
                  delete $refgraf->{cualobjele}->{"$cod$texto"};
              };          
          };
      };
  };
  comfin('find partir_refgraf');
  return ''; 
}#partir_refgraf
# ----------------------------------------------------------------------------
sub preparar_para_modelos {
  #determina los archivos que pueden proveer los modelos requeridos y aumenta 
  #$reffalta_pcs y $reffalta_plantilla 
  comfin('comd preparar_para_modelos',@_);
  my ($ref, $refarchmod, $reffalta_plantilla
       , $reffalta_modelo, $reffalta_nombre) = @_;
  my $coderr= '';
  my @archmodposibles = @$refarchmod;
  foreach my $nombrev (sort keys %$reffalta_nombre) {
      push @archmodposibles,
            conseguir_nombres_ele_mod_uni($ref,$nombrev,'mod');
  };
  my @archmodrevisados;
  #impr_debug(__LINE__.' Desd @archmodposibles', \@archmodposibles);
  foreach my $archmod (@archmodposibles) {
      $coderr= '';
      my $refm = $reffimod{$archmod}; 
      if (defined $refm) {
          $refm->{clasearch} eq 'modelo' or next;
      } else {
          $coderr  = traducirxml($archmod);     
          $coderr and do {porparar1($coderr,$refm); next};
          defined $reffimod{$archmod} or do{
              mensajear ("$archmod no dfine un modelo");   
          };
          my $rfm = $reffimod{$archmod}; 

          my $posible ='';
          my @pcsmodelos = keys %{$refm->{tienemodelo}};
          impr_debug(__LINE__.' Desd @pcsmodelos',\@pcsmodelos );
          impr_debug(__LINE__.' Desd $refm',$refm->{tienemodelo} );
          @pcsmodelos == 1 or 
	      do {$coderr = 242;
              porparar1($coderr,$refm
             , "Aquí debe aparecer un solo tipo de ícono de modelo");
	       next;
          };
          foreach my $pcsmodelo  (@pcsmodelos) {
              defined $reffalta_modelo->{$pcsmodelo} and
              do {$posible = 1}               
          };
          $posible or next;
      }; 
      my (@modelos, @idens);
      foreach my $il (@{$refm->{capas}}) {
          my $reflay = $reflayers[$il]; 
          foreach my $numobj (keys %{$reflay->{refvalores}->{USO}}) {
              my @renglones = @{$reflay->{refvalores}->{USO}->{$numobj}};
              ($coderr,@renglones) = juntar_por_signos_y_paren('',@renglones);
              if ($coderr) {
		  $coderr = 243;
                  porparar1($coderr,$refm);
                  next;
              };
              map (do 
                {/\s*(T\w+)\s*=\s*(\w+)/ and $reffalta_nombre->{uc($2)} and
		 push @idens,$1 and push @modelos, uc($2)}, @renglones);
          };
      };
      impr_debug(__LINE__.' Desd @modelos, @idens',[@modelos, @idens]);
      @modelos or next;
      for (my $j = 0; $j < @modelos; $j++) {
           my $iden  = $idens[$j]; my $nombre = $modelos[$j]; 
           my $obj = $refm->{cualobjmodelo}->{uc($iden)};
           my $pcs = $plantillalista->[$obj].'c'.$shapelista->[$obj];
           if ($reffalta_modelo->{$pcs}->{$nombre}) {
               push @archmodrevisados, $archmod; 
               delete $reffalta_modelo->{$pcs}->{$nombre};
               #delete $reffalta_nombre->{$nombre};
           } else { 
               delete $idens[$j]; delete $modelos[$j];
           }; 
 
      };
      @modelos = grep ( defined $_, @modelos);
      @modelos or next;
      foreach my $plantilla (keys %{$refm->{tieneplantilla}}) {
          $reffalta_plantilla->{$plantilla} = 1;
          # Toma unidades. TERCERO, de los archivos de modelos
	  not defined $ref->{DEFIUNI}->{$plantilla} and
             defined $refm->{refvalores}->{UNIDADES} and
	  do {definir_UNIDADES($refm,'TERC'); #TERCERO de los modelos
              delete $refm->{refvalores}->{UNIDADES};
	  };
      };
      map (do { scalar keys %{$reffalta_modelo->{$_}}
             or delete $reffalta_modelo->{$_}} , keys %$reffalta_modelo);
      scalar keys %$reffalta_modelo or last;
  }; #
  impr_debug(__LINE__.' Desd $reffalta_modelo', Dumper $reffalta_modelo);
  map (do { scalar keys %{$reffalta_modelo->{$_}}
             or delete $reffalta_modelo->{$_}} , keys %$reffalta_modelo);
  scalar keys %$reffalta_modelo and do {
      $coderr = 248;
      my @cuales = keys %$reffalta_modelo;
      my $mensaje = "Faltan definiciones para modelos:
          @cuales";
      comfin('find preparar_para_modelos', $coderr,$ref,$mensaje);
      return $coderr, $ref,$mensaje;
  };
  comfin('find preparar_para_modelos', @archmodrevisados);
  return $coderr, \@archmodrevisados;
}#preparar_para_modelos
# ---------------------------------------------------------------------------
sub refinar_por_nombre{# lo usa simusol1.pl y Desdexml cuando le llegan archivos
  comfin('comd refinar_por_nombre',@_);
  my ($base,@archivosori) = @_;
  my (@archivos,@descartarnombres,@descartarext);
  foreach (@archivosori){
      impr_debug(__LINE__.' Desd $_,$base',[$_,$base]);
      (my $coderr,$_)  = compl_archivo($_,$base);
      if ($coderr) {
	  push @descartarnombres,$_;
      } else {
          push @archivos,$_;
          impr_debug(__LINE__.' Desd',"complete archivo $_");
      };
  };
  if (@descartarnombres) {
      my $descartados = "\n      " .join "\n      ",@descartarnombres;
      explic(
       " Se han descartado nombres no apropiados para archivos: $descartados");
  };
  @descartarext = grep ($no_ext{$_}, @archivos);
  if (@descartarext) {
      my $descartados = "\n      " .join "\n      ",@descartarext;
      explic(
    "Simusol no acepta como diagramas (extension reservada para otros fines): "
	  ."$descartados");
  };
  @archivos = grep (do{not $no_ext{$_}}, @archivos);
  @archivos = grep (do{ not $_ =~ /\~$/},@archivos);
  comfin('find refinar_por_nombre',@archivos);
  return @archivos;
}#refinar_por_nombre
# ---------------------------------------------------------------------------
sub refinar_seleccion_archivos{ # lo usa simusol1.pl cuando le llegan
# los archivos
  # se descartan los archivos que pueden ser producidos y los que
  #podrian dar problemas
  comfin('comd refinar_seleccion_archivos',@_);
  my @archivos = @_;
  my (@procesar, @procesarsindia,@malos, @descartar);
  foreach my $arch (@archivos) {
      (my $archsindia = $arch) =~ s/\.dia$//;
      my $archcondia = "$archsindia.dia";
      impr_debug(__LINE__.' Desd $archcondia, $archsindia'
        ,[$archcondia,$archsindia]);
      if (-d $archcondia or -d $archsindia) {
          push @malos, $archcondia,$archsindia;
          impr_debug(__LINE__.' Desd @malos',\@malos);
      } elsif (-e $archcondia  and -e $archsindia) { 
          push @malos, $archcondia,$archsindia;
          impr_debug(__LINE__.' Desd @malos',\@malos);
     } elsif (-e $archcondia) {
	 $arch = $archcondia;
          push @procesar, $arch; push @procesarsindia,$archsindia;
      } elsif (-e $archsindia) {
          $arch = $archsindia;
          push @procesar, $arch; push @procesarsindia,$archsindia;
      } else {
          push @descartar,$arch;
      };
  };
  impr_debug(__LINE__.' Desd @malos,@descartar,@procesar'
    ,[@malos,'||',@descartar,'||',@procesar]);
  if (@malos) {
      my $malos = "\n" . "\n      " .join "\n      ",@malos;
      parary(251,"Simusol no trabaja bien con dos o mas archivos 
      que difieren solamente en tener o no la extensión .dia: $malos"); 
  };
  if (@descartar) {
      my $descartados = "\n      " .join "\n      ",@descartar;
      explic(
  "Se han descartado archivos (no existen o no son diagramas): $descartados");
  };
  if (@procesar == 0) {
      mensajear (" No quedaron mas archivos para analizar"); 
  };
  @procesar = union_conorden(@procesar);
  @procesarsindia= union_conorden(@procesarsindia);
  comfin('find refinar_seleccion_archivos',@procesar,'||',@procesarsindia);
  return \@procesar,\@procesarsindia;
}#refinar_seleccion_archivos
# ---------------------------------------------------------------------------
sub registrar_crudo{
# registra en {refvalores} o en {complem}
  comfin('comd registrar_crudo', @_);
  my ($reflay,$texto,$Tidtabla,$crudo,$ij) = @_; my $coderr = '';
  my $numobj = "\#numobj$ij";
  my @crudo; my $refcrudo = \@crudo;
  my @crudoout; my $refcrudoout = \@crudoout;
  if ($crudo) {
      impr_debug(__LINE__.' Desd $crudo',$crudo);
      my ($mensaje,$refcrudo) = depurar_crudo($crudo);#en registrar_crudo
      $mensaje and mensajear("$mensaje;\n    en " .descripcion_cuadro($numobj)); 
      @crudo = @$refcrudo if $refcrudo;
      if ($texto eq 'ARCHIVOS_COMPLEMENTARIOS') {
          tratar_1ARCHIVOS_COMPLEMENTARIOS($reflay,$ij,$crudo);
      } else {
          ($coderr,$refcrudoout) = mejorar_crudo($texto,$refcrudo);
          impr_debug(__LINE__.' Desd $refcrudoout', Dumper $refcrudoout);
          if ($coderr) {
              if ($texto =~/^(DATOS|PARAM|INICIALES)/) {
                  mensajear (" error ($coderr) en
              @crudo
             ". descripcion_cuadro($numobj) ."; se ignora el cuadro");
                  @{$reflay->{lisobjO}}
                    = grep($_ ne $numobj,@{$reflay->{lisobjO}});  
              } else {
                  my $agre ='';
		  if (@$refcrudoout == 0) {
                      $agre = ";                           No quedo nada";
                  };
                  mensajear("error ($coderr) en
             ". descripcion_cuadro($numobj). $agre); # en reg._crudo;
		  @$refcrudoout and $coderr = '';
              };
          };
          if (not $coderr) {
#             impr_debug(__LINE__.' Desd $texto',$texto); 
             if ($cuadro2clase{$texto} =~/funciones|tablas|unidades/) {
	          $reflay->{complem}->{$texto}->{$numobj} = $refcrudoout;
             } else {
                  $reflay->{refvalores}->{$texto}->{$numobj} # en reg._crudo
	            = $refcrudoout;
                  $error_cuadros{$texto} = ''; 
              };
          };
      };
  };
  comfin('find registrar_crudo',$coderr,@$refcrudoout);
  return $coderr,$refcrudoout;
}#registrar_crudo
# ----------------------------------------------------------------------------
sub selec{
   # en una lista arbolada dada por su referencia, $ref
   # busca el índice (y lo retorna o retorna 0 si no)
   # para el comienzo del primer nodo basico
   # con tag igual  $tagbuscada, y con key $conkey y valor $valorkey
   my ($tagbuscada,$conkey,$valorkey,$ref)=@_;
   my @lista=@$ref;  
   for (my $ii=1; $ii<@lista -1; $ii += 2) {
      #podria empezarse con $i=3 y aumentar de 4, si seguro prettyprint?
        $lista[$ii] eq $tagbuscada
     &&	 $lista[$ii+1][0]{$conkey} eq  $valorkey
     &&  return $ii
   };
   return 0 
}#selec
# ----------------------------------------------------------------------------
sub selec0{
   # en una lista arbolada dada por su referencia,
   # busca el índice (y lo retorna o retorna 0 si no)
   # para el comienzo del primer nodo basico
   # con tag igual al tag buscado
   my ($tagbuscada,$ref)=@_;
   my @lista=@$ref;
 #  impr_debug( __LINE__.' Desd selec0 la lista',$ref);  
   for (my $ii=1; $ii<@lista -1; $ii += 2){
       #podria empezarse con $i=3 y aumentar de 4
       #si estuvieramos seguros del pretty print
        $lista[$ii] eq $tagbuscada
     && do {
            return $ii}
   };
   return 0 
}#selec0
# ----------------------------------------------------------------------------
sub selectags{
  # en una lista de arboladas, dada por su referencia, y en su primer nivel,
  # busca los elementos con un tag igual al buscado;
  # devuelve una lista, por sí,
  # con las referencias a las listas arboladas correspondientes.
  comfin('comd selectags', @_);
  my ($tagbuscado, $refla)=@_;
  my @lisarb=@$refla;
  impr_debug(__LINE__. ' Desd selectags @lisarb',scalar @lisarb.' partes');
  my $hash=shift @lisarb;
  my @listaref=();
   while (my @ele=splice (@lisarb,0,2)){
#        impr_debug(__LINE__. ' Desd selectags',\@ele);
       if ($tagbuscado eq $ele[0]) {
           if ($tagbuscado eq 'dia:layer') {
               my $reflayer = [$ele[0],$ele[1]];
 #              impr_debug(__LINE__.' Desd selectags'
 #                ." $tagbuscado ", scalar @$reflayer.' cosas');
               desagrupar($reflayer);
 #              impr_debug(__LINE__.' Desd selectags'
 #                ." $tagbuscado ", scalar @$reflayer.' cosas');
           };
	   push (@listaref, $ele[1]);
      };
 };   
 comfin('find selectags');
 return @listaref;
}#selectags
# ----------------------------------------------------------------------------
sub string{
  # en una lista arbolada dada por su refencia,
  # busca el string correspodiente  a un "dia:attribute"
  # con valor para  "name" dado 
  my ($valor,$ref)=@_;
  my @lista = @$ref;
  my $texto='&';
  my $j=selec("dia:attribute", "name",$valor,$ref);
  $j or return $texto;
  my $jj=selec("dia:composite","type","text",${$ref}[$j+1]);
  $jj or return $texto;
  my $jjj=selec("dia:attribute","name","string",${$ref}[$j+1][$jj+1]);
  $jjj or return $texto;
  my $jjjj=selec0("dia:string",${$ref}[$j+1][$jj+1][$jjj+1]);
  $jjjj or return $texto;    
  $texto=${$ref}[$j+1][$jj+1][$jjj+1][$jjjj+1][2];
  $texto=~s/^\#\s*([.]*)/$1/;  
  $texto=~s/([.]*)\s*\#$/$1/;
      # si se usa una sola sentencia para limpiar a ambos 
      # lados, los de más de un renglon no se limpian 
            #  el . no puede representar un fin de línea
  return $texto;
}#string
# ---------------------------------------------------------------------------
sub traducir{
  comfin('comd traducir',@_);
  my ($refarchivos,$refarchivossin) = @_;
  my @archivos = @$refarchivos; my @archivossin = @$refarchivossin;
  $curdirori =`pwd`;chomp $curdirori; $curdirori .= '/';
  $reflayers[0] = {'numfile' => 0,'numcapa' => 0};
  my ($coderr, $mensaje, $clase,$no_hay_archivos)  = ('','','',1);
  my $base = $curdirori;
  for my $arch (@archivos) {#$arch es nombre completo
      my $archsin = shift @archivossin;
      not -e $arch and $arch = $archsin; 
      impr_refall(__LINE__.' Desd');
      impr_debug(__LINE__.' Desd @refarchers',Dumper \@refarchers);
      contab_archivo($arch);
      my $coderr = traducirxml($arch);
      impr_debug(__LINE__.' Desd @refarchers',Dumper \@refarchers);
      impr_refall(__LINE__.' Desd');
      if ($refall->{cualnumclasenum}->{compl}) {
          $base = $refnombres[-1]->{BASEARCH}; 
          while (@{$refall->{cualnumclasenum}->{compl}}) {
              my $numobj = shift @{$refall->{cualnumclasenum}->{compl}};
              my ($refmasarchivos,$refmasarchivossindia)
                = tratar_DIAGRAMAS_COMPLEMENTARIOS($numobj,$base);
              push @archivos,@$refmasarchivos,@$refmasarchivossindia;
          };
      };
      not $coderr and $no_hay_archivos = '';
      my $numfile = $cualfile->{$arch}; my $refarch = $refarchers[$numfile];
      $no_hay_archivos and parar1(250,0);
      if (not $coderr and scalar keys %{$refall->{hashclasegr}}) {
          my @capas = @{$refarch->{capas}};
          my $clasearch = $refarch->{clasearch};
          $coderr = controlar_nodos_simples_dobles($refarch) 
            unless $clasearch =~ /elementos|modelo/;
          not $coderr and $coderr = tratar_conex($refarch);
          if ($coderr) {
              foreach my $numcapa (@capas) {
                  porparar1($coderr,$reflayers[$numcapa]);
                  eliminar_capa($numcapa,'circuitor');
              };
              $coderr = 0; 
              next;             
          };
          if ($clasearch eq 'elementos' or $clasearch eq 'modelo') {
              foreach my $ilayer (@{$refarch->{capasele}}) {
                  my $coderr = '';
                  my $reflay = $reflayers[$ilayer];
                  ($coderr,my @mensajes)
                    = controlar_iconos_ele($refarch,$ilayer,$reflay);
                  if (@mensajes) {
                      unshift @mensajes,descripcion_capa($ilayer);
                      unshift @mensajes," Hubo problema con los iconos de la";
                      my $mensaje = join "\n",@mensajes;
                      mensajear($mensaje);
                  }; 
                  if ($coderr) {
                      porparar1($coderr,$reflay);
                      eliminar_capa($ilayer,'elementos'); 
                  };
                  $coderr= 0; 
              };
              impr_debug(__LINE__.' Desd $refarch->{cualcapaclase}'
	        ,$refarch->{cualcapaclase});
              impr_debug(__LINE__.' Desd $refarch->{sobreformulas}'
                , Dumper $refarch->{sobreformulas}); 
              if ($refarch->{capasmod}) {
                  foreach my $capa (@{$refarch->{capasmod}}){
                      tratar_capa_mod($capa);
                  };
              };
          } else {
              $clasearch eq 'nada' and parar1(7,$refarch);
          };
      };
      $refarch->{mensajes} = \@MENSAJES;
      @MENSAJES = ();
  };
  $coderr = elegir_principal();
#  impr_debug(__LINE__.' Desd @refarchers',Dumper \@refarchers);
  if (not defined $NUMPRINCIPAL) {
      $coderr = 7;
  };
  if ($coderr) {
      comfin('find traducir,linea ',__LINE__,$coderr);
      parar1($coderr,0);
  };
  if (@{$refall->{capascir}}) {
      llevar_a_refarchs();
      impr_debug(__LINE__.' Desd $NUMPRINCIPAL,$PRINCIPAL,$CLASEPRINCIPAL'
	     ,[$NUMPRINCIPAL,$PRINCIPAL,$CLASEPRINCIPAL]);
      llevar_UNIDADES_refarch();
  };
  impr_refes(__LINE__.' Desd');
  controlar_our();
  my $refarch = $refarchers[$NUMPRINCIPAL];
  $refarch->{clasearch} = $CLASEPRINCIPAL;
  impr_debug(__LINE__.' Desd @refarchers/',Dumper \@refarchers);
  comfin('find traducir,linea ',__LINE__,$coderr);
  return $coderr
}#traducir
# ---------------------------------------------------------------------------
sub traducirxml{
  comfin('comd traducirxml', @_); #puede terminar, por error, sin aviso fin
  #$archivo es nombre completo de archivo
  my $archivo = $_[0];
  (my $archivosindia = $archivo) =~ s/\.dia$//;
  my ($coderr,$codcirc,$mensaje) = ('','',''); my @mensajes;
  explic("Traduciendo el archivo $archivo");
  $ARCHIVOA = $archivo; 
  ($CORTOA = $archivo) =~ s/^$curdirori//;
  my ($refarch,$refgraf);
  impr_debug(__LINE__.' Desd $cualfile',Dumper $cualfile);
  my $numfile = $cualfile->{$archivo};
  impr_debug(__LINE__.' Desd $numfile', $numfile);
  if (defined $numfile) {
      $refarch = $refarchers[$numfile];
      if ($refarch->{clasearch}) {
           # signififica que ya ha sido traducido el archivo con anterioridad
           # en este proceso
           $coderr = -1;
           comfin('find traducirxml','linea coderr',__LINE__,$coderr);
           return $coderr;
      };
  } else {
      $numfile = scalar @$nombrefile;
      push @{$refall->{archivos}},$numfile;
      push @$nombrefile, $archivo;
      $cualfile->{$archivo} = $numfile;
      $refarch = {'numfile' => $numfile};
      $refarchers[$numfile] = $refarch;
   };
  $reftrabajo->{$archivo} = $refarch; 
  impr_refall(__LINE__.' Desd');
 #  impr_refes(__LINE__.' Desd');
 #  impr_ARCHIVOS(__LINE__.' Desd');
  my $p = XML::Parser->new(Style=>'Tree');
  my $doc;
  eval{$doc=$p->parsefile($archivo)};
  print STDERR $@,"\n";
  $@ eq '' or # quizas está comprimido,que es el modo natural de Dia
  do {$coderr = system "zcat $archivo >$gnusdir/llll 2>/dev/null";  
      $coderr and 
      do{mensajear(" $archivo no es un buen archivo XML ni es comprimido;
                  no es un archivo de Dia");
         $coderr = 250; porparar1($coderr,$refarch);
         comfin('find traducirxml','linea coderr',__LINE__,$coderr);
         return $coderr;
      };
      eval{$doc=$p->parsefile("$gnusdir/llll")};
      $@ eq '' or
        do{ $coderr = 251; porparar1($coderr,$refarch, 
           " $archivo no es el compr. de un archivo XML:
                  no es un archivo de Dia");
            comfin('find traducirxml','linea coderr',__LINE__,$coderr);
            return $coderr;
	};
  };
  $doc->[0] eq "dia:diagram" or 
  do {$coderr = 252; porparar1($coderr,$refglobal
           ,"No es un \"dia:diagram\"",$archivo );
      comfin('find traducirxml','linea coderr',__LINE__,$coderr);
      return $coderr;
  };#do       
  my $diagrama=$$doc[1];  #ref. a lista de listas arboladas 
  #imprlisarb(__LINE__.' Desd  diagrama ',$diagrama);
  my @refcaps = selectags("dia:layer",$diagrama); 
  if ($refall->{lisobjcuadrosdescon}) {
      my @objs = @{$refall->{lisobjcuadrosdescon}};
      push @mensajes 
        , " Se ignoran los cuadros con texto ident. desconocido:";
      map (do {push @mensajes,descripcion_cuadro($_)},@objs);
  };
  @{$refdias[$numfile]} =  @refcaps;
  ($coderr) = tratar_capas($refdias[$numfile],$numfile);
   comfin('find traducirxml','linea coderr',__LINE__,$coderr);
   return $coderr;
}#traducirxml
# ---------------------------------------------------------------------------
sub traducir_objetos{
  comfin('comd traducir_objetos', @_); #de una capa de archivo
  my ($refl,$ilayer) = @_;
  my $reflay = $reflayers[$ilayer];
  my $numfile = $reflay->{numfile};
  my $refgraf = $refgrafers[$ilayer];
#  impr_debug(__LINE__.' Desd $reflay,$refgraf,$refall',[$reflay,$refgraf,$refall]);
  my @refobjes=selectags("dia:object",$refl);
  my $coderr = '';
  # $rrDia referencia a array para un objeto de Dia (en su archivo)
  # $ij mumero de objeto para Simusol 
#  impr_debug(__LINE__.' Desd $cualplantilla',$cualplantilla);
#  impr_debug(__LINE__.' Desd $cualshape',$cualshape);
  impr_debug(__LINE__.' Desd @objes',scalar @refobjes.' objetos');
  my (@objign,@noident);;
#  impr_debug(__LINE__.' Desd %cuadro2clase',Dumper \%cuadro2clase);   
  foreach my $rrDia (@refobjes) {
      my ($coder,$clase) = ('','');
      my $ij = scalar @$codlista; #nunca vale 0
      my $j = selec('dia:attribute','name','obj_pos',$rrDia);
      my $jj = selec0('dia:point',$rrDia->[$j+1]);
      my $lugar = mejorar_lugar($rrDia->[$j+1][$jj+1][0]);
      my $fileobj = $rrDia->[0]->{id}; 
      $fileobj =~ s/^O(\d*)/$1/ or do {
          my $archivo = $reflay->{ARCHIVOCAPA};
          $coderr = 253;
          porparar1($coderr,$refglobal,"¿Objeto en $lugar con Id=$fileobj ? 
          el diagrama ha sido modificado!",$archivo);
          last;
      };
      $Dia2Simusol[$numfile]->{$fileobj} = undef;
      $Simusol2Dia[$numfile]->{$ij} = $fileobj;
      my $type = $rrDia->[0]->{type};
      my $textito = uc(string('text',$rrDia));
      # los posibles \n en el diagrama aparecen como espacios
      $textito =~  s/^\s*(.+)\s*$/$1/;
      $textito =~ s/\s+/ /g;
      #para iconos sin texto, la sub string devuelve '&'
      # textito es '', solo para iconos con textbox que no ha recibido nada
      my ($sheet,$shape) = ('descon','descon');
      ($sheet,$shape) = ($1,$2) if $type =~ /(.+) - ([^-]+)$/; 
      impr_debug(__LINE__.' Desd $sheet,$shape',[$sheet,$shape]);
      if ($sheet eq 'descon' or $shape eq 'descon')  {
          push @objign,[$type,$lugar,'sintaxis',$textito]; next;   
      };
      my $numplantilla = $cualplantilla->{$sheet};
      if (not defined $numplantilla) {
	  push @objign,[$type,$lugar,'plantilla',$textito]; next;
      };
      my $numshape =  $cualshape->{$shape};
      if (not defined $numshape) {
          push @objign,[$type,$lugar,'shape',$textito]; next;
      };
      my $pcs = $numplantilla . 'c' . $numshape; 
      impr_debug(__LINE__.' Desd $sheet,$shape,$pcs',[$sheet,$shape,$pcs]);
      impr_debug(__LINE__.' Desd $pcs,$refglobal->{refcodigos}->{$pcs}'
		 , [$pcs,$refglobal->{refcodigos}->{$pcs}]);
      if (not defined  $refglobal->{refcodigos}->{$pcs}) {           
          my $nump = $cualplantilla->{"Viejos$sheet"};
          if (defined  $refglobal->{refcodigos}->{$nump . 'c' . $numshape}) {
              push @objign ,[$type,$lugar,'obsoleto',$textito];
              $coderr = 251;
          } else { 
              push @objign, [$type,$lugar,'pcs',$textito];
              $coderr = 252;
          };  
          next; 
      };
      my ($cod,$codvalor) = @{$refglobal->{refcodigos}->{$pcs}};
      impr_debug(__LINE__.' Desd $cod,$codvalor,$pcs',[$cod,$codvalor,$pcs]);
      if ($cod eq 'A') {
          next;
      } elsif (defined $cod and $cod =~ /$codcontexto/ and $textito eq '') {
          push @noident, [$type,$lugar];
          next;
      };
      $Dia2Simusol[$numfile]->{$fileobj} = $ij;
      agregar_objeto($reflay,$refgraf,$ij, $cod, $textito, $codvalor
		    , $numplantilla, $numshape, $ilayer, $lugar,$numfile);
#      $cod ne 'O' and push @{$refgraf->{capas}},$ilayer;
      #$fileobj el numero identificatorio de objeto que aparece en el archivo
      #$ij  numero de orden de encuentro de objeto en  Simusol
      # con $Dia2Simusol se convierte numero de objeto
      #  dentro del diagrama  a numero de objeto dentro del simusol 
      ($coder,$clase) = tratar_cod($reflay,$ij,$shape,$rrDia,$refgraf);
      impr_debug(__LINE__.' Desd $coder',$coder);
      scalar keys %{$reflay->{refvalores}} or delete $reflay->{refvalores}; 
  }; # foreach ...@refobjes
#  impr_debug(__LINE__.' Desd $refgraf',Dumper $refgraf);
  if (@objign) {
      my $descr_capa = descripcion_capa($ilayer);
      $descr_capa eq '()' and $descr_capa = '' or 
        $descr_capa = "   en $descr_capa";
      my @mensajes = 
	  (" Se han ignorado formas que no son utiles para Simusol");
      push @mensajes, $descr_capa if $descr_capa;
      foreach my $refcuaterna (@objign) {
	  my ($type,$lugar,$causa,$textito) = @$refcuaterna;
          $causa eq 'sinident' and $causa = 'icono no identificado'
 #           or $causa eq 'texto' and 
 #              $causa = "texto $textito solo util como comentario"
	    or $causa eq 'obsoleto' and do {
	        $causa = 'Simusol ya no lo usa';
                $textito and $causa .= "; ident:  $textito";
	     }
             or $causa eq 'plantilla'and $causa = 'No se reconoce la plantilla'
             or $causa eq 'pcs' and
                $causa
                   = 'No se reconoce la combinacion de plantilla con forma';
          push @mensajes,"         $type, en $lugar, $causa";
      };
      my $mensaje = join "\n",@mensajes;
      mensajear($mensaje);
  };#if @objign
  if (@noident) {
      my @mensajes =  (" Se ignoran iconos o cuadros, aceptables para Simusol"
	  .", pero sin identificacion");
      foreach my $refpar (@noident) {
          my ($type,$lugar) = @$refpar;
          push @mensajes,"       $type, en $lugar";
      };
      my $mensaje = join "\n",@mensajes;
      mensajear($mensaje);
  };               
  my @objetos = (1..scalar @$codlista-1);
  impr_objs(__LINE__.' Desd @objetos',$refgraf,'',[$ilayer],\@objetos);
  my @objelems = grep do{$codlista->[$_] =~/$codelemTs/},@objetos;
  my @objnodos = grep do{$codlista->[$_] =~/$codnodos/},@objetos;
  impr_objs(__LINE__.' Desd ELEMS luego de traducir_objetos'
	    ,$refgraf,'',[$ilayer],\@objelems) if @objelems;
  impr_objs(__LINE__.' Desd NODOS luego de traducir_objetos'
	    ,$refgraf,'',[$ilayer],\@objnodos) if @objnodos;
  my @objramas = grep do{$codlista->[$_] =~/$codramas/},@objetos;
  impr_objs(__LINE__.' Desd RAMAS luego de traducir_objetos'
	    ,$refgraf,'',[$ilayer],\@objramas) if @objramas;
  impr_ramas(__LINE__.' Desd',$refgraf,1) if @objramas;
#  impr_debug(__LINE__.' Desd $refgraf',Dumper $refgraf);
  comfin('find traducir_objetos linea',__LINE__, $coderr);
  return $coderr;
}#traducir_objetos
#---------------------------------------------------------------------------
sub tratar_capas{
  comfin('comd tratar_capas',@_);
  my ($refca,$numfile) = @_;
#  my $numfilePRINCIPAL = $cualarch{PRINCIPAL};
  my $coderr = ''; my @mensajes; 
  my $ilayerfile = -1;# se usa para nombrar a la capa dentro de su archivo
#  estoy analizando todas las capas provenientes del archivo estudiado por
# traducirxml
#  impr_debug(__LINE__.' Desd $cuallay',Dumper $cuallay);
#  impr_debug(__LINE__.' Desd $cualfile',Dumper $cualfile);
  impr_refall(__LINE__.' Desd antes t_c');
  my $archivo = $nombrefile->[$numfile];
  impr_debug(__LINE__.' Desd $archivo',$archivo);
  foreach my $reflDia (@$refca) {
      $ilayerfile ++; my $clasecapa = 'nada';
      my $nomlayer = $reflDia->[0]->{name} ."($ilayerfile - $archivo)" ;
      my $ilayer = scalar keys @reflayers;
      impr_debug(__LINE__.' Desd $cuallay',Dumper $cuallay);
      push @$nombrelay,$nomlayer;
      $cuallay->{$nomlayer} = $ilayer;
      #algun día podria haber mas de un circuito por archivo (no por ahora),
      #nombrando las capas adecuadamente
      my $reflay = $reflayers[$ilayer] = {};
      $reflay->{ARCHIVOCAPA} = $archivo;
      $reflay->{numfile} = $numfile; #esto podria cambiar 
      $reflay->{numcapa} = $ilayer;
      my $refgraf = $refgrafers[$ilayer] = {};
      $refgraf->{hashclasegr} = {};
      $refgraf->{numfile} = $numfile;
      $refgraf->{numcapa} = $ilayer;
      ($coderr,$clasecapa) = tratar_1capa($reflDia,$reflay,$ilayer);
      if ($coderr or ($clasecapa =~ /^(nada|comen)$/)) {
          eliminar_capa($ilayer,$clasecapa);$coderr = '';
          next;
      };
      impr_debug(__LINE__.' Desd keys $reflay',[sort keys $reflay]);
  };
  impr_refall(__LINE__.' Desd antes compl');
  if ($refall->{cualnumclasenum}->{funciones}) {
      tratar_FUNCIONES();
  };
  impr_refall(__LINE__.' Desd antes U');
  if ($refall->{cualnumclasenum}->{unidades}) {
      tratar_UNIDADES();
  };
  if ($refall->{cualnumclasenum}->{tablas}) {
      tratar_TABLAS_CUALQ();
  }; 
  if (@mensajes) {
     my $mensaje = join "\n",@mensajes; mensajear($mensaje);
  };
       
 #  if (scalar keys %{$refarch->{cualnumclasenum}} == 0) {
#   mensajear(" No quedaron cuadros con informacion textual para este circuito.
#        Se interrumpe la traduccion");
#     $coderr = 7;
#  };     
 comfin('find tratar_capas $coderr',$coderr);
  return $coderr;
}#tratar_capas
# ---------------------------------------------------------------------------
sub tratar_cod{
  comfin('comd tratar_cod', @_);
  my ($reflay,$ij,$shape,$rrDia,$refgraf) = @_;
  my ($coderr,$clase) = ('',''); 
    my $cod = $codlista->[$ij];
  my $texto = $textolista->[$ij];
  if ($cod =~ /$codelemTs/) {
      $clase = 'iconos';
  };
#  my $rrDia = $refgrafprovi->{contcapa}->[$reflay->{numcapa}]->{objetos}->[$ij];
  # algunos de los siguientes son if independientes
  if ($cod  eq 'O') {
      ($coderr,my $refcrudo) = tratar_codconattrib($reflay,$rrDia,$ij);
      impr_debug(__LINE__.' Desd $coderr',$coderr);
      comfin('find tratar_cod linea $coderr',__LINE__,$coderr);
      return $coderr;
  } elsif ($cod  =~ /$codcontexto/) {
      if ($cod =~ /[Nn]/) {         
         $texto or  
          do {$coderr = 245;
              porparar1(
                  $coderr,"Nodo sin identificación en $lugarlista->[$ij]");
              comfin('find tratar_cod linea $coderr $clase'
                    ,__LINE__,$coderr,$clase);
              return $coderr;
          };
          $clase = 'iconos';
          impr_debug(__LINE__.' Desd $plantillalista->[$ij]'
		    ,$plantillalista->[$ij]);
#          push @{$reflay->{cualobjtextonodo}->{$texto}},$ij;
#          push @{$reflay->{lisobjnodos}},$ij;
#          push @{$reflay->{NODOSPLANT}->{$plantillalista->[$ij]}},$ij;
          push @{$refgraf->{cualobjtextonodo}->{$texto}},$ij;
          push @{$refgraf->{lisobjnodos}},$ij;
          push @{$refgraf->{NODOSPLANT}->{$plantillalista->[$ij]}},$ij;
      } elsif ($cod eq 't') {
          push @{$reflay->{cualobjtextonodo}->{0}},$ij;
          push @{$refgraf->{cualobjtextonodo}->{0}},$ij;
      } elsif ($cod  =~ /[CEJLR]/) {
          my $iden = $cod .$texto;
#          push @{$reflay->{cualobjele}->{$iden}}, $ij;
#          $reflay->{ELESPLANT}->{$iden} = $plantillalista->[$ij];
          push @{$refgraf->{cualobjele}->{$iden}}, $ij;
          $refgraf->{ELESPLANT}->{$iden} = $plantillalista->[$ij];
          #idea distinta que para nodos
      } elsif ($cod  =~ /[cejlr]/) {
          my $iden = $cod .$texto; my $uciden = uc($cod) . $texto;
#          $reflay->{ELESPLANT}->{$uciden} = $plantillalista->[$ij];
#          push @{$reflay->{cualobjele}->{$uciden}}, $ij;
          $refgraf->{ELESPLANT}->{$uciden} = $plantillalista->[$ij];
          push @{$refgraf->{cualobjele}->{$uciden}}, $ij;
          #idea distinta que para nodos
      };
      impr_debug(__LINE__.' Desd $refgraf->{cualobjtextonodo}'
          ,Dumper $refgraf->{cualobjtextonodo}); 
      comfin('find tratar_cod linea $coderr',__LINE__,$coderr,'iconos');
      return $coderr,'iconos';
  } elsif ($cod=~/$codramas/) {
     my $j=selec("dia:attribute","name",$nombrepuntos{$shape},$rrDia);
      map (push(@{$refgraf->{lughandles}->{$ij}},@{$_})
           ,selectags("dia:point",$rrDia->[$j+1]));
      my $listalug = $refgraf->{lughandles}->{$ij};
      map ($_ = mejorar_lugar($_), @$listalug);
      $j=selec0("dia:connections",$rrDia); 
      if ($j){  #tiene enganches   
          map (push(@{$refgraf->{enganches}->{$ij}},@{$_})
              ,selectags('dia:connection',$rrDia->[$j+1]));          
      } else {
          $refgraf->{enganches}->{$ij}= [];
      };# if else $j
      comfin('find tratar_cod linea $coderr',__LINE__,$coderr,'ramas');
      return '','ramas';
  } elsif ($cod eq 'T') {#modelo
      push @{$reflay->{cualobjmod}->{'T' . $texto}},$ij;
      return '','modelo'
  };# if elsif elsif elsif ..$codnodos
  error_progr($reflay,__LINE__.' Desd $cod inesperado en tratar_cod '.$cod);
  comfin('find tratar_cod linea $coderr',__LINE__,$coderr,$clase);
  return $coderr,$clase; # no llega por aqui;
}#tratar_cod
# ---------------------------------------------------------------------------
sub tratar_codconattrib{
  comfin('comd tratar_codconattrib',@_);
  my ($reflay,$rrDia,$ij) = @_; my ($coderr,$Tidtabla) = ('','');
  my $crudo = string('attrib',$rrDia);
  my $texto = $textolista->[$ij];
  impr_debug(__LINE__.' Desd $crudo',Dumper $crudo);
  cajear_crudo($reflay,$texto,$crudo); 
  if (uc($texto) =~ /COMENTAR/) {
      return '',[];
  };
  if (not $crudo) {
      mensajear(" Cuadro sin informacion en\n     "
	.descripcion_cuadro("\#numobj$ij"));
      comfin('find tratar_codconattrib linea $coderr',__LINE__,$coderr);
      return $coderr,[];
  };
#  impr_debug(__LINE__.' Desd $crudo',Dumper $crudo);
  if (not defined $reflay->{numfile}) {
      impr_debug(__LINE__.' Desd',__LINE__. ' sin numfile');
  };
  ($coderr,$texto,$Tidtabla) = tratar_texto_cuadro($reflay,$ij);
  my $refcrudo;
  if (not $coderr and $texto) {
      ($coderr,$refcrudo)
        = registrar_crudo($reflay,$texto,$Tidtabla,$crudo,$ij);
  };
  comfin('find tratar_codconattrib linea $coderr',__LINE__,$coderr);
  return $coderr,$refcrudo;
}#tratar_codconattrib
# ---------------------------------------------------------------------------
sub tratar_DIAGRAMAS_COMPLEMENTARIOS{ #aqui no llegan capas con USO_DEF
  comfin('comd tratar_DIAGRAMAS_COMPLEMENTARIOS',@_);
  my ($numobj,$basearch) = @_;
  my $refcuadro = $refboxes{$numobj};
  my $reflay = $reflayers[$refcuadro->{numcapa}]; 
  my @diagramas
    = @{$reflay->{refvalores}->{DIAGRAMAS_COMPLEMENTARIOS}->{$numobj}};
  my @archivos = refinar_por_nombre($basearch,@diagramas);
  my ($refprocesar,$refprocesarsindia) = refinar_seleccion_archivos(@archivos);
  
  comfin('find tratar_DIAGRAMAS_COMPLEMENTARIOS'
    ,@$refprocesar,'||',@$refprocesarsindia);
  return $refprocesar,$refprocesarsindia;
}#tratar_DIAGRAMAS_COMPLEMENTARIOS
# ---------------------------------------------------------------------------
sub tratar_iconos{ #aqui no llegan capas con USO_DEF
  comfin('comd tratar_iconos',@_);
  my ($refgraf,$clasecapa) = @_;
  my $coderr = '';
  my ($nodos,$poseles) = (0,0);
  $refgraf->{lisobjnodos} and $nodos = scalar @{$refgraf->{lisobjnodos}};
  $refgraf->{lisobjelemTs} and
      $poseles = scalar @{$refgraf->{lisobjelemTs}};
  impr_debug(__LINE__.' Desd $refgraf->{lisobjelemTs}'
           ,$refgraf->{lisobjelemTs});
  explic("Hay $nodos nodos  y  $poseles posibles elementos "
          ." en capa $refgraf->{numcapa}");
  $coderr = controlar_iconos($refgraf); 
  if ($coderr) {
      delete $refgraf->{hashclasegr}->{iconos};
  };
  comfin('find tratar_iconos $coderr',$coderr);
  return $coderr;
}#tratar_iconos
# ----------------------------------------------------------------------------
sub tratar_refvalores_otros{
  comfin('comd tratar_refvalores_otros',@_);
  my ($ref,$CORTO,$reffalta_modelo) = @_;
  #impr_debug(__LINE__.' Desd  $reffalta_modelo',  Dumper $reffalta_modelo);
  my $coderr = ''; my $codcirc = $ref->{clasearch};
  my $refv = $ref->{refvalores};
  $ref->{nombrecirc} = $CORTO;
#  if (defined $refv->{DEFINICION} and not defined $refv->{USO}) {
#      $ref->{clasearch} = 'modelo';
#      $coderr = 246;
#      porparar1($coderr,$refglobal,"Falta un cuadro USO", $CORTO);
#      return $coderr; 
#  } elsif (defined $refv->{USO} and not defined $refv->{DEFINICION}) {
#      $ref->{clasearch} = 'modelo';
#      $coderr = 247;
#      porparar1(95,$refglobal,"Falta un cuadro DEFINICION",$CORTO);
#      return $coderr; 
#  } elsif (defined $refv->{USO}) {
  if ($codcirc eq 'modelo') {
      my ($pcs,$nombremod);  
      $ref->{clasearch} = 'modelo';
      my @lisque = grep(/USO|DEFINICION|/
                        ,keys %$refv); 
      $coderr = asignaciones(\@lisque,$ref,0); #modelo
      not $coderr and $coderr = controlar_cadena_param($ref); #para mod.
      $coderr and 
      do {porparar1($coderr,$ref); return $coderr};
      not $coderr and  ($coderr , $pcs, $nombremod) 
              = asignar_mod($ref);#antes de controlar_circ 
      $coderr or $coderr = controlar_circ($ref,'modelo'); 
      not $coderr and $coderr = controlar_modelo($ref);      
      if ($coderr) {
	  porparar1($coderr,$ref); return $coderr;
          defined $DEFIMOD and defined $pcs and defined $nombremod 
          and defined $DEFIMOD->{$pcs} and 
          do {defined $DEFIMOD ->{$pcs}->{$nombremod}
              and  delete $DEFIMOD->{$pcs}->{$nombremod};
	      scalar keys %{$DEFIMOD->{$pcs}} and delete $DEFIMOD->{$pcs};
          };
          return $coderr; 
      } else {
          delete $reffalta_modelo->{$pcs}->{$nombremod};
          scalar keys %{$reffalta_modelo->{$pcs}} > 0 
              or delete $reffalta_modelo->{$pcs};
      };
      impr_ARCHIVOS(__LINE__.' Desd');  
      if ($PRINCIPAL eq $CORTOA) { 
          imprs_archivo_mod($ref);
          imprs_lis_obj_sceptre($ref,'modelo',$ARCHIVOA,$ARCHIVOA); 
          parar1(1,$ref);
      } else {
          my $refp = $reftrabajo->{$PRINCIPAL};
          my @palabras = keys %{$refp->{palabrasequivV}};
          if ($ref->{cualobjtextonodo}) {
              marcar_nodos($ref,\@palabras);
          };
      };
  } elsif ( defined $refv->{DATOS} or
	    defined $refv->{PARAMETROS}) {
      #push @{$lay_circ_arch{$CORTO}},$ilayer;
      $ref->{clasearch} = 'circuito';  
  } elsif (defined $refv->{GRAFICOS}) {
      $ref->{clasearch} = 'graficos' if $ref->{clasearch} eq 'nada';
      #puede haber varias capas; (pero para modelos todo en la misma)
  } else {
  };# if elsif elsif else defined ....USO   
  $clasearchivos{$CORTO} = $ref->{clasearch};
  comfin('find tratar_refvalores_otros', "clase $ref->{clasearch}");
  return $coderr;
}#tratar_refvalores_otros
# ---------------------------------------------------------------------------
sub tratar_texto_cuadro{
  comfin('comd tratar_texto_cuadro',@_);
  my ($reflay,$ij) = @_; my ($coderr,$idtabla,$Tidtabla) = ('','','');
  my $texto = $textolista->[$ij]; my $clase = 'nada';
  my $archivo = $reflay->{ARCHIVOCAPA};
  my $numobj = "#numobj$ij";
  $texto =~ s/\#.+$//;
  if ($texto !~ /\S/) {
      push @{$refall->{lisobjcuadrosnoid}},$ij;
      mensajear(descripcion_cuadro($numobj)
        ."\n     sin identificacion conocida");
     $coderr = 80; 
  } else { 
      $texto =~ tr/-/_/; $texto =~ s/__/_/g;
      $texto =~ s/S+/S/g;
      if ($texto eq 'TABLAS_ARCHIVOS') {
      } elsif ($texto =~ /^\s*TABL[AE](.+)$/) { 
          $idtabla = $1; $idtabla =~ s/^\s*//;$Tidtabla = "T$idtabla";
          $texto = 'TABLAS';
      };
      impr_debug(__LINE__.' Desd $texto', 'm'.$texto.'m'); 
      if($texto eq 'TABLA') {
          mensajear(descripcion_cuadro($numobj)
           ."\n    con identificacion incompleta: falta identificacion de tabla
            Se ignora todo el cuadro"); $texto = 'TABLA ??';$coderr = 30;
          comfin('find tratar_texto_cuadro linea $coderr'
            ,__LINE__,$coderr,$texto); 
          return $coderr,$texto;
      };   
      if (defined $cuadro2clase{$texto}) {
      } else {
         if (defined $locale{$texto}) {  
             $texto = $locale{$texto};
	 } elsif ($texto =~ s/^(\w+)\W.*$/$1/ and defined $locale{$texto}) {
              $texto = $locale{$texto};
         };
         $textolista->[$ij] = $texto;
      };
      defined $cuadro2clase{$texto} or do {
         push @{$refall->{lisobjcuadrosnoid}},#numobj$ij;
         $coderr = 31; 
         comfin('find tratar_texto_cuadro linea $coderr'
            ,__LINE__,$coderr,$texto); 
          return $coderr,$texto;
      };
      if ($cuadro2clase{$texto}) {
          $clase = $cuadro2clase{$texto};
          push @{$reflay->{cualnumclasenum}->{$clase}},$numobj;
          (my $clasesin = $clase) =~s /[ad]$//;
          push @{$refall->{cualnumclasenum}->{$clasesin}},$numobj;
          my $refcuadro
           = {'numcapa'=>$reflay->{numcapa},'numobj'=>$numobj,'texto'=>$texto};
	  $refboxes{$numobj} = $refcuadro;
          $textolista->[$ij] = $texto;
          $Tidtabla and $refcuadro->{Tidtabla} = $Tidtabla;
          impr_debug(__LINE__.' Desd $clase'." $clase ",Dumper $refcuadro);
      } else {
          push @{$refall->{lisobjcuadrosdescon}},"#numobj$ij";
          $coderr = 88;
          comfin('find tratar_texto_cuadro linea,$coderr,$texto'
            ,__LINE__,$coderr,$texto);
          return $coderr,$texto; 
      };
  };
  impr_refall(__LINE__.' Desd $numobj '.$numobj);
  comfin('find tratar_texto_cuadro linea,$coderr,$texto,$Tidtabla'
    ,__LINE__,$coderr,$texto,$Tidtabla);
  return $coderr,$texto,$Tidtabla;
}#tratar_texto_cuadro 
# --------------------------------------------------------------------------
sub tratar_1ARCHIVOS_COMPLEMENTARIOS{
  comfin('comd tratar_1ARCHVOS_COMPLEMENTARIOS',@_);
  my ($reflay,$ij,$crudo) = @_;
  my $refarch = $refarchers[$reflay->{numfile}];
  my @archivos = split /\s*\n\s*/,$crudo;
#  impr_ARCHIVOS(__LINE__.' Desd',$refarch);
  my $numobj = "\#numobj$ij"; my @crudost; my $crudot = '';
  foreach my $archivo (@archivos) {
      my $archbue = $archivo;
      $archbue =~ /^\// or $archbue = $refnombres[0]->{BASEARCH} . $archbue;
      impr_debug(__LINE__.' Desd $archbue',$archbue);
      $crudot .= "En archivo $archivo:\n     ";
      -e $archbue or do{
            my $mensaje = " No existe el archivo";
            mensajear($mensaje);
            push @{$refboxes{$numobj}->{ERRORES}}, $mensaje. " $archivo\n";
            $crudot .= $mensaje ."\n";
            next;
      };
      my $crudo = `cat $archbue`;
      my ($mensaje,$refcrudo) = depurar_crudo($crudo);
      $mensaje and mensajear("$mensaje;\n    en $archbue"); 
      impr_debug(__LINE__.' Desd $refcrudo',Dumper $refcrudo);
      my ($coderr,$refcrudoout)
          = mejorar_crudo('ARCHIVOS_COMPLEMENTARIOS',$refcrudo);
      if ($coderr) {
          my $mensaje = " Hay errores";
          mensajear($mensaje);
          push @{$refboxes{$numobj}->{ERRORES}}
            , $mensaje." en archivo $archivo";
          $crudot .= $mensaje."\n";
          next;
      } else {
          impr_debug(__LINE__.' Desd $numobj $refcrudoout',Dumper $refcrudoout);
          push @crudost,@$refcrudoout;
          $crudot .= join ("\n     ",@$refcrudoout) ."\n";
      };
  };
  if (@crudost) {
      push @{$reflay->{refvalores}->{ARCHIVOS_COMPLEMENTARIOS}
        ->{$numobj}},@crudost;
      $error_cuadros{ARCHIVOS_COMPLEMENTARIOS} = '';
      impr_campo(__LINE__.' Desd $reflay',$reflay,'refvalores'
                   ,'ARCHIVOS_COMPLEMENTARIOS');
      impr_campo(__LINE__.' Desd $refarch',$refarch,'refvalores'
                   ,'ARCHIVOS_COMPLEMENTARIOS');
  };
  $CAJAS->{$ARCHIVOA} .= $crudot;
  comfin('find tratar_1ARCHVOS_COMPLEMENTARIOS',@_);
  return;
}#tratat_1ARCHIVOS_COMPLEMENTARIO
# --------------------------------------------------------------------------
sub tratar_1capa{
  comfin('comd tratar_1capa',@_);
  my ($reflDia,$reflay,$ilayer) = @_; my $coderr = '';
  push @{$refall->{ARCHIVO2extras}->{$reflay->{ARCHIVOCAPA}}->{capas}}
    ,$ilayer;
  push @{$refarchers[$reflay->{numfile}]->{capas}},$ilayer;
  impr_debug(__LINE__.' Desd $refall->{ARCHIVO2extras}'
    ,Dumper $refall->{ARCHIVO2extras});
 
 
  $coderr = traducir_objetos($reflDia,$ilayer);
  impr_campo(__LINE__.' Desd $reflay',$reflay,'cualnumclase');
#  my $archivo = $reflay->{ARCHIVOCAPA}; 
#  my $refarch = $refarchers[$reflay->{numfile}];
  ($coderr, my $clasecapa) = determinar_clase_capa($reflay,$ilayer);
  if ($coderr) {
      comfin('find tratar_1capa linea',__LINE__,'',$clasecapa);
      return $coderr,$clasecapa;
  };
  impr_debug(__LINE__.' Desd $reflay->{cualnumclasenum}'
    , Dumper $reflay->{cualnumclasenum});
  foreach my $numobj (@{$reflay->{lisobjO}}) {
      $refboxes{$numobj}->{clasecapa} = $clasecapa;
      impr_debug(__LINE__.' Desd $refboxes{$numobj}',Dumper $refboxes{$numobj});
  };
  comfin('find tratar_1capa linea',__LINE__,'',$clasecapa);
  return '',$clasecapa;
}#tratar_1capa
# ---------------------------------------------------------------------------
sub ubicar_coment_sceptre{
  comfin('comd ubicar_coment_sceptre',@_);
  my ($refcoment,@listain) = @_;
  impr_debug(__LINE__.' Desd com ubicar $refcoment', Dumper $refcoment);
  impr_debug(__LINE__.' Desd com ubicar @listain', Dumper \@listain);
  foreach (@listain) {
#      impr_debug(__LINE__.' Desd $_',$_);
      my ($cuantos) = ($_ =~ tr/&//); 
      if ($cuantos) {
          $_ =~ s/&//g;
          for (my $i = 0; $i < $cuantos; $i ++) { 
              my $com = shift @$refcoment;
              $_ .= "; $com" if $com;
          };
      }; 
  };
  foreach (@$refcoment) {
      push @listain,"; $_";
  };
  impr_debug(__LINE__.' Desd fin ubicar @listain', Dumper \@listain); 
  comfin('find ubicar_coment_sceptre');
  return @listain;
}#ubicar_coment_sceptre
# ----------------------------------------------------------------------------
1
