package Simusol::Elementos;
#Para interpretar archivos .ele
#usados por simusol
use Simusol::Auxiliares;
use Simusol::GlobalesSimusol;
use Simusol::TraAbrev;
use Simusol::Ayudas;
use Simusol::Algebraico;
use Simusol::Ampliaciones;
use Simusol::Controles;
use Simusol::Sceptre;
use Simusol::Tablasfuncq;

use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&tratar_1capa_ele
                &tratar_1capa_mod
                &tratar_refvalores_USO_DEF
                &definir_UNIDADES
               )
 };
# ---------------------------------------------------------------------------
sub abreviaturas_elementos{# solo nemotecnico
  comfin('come abreviaturas_elementos', @_);
  my %abr_elem = (
    '$rdb'=>'$reflay->{}'
   ,'$rdb'=>'$reflay->{defidibu}'
   ,'$rde'=>'$reflay->{defiele}'
   ,'$rden'=>'$reflay->{defiele}->{nombre}'
   ,'$rdenn'=>'$reflay->{defiele}->{nombre}->{$nombre}'
   ,'$rdennf'=>'$reflay->{defiele}->{nombre}->{$nombre}->{formula}'   
   ,'$rdennf'=>'$reflay->{defiele}->{nombre}->{$nombre}->{formula}->{$formula}'
   ,'$rdecc'=>'$reflay->{defiele}->{datosclasepcs}->{$clasepcs}'
   ,'$rdepp'=>'$reflay->{defiele}->{datospcs}->{$pcs}     no se ha usado'
   ,'$rdemj'=>'$reflay->{defiele}->{malnumobj}' 
   ,'$rdf'=>'$refarch->{sobreformulas}  lo bueno de $rde pasa al archivo
             en guardar_defiele'
   ,'$rdt'=>'$reflay->{defiexto}'
   ,'$rdtj'=>'$reflay->{defitexto}->{numobj}'
   ,'$DEFIELE'=> 'lo bueno de $rdf pasado a global, en asignar_defiele'
  );
  #otros keys para $rde : texto
  comfin('fine abreviaturas_elementos');
}#abreviaturas_elementos;
# ---------------------------------------------------------------------------
sub asignar_defiele{
  comfin('come asignar_defiele', @_);
  #hace lo que puede por asignar; no interrumpe  a todo simusol por errores
  #pero si interrumpe procesamiento de la capa; es decir 
  #no tiene en cuenta definiciones correctas junto con incorrectas
  #interpreta las definiciones de los diferentes tipos de objetos
  my ($reflay) = @_; 
  my ($rdb,$rde) = @$reflay{'defidibu', 'defiele'};
  #impr_debug(__LINE__. 'Elem $rde', Dumper $rde);
  my $rden = $rde->{nombre};
  my $listaformulas;
  foreach my $nombre (sort keys %$rden) {
      my $rdenn = $rden->{$nombre};
      my $clase = $rdenn->{clasepcs};
      foreach my $formula (sort keys %{$rdenn->{formula}}) {
          my $rdennff= $rdenn->{formula}->{$formula};
          next unless defined $rdennff->{definicion};
          my $comodin = $rdennff->{comodin};
          my $lisque =  ['DATOS','PARAMETROS'];
          my $coderr = normalizar($rdennff, $lisque); #en asignar_defiele
          not $coderr and 
          $coderr = limpiar_unico($rdennff, $lisque); #asignar_defiele
          $coderr and return $coderr;  
          my @varposibles;
          if (@{$rdennff->{listaPARAMETROS}}) {
              #push @varposibles, keys %{$ref->{PARAMETROS}};
              $coderr = controlar_cadena_param($rdennff);
              $coderr and return $coderr;
          };
          push @varposibles, @{$rdennff->{listaarg}} 
              if defined $rdennff->{listaarg};
          if ($comodin !~ /^E/) {push @varposibles,"V$comodin"};
          if ($comodin !~ /^J/) {push @varposibles,"I$comodin"}; 
          my %posibles;
          map($posibles{$_} = 1, @varposibles);
          my @lisexpres = ();
#          push @lisexpres,$rdennff->{VALOR}->{$comodin}; 
          push @lisexpres, values %{$rdennff->{VALOR}} 
             if defined $rdennff->{VALOR};
          my $reflistafunnod = $rdennff->{funcionesdenodos};
          #ya mirar_NODOS  controlo que los argumentos de las 
          #FUNCIONESDENODS sean efectivamente nodos y están marcados
          #como NODOELEM; ahora sustituimos provisoriamente por 1
          #para que no aparezcan contabilizadas como funciones y/ o variables
          #impr_debug(__LINE__.' Elem   lisexpres ',\@lisexpres);
          my $expresion = ';' . join (';',@lisexpres) . ';';
          #para que no se vean las llamadas a FUNCIONESDENODOS
          my $uno = 1;
          foreach my $fun (@{$rdennff->{funcionesdenodos}}) {
              while ($expresion =~ s/(\W)$fun\(\w+\)(\W)/$1$uno$2/) {}
          };
          #impr_debug(__LINE__.' Elem %posibles',Dumper \%posibles);
          my ($coderror,$reff,$refp,$reft,$refv,$refx,$refnodo) 
            = fun_par_tab_var($expresion,$rdennff,\%posibles); #en as_defiele
          #impr_debug(__LINE__.' Elem $refv',Dumper $refv);
          #impr_debug(__LINE__.' Elem $refp',Dumper $refp);
          $coderror and return $coderror;
          my @noposibles; 
          #impr_debug(__LINE__.' Elem', Dumper $refv); 
          #impr_debug(__LINE__.' Elem @noposibles', Dumper \@noposibles); 
          foreach (keys %$refv) {
              #impr_debug(__LINE__.' Elem   ',$_);
              next if $posibles{$_};
              push @noposibles, $_;
          };
          @noposibles and 
	  do {foreach my $nodo (@noposibles) {
                  if ($refarchers[$reflay->{numfile}]->{cualobjtextonodo}) {
                      explic("Quizas necesita declarar FUNCIONESDENODOS");
		      last;
		  };
              }; 
              porparar1(60,$reflay,"Variables no posibles @noposibles
        en la definicion de formula $formula");
              return 60;
          };
          push @{$listaformulas->{$nombre}}, $formula;
          # se deja que el que programe las formulas elija bien que explotar
          # si no, se demora hasta que se sustituye 
          $coderr and return $coderr;
      }; # my $formula
  }; # my $nombre
  #impr_debug(__LINE__. ' Elem $rde', Dumper $rde);
  comfin('fine asignar_defiele');
  return '';
}
# ---------------------------------------------------------------------------
sub asignar_defiuni{
  comfin('come asignar_defiuni',@_);
  my ($reflay,$refhash) = @_;
  # $refhash contiene toda la informacion de los cuadros UNIDADES
  impr_debug(__LINE__.' Elem $refhash',Dumper $refhash);
  my $coderr = '';
  my $refarch = $reflay->{refarch};
  my $refun = $refarch->{defiuni};
  my @stringplants = keys %$refhash;
  impr_debug(__LINE__.' Elem $cualplantilla',Dumper $cualplantilla);
  foreach my $string (@stringplants) {
      my @listaplants = split ',', $string;
      impr_debug(__LINE__.' Elem @listaplants',Dumper \@listaplants);
      my @archivoscapas; 
      foreach my $nomplant (@listaplants) {
          if ($nomplant eq 'Auxiliar') {
              mensajear("No se deben definir unidades para plantilla Auxiliar;
                 Se ignoran");
              $refhash->{$nomplant} = {};  
              $nomplant = undef; 
              next;
          };
         impr_campo(__LINE__.' Elem $cualplantilla',$cualplantilla,'$nomplant');
          impr_debug (__LINE__.' Elem $nomplant',$nomplant);
          defined $cualplantilla->{$nomplant} or
              aumentar_plantilla($nomplant);
#          defined $refun->{$nomplant} or do{
#              $refun->{$nomplant}->{defis} ={};
#              $refun->{$nomplant}->{numcapa} = $reflay->{numcapa}; 
#          };
      };
      @listaplants = grep $_, @listaplants; 
      @listaplants or return '';
      impr_debug(__LINE__.' Elem @listaplans',\@listaplants); 
      my @listanumobjs = keys %{$refhash->{$string}->{numobj}};
      foreach my $numobj (@listanumobjs) { 
          my $cuadro = descripcion_cuadro($numobj);
          if (@listaplants >1) {
               mensajear(
           'Está definiendo unidades para '. scalar @listaplants." plantillas
                 @listaplants en $cuadro");
          };  
          my @renglones = @{$refhash->{$string}->{numobj}->{$numobj}};
          if (not @renglones) {
               avnoseent("Anunciar unidades para plantilla  @listaplants y 
           no dar ninguna");
               delete $refhash->{$string}->{numobj}->{$numobj};
              next;
           };
          impr_debug(__LINE__.' Elem @renglones',\@renglones);
          foreach my $nomplant (@listaplants) {
              $coderr
                = interpretar_renglones_UNIDADES($refun,$nomplant,\@renglones);
              not $coderr and 
                 push @{$reftrabajo->{UNIDADES}->{$cualplantilla->{$nomplant}}} 
                ,$refun;  
          };
      }; #foreach my $numobj
      impr_debug(__LINE__.' Elem $refun',Dumper $refun);
  }; #my $string
  impr_UNIDADES(__LINE__.' Elem reftrabajo',$refarch);
  comfin('fine asignar_defiuni',$coderr);
  return $coderr;
  }
# ---------------------------------------------------------------------------
sub asignar_ele{
  comfin('come asignar_ele', @_);
# incorpora a $DEFIELE la información de $defiele que no choca con la anterior
  my $reflay = $_[0];
  my $rde = $reflay->{defiele};
  my $usado = '';  
  foreach my $pcs (keys %{$rde->{datospcs}}) {
      if (defined $DEFIELE->{datospcs}->{$pcs}) { 
          my $Clase = $DEFIELE->{datospcs}->{$pcs}->{clasepcs};
          my $clase = $rde->{datospcs}->{$pcs}->{clasepcs}; 
          $Clase eq  $clase or  
	  do {porparar1(66,$reflay, "$pcs está agrupado en forma diferente;
              antes: $Clase    ahora: $clase;
              se ignorarán las definiciones del archivo 
              $CORTOA");
              return 66;
          };
      } else {
	  $DEFIELE->{datospcs}->{$pcs}->{clasepcs} 
             = $rde->{datospcs}->{$pcs}->{clasepcs}; 
      };
  };
  foreach my $clasepcs (keys %{$rde->{datosclasepcs}}) {
      if (not defined $DEFIELE->{datosclasepcs}->{$clasepcs}) {
          $usado = 1;
          my $rdecc = $rde->{datosclasepcs}->{$clasepcs};
          %{$DEFIELE->{datosclasepcs}->{$clasepcs}} 
              = %{$rdecc};
          my $nombre = $rdecc->{nombre};
          %{$DEFIELE->{nombre}->{$nombre}} 
             =  %{$rde->{nombre}->{$nombre}}; 
          my @listapcs = split ' ', $clasepcs;
          foreach my $pcs (@listapcs) {
#              $comocod->{$pcs} = $rdecc->{cod};
#	      $comocodvalor->{$pcs} = $rdecc->{codvalor}; 
#              $comootrosnodos ->{$pcs} = $rdecc->{otrosnodos};
#              $nombre_menu_Dia ->{$pcs} = $rdecc->{nombre}; # MAL
          };  
      } else {
	  #impr_debug(__LINE__.' Elem $clasepcs '.$clasepcs
	  #	     , Dumper $DEFIELE->{datosclasepcs}->{$clasepcs});
          my $nombre = $rde->{datosclasepcs}->{$clasepcs}->{nombre};
          my $Nombre =
                $DEFIELE->{datosclasepcs}->{$clasepcs}->{nombre};
          $Nombre eq $nombre or
          do{ explic("$clasepcs tiene nombres diferentes;
              antes: $Nombre   ahora: $nombre; 
              se ignorarán las nuevas definiciones");
              next;
          };
          my $rdenn = $rde->{nombre}->{$nombre};
          my $rDenn = $DEFIELE->{nombre}->{$nombre};
          foreach my $formula (sort keys %{$rdenn->{formula}}) { 
              if (not defined $rDenn ->{formula}->{$formula}) { 
                  $usado = 1;
                  %{$rDenn ->{formula}->{$formula}}
                     = %{$rdenn ->{formula}->{$formula}};
              } else { 
                  explic(
      " Hay definición anterior para la formula $formula; se mantendrá");
              };
          }; 
      };        
  };
  push @{$DEFIELE->{archeleorigen}}, $reflay->{refcirc}->{archivo} if $usado;
  #impr_debug(__LINE__.' Elem $DEFIELE', Dumper  $DEFIELE); 

comfin('fine asignar_ele');

}# asignar_ele 
# --------------------------------------------------------------------------
sub aumentar_UNIDADES{
  comfin('come aumentar_UNIDADES',@_);
  my ($reffrom,$refto,$nomplanti) = @_;
  impr_debug(__LINE__.' Elem from Termico'
      ,Dumper $reffrom->{DEFIcalculo}->{Termico});
  impr_campo(__LINE__.' Elem $refto',$refto,'DEFIcalculo');
  foreach my $DEFI ('DEFIcomp','DEFIabrev','DEFIequiv','DEFIcalculo') { 
      foreach my $cosa (keys %{$reffrom->{$DEFI}->{$nomplanti}}) {
          not defined $refto->{$DEFI}->{$nomplanti}->{$cosa} and
          $refto->{$DEFI}->{$nomplanti}->{$cosa} 
            = $reffrom->{$DEFI}->{$nomplanti}->{$cosa};
      }; 
  };
  impr_campo(__LINE__.' Elem $refto',$refto,'DEFIcalculo');
  my $unidadtiempo = $refto->{DEFItiempos}->{unidadtiempo};
  if (not defined $unis_tiempo{lc($unidadtiempo)}) {
     $refto->{DEFItiempos}->{unitiempo} = $unidadtiempo;
  }; 
  comfin('fine aumentar_UNIDADES');
  impr_UNIDADES(__LINE__.' Elem $refto',$refto);
  return '';
}#aumentar_UNIDADES
# ---------------------------------------------------------------------------
sub aumentor_plantilla{
  comfin('come aumentar_plantilla',@_);
  my $nombre = $_[0];
  my $numero = scalar @{$nombreplantilla};
  push(@$nombreplantilla,$nombre);
  $cualplantilla->{$nombre} = $numero;
  push @$plantillalista,$numero;
  impr_debug(__LINE__.' Elem',$nombreplantilla);
  comfin('fine aumentar_plantilla');
  return '';
}#aumentor_UNIDADES 
# ----------------------------------------------------------------------------
sub definir_dibu{# guarda en $reflay->{defidibu}; key $texto o t&
# analiza la parte grafica del diagrama, guarda la informacion,
# luego de controlar lo controlable, en 
# $reflay->{defidibu} (key principal $texto es decir $ele o t&)
#   $texto con primer letra de acuedo con $codlista que nacio con archivo .shhet
#   y la identificacion propia en el diagrama
  comfin('come definir_dibu',@_);
  my ($numcapa,$reflay,$refgraf) = @_;my $coderr = '';
  my $rdb = $reflay->{defidibu} = {};
  my @nodosdoblesobjs
      = grep ($codlista->[$_] eq 'n',@{$reflay->{lisobjtodos}}); 
  if ($reflay->{cualobjele}) {
      my @eles = keys %{$reflay->{cualobjele}};
      impr_debug(__LINE__.' Elem @eles',\@eles);
      #antes $rdbt tenia que ver con texto; ahora directamente con $ele
      foreach my $ele (@eles) {
          my $obj = $reflay->{cualobjele}->{$ele}->[0];
          my $cod = $codlista->[$obj];
          (my $ele0 = $ele) =~ s/^./$cod/;
          $rdb->{$ele} = {}; 
          my $rdbt = $rdb->{$ele};
          my $uniuni = $reflay->{uniuni}->{$ele0};
           #ya se controlo que es sienpre lo mismo, en controlar_iconos_ele
          $rdbt->{uniuni} = $uniuni;
          $rdbt->{cod} = $cod; 
          $rdbt->{clasepcs} = $refgraf->{iden2clase}->{$ele};
      };
  };
  # para tierra
  my @tierrasobj = grep (
     do{$codlista ->[$_] eq 't' and $textolista->[$_] eq '&'}
        ,@{$reflay->{lisobjtodos}});  
  if (@tierrasobj) {
      impr_debug(__LINE__.' Elem @tierrasobj',\@tierrasobj);
      defined $rdb->{"t&"} or $rdb->{"t&"} = {};
      my $rdbt = $rdb->{"t&"};
      $rdbt->{clasepcs} = $refgraf->{iden2clase}->{"t&"};
  };
  comfin('fine definir_dibu',$coderr);
  return $coderr; 
}
# ----------------------------------------------------------------------------
sub definir_formula_texto{
  #es llamada por definir_texto y llama a mirar_NODOS
  # hay a lo sumo un cuadro en la capa por cada icono;
  # de haber más de un cuadro, no se registra ninguno
  comfin('come definir_formula_texto',@_);
  my ($reflay,$rdtj) = @_; my $coderr = ''; my @mensajes;
  impr_campo(__LINE__.' Elem $reflay',$reflay,'defitexto');
  my ($rdb, $rdt)  = @$reflay{'defidibu', 'defitexto'};
  my ($uso,$comodin) = @$rdtj{'uso','comodin'}; 
  my $rdbt = $rdb->{$comodin};
  if (not defined $rdbt) { #para no tierras
      $coderr = 40;
      push @mensajes," No hay ningun icono para $comodin;
                \'$uso\' es una definicion inutil";
          comfin('fine definir_formula_texto',$coderr);
          return $coderr,@mensajes;
  }; 
  $rdtj->{clasepcs} =  $rdbt->{clasepcs};
  $rdtj->{uniuni}->{$comodin} = $rdbt->{uniuni};
  $rdtj->{cod} = $rdbt->{cod};
#  push @{$rdbt->{numobj}},$rdtj->{numobj};
  my @listaarg = split /\s*,\s*/, $rdtj->{stringargs};
  my @listaexp = grep(/\S/,@listaarg);
  if (scalar (union_conjunto(@listaexp))  != scalar (@listaarg)) {
      push @mensajes,
       ,"Hay argumentos repetidos o vacíos:\n      @listaarg\n   en "
	   .$rdtj->{stringargs};
      $coderr = 42;
      comfin('fine definir_formula_texto',$coderr);
      return $coderr,@mensajes; 
  };
  foreach my $exp (@listaexp)  { # FALTA?
  };     
  @$rdtj{'listaDATOS','listaPARAMETROS'} = ([],[]);
  foreach my $renglon (@{$rdtj->{definicion}}) {
      $renglon =~ s/\s+//g;          
      if ($renglon =~  /^(\w)(\w*)=(\S+)$/) {
          if ($1 eq 'P') {
              $rdtj->{VALOR}->{"$1$2"} = $3;
              push @{$rdtj->{listaPARAMETROS}}, "$1$2";
          } else {
              $rdtj->{VALOR}->{"$1$2"} = $3;
              push @{$rdtj->{listaDATOS}}, "$1$2";
          };
          $rdtj->{TIPOTOK}->{"$1$2"} = 'A';
      } else {
          push @mensajes,
            ," Error de siintaxis (no es asignación) en el renglón
            $renglon de la definición para $comodin";
          $coderr = 43;
          comfin('fine definir_formula_texto',$coderr);
          return $coderr,@mensajes;
      };
  };
  impr_datos(__LINE__.' Elem',['DATOS','PARAMETROS'],$rdtj); 
  if (scalar @listaarg + scalar @{$rdtj->{listaPARAMETROS}} != 
      scalar union_conjunto(@listaarg,@{$rdtj->{listaPARAMETROS}})) {
      $coderr = 44; 
      push @mensajes," No debe haber argumentos y parámetros de igual nombre
      argumentos: @listaarg
      parámetros: @{$rdtj->{listaPARAMETROS}}";
      comfin('fine definir_formula_texto',$coderr);
      return $coderr,@mensajes;
  };
#  $rdennff->{listaarg} = \@listaarg;  
  if (@{$rdtj->{listaDATOS}} != 1 or $rdtj->{listaDATOS}->[0] ne $rdtj->{comodin}) {
      $coderr = 45;
      push @mensajes
        ," Error de sintaxis en la definición para $comodin;
        no asigna a $rdtj->{comodin} sino  a: @{$rdtj->{listaDATOS}} ";
      comfin('fine definir_formula_texto',$coderr);
      return $coderr,@mensajes;
  };
  ($coderr,@mensajes) =  mirar_CONDICION($reflay, $rdtj) if $rdtj->{condicion};
  impr_debug(__LINE__.' Elem defitexto', Dumper $rdt);
  comfin('fine definir_formula_texto');
  return $coderr,@mensajes;
} 
# ----------------------------------------------------------------------------
sub definir_formula_texto_t{
  #es llamada por definir_texto y llama a mirar_NODOS
  comfin('come definir_formula_texto_t',@_);
  my ($reflay, $rdtj) = @_; my $coderr = ''; my @mensajes;
  #impr_campo(__LINE__.' Elem $reflay',$reflay,'defiele');
  #impr_campo(__LINE__.' Elem $reflay',$reflay,'defidibu');
  my ($rdb, $rdt)  = @$reflay{'defidibu', 'defitexto'};
  impr_debug(__LINE__.' Elem $rdtj', Dumper $rdtj);
  impr_debug(__LINE__.' Elem  $rdb',Dumper $rdb);
  if ($rdtj->{codigos}->[0] =~ /^(\S)\s*(\S)/i) { 
      $rdtj->{codigos} = [$1,$2]; 
      my $formula = uc($2).'0';
      my $texto = '0';

#          $rdennff->{archivoele} 
#           = $refarchers[$reflay->{numfile}]->{archivo};#"$BASEARCHA$PROPIOA"; 
#          $rdennff->{comodin} = lc($1).'0';
#	  my $nodosot;
#          $coderr 
#             = mirar_NODOS($reflay, $formula,'0',$numobj);#para t
#          comfin('fine definir_formula_texto_t',$coderr);
#          return $coderr;
  };
  comfin('fine definir_formula_texto_t',$coderr);
  return $coderr;
} # definir_formula_texto_t
# ----------------------------------------------------------------------------
sub definir_texto {
  # analiza la parte de texto de un cuadro USU_DEF sin preocuparse de 
  # que otros cuadros quieran usar los mismos iconos
  # aumenta informacion para defidibu de los iconos utilizados
  # y llena o pide llenar parcialmente $reflay->{defiele}
  # marca el cuadro como malo en defiele->{malnumobj} , con su mensaje de error
  # no es error que haya nombres largos como argumentos; no llegan al Sceptre
  # solo mira contenido de cuadros
  # $reflay->{defidibu}: lo relativo a la parte grafica de la capa;
      # al final, con mencion de cuales cuadros usaron los iconos
  # $reflay->{defitexto} lo que tiene que ver con los cuadros sin registrar
      # choques con otros cuadros; organizado por $numobj con alguna informacion
      # sobre iconos utilizados
  # $reflay->{defiele} tiene un resumen de $reflay->{defiele} con sus 
      # problemas de competencia
  # $refarch->{defiele} lo de todas las capas que no choquen entre si;
      # depende del orden en que se incorporan las capas
  comfin('come definir_texto', @_);
  my ($reflay,$rdtj,$rdmj,$refrenglones) = @_;my $coderr = ''; my @mensajes;
  my @renglones = @$refrenglones;
  impr_debug(__LINE__.' Elem @renglones',"\n".join("\n",@renglones)); 
  map (do{ s/^\s*//; s/\s*$//; s/\s*=\s*/=/g},@renglones);
  #impr_debug(__LINE__.' Elem @renglones ',Dumper \@renglones);
  my $rdemj = $reflay->{defiele}->{malnumobj};
  my @renglonesusodef;
  foreach my $renglon (@renglones) {
      if ($renglon 
     =~ /^(nombre|codigos|condicion|parnombrearchivotabla|otrosnodos|funcionesdenodos)\s*=\s*(.*)$/i) {
          my $palabra = lc($1); my $cosa = $2;
          impr_debug(__LINE__.' Elem $palabra $cosa',[$palabra,$cosa]);
          $palabra ne 'parnombrearchivotabla' and $cosa = uc($cosa);
          (my $cosanotigual = $cosa) =~ s/==/eqn/g;
          $cosanotigual =~ s/<=/len/g;
          $cosanotigual =~ s/>=/gen/g;
          if ($cosanotigual eq '' or $cosanotigual =~ /=/  ) {
              $rdemj->{$rdtj->{numobj}} 
              = "Definición incompleta  para $palabra con $cosa  por $renglon";
              return '';
          };  
          push @{$rdtj->{$palabra}}, $cosa;
      } else {
          push @renglonesusodef,$renglon;
      };
  };
  impr_debug(__LINE__.' Elem $rdtj ',Dumper $rdtj);
  foreach my $palabra (keys %$rdtj) {
      next if $palabra =~ /^(numcapa|numobj)$/;
      impr_campo(__LINE__.' Elem $rdtj',$rdtj,$palabra);
      if (@{$rdtj->{$palabra}} > 1) {
          $rdemj->{$rdtj->{numobj}} 
            = " Hay más de una asignación a \"$palabra\" ";
         return '';
      } else {
          $rdtj->{$palabra} = $rdtj->{$palabra}->[0];
      };
  };
  impr_debug(__LINE__.' Elem $rdtj',Dumper $rdtj);
  if (not $rdtj->{nombre}) {
      $rdemj->{$rdtj->{numobj}} 
        = " Falta la definición de \"nombre\" para los elementos";
      return '';
  };
  
  map (s/\s+//g,@renglonesusodef); 
  @renglones = grep(/\S/, @renglonesusodef);
  if ($rdtj->{codigos} and @renglones) {
      $rdemj->{$rdtj->{numobj}} 
        = " Hay información mezclada para tierra y no tierra"; 
      return '';   
  } elsif (not $rdtj->{codigos} and not @renglones) {
      $rdemj->{$rdtj->{numobj}} 
       = " La información no sirve para definir una tierra ni a una no tierra:";
  };
  impr_debug(__LINE__.' Elem @renglones',Dumper \@renglones);
  if (not defined $reflay->{defiele}) {
      $reflay->{defiele} = {};
  };
  defined $rdtj->{otrosnodos} or $rdtj->{otrosnodos} = '? - ?';
  my ($nombre,$numobj,$otrosnodos) = @$rdtj{'nombre','numobj','otrosnodos'};
  my $rdej = $reflay->{defiele}->{$numobj};
  @$rdej{'nombre','numobj','otrosnodos'} = ($nombre,$numobj,'otrosnodos');
  if (@renglones) {
      $coderr = mirar_USO_DEF($reflay,$rdtj,$rdemj,\@renglones);
      impr_debug(__LINE__.' Elem $rdej', Dumper $rdej);
      if ($coderr) {   
          comfin('fine definir_texto linea ',__LINE__,$coderr);
          return $coderr;
      };
  };
  impr_debug(__LINE__.' Elem $rdtj', Dumper $rdtj);
  if ($rdtj->{codigos}) {
      my $comodin = $rdtj->{comodin} = 't&';
#      my $codvalor = substr($rdtj->{codigos},1,1);
#      $rdtj->{codvalor} = $codvalor;
      $rdtj->{formula} = '';
      if ($reflay->{defidibu}->{$comodin}) { # para tierra
          $rdtj->{clasepcs} = $reflay->{defidibu}->{$comodin}->{clasepcs};
          push @{$reflay->{defidibu}->{$comodin}->{numobj}}, $rdtj->{numobj};
          push @{$reflay->{defidibu}->{$comodin}->{nombre}}, $rdtj->{nombre};
      } else {
          $rdemj->{$rdtj->{numobj}} 
     = "No hay ningun icono posible para tierra; no debe admitir identificacion;
               definicion inutil";
          $coderr = 35;
          comfin('fine definir_texto linea ',__LINE__,$coderr);
          return $coderr;
      };
  } elsif (defined $rdtj->{uso} and defined $rdtj->{definicion}) {
      impr_debug(__LINE__.' Elem $rdtj', Dumper $rdtj);
      ($coderr,@mensajes) = definir_formula_texto($reflay, $rdtj);
      if ($coderr) {
          $rdemj->{$rdtj->{numobj}} = join "\n",@mensajes;
      };        
  };
  comfin('fine definir_texto linea ',__LINE__,$coderr);
  return $coderr;
#  #impr_debug(__LINE__.' Elem defidibu',   Dumper $rdb);
#  #impr_debug(__LINE__.' Elem defitexto',   Dumper $rdt);
#  my $rde = $reflay->{defiele}; #en definir_dibu se lleno ->{datospcs} y .... 
#  my $rden = $rde->{nombre} = {};
#  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
#  foreach my $nombre (sort keys %$rden) {
#      my $rdenn = $rde->{nombre}->{$nombre};
#      my $clasepcs = $rdenn->{clasepcs};
#      $rde->{datosclasepcs}->{$clasepcs}->{nombre} = $nombre;
#      foreach my $palabra ('cod', 'codvalor', 'otrosnodos') {
#          my @lista = union_conjunto(@{$rdenn->{$palabra}}); 
#          if (@lista == 1) {
#              $rde->{datosclasepcs}->{$clasepcs}->{$palabra}
#                = $lista[0];
#              delete $rdenn->{$palabra};
#          } else {
#              porparar1(66,$reflay);
#              return 66;
#          };    
#      };
#  };
  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
#  foreach my $texto (keys %$rdb) {
#      my $rdbt = $rdb->{$texto};   
#      defined $rdbt->{numobj} or
#      do {porparar1(30,$reflay,"No hay ningun cuadro USO_DEF para
#       íconos identificados con \"$texto\"; lugares: $rdbt->{stringlugares}"); 
#          return 30;
#      };
#      @{$rdbt->{numobj}} == 1 or 
#      do {porparar1(31,$reflay,"Hay más de un cuadro USO_DEF con 
#           texto identificatorio para los elementos \"$texto\"");
#          return 31;        
#      };
#      my $numobj = $rdbt->{numobj} = $rdbt->{numobj}->[0];
  #impr_debug(__LINE__.' Elem defiele',   Dumper $rde);
  #impr_debug(__LINE__.' Elem defitexto',   Dumper $rdt);
#      my $nombre = $rdt->{$numobj}->{nombre};       
#      #a varios $textos puede corresponder igual nombre
#      defined $rde->{nombre}->{$nombre} or  $rde->{nombre}->{$nombre} = {};
#  }; 
#  impr_debug(__LINE__.' Elem defitexto',   Dumper $reflay->{defitexto});
#  comfin('fine definir_texto');
#  return '';
} 
# ----------------------------------------------------------------------------
sub mirar_NODOS{
  comfin('come mirar_NODOS', @_);
  my ($reflay, $nombre, $formula,$texto,$numobj) = @_;
  my ($rdb, $rdt, $rde) = @$reflay{'defidibu', 'defitexto', 'defiele'}; 
  my ($rden, $rdenn) = ($rde->{nombre},$rde->{nombre}->{$nombre});
  my $rdennff = $rdenn->{formula}->{$formula};
  #impr_debug(__LINE__.' Elem defitexto comienzo mirar_NODOS'
  #    ,Dumper $rdt);
  #impr_debug(__LINE__.' Elem defiele comienzo mirar_NODOS'
  #    ,Dumper $rde);
  #impr_debug(__LINE__.' Elem defidibu comienzo mirar_NODOS'
  #    ,Dumper $rdb);
  my $clasepcs = $rdb->{$texto}->{clasepcs};
  $rdenn->{clasepcs} = $clasepcs;
  my $comodin = $rdennff->{comodin};
  $rdennff->{uni}->{$comodin} = $rdb->{$texto}->{nodos} 
      if $rdb->{$texto}->{nodos};
  
  #my @lista = @{$rdt->{$numobj}->{nodos}};

   #my @OTROS = grep (/^otrosnodos/i,@lista);
  my @OTROS = @{$rdt->{$numobj}->{otrosnodos}};
  my $cod = $rdenn->{cod}->[-1];#si hay mas de uno se detecta luego el error
  my $nodosot;
  my $cuantosnodos 
     = $rde->{datosclasepcs}->{$clasepcs}->{cuantosnodos}; 
  if (@OTROS >1) {
      porparar1(45,$reflay, 'Hay ' . scalar @OTROS
               .' > 1 renglones con otrosnodos');
      return 45;
  } elsif (@OTROS) {
      my $renglonnodos = $OTROS[0];
      if ($renglonnodos =~ /^\s*(.+)/i) { 
          $nodosot = $1;
          $nodosot =~ s/\s+//g;
          push @{$rdenn->{otrosnodos}}, $nodosot;
          my $preg= ($nodosot =~ tr/?//);
          my $cuantosot = ($nodosot =~ tr/-//) +1;
          if ($preg >1) {
              porparar1(46,$reflay
              ,"Más de un signo ? en OTROSNODOS = $nodosot"); 
              return 46;
          } elsif ($cuantosot != 2 and $cod =~ /[CEJLR]/) {          
              porparar1(47,$reflay,descripcion_cuadro($numobj) 
                  . " indica,con OTROSNODOS número distinto de dos conexiones
                      para el elemento identificado con $texto");
              return 47;
          } elsif ($preg == 1 and defined $rdenn->{cuantosnodos}) {      
              if ($cuantosnodos != 1 and $cod =~ /[CEJLR]/) { 
                  porparar1(48,$reflay,"Inconsistencia entre parte grafica y 
                  textual sobre cantidad de conexiones");
                  return 48;
              };
          };
      } else {
          #$rdb->{$texto}->{otrosnodos} = '';
          push @{$rdenn->{otrosnodos}}, '';
          if (not defined $cuantosnodos and  $cod ne 't') {
              porparar1(49,$reflay,"Elemento identificado con $texto, 
              sin conexiones, pero no declarado con código \"t\"");
              return 49; 
          } elsif ($cuantosnodos != 2 and $cod =~ /[CEJLR]/) { 
              porrparar1(50,$reflay,"Cantidad de conexiones, $cuantosnodos,
              incorrecta para los íconos, de clase $cod,
              identificados con $texto"); 
              return 50;  
	  };
      };
  } else {
          push @{$rdenn->{otrosnodos}}, '';
  };

  #@lista = grep (/^funcionesdenodos/i,@lista); #en mirar_NODOS
  my $reflista = $rdt->{$numobj}->{funcionesdenodos};
  impr_debug(__LINE__.' Elem ',Dumper $reflista );
  if (defined $reflista and @{$reflista}) {
      my @lista = @$reflista;
      #map (s/^funcionesdenodos\s*//i, @lista);
      #map (s/^=\s*//, @lista);
      @{$rdennff->{funcionesdenodos}} = @lista;
      @lista = union_conjunto(@lista); my %usado;
      my $defin = $rdt->{$numobj}->{definicion}; my $mal = '';
      my @nonodos;
      #impr_debug(__LINE__.' Elem ', $defin); 
      foreach (@$defin) {
          my ($izq,$der) = /^(\w+)=(.+)$/; $der = ";$der;";
          foreach my $func (@lista) {
	      #impr_debug(__LINE__.' Elem $der', $der); 
              while ($der =~ s/(\W$func\()(\w+)\)/$1&NODOELEM$2\)/) {
                  $usado{$func} = 1;
                  push @{$rdt->{$numobj}->{NODOELEM}},$2;
                  push @{$rdennff->{nodoelem}},$2;
                  $rdb->{$texto}->{esunnodo}->{$2} or
		  push @nonodos, $2;
              };
              if ($der =~ /\W$func(\W)/ and $1 ne '(') {
                  $mal = 1;
              };  
                 
          };
          $der =~ s/&//g; 
          $der =~ s/^;(.*);$/$1/;
          $_ = "$izq=$der";
      };
      @nonodos and 
      do {porparar1(51, $reflay, "@nonodos debieran ser nodos y no lo son");
          return 51; 
      };            
      #impr_debug(__LINE__.' Elem %usado', Dumper \%usado);
      #impr_debug(__LINE__.' Elem @lista', Dumper \@lista);
      scalar keys %usado == @lista and not $mal  or
      do {avnograv("Hay funcionesdenodos (@lista) no usadas (o no bien usadas)
                 en USO_DEF de $nombre");  
      };
      $rdt->{$numobj}->{definicion} = $defin;
  } else {
      $rdennff->{funcionesdenodos} = [];
  };
  #impr_debug(__LINE__.' Elem defiele',Dumper $rde);
  comfin('fine mirar_NODOS');
  return '';  
}  
# ----------------------------------------------------------------------------
sub mirar_CONDICION{
  comfin('come mirar_CONDICION', @_);
  my ($reflay, $nombre, $formula) = @_;
  my $rdennff = $reflay->{defiele}->{nombre}->{$nombre}->{formula}->{$formula};
  #impr_debug(__LINE__.' Elem $rdennff condicion'
  #      , Dumper $rdennff->{condicion});
  #cada condicion (numerada)  puede ser un or ||  de varias otras and &
  #no admito parentesis
  map (s/CONDICION\s*=\s*//i,@{$rdennff->{condicion}});
  map (s/CONDICION//i, @{$rdennff->{condicion}});
  my @listacond = @{$rdennff->{condicion}}; 
  my $stringcond = "@listacond";
  $stringcond =~ /[\(\)\+\-\*\/]/ and
      do {$stringcond = join "\n       ", @listacond;
porparar1(55,$reflay
       ,"No se admiten paréntesis ni operaciones aritméticas en 
         las condiciones\n       $stringcond");
        return 55;
  }; 
  foreach my $cond (@listacond) {
      my $resul = eval($cond);
      my @listaor = split /\s*\|\|\s*/, $cond;
      #impr_debug(__LINE__.' Elem $cond',[$cond,$resul]);
      foreach my $expror (@listaor) {
          my @listaand = split /\s*&\s*/, $expror;
          my $resul = eval($expror);
          #impr_debug(__LINE__.' Elem   $expror',[$expror,$resul])
          #    if @listaor >1;
          foreach my $compa (@listaand) {
              my ($pal1,$op,$pal2,);
              my $resul = eval($compa);
              #impr_debug(__LINE__.' Elem      $compa',[$compa,$resul]);
              if(($pal1,$op,$pal2) = ($compa =~ /\s*(\w+)(\W+)(\w+)/)) {
                  foreach my $var ($pal1,$pal2) {
                      my($tipo,$nvalor) = tipear($var,0);
		      $rdennff->{varcond}->{$var}= 1  if ($tipo ne 'n');
                  }; 
              } else {
                  porparar1(56,$reflay,"En  $cond para $nombre
                  no se entiende $compa ; deberia ser una comparación"); 
		  return 56;
              };

          };
      };
  };
  my $stringlistaarg = ';'. join (',',@{$rdennff->{listaarg}}) .';';
  foreach my $var (keys %{$rdennff->{varcond}}) {
      if ($stringlistaarg =~ /\W$var\W/) {
          $rdennff->{varcond}->{$var} = 'arg'; 
      } elsif (defined $rdennff->{PARAMETROS}->{$var}) {   
          $rdennff->{varcond}->{$var} = 'PARAMETROS';
      } else {     
          porparar1(57,$reflay, "En las condiciones:\n"
          . join("/n",@listacond) . "no se reconoce $var");
          return 57;
      };
  };
  #impr_debug(__LINE__.' Elem varcond', Dumper $rdennff->{varcond});  
  #impr_debug(__LINE__.' Elem',Dumper $rdennff); 
  comfin('fine mirar_CONDICION');
  return '';
}  
# ----------------------------------------------------------------------------
sub mirar_DEF{
  comfin('come mirar_DEF', @_);
  my ($reflay,$rdtj,$refrenglonesdef) = @_; my $coderr = ''; my $mensaje;
  my @renglonesdef = @$refrenglonesdef;
  ($coderr,@renglonesdef)
      = juntar_por_signos_y_paren('',@renglonesdef);
  if ($coderr) {
      $coderr = 27;
      $mensaje = "Error de sintaxis en:". join ("\n",@renglonesdef);
  } else {
      map (s/\s+//g,@renglonesdef);  
      $rdtj->{definicion} = \@renglonesdef;
  }; 
  comfin('fine mirar_DEF', $coderr,$mensaje);
  return $coderr,$mensaje;
}  
# ----------------------------------------------------------------------------
sub mirar_USO{
  comfin('come mirar_USO', @_);
  my ($reflay,$rdtj,$refrenglonesuso) = @_; my $coderr = ''; my $mensaje = '';
  my $rdb = $reflay->{defidibu};
  impr_debug(__LINE__.' Elem $reflay->{refidibu}',Dumper $rdb);
  my @renglonesuso = @$refrenglonesuso;
  ($coderr,@renglonesuso) = juntar_por_signos_y_paren('',@renglonesuso);
  if ($coderr) {
      $coderr = 28;
      $mensaje = "Error de sintaxis en:" . join ("\n",@renglonesuso);
      return $coderr,$mensaje;
  } else {
      if (@renglonesuso == 1) {
          my $renglon = $renglonesuso[0];
          $renglon =~ s/\s+//g; 
          impr_debug(__LINE__.' Elem $renglon',$renglon);
          if ($renglon =~ /^([CEJLRcejlr])(\w+)=(\w)([^,]+),(.*+)$/) {
              @$rdtj{'uso','comodin','formula','stringargs'}
                = ($renglon,"$1$2","$3$4",$5);
              my $comodin = $rdtj->{comodin};
              my $rdbt = $rdb->{$comodin};
              if (not defined $rdbt) {
                  $coderr = 22;
                  $mensaje = "No hay ningun ícono para $comodin";
                  return $coderr, $mensaje;
              };  
              @$rdtj{'cod','clasepcs'} = @$rdbt{'cod','clasepcs'};
              push @{$rdbt->{numobj}}, $rdtj->{numobj};
	      my $cod = $rdtj->{cod};
              if ($cod eq uc($cod) and $rdtj->{otrosnodos} ne '? - ?') {
                  $coderr = 24;
                  $mensaje = " No corresponde definir 'OTROSNODOS'";
                  return $coderr,$mensaje;
              };
          } else {
              $coderr = 28;
              $mensaje = "Error de sintaxis en:\n$renglon";
               comfin('fine mirar_USO linea $coderr,$mensaje'
                 ,__LINE__, $coderr,$mensaje);
               return $coderr,$mensaje;
          };
      } else { 
          my $renguso = join "\n       ", @renglonesuso;
          $coderr = 26;
          $mensaje = " Parte de USO con más de un renglon:\n   $renguso";
          return $coderr,$mensaje;
      };      
  };   
  comfin('fine mirar_USO', $coderr,$mensaje);
  return $coderr,$mensaje;
}  
# ----------------------------------------------------------------------------
sub mirar_USO_DEF{
  comfin('come mirar_USO_DEF', @_);
  my ($reflay,$rdtj,$rdemj,$refrenglones) = @_;
  my $coderr = ''; my $mensaje;
  my $numobj = $rdtj->{numobj};
  my @renglones = @$refrenglones;
  my @malos = grep (/&/, @renglones);
  if (@malos) {
      $coderr = 20;
      $rdemj->{$numobj} = ' No deben aparecer símbolos "&" en el cuadro';
      return $coderr;
  };
  my $renglon = shift @renglones;
  while ($renglon !~ /^=\s*\>\s*\{(.*)\}/ and @renglones) {
      $renglon  .= '&' . shift @renglones;
  };
  impr_debug(__LINE__.' Elem $renglon para ayudar', $renglon);
  my (@renglonesuso,@renglonesdef);
  if (my ($antes,$despues,$malo) 
        = ($renglon =~/^(.+)=\s*\>[\s&]*\{(.*)\}(.*)$/)) {
      @renglonesuso = split /\s*&\s*/, $antes;
      @renglonesdef = split /\s*&\s*/, $despues; 
      unshift @renglones, $malo if $malo;         
  } else {
      $coderr = 20;
      $rdemj->{$numobj}
         = ' Error de sintaxis: no aparecen  separadores "=>{" y "}"
           en la parte de definicion';
      return $coderr;
  };
  push @renglonesdef, @renglones;
  impr_debug(__LINE__.' Elem ,@renglonesuso',\@renglonesuso);
  my $todosren =  "@renglonesuso @renglonesdef";
  if ($todosren  =~ /[\{\}]/) {
      $coderr = 20;
      $rdemj->{$numobj} = " Hay llaves de más en la parte de definicion";
      return $coderr;
  };
  if (@renglones) {
      $coderr = 20;
      $rdemj->{$numobj}
        = " Hay texto luego del separador final en la parte de definicion";
      return $coderr;
  };
  @renglonesuso =  grep (/\S/,@renglonesuso);
  @renglonesdef = grep (/\S/,@renglonesdef);
  impr_debug(__LINE__.' Elem ,@renglonesuso',\@renglonesuso);
  if (@renglonesuso) {
      $rdtj->{uso} = \@renglonesuso;
      ($coderr, $mensaje) = mirar_USO($reflay,$rdtj,\@renglonesuso);
  impr_debug(__LINE__.' Elem $coderr $mensaje',[$coderr,$mensaje]);
  } else {
      $coderr = 20;
      $mensaje = " Falta parte de uso";
  };
  impr_debug(__LINE__.' Elem $coderr $mensaje',[$coderr,$mensaje]);
  if (not $coderr ) {
      if (@renglonesdef) {
          $rdtj->{definicion} = \@renglonesdef;
          ($coderr,$mensaje) = mirar_DEF($reflay,$rdtj,\@renglonesdef);
      } else {
          $coderr = 28; 
          $mensaje = " Sin parte de definicion";
      };
  } else {
      $rdemj->{$numobj} = $mensaje; 
  };
  comfin('fine mirar_USO_DEF',$coderr);
  return $coderr; 
# ----------------------------------------------------------------------------
sub relacionar_buenos_cuadros{
  # compara los distintos cuadros de una misma capa entre si y
  # con los iconos de la capa 
  # cada cuadro USO_DEF esta asociado a un nombre que puede compartir con otros 
  # los cuadros USO_DEF que no definen tierras, estan asociados a:
  # un comodin (solo para el cuadro)
  # una formula
  # y uno o mas iconos en el diagram (solos para el cuadro)
  # cuadros distintos pueden tener igual nombre pero en ese caso,
  #    las formulas deben ser distintas pero:
  # Cada pcs que aparezca en la capa con la identificacion del comodin 
  # recibe el nombre; el uc(codigo del icono) debe coincidir
  # con el uc(primer letra del comodin)
  # lo bueno de la capa, de $reflay->{defitexto} para a $reflay_defiele  
  comfin('come relacionar_buenos_cuadros',@_);
  my ($reflay,@buenosnumobjs) = @_; 
  my $rdt = $reflay->{defitexto};
  my $numcapa = $reflay->{numcapa};
  my $rde = $reflay->{defiele} = {};
  impr_debug(__LINE__.' Elem $rdt', Dumper $rdt);
  impr_debug(__LINE__.' Elem $rde', Dumper $rde);
  my ($refcualnumobj,$refcual2,$refcual0) = ({},{},{});
  my @palabras1 = ('nombre','clasepcs','comodin'); 
  my @palabras2 = ('formula','otrosnodos'); 
  foreach my $numobj (@buenosnumobjs) {
      my $rdtj = $rdt->{$numobj};
      foreach my $palabra (@palabras1) {
          push @{$refcualnumobj->{$palabra}->{$rdtj->{$palabra}}}, $numobj;
      };
      foreach my $palabra (@palabras2) {
          push @{$refcual2->{$rdtj->{nombre}}->{$palabra}},$rdtj->{$palabra};
      };
  };
  impr_debug(__LINE__.' Elem $refcual2',Dumper $refcual2);
  my @malosnombres;
  foreach my $nombre (keys %{$refcualnumobj->{nombre}}) {
      next if @{$refcualnumobj->{nombre}->{$nombre}} == 1;
      my @otrosnodos = union_conjunto(@{$refcual2->{$nombre}->{otrosnodos}});
      if (@otrosnodos > 1) {
          mensajear("Mas de un otrosnodos para nombre $nombre: @otrosnodos");
          push @malosnombres, $nombre;
      };
#      my @codigos = union_conjunto(@{$refcual2->{$nombre}->{codvalor}});
#      if (@codigos > 1) { 
#	  mensajear(" Mas de un codvalor para nombre $nombre: @codigos");
#          push @malosnombres, $nombre;
#      };
      my $cuantasformulas = {};
      map (do{$cuantasformulas->{$_}++},@{$refcual2->{$nombre}->{formula}});
      my @repeformulas = grep(do{$cuantasformulas->{$_}>1}
          ,keys %$cuantasformulas);
      impr_debug(__LINE__.' Elem $cuantasformulas para '.$nombre
        ,$cuantasformulas);
      foreach my $formula (@repeformulas) {
         impr_debug(__LINE__.' Elem $refcual2->{$nombre}->{formula}'
             , $refcual2->{$nombre}->{formula});
          mensajear(
	  " Hay redefinicion de formula $formula para nombre $nombre");
          push @malosnombres, $nombre;
     }; 
  }; 
  foreach my $comodin (keys %{$refcualnumobj->{comodin}}) {
      next if @{$refcualnumobj->{comodin}->{$comodin}} == 1;
      my @cualesnumobjs =  @{$refcualnumobj->{comodin}->{$comodin}};
      my $clasepcs = $rdt->{$cualesnumobjs[0]}->{clasepcs};
      my @lugares = Topologia::lugares_clasepcs($reflay,$clasepcs);    
      mensajear (" $comodin, que aparece en @lugares,
              es necesitado por mas de un cuadro:");
      map(do{mensajear(descripcion_cuadro($_))},@cualesnumobjs);
  };
  my ($pcs2nombre,@listatotalpcss);
  foreach my $clasepcs (keys %{$refcualnumobj->{clasepcs}}) {
      my @listapcss = split 'd', $clasepcs;
      push @listatotalpcss,@listapcss;
      my $refcual = {};
      foreach my $pcs (@listapcss) {
          push @{$refcual0->{$pcs}},@{$refcualnumobj->{clasepcs}->{$clasepcs}};
          my @listanumobjs = @{$refcualnumobj->{clasepcs}->{$clasepcs}};
          foreach my $numobj (@listanumobjs) {
              push @{$pcs2nombre->{$pcs}}, $rdt->{$numobj}->{nombre};
          };
          @{$pcs2nombre->{$pcs}}
            = union_conjunto(@{$pcs2nombre->{$pcs}});
      };
  };
  impr_debug(__LINE__.' Elem $pcs2nombre',Dumper $pcs2nombre);
  @listatotalpcss = union_conjunto(@listatotalpcss);
  impr_debug(__LINE__.' Elem @listatotalpcs',\@listatotalpcss);
  foreach my $pcs (@listatotalpcss) {
      if (@{$pcs2nombre->{$pcs}} >1) {
          my ($numplant,$numshape) = ($pcs =~ /^(.+)c(.+)$/);
          impr_debug(__LINE__.' Elem $numcapa,$numplant,$numshape'
		     ,[$numcapa,$numplant,$numshape]);
          my (@idens,@lugares);
          foreach (1 .. scalar @$laylista -1) {
              if ($laylista->[$_] == $numcapa
                  and $plantillalista->[$_] == $numplant
                  and $shapelista->[$_] == $numshape) {
                  push @idens,"$codlista->[$_]$textolista->[$_]";
		  push @lugares,$lugarlista->[$_];
              };
          };
          mensajear(" El icono $pcs, con identificaciones:  @idens,
           que aparece en lugares: @lugares 
              recibe mas de un nombre: @{$pcs2nombre->{$pcs}}");
          push @malosnombres,@{$pcs2nombre->{$pcs}};
      } else {
          $reflay->{defiele}->{pcs2nombre}->{$pcs}
             = $pcs2nombre->{$pcs}->[0];
      };
  };
  if (@malosnombres) {
      my (%malonombre,%cualnumobjnombre,@buenos); 
      map(do{$malonombre{$_} = 1},@malosnombres);
      foreach my $numobj (@buenosnumobjs) {
          my $nombre = $rdt->{$numobj}->{nombre};
          if ($malonombre{$nombre}) {
              push @{$cualnumobjnombre{$nombre}}, $numobj;
          } else {
              push @buenos,$numobj;
          };
      };
      foreach my $nombre (keys %malonombre) {
          mensajear( 
           " _ _ Problemas de competencia con cuadros para el nombre $nombre");
          foreach my $numobj (@{$cualnumobjnombre{$nombre}}) {
               mensajear(descripcion_cuadro($numobj));
          };
      };
      @buenosnumobjs = @buenos;
   };     
  impr_debug(__LINE__.' Elem $refcual0', Dumper $refcual0);
  impr_debug(__LINE__.' Elem $pcs2nombre',Dumper $pcs2nombre);  
  impr_debug(__LINE__.' Elem $refcualnumobj',Dumper $refcualnumobj);
  comfin('fine relacionar_buenos_cuadros',@buenosnumobjs);
  return @buenosnumobjs;
} 
# ----------------------------------------------------------------------------
sub revisar_clasespcs{
  # revisa lo de $ref y copia lo bueno en $ref1
  comfin('come revisar_clasespcs', @_);
  my ($ref,$ref1) = @_; my $coderr = ''; my @mensajes;
  my (%malnumobj);
  impr_debug(__LINE__.' Elem $ref->{clasepcs2codvalor}'
	     , Dumper $ref->{clasepcs2codvalor});
  impr_debug(__LINE__.' Elem $ref->{clasepcs2nombre}'
	     , Dumper $ref->{clasepcs2nombre});

  foreach my $clasepcs (keys %{$ref->{cualnumobjclasepcs}}) {
      if ((@{$ref->{clasepcs2codvalor}->{$clasepcs}} == 1) and
          (@{$ref->{clasepcs2nombre}->{$clasepcs}} == 1)) {
          my $codvalor = $ref->{clasepcs2codvalor}->{$clasepcs}->[0];
          my $nombre = $ref->{clasepcs2nombre}->{$clasepcs}->[0];
          push @{$ref->{codvalor2clasepcs}->{$codvalor}}, $clasepcs;
          push @{$ref->{nombre2clasepcs}->{$nombre}}, $clasepcs;
          push @{$ref1->{cualnumobjclasepcs}->{$clasepcs}}
	    , @{$ref->{cualnumobjclasepcs}->{$clasepcs}};
          $ref1->{clasepcs2codvalor}->{$clasepcs}
	    = $ref->{clasepcs2codvalor}->{$clasepcs}->[0];
          $ref1->{clasepcs2nombre}->{$clasepcs}
            = $ref->{clasepcs2nombre}->{$clasepcs}->[0];
          push @{$ref1->{codvalor2clasepcs}->{$codvalor}}
	  , $clasepcs;
          push @{$ref1->{nombre2clasepcs}->{$nombre}}
	  , $clasepcs;
      } else {
 	  $ref1->{malaclasepcs}->{$clasepcs} = 1;
      };
  };
  impr_campo(__LINE__.' Elem $ref1',$ref1,'codvalor2clasepcs');
  foreach my $codvalor (keys %{$ref1->{codvalor2clasepcs}}) {
      if (@{$ref1->{codvalor2clasepcs}->{$codvalor}} > 1) {
  	  map (do {my $clasepcs = $ref1->{codvalor2clasepcs}->{$_}->[0];
                   $ref1->{malaclasepcs}->{$clasepcs} = 1}
               ,keys %{$ref1->{codvalor2clasepcs}}); 
      };
  };
  impr_campo(__LINE__.' Elem $ref1',$ref1,'nombre2clasepcs');
  foreach my $nombre (keys %{$ref1->{nombre2clasepcs}}) {
      if (@{$ref1->{nombre2clasepcs}->{$nombre}} > 1) {
  	  map ( do {my $clasepcs = $ref1->{nombre2clasepcs}->{$_}->[0];
                  $ref1->{malaclasepcs}->{$clasepcs} = 1}
		,keys %{$ref1->{nombre2clasepcs}});
      };
  };
  impr_campo(__LINE__.' Elem $ref1',$ref1,'malaclasepcs');  
  impr_debug(__LINE__.' Elem @mensajes',join "\n",@mensajes);
  comfin('fine revisar_clasespcs',$coderr,@mensajes);
  return $coderr,@mensajes;
}#revisar_clasespcs  
# ----------------------------------------------------------------------------
sub tratar_1capa_ele{
  comfin('come tratar_1capa_ele', @_);
  my $numcapa = $_[0];my $coderr = '';
#  my $numfile = $refarch->{numfile};
my $refgraf = {};my $refarch = {};#  my $refgraf = $refgrafers[$numfile];
  my (@buenosnumobjs,@sobranidens,@sobrannumobjs);
      defined $reflayers[$numcapa] or next;
      my $reflay = $reflayers[$numcapa];
      my $rde = $reflay->{defiele} = {};
      my $rdemj = $rde->{malnumobj} = {}; 
      definir_dibu($numcapa,$reflay,$refgraf);
      next unless defined $reflay->{refvalores}->{USO_DEF};
      my $rdt = $reflay->{defitexto} = {}; 
      my %todos = %{$reflay->{refvalores}->{USO_DEF}};
      @buenosnumobjs = keys %todos;
      foreach my $numobj (@buenosnumobjs) {
          my $rdtj = $rdt->{$numobj} = {};
          $rdtj->{numobj} = $numobj;
          $rdtj->{numcapa} = $numcapa;
          my @renglones = @{$todos{$numobj}};
          impr_debug(__LINE__.' Elem @renglones',"\n".join("\n",@renglones)); 
          $coderr = definir_texto($reflay,$rdtj,$rdemj,\@renglones);
          if ($coderr) {
              delete $rdt->{$numobj};
          };
      }; # $numobj
 
      if (scalar keys %{$rdemj}) {
          mensajear (" _ _ _ Cuadros USO_DEF ignorados por errores:");
          foreach my $numobj (keys %{$rdemj}) {
              mensajear (descripcion_cuadro($numobj) ."\n" 
			 . $rdemj->{$numobj});
	  }
          @buenosnumobjs = grep 
	      (do{not defined $rdemj->{$_}}
            , @buenosnumobjs);
          impr_debug(__LINE__.' Elem @buenosnumobjs',\@buenosnumobjs);
      }; 
      foreach my $iden (keys %{$reflay->{defidibu}}) {
          my $rdbt = $reflay->{defidibu}->{$iden};
          if (not defined $rdbt->{numobj} or not @{$rdbt->{numobj}}) {
              push @sobranidens, $iden;
	  };
      }; 
      impr_debug(__LINE__.' Elem @sobranidens',\@sobranidens);
      if (@sobranidens) {
          my (@listaobjs, @listaidens, @listatierrasobjs);
          foreach my $iden (sort @sobranidens) {
              if (substr($iden,0,1) =~ /^[CEJLR]$/i) {
                  push @listaobjs, @{$reflay->{cualobjele}->{$iden}};
                  push @listaidens, $iden;
              } elsif ($iden eq 't&') {
                  push @listatierrasobjs
                    , @{$reflay->{cualobjnoigno}->{'t&'}};
               };
          };
          if (@listaobjs) {
               my (@lugares,$stringlugares);
               map(do{push @lugares,$lugarlista->[$_]},@listaobjs);
               $stringlugares = join " ",@lugares;
               mensajear
            (" _ _ Iconos ignorados por no intervenir en ninguna definicion,
           identificados como  @listaidens, en lugares: $stringlugares");
          };
          if (@listatierrasobjs) {
               my (@lugares,$stringlugares);
               map(do{push @lugares,$lugarlista->[$_]},@listatierrasobjs);
               $stringlugares = join " ",@lugares;
               mensajear
            (" _ _ Iconos ignorados por no intervenir en ninguna definicion,
           sin identificacion, en lugares: $stringlugares");
          };
      };
      impr_debug(__LINE__.' Elem buenosnumobjs',\@buenosnumobjs);
      if (@buenosnumobjs) {
          (@buenosnumobjs) = relacionar_buenos_cuadros($reflay,@buenosnumobjs);
      };
      $reflay->{defiele}->{buenosnumobjs} = \@buenosnumobjs;
      impr_campo(__LINE__.' Elem $reflay',$reflay,'defidibu');
      impr_campo(__LINE__.' Elem $reflay',$reflay,'defitexto');
      impr_campo(__LINE__.' Elem $ref1',$reflay,'codvalor2clasepcs');
      impr_campo(__LINE__.' Elem $reflay',$reflay,'defiele');
      if (not $reflay->{defiele} or 
          not $reflay->{defiele}->{buenosnumobjs}
          or not @{$reflay->{defiele}->{buenosnumobjs}}) {
          mensajear(" No quedo niguna definicion en\n   "
		     . descripcion_capa($reflay->{numcapa}));
          $reflay->{clasecapa} = 'nada';
          @{$refarch->{capasele}}
	  = grep ($_ !~ $numcapa, @{$refarch->{capasele}});
      } else {
          guardar_defiele($refarch,$reflay);
      };
  comfin('fine tratar_1capa_ele');
  return;
}#tratar_1capa_ele
# ----------------------------------------------------------------------------
sub tratar_capas_olo{
  comfin('come tratar_capas_ele', @_);
  my $refarch = $_[0];my $coderr = '';
  $refarch->{defiele} = {};
  my (@buenosnumobjs,@sobranidens,@sobrannumobjs);
  foreach my $numcapa (@{$refarch->{capasele}}) {
      tratar_1capa_ele($refarch,$numcapa);
  };# capa 
  if ($refarch->{clasearch} eq 'elementos' and not @{$refarch->{capasele}}) {
      $refarch->{viejaclasearch} = 'elementos';
      $refarch->{clasearch} = 'nada';
  };
  comfin('fine tratar_capas_olo',$coderr);
  return;
}  
# ----------------------------------------------------------------------------
sub guardar_defiele{
  # lleva las definiciones de elementos que han sobrevivido de un $reflay 
  # a $refarch; la primera $reflay no tiene inconvenientes; una no primera
  #  no debe chocar con las anteriores
  comfin('come guardar_defiele', @_);
  my ($refarch,$reflay) = @_;
  my $rde = $reflay->{defiele};
  defined $refarch->{sobreformulas} or $refarch->{sobreformulas} = {};
  my $rdf = $refarch->{sobreformulas};
  impr_debug(__LINE__.' Elem comienzo $rdf',Dumper $rdf); 
  foreach my $numobj (@{$reflay->{defiele}->{buenosnumobjs}}) {
      impr_debug(__LINE__.' Elem $numobj ',$numobj);
      my $rdtj = $reflay->{defitexto}->{$numobj};
      my ($clasepcs,$nombre,$formula,$otrosnodos)
            = @$rdtj{'clasepcs','nombre','formula','otrosnodos'};
      impr_debug(__LINE__.' Elem $numobj '
        ,[$numobj,$clasepcs,$nombre,$formula,$otrosnodos]);
      my @listapcss = split 'd',$clasepcs;
      my @listitapcss = grep(do {$rdf->{yaestapcs}->{$_}},@listapcss);
      my (@clases,@nombres);
      map (do{push @clases,$rdf->{yaestapcs}->{$_}->[0]},@listitapcss);
      map (do{push @nombres,$rdf->{yaestapcs}->{$_}->[1]},@listitapcss);
      if (@clases) {
          @clases = union_conjunto(@clases);
          @nombres = union_conjunto(@nombres);
          if (@clases > 1 or $clasepcs ne $clases[0]) {
              mensajear(" Ahora $clasepcs; ya registradas:  @clases");
              return;
          };
          if (@nombres > 1 or $nombre ne $nombre) {
	      mensajear(" Ahora $nombre; ya registrados:  @nombres");
              return;
          };
      } else {
          foreach my $pcs (@listapcss) {
              $rdf->{yaestapcs}->{$pcs} = [$clasepcs,$nombre];
          };
      }; 
      defined $rdf->{nombre}->{$nombre}->{formula} or
          $rdf->{nombre}->{$nombre}->{formula} = {}; 
      my @formulas = keys %{$rdf->{nombre}->{$nombre}->{formula}};
      if (grep (do {$formula eq $_},@formulas)) {
          mensajear (" Hay definicion anterior de $formula");
          return '';
      } else {
          $rdf->{nombre}->{$nombre}->{formula}->{$formula}
            = $rdtj;
      };
      impr_debug(__LINE__.' Elem final $rdf',Dumper $rdf); 
 };
  comfin('fine guardar_defiele');
  return '';
}  
# ----------------------------------------------------------------------------
sub tratar_1capa_mod{
  comfin('come tratar_capa_mod', @_);
  comfin('fine tratar_capa_mod');
  return '';
}  
# ----------------------------------------------------------------------------
}
1
