package Simusol::GlobalesSimusol;
#variables y constantes globales
use Simusol::Ayudas;
use Simusol::Auxiliares;
#use Simusol::Evaluaciones;
use warnings;
use strict;
use Text::Abbrev;
use Data::Dumper;
$Data::Dumper::Indent = 1; 
our $version= 0.87;
our $HOME = $ENV{HOME}; 
my @listainstall;
#foreach my $inst ($HOME,"/usr/local") {
#    if (-d "$inst/share/simusol/") {
#        push @listainstall,$inst;
#    };
#};
@listainstall = ("/usr/local");
@listainstall or parary(250," Simusol no esta instalado");
our $INSTALLDIR = $listainstall[0]; 
our $SIMUSOLBINDIR =  "$INSTALLDIR/bin";
our $SIMUSOLLIBDIR = "$INSTALLDIR/lib/simusol";
our $INSTDIR; #directorio que tendrá los ejecutables de sceptre
if (-e "$INSTALLDIR/bin/sceptre") {
    $INSTDIR = $INSTALLDIR
} else { 
    $INSTDIR = `which sceptre`;
    $? and die " sceptre no está disponible\n";
    chomp $INSTDIR;
    $INSTDIR =~ s/\/bin\/sceptre//;
}; 
our $LIBDIR = "$INSTDIR/lib";
our $BINDIR = "$INSTDIR/bin";
our (@Dia2Simusol,@Simusol2Dia); #conversion de numero de objetos
# hay una conversion para cada diagrama procesado
#our %opt_hash; #cada script comparte variables our con las subrutinas 
# llamadas por el ( siempre que ...
# pero dos scripts (uno llama al otro pero a traves de system) 
# no comparten esas variables; simusol y simusol1.pl no comparten $opt_hash
our %nombresusados; #key nombre de elemento no rama; general; values 1;
    #se usa para cuando hay que crear elementos JN...
our %expr_usadas; #key identificacion de expres. usadas

#our %modelo; #key nombre del modelo; value referencia a los datos del
    # circuito que lo definio; $DEFIMOD sustituye       
#our %circ_model; #hash con key nombre (CORTO) de archivo y 
    #value referencia al  hash con datos del circuito
our $reftrabajo; # referencia a hash de referencias
     # a datos de archivos; key nombres de
     #archivo; value referencia a un hash
our %reffiele;# hash de referencias a definiciones de elementos 
     # de un archivo; key nombre de archivo;
     #value referencia a un hash 
our %reffimod;# hash de referencias a definicion de un modelo;
     #key nombre de archivo; value referencia a un hash 
# un mismo archivo puede ser key para los tres anteriores
our %reffipri;# hash de referencias a datos de archivos complementarios;
    # key nombres de archivo; value referencia a un hash 
our %refficompl;# hash de referencias a datos de archivos complementarios
    # de uno dado;
    # key nombres de archivo principal; value referencia a un hash  
    #que tiene como keys nombres de archivos secundarios
our %clasearchivos; #hash con key nombre de archivo y value: 
    # modelo, elementos  o circuito (el principal de ellos)
#our (%falta_pcs,%falta_uni,%falta_modelo); 
our @dirplantiquedan;
our $cuantosiconos = {}; #apunta a hash con keys de plantilla;
our @refallermods; #array de referencias a hash con caracteristicas generales
                 #de un modelo; indice $numlayer; puede haber valores de
                 #indice para los que no este definido
our @refdias; #array de referencias a array con lo de las capas del
              # archivo diagrama dia
our @refarchers;  #array de referencias a hash con caracterisricas de archivo 
our @refgrafers; #array de referencias a hash con características 
                 #de la parte grafica del archivo
our @refnombres; #array de referencias a hash con distintos
                 # nombres para archivos
our @reflayers; #array de referencias a hash con características de layers;
                #fundamentalmente los cuadros
our %refboxes; #hash de referencias con keys #numobj de cuadro
our $CAJAS = {}; #referencia a hash 
                #con key nombre de archivo de tipo circuito,  o modelo
		#y value el texto de las cajas y alguna otra cosa
#referencia a listas con palabras codificadas
our ($nombrefile,$nombrelay, $nombreplantilla, $nombreshape ,$nombreelemento)
    = ([],[],[],[],[]);
  #$nombrefile        #nombre absoluto de aechivo; relacionado con $filelista
  #$nombrelay'}       #capas
  #$nombreplantilla'} #primeras partes de nombres de shapes
  #$nombreshape'}     #segundas partes de nombres de shapes
  #$nombreelemento'}  #nombres de elementos en cuadro USO_DEF
#referencia a listas de códigos de los objetos de los diagramas leidos
our ($filelista, $laylista, $plantillalista, $shapelista, $codlista)
    = ([], [], [], [], []);
our ($codvalorlista, $textolista, $lugarlista) = ([], [], []);
  #$filelista       #numero del archivo por orden de lectura; relacionado con 
  #                 # $reftrabajo 
  #$laylista        #de la capa (por orden de lectura luego de ..)
  #$plantillalista  #de la primera parte del nombre de la forma
  #$shapelista      #de la segunda parte del nombre de la forma 
  #$codlista        #como elemento (fundam. para sceptre)
  #$codvalorlista   #junto con codlista identifican icono
  #$textolista      #identif. del elemento en el diagrama
  #$lugarlista      #lugar en diagrama
# referencia a hashes                        
  our ($cualfile,$cualplantilla, $cuallay, $cualshape, $cualelemento)
     = ({}, {}, {}, {}, {}); 
  #$cualfile        #nombrefile => lugar en la lista de nombres de archivos
  #$cualplantilla)  #nombreplantilla => lugar en la lista de plantillas
  #$cuallay         #nombre de capa => lugar en la lista global de capas
  #$cualshape       #nombre de shape = > lugar en la lista de shapes
  #$cualelemento    #nombre de elemento => lugar en la lista

# referencia a hashes   con key $pcs
                               #dado en diagrama de definicion de elementos
our ($nombre_menu_Dia,$refcodigos,$comocod, $comocodvalor, $comootrosnodos)
 = ({}, {}, {}, {}, {});
  #$nombre_menu_Dia      #plantillacshape => nombre del elemento 
  #$comocod         #plantillacshape => codigo (de letra, sceptre)
  #$comocodvalor    #plantillacshqape => codigo (de letra, fórmula)

#hashes con definiciones resultantes de archivos _ele _mod y similares
#con key $plantilla (primera parte de  nombre de forma
our ($DEFIELE, $DEFIMOD) = ({}, {});
  #$DEFIELE            # key nombre de elemento, value ref a hash
                               # de datos sobre el elemento 
  #$DEFIMOD        # identif. del modelo => ref a hash
our (@opciones,$opciones); #relativo a llamada a simusol
our @orden_nodos_mod = (4, 2, 0, 6, 7, 8, 1, 3, 5); 
    # es el orden correspondiente a
    # sentido horario para el modelo general, la shape de 9 conexiones;
    # el punto de conexion 0 corresponde al 4, el 1 al 2 el ultimo al 5
    # y se trabaja como si siempre se ocuparan las primeras conexiones.
    #los demás modelos deben tener justo el número exacto de conexiones
    # que usen#por lo que no tendra importancia ese orden
our %quenombre=(
    'J'=>'fuente de corriente',
    'R'=>'resistencia',
    'E'=>'fuente de tensión',
    'C'=>'condensador',
    'N'=>'nodo',
    'n'=>'nodo rep.',
    'A'=>'texto descriptivo o fig. auxiliar',
#    'l'=>'rama de conexión con posibles contactos',
    'u'=>'rama de conexión con posibles contactos',
    'X'=>'rama de conexión',
    'X'=>'rama tipo ZigZag',
    'V'=>'texto con valores',
    'T'=>'modelo',
    'O'=>'Cuadro',
);
our %codigoStandard=(
    'Image'=>['A','A'],
    'Text'=>['A','A'],
    'Ellipse'=>['A','A'],
    'Box'=>['A','A'],
    'Polygon'=>['A','A'],
    'Arc'=>['x','x'],
    'BezierLine'=>['x','X'],
    'Beziergon'=>['A','A'],
#    'Line'=>['l','l'],
    'Line'=>['u','u'],
    'PolyLine'=>['x','X'],
    'ZigZagLine'=>['X','x']);
    # en la explicación siguiente handle significa
    # "enganchable activo": hay que pescarlo precisamente
    # y acercarlo a un punto de conexión para
    # conseguir un enganche. (mientras se trabaja con Dia)
    #las ZigZagLine nombran diferente a sus handlers
our %nombrepuntos=(
    'PolyLine'=>'poly_points',
    'ZigZagLine'=>'orth_points',
    'Line'=>'conn_endpoints',
    'Arc'=> 'conn_endpoints',
    'BezierLine'=>'bez_points');     
#our %unis_tiempo;
#abbrev \%unis_tiempo, qw(minutos horas segundos dias);
#lo anterior define un hash con key: abreviatura y value los dados;
# ejemplo: $unis{se} vale segundos; $unis{'aab'} está indefinido
#our %factort = ('segundos' => 1, 'minutos' => 60, 'horas' => 3600, 
#                'dias' => 86400);
our %reftrabajo;
our ($unidadtiempo);
my @aceptables = qw(sqrt sin cos exp abs log log10 sign);
our $marca_Simusol = "producido por S I M U S O L";
# -------------------------------------------------------------------------
$CORTOA = '';
our ($PROPIOSIN,$PROPIO,$PROPIOSINGUARDAR,$PROPIOGUARDAR);
 # solo se usan luego que se sabe cual es el principal
our @cuadros_principales = ('DATOS', 'PARAMETROS','INICIALES','TIEMPO'
		       ,'CONTROLES','RESULTADOS','GRAFICOS','AGREGAR_GRAFICOS');
our (%error_cuadros,$error_diagrama); #se llena con '' recien en con_1archivo
map ($error_cuadros{$_} = 1,@cuadros_principales);
our @cuadros_clasif = qw(DATOS  VIINICIALES RVIINICIALES 
                      DPARAMETROS DINICIALES RDINICIALES
                      INICIALES
                      PARAMETROS PPARAMETROS RPPARAMETROS PEDIDOS);
our @listas_RESULTADOS = qw(taPEDIDOS pedidos sceptres propias magnitudes 
         unidades pares
         malos repetidos indicebueno comeRESU  pedidoscom);
our (%hash_FUNCIONES_definidas, %hash_TABLAS_definidas,%hash_defiTABLAS);

our ($codcontexto,$codramas ,$codnodos,$codelemTs,$codconects)
          =('^[CEJLRcejlrTNntO?]$','^[uxX]$','^[Nnt]$'
	  ,'^[CEJLRcejlrT]$','^[CEJLRcejlrTNntu]$'); 
our %pedida_sceptre; #variables pedidas como outputs
our @datoslista = qw(REFARG);
our @datosescalar = qw(VALOR TIPO TIPOTOK TIPARG);
our @extraslistaFUNCION 
   = qw(listaargFUNCION listaeleparFUNCION listawFUNCION listakFUNCION
         listagqtFUNCION listasSFUNCION); 
our @extrasescalarFUNCION = qw(com ori indepFUNCION nocalcFUNCION);
our @extrasnoFUNCION = qw(uni ori com);

our %acep_fun;
map (do{$acep_fun{$_} = 1; $acep_fun{"d$_"} = 1},@aceptables);
#$acep_fun{qproducto} = 1; $acep_fun{qsuma} = 1;
    #impr_debug(__LINE__.' Glob,%acep_fun',\%acep_fun);


our %codigovalor=(
    'nodo'=>'N', 
    'nodod'=>'n',
    'Image'=>'A', 
    'Text'=>'A',
    'Ellipse'=>'A',
    'Box'=>'A',
    'Polygon'=>'A',
    'Arc'=>'x',
    'BezierLine'=>'X',
    'Beziergon'=>'A',
    'Line'=>'l',
    'PolyLine'=>'X',
    'ZigZagLine'=>'x',
    'Objet'=>'O',
    'Object'=>'O',
    'modelo'=>'T',
 );
our %fortranfun = ('DSQRT',1,'DSIN',1,'DCOS',1,'DEXP',1,'DATAN',1
                    ,'DABS',1,'DLOG',1,'DLOG10',1);
#   $hash_TABLAS_definidas{$Tidtabla}->{$ij} es 1 o 0 (vigente o no)
# key: identif. de tabla o funcion; value; hash :  REVISAR
#tablas usadas por un circuito se guardan en $refcirc-{USATAB}

our $refglobal = {};
our $refall = {'nombre'=>'todas las capas'
	       ,'capas'=>[],'capasele'=>[],'capasmod'=>[],'capasgra'=>[]
               ,'capascir'=>[],'capasresto'=>[],'capasnosirven'=>[]
               ,'capasDIAGR'=>[]
               ,'archivos'=>[]
               ,'lisobjO'=>[],'ARCHIVO2extras'=>{},'cualnumclasenum'=>{} };
#inicial scalar keys %$refall 12
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                $CAJAS
                $DEFIELE $DEFIMOD
		$INSTALLDIR $SIMUSOLBINDIR $SIMUSOLLIBDIR
		$INSTDIR $LIBDIR $BINDIR
                $codcontexto $codramas 
                $codnodos
                $codelemTs $codconects
                $codlista $codvalorlista $textolista $lugarlista
		$comocod $comocodvalor $comootrosnodos
                $cualelemento $nombre_menu_Dia $nombreelemento
                $cualfile $nombrefile                 
                $cuallay $nombrelay
		$cualplantilla $nombreplantilla
                $cualshape $nombreshape
                $cuantosiconos
                $filelista $laylista $plantillalista $shapelista
                $marca_Simusol
                $refall
                $refcodigos
                $reftrabajo
                $unidadtiempo
                $version
                $refglobal
                $PROPIO $PROPIOSIN $CORTO $CORTOSIN $PUNTOEXT
                $PROPIOGUARDAR $PROPIOSINGUARDAR $CORTOGUARDAR $CORTOSINGUARDAR
                @cuadros_clasif
                @cuadros_principales
                @datosescalar 
                @dirplantiquedan
                @extrasescalarFUNCION
                @extraslistaFUNCION
                @listas_RESULTADOS
	        @nomcirc @nomfile
	        @opciones $opciones
		@orden_nodos_mod
                @refdias @refarchers @refnombres @refgrafers
                @reflayers @refallers
                %refboxes
                @Dia2Simusol @Simusol2Dia
		%acep_fun %codigoStandard
                %clasearchivos
                %codigo %codigovalor
                %codigoStandard
                %error_cuadros
                %expr_usadas
		%extension
                %factort
                %fortranfun
                %hash_defiTABLAS
                %hash_FUNCIONES_definidas 
 		%hash_TABLAS_definidas
                %lay_mod_arch %lay_circ_arch
                %nombrepuntos
	        %nombresusados
                %numarch
	        %opt_hash %opt_comun 
                %pedida_sceptre
                %propio_copiar
                %quenombre
                %refallermods
                %refficompl                
                %reffiele %reffimod
     	        %reffipri
                %reffiuni
                %unis_tiempo
                &actualizar_valor2cual
                &agregar_comentarios
                &borrar_datos
                &cajear_capa
                &cargar_datos &cargar_datos_tipotok
                &cargar_tiparg_refarg
                &cargar_tipotok_que
                &comparar_icono
                &contab_archivo
	        &controlar_our
                &copiar_datos
                &copiar_cua_datos 
                &depurar_comentarios 
                &descripcion_capa 
                &descripcion_clasepcs
                &descripcion_cuadro
                &descripcion_iden_ref
                &descripcion_icono
                &descripcion_objeto
                &descripcion_rama
                &expandir_datos_que  
                &error_progr
                &impr_ARCHIVOS
                &impr_SUST
                &impr_UNIDADES
                &impr_cualobjref
                &impr_dat_cosas &impr_dat_que
                &impr_dat &impr_datos
                &impr_detallado &impr_detal_ip
                &impr_listas_que
                &impr_par
                &impr_tipotok_valor_ori_num_master_que
                &impr_objs &impr_identi
                &impr_resultados
                &impr_refall
                &impr_refes
                &impr_unionesobj
                &mover_datos 
                &para_sceptre_num
	        &parar1 &porparar1
		&repite_nombre
                &tiparg_refarg_2_valor_talcual
                &tiparg_refarg_2_vttr_talcual
                &tomar_cua_datos 
                &tomar_tiparg_refarg
                &tomar_tipotok_valor_ori_num_master_que
                &tomar_todo_datos	
                &valor 
       );  
};
END();
# ---------------------------------------------------------------------------
sub actualizar_valor2cual{
  comfin('comG actualizar_valor2cual',@_);
  my ($ref,$cosa,$valor) = @_;
  my $ya= '';
  if ($ref->{valor2cual}->{$valor}) {
      my $ant = $ref->{valor2cual}->{$valor}->[0];
      if (defined $ant) {
          if ($ref->{parscreados}->{$ant} and $cosa ne $ant) {
              $ref->{valor2cual}->{$valor}->[0] = $cosa;
          } else {
              push @{$ref->{valor2cual}->{$valor}},$cosa;
          };
      } else {
#          push @{$ref->{valor2cual}->{$valor}},$cosa;
      };
      @{$ref->{valor2cual}->{$valor}}
        = union_conjunto(@{$ref->{valor2cual}->{$valor}});
  } else {
      push @{$ref->{valor2cual}->{$valor}},$cosa;
  };
  impr_debug(__LINE__.' Glob valor2cual',Dumper $ref->{valor2cual});
  comfin('finG actualizar_valor2cual');
}#actualizar_valor2cual;
# ---------------------------------------------------------------------------
sub agregar_comentarios{
  comfin('comG agregar_comentarios',@_);
  my ($ref,$key,@listacomis) = @_;
  my $mensajedonde = pop @listacomis;
  impr_dat(__LINE__.' Glob',$key,$ref,'agc');  
  @listacomis or return;
  my @listacomkey = @{valor($ref,'listacom',$key)}; 
#  impr_debug(__LINE__.' Glob @listacomkey',\@listacomkey);
  my $principal = $listacomis[0];
#  my @comentarios = (@listacomkey,@listacomis); 
  my @comentarios = @listacomis;
  my @extras = @listacomkey;
  push @extras,uc(valor($ref,'VALOR',$key)) if valor($ref,'VALOR',$key) ne ''; 
  push @extras,$key; 
  impr_debug(__LINE__.' Glob @extras',\@extras);
  my @nuevoscoment;
  foreach my $coment (@comentarios) {
      $coment =~ /\S/ or next;
      if ($coment =~ /\s/) {
          $coment =~ s/([\+\-])\s/$1/g; #los espacios dejados por precaucion
          $coment =~ s/\s([\+\-])/$1/g;
      };
      impr_debug(__LINE__.' Glob $coment',$coment);
      my @extrascoin = grep (do{uc($_) eq uc($coment)},@extras);
      impr_debug(__LINE__.' Glob @extrascoin',\@extrascoin);
      @extrascoin  and  next; 
      my $comentTIME = "($coment)";
      while ($comentTIME =~ s/(\W)TIME(\W)/$1TIEMPO$2/) {};
      $comentTIME =~ s/^.(.+).$/$1/;
      impr_debug(__LINE__.' Glob $comentTIME',$comentTIME);
      grep(do{uc($_) eq uc($comentTIME)},@extras) and next;
      impr_debug(__LINE__.' Glob $coment',$coment);
      push @nuevoscoment,$coment; push @extras,$coment;
    }; 
  @{$ref->{listacom}->{$key}} = (@nuevoscoment,@listacomkey);
  my $comtotal =  join "; " ,@{$ref->{listacom}->{$key}};
  $ref->{com}->{$key} = $comtotal;
  impr_dat(__LINE__.' Glob',$key,$ref,'agc');  
  comfin('finG agregar_comentarios',$comtotal,$mensajedonde);
  return;
}#agregar_comentarios
# ---------------------------------------------------------------------------
sub borrar_datos{
  comfin('comG_borrar_datos',@_);
  my ($ref,$que,$nombre,$mensaje) = @_;
  if (not $que) {
      $que = $ref->{que}->{$nombre};
  };
  $mensaje or $mensaje = '';
  impr_debug(__LINE__.' Globl parscreados',$ref->{parscreados});
  my @lisque1 = ($que);
  $que =~ /PARAMETROS/  and 
    @lisque1 = ('PARAMETROS','PPARAMETROS','RPPARAMETROS','DPARAMETROS'
                ,'DINICIALES','RDINICIALES','VIINICIALES','FUNCIONES','TABLAS');
  foreach my $que1 (@lisque1) {
      @{$ref->{"lista$que1"}} = grep ($_ ne $nombre, @{$ref->{"lista$que1"}});
  };
  foreach my $cosa
           ('TIPOTOK','VALOR','TIPO','TIPARG','REFARG','uni','com','ori') {
      delete $ref->{$cosa}->{$nombre};
  };
  explic(" Borrado el dato $nombre");
  comfin('finG_borrar_datos');
}#borrar_datos   
# ---------------------------------------------------------------------------
sub cajear_capa{
  comfin('comG cajear_capa',@_);
  my ($reflay) = @_;
  my $nombre = $nombrelay->[$reflay->{numcapa}];
  my $PROPIOSIN = $reflay->{PROPIOSIN};
  my $archcaj = "$dirsal{caj}/$PROPIOSIN.caj";
  open SALIDAcaj, ">>$archcaj" or die "No pude abrie $archcaj";
  print SALIDAcaj "# capa ", $nombre,"\n";
  foreach my $key (keys %{$reflay->{refvalores}}) {
     foreach my $num (keys %{$reflay->{refvalores}->{$key}}) {
          print SALIDAcaj ' 'x10, "Cuadro $key\n";
          print SALIDAcaj 
            join ("\n",@{$reflay->{refvalores}->{$key}->{$num}}),"\n";
      };
  };
  close SALIDAcaj;
  comfin('finG cajear_capa'); 
}#cajear_capa
# ---------------------------------------------------------------------------
sub cargar_datos{
  comfin('comG cargar_datos',@_);
  my ($ref,$que,$nombre,@refargus)= @_;
  # @refargus al menos 4 elementos; hasta 8 elementos (7 el ultimo)
  my @listapres = ('VALOR','TIPO','TIPARG','REFARG','mensaje'
     ,'uni','ori','com');
  for (my $i = 0; $i < @refargus; $i ++) {
      next if $i == 4; 
      my $valor = $refargus[$i]; 
      next unless defined $valor;
      $valor =~ /ARRAY/ and 
       do {my $reflista = []; @$reflista = @$valor; $valor = $reflista};   
      $ref->{"$listapres[$i]"}->{$nombre} = $valor; 
  }; 
  if ($refargus[1] eq ',') {
      my @lista = split ',',$refargus[0];
      @{$ref->{REFLISTAVALOR}->{$nombre}} = @lista;
  } elsif  ($nombre =~ /^[CEJLPR]/) {#  and $refargus[1] !~ /^[no]$/) {
      actualizar_valor2cual($ref,$nombre,$refargus[0]);
  #no se guardan derivadas de parametros
  };
  if ($ref->{com}->{$nombre}) {
      my @listacoment = split /\s*;\s*/,$ref->{com}->{$nombre};
      $ref->{listacom}->{$nombre} = \@listacoment;
  };
  impr_dat(__LINE__.' Glob',$nombre,$ref,'CRD');
  if ($que eq '') { 
      comfin('finG_cargar_datos');
      return '';
  } else {
      $ref->{que}->{$nombre} = $que;
  };
  push @{$ref->{"lista$que"}}, $nombre;
  @{$ref->{"lista$que"}} = union_conorden (@{$ref->{"lista$que"}});
  comfin('finG cargar_datos');
  return '';
}#cargar_datos  
# ---------------------------------------------------------------------------
sub cargar_tipotok_que{# y llena {listaprincipales}
  comfin('comG cargar_tipotok_que',@_);
  my ($ref,$que,$nombre,$tipotok,$esmaster) = @_;
  $ref->{que}->{$nombre} = $que;
  $ref->{TIPOTOK}->{$nombre} = $tipotok;
  push @{$ref->{"lista$que"}},$nombre;
  @{$ref->{"lista$que"}} = union_conjunto(@{$ref->{"lista$que"}});
  push @{$ref->{listaprincipales}},$nombre unless $esmaster;
  comfin('finG cargar_tipotok_que');
  return;
}#cargar_tipotok_que
# ---------------------------------------------------------------------------
sub cargar_datos_tipotok{
  comfin('comG cargar_datos_tipotok',@_);
  my ($ref,$que,$nombre,@refargus)= @_; 
  # @refargus al menos 5 elemntos; hasta 9 elementos (8 el ultimo)
  my $actual = valor($ref,'VALOR',$nombre);
  my @listapres = ('TIPOTOK','VALOR','TIPO','TIPARG','REFARG','mensaje'
     ,'uni','ori','comp');
  for (my $i = 0; $i < @refargus; $i ++) {
      next if $i == 5; 
      my $valor = $refargus[$i]; 
      next unless defined $valor;
      if ($valor =~ /ARRAY/) { 
        my $reflista = []; @$reflista = @$valor; $valor = $reflista
      };   
      $ref->{$listapres[$i]}->{$nombre} = $valor; 
  };
  if ($refargus[2] eq ',') {
      my @lista = split ',',$refargus[1];
      @{$ref->{REFLISTAVALOR}->{$nombre}} = @lista;
  } elsif ($nombre =~ /^[CEJLPR]/ ) { #and $refargus[2] !~ /^[no]$/) {
      actualizar_valor2cual($ref,$nombre,$refargus[1]);
  };
  $ref->{ori}->{$nombre} or $ref->{ori}->{$nombre} = $actual;
  comfin('finG cargar_datos_tipotok',"datos para $nombre",@refargus[0..4]);
  return '' unless $que ne '';
  $ref->{que}->{$nombre} = $que;
  push @{$ref->{"lista$que"}}, $nombre;
  @{$ref->{"lista$que"}} = union_conorden (@{$ref->{"lista$que"}});
#  impr_dat(__LINE__.' Glob',$nombre,$ref,'CDT');
  return '';
}#cargar_datos_tipotok  
#----------------------------------------------------------------------------
sub cargar_tiparg_refarg{
  comfin('comG cargar_tiparg_refarg',@_);
  my ($ref,$cosa,$tiparg,$refarg) = @_;
  my ($coderr,$valor,$tipo,$tiparg1,$refarg1)
    = tiparg_refarg_2_vttr_talcual($tiparg,$refarg);
  not $coderr and cargar_datos($ref,'',$cosa,$valor,$tipo,$tiparg1,$refarg1);
  # comfin('finG cargar_tiparg',@_);
  return $coderr;
}#cargar_tiparg_refarg  
#----------------------------------------------------------------------------
sub comparar_icono{
  my ($ref,$descrig,$rh) = @_;
  my $rhv = $ref->{$descrig};my $coderror = 0; 
  if (defined $rhv->{nombre}) {
      foreach my $tema ('nombre','cod','codvalor') {
          $rhv->{$tema} eq $rh->{$tema} or
             return ($tema, $rhv->{$tema}, $rh->{$tema});
      };
  };
  foreach my $tema ('nombre','cod','codvalor') {
      $rhv->{$tema} =  $rh->{$tema};
  };
  return '';
}#comparar_icono
# ---------------------------------------------------------------------------
sub contab_archivo{
  comfin('comG contab_archivo',@_);
  my $ARCHIVOA = $_[0];
  my $archsindia = $ARCHIVOA;
  if ($archsindia =~ s/(\.\w*)$//) {
      $PUNTOEXTA = $1;
  } else {
      $PUNTOEXTA = '';
  }; 
  my $numfile = scalar (keys (%$cualfile))-1;# por si no lo encuentra
  if ($archsindia =~ /(^.*)\/([^\/]+)$/) {
      $BASEARCHA = "$1/"; $PROPIOASIN = $2;
      if ($ARCHIVOA =~ /(^.*)\/([^\/]+)$/) {
          $PROPIOA = $2;
      }; 
      if ($cualfile->{$ARCHIVOA}) {
          $numfile = $cualfile->{$ARCHIVOA};
          $refnombres[$numfile]->{ARCHIVO} = $ARCHIVOA;
          # puede estar sobrescribiendo 
      } else {
          $numfile = scalar @$nombrefile;
          push @{$nombrefile}, $ARCHIVOA;
          $cualfile->{$ARCHIVOA} = $numfile;
      };
      $refarchers[$numfile] = {'numfile'=>$numfile};
      my $date = scalar localtime((stat "$ARCHIVOA")[9]);
      @{$refnombres[$numfile]}{
   'ARCHIVO','BASEARCH','PROPIO','PROPIOSIN','PUNTOEXT','numfile0','DATE'}
    = ($ARCHIVOA,$BASEARCHA,$PROPIOA,$PROPIOASIN,$PUNTOEXTA,$numfile,$date);
       impr_debug(__LINE__.' Glob $refnombres[$i]'
         ,Dumper $refnombres[$numfile]);
      push @{$refall->{archivos}},$numfile;
      impr_debug(__LINE__.' Glob @refnombres', Dumper \@refnombres);
  } else {
      error_progr(0,__LINE__." Glob $ARCHIVOA no es nombre completo");
  };
  impr_debug(__LINE__.' Glob $archsindia,$BASEARCHA,$PROPIOA,$PROPIOASIN'
	     ,[$archsindia,$BASEARCHA,$PROPIOA,$PROPIOASIN]);
  comfin('finG contab_archivo');
  return;
}#contab_archivo
# ---------------------------------------------------------------------------
sub controlar_our{
  comfin('comG controlar_our');
  #solo se esta usando desde este modulo; pero esta disponible para todos
  #modificada para .....
  #sólo para depurar
  my ($ref,$mensaje) = @_;
  my $cuantos = scalar @$laylista; my $mal ='';    
#  print STDERR "Los 9 largos deben ser todos iguales  ";
#  map (do{print STDERR ( ' ' . scalar @$_ ,' ')},
#          ($filelista,$laylista, $plantillalista , $shapelista, $codlista,
#	   $codvalorlista, $textolista, $lugarlista,$filelista));
#   print STDERR "\n";
   foreach my $cosa ( $filelista,$plantillalista , $shapelista, $codlista,
		     $codvalorlista, $textolista, $lugarlista,$filelista) {
       if (scalar @$cosa != $cuantos) {
           $mal = 1;
       } 
   };
   if (not $mal) {
      comfin('finG controlar_our');
      return '' ;
   };
   print STDERR 
    '$filelista,$laylista, $plantillalista , $shapelista, $codlista, 
		     $codvalorlista, $textolista, $lugarlista'."\n";
   foreach my $cosa ($filelista,$laylista, $plantillalista , $shapelista
    , $codlista, $codvalorlista, $textolista, $lugarlista) {
       foreach (@$cosa) {
           print STDERR " $_";
       };
       print STDERR " fin renglon \n";
   };
   comfin('finG controlar_our');
  return 254;
}#controlar_our
# ---------------------------------------------------------------------------
sub copiar_datos{
  comfin('comG copiar_datos',@_);
  # $qued puede ser ''; 
  # copia al ori y al com y al listacom solo si $modo
  my ($refo, $queo, $nombreo,$refd,$qued,$nombred,$modo) = @_;
  $refo eq $refd and $nombreo eq $nombred and return;
  $refd->{TIPO}->{$nombred} = $refo->{TIPO}->{$nombreo};
  my @cuales = (qw(VALOR TIPO TIPARG REFARG uni));
  $modo and  push @cuales,('ori','com','listacom');
  foreach my $pre (@cuales) {
      my $nuevo = $refo->{$pre}->{$nombreo};   
      if (defined $nuevo) {
          $nuevo =~ /ARRAY/ and 
          do {my $reflista = []; @$reflista = @$nuevo; $nuevo = $reflista
          };
      };
      $refd->{$pre}->{$nombred} = $nuevo;
  };
  if ($refo->{TIPOTOK}->{$nombreo} eq '0') {
      $refd->{TIPOTOK}->{$nombred} = '0';
  } elsif (not defined $refd->{TIPOTOK}->{$nombred}) { 
      $refd->{TIPOTOK}->{$nombred} = $refo->{TIPOTOK}->{$nombreo};
  };
  $refo->{REFLISTAVALOR}->{$nombreo} and
    @{$refd->{REFLISTAVALOR}->{$nombred}} 
      = @{$refo->{REFLISTAVALOR}->{$nombreo}};
  if (substr($nombreo,0,1) eq 'Q' and substr($nombred,0,1) eq 'Q') {
      defined $refo->{listaargFUNCION}->{$nombreo} and
          @{$refo->{listaargFUNCION}->{$nombreo}} and
          @{$refd->{listaargFUNCION}->{$nombred}}
            = @{$refo->{listaargFUNCION}->{$nombreo}} or
		delete $refd->{listaargFUNCION}->{$nombred};
  };
  impr_dat(__LINE__.' Glob',$nombred,$refd,'cop');
  if ($qued ne '') {
      push @{$refd->{"lista$qued"}}, $nombred;
      @{$refd->{"lista$qued"}} = union_conorden (@{$refd->{"lista$qued"}});
  };
  comfin('finG copiar_datos');
}#copiar_datos   
# ---------------------------------------------------------------------------
sub copiar_cua_datos{
  comfin('        comG copiar_cua_datos',@_);
  my ($ref,$nombreo,$nombred) = @_;
#  impr_dat(__LINE__.' Glob',$nombreo,$ref,'CCD');
  foreach my $pal ('VALOR','TIPO','TIPARG') {# no se copia los com comp
      $ref->{$pal}->{$nombred} = $ref->{$pal}->{$nombreo};
  };
  @{$ref->{REFARG}->{$nombred}} = @{$ref->{REFARG}->{$nombreo}};
#  impr_dat(__LINE__.' Glob',$nombred,$ref,'CCD');
  comfin('        finG copiar_cua_datos');
}#copiar_cua_datos
# ---------------------------------------------------------------------------
sub depurar_comentarios{
  comfin('comG depurar_comentarios',@_);
  my($ref,$key) = @_;
  my @listacomprincipal = @{valor($ref,'listacom',$key)};
  @listacomprincipal = union_conorden(@listacomprincipal);
  my @newlista;
  my $valor = $ref->{VALOR}->{$key};
  while (@listacomprincipal) {
      my $coment = shift @listacomprincipal;
      $coment eq $valor and next;
      push @newlista,$coment;
  };
  $ref->{listacom}->{$key} = \@newlista;
  my $coment = $ref->{com}->{$key} = join "; ",@newlista;
  comfin('finG depurar_comentarios',$coment);
  return $coment;
}#depurar_comentarios' 
# ---------------------------------------------------------------------------
sub descripcion_capa{
  #comfin('comG descripcion_capa',@_);
  my $numcapa = $_[0];
  my ($capa,$descr,$nombrecapa,$nombrearchivo) = ('()','','','');
  my $reflay = $reflayers[$numcapa];
  my $numfile = $reflay->{numfile}; my $refarch = $refarchers[$numfile];
  impr_debug(__LINE__.' Glob $refnombres[$numfile]'
	     ,Dumper $refnombres[$numfile]);
  my $PROPIO = $refnombres[$numfile]->{PROPIO};
  my $cali = '';
  $reflay->{eliminada} and $cali =' capa elimnada';
  my $ARCHIVOCAPA = $reflay->{ARCHIVOCAPA};
  my $cuantascapas = @{$refarch->{capas}};
  impr_debug(__LINE__.' Glob $cuantascapas',$cuantascapas);
  impr_debug(__LINE__.' Glob $refarch->{capas}',$refarch->{capas});
  if ($cuantascapas > 1) {
      if ($nombrelay->[$numcapa]) {
          $capa = $nombrelay->[$numcapa];
          if ($capa =~ /^(.*)\((\d+) \- (.*)\)$/) {
              ($nombrecapa,$numcapa,$nombrearchivo) = ($1,$2,$3);
              $capa = "$nombrecapa($numcapa - $PROPIO)";
          };
          $descr = $capa;
      } else {
          $descr = "capa: $numcapa";
      };
  };
  impr_debug(__LINE__.' Glob $ARCHIVOCAPA,$numfile,$nombrearchivo,$PROPIO'
	     ,[$ARCHIVOCAPA,$numfile,$nombrearchivo,$PROPIO]);
  $descr ne '' and $descr .= $cali;
  $descr = "(" .$descr .")";
  #comfin('finG descripcion_capa');
  return $descr; 
}#descripcion_capa
# ---------------------------------------------------------------------------
sub descripcion_clasepcs { #argumento marcado con '#numobj'
  my $ref = $_[0];
  my $descr = ''; my $nomplant0 = '';
 # impr_debug(__LINE__.' Glob $refglobal
  return unless $ref->{sobreformulas}->{yaestapcs} and 
     scalar keys %{$ref->{sobreformulas}->{yaestapcs}};
  $descr = '# ' . '-'x20 . ' ICONOS CUBIERTOS' ."\n#"
     .'     nombre para menu_DIA         nombre para Simusol' . "\n";
  foreach my $pcs (sort keys %{$ref->{sobreformulas}->{yaestapcs}}) {
      (my $numplant = $pcs) =~ s/^(.+)c.+$/$1/;
      my $nomplant = $nombreplantilla->[$numplant];
      if ($nomplant ne $nomplant0) {
          $descr .= ' 'x40 . "(para hoja Simusol - $nomplant)";
          $nomplant0 = $nomplant;
      };
      my $nombre_menu_Dia
        = sprintf("#%-40s",$refglobal->{nombre_menu_Dia}->{$pcs});
      $descr
      .= "\n$nombre_menu_Dia   $ref->{sobreformulas}->{yaestapcs}->{$pcs}->[1]";
  };
  return $descr; 
}#descripcion_clasepcs
# ---------------------------------------------------------------------------
sub descripcion_cuadro{#argumento marcado con '#numobj'
  #comfin('comG descripcion_cuadro',@_);
  my ($numobjori,$concrudos) = @_;
  (my $numobj = $numobjori)  =~ s/#numobj(.+)/$1/;
  my $lug = $lugarlista->[$numobj]; $lug =~ s/\s*$//;
  my $il = $laylista->[$numobj];
  if ($concrudos) {
      impr_debug(__LINE__.' Glob',Dumper $reflayers[$il]->{refvalores}->
                 {$textolista->[$numobj]}->{$numobjori});
  };
  my $texto = $textolista->[$numobj];
  if ($texto eq 'TABLAS') {
      $texto =~ s/S$//;
      $texto .= " $refboxes{$numobjori}->{Tidtabla}";
  };
  $texto = "Cuadro $texto en $lug";
  my $descr_capa = descripcion_capa($il); 
  $descr_capa ne '()' and $texto .= "-$descr_capa";
  #comfin('finG descripcion_cuadro');
  return $texto;
}#descripcion_cuadro
# ---------------------------------------------------------------------------
sub descripcion_icono{ #describe el $pcs
# descripcion (el nombre de la shape) de la forma dada por el $plcshape
# que le toco 
  #comfin('comG descripcion_icono', @_);
  my $pcs = $_[0];
  my ($pl,$shape) = $pcs =~ /(\d+)c(\d+)/;
  #comfin('finG descripcion_icono');
  return  "$pcs:  $nombreplantilla->[$pl]" .' - ' . $nombreshape->[$shape];
}#decripcion_icono
# ---------------------------------------------------------------------------
sub descripcion_iden_ref{
# describe a un objeto dado por su identificacion $iden "para sceptre",
# en el hash referido por $reff->{cualobjele
  #comfin('comG descripcion_iden_ref', @_);
  my ($iden,$reff) = @_; 
  my ($cod,$texto) =  ($iden =~ /^(.)(.*)/);  
  my $idenn = $iden;
  if ($cod eq 'O') {$idenn  = $texto};
  my $listadescrip=''; 
  my $cualobjele = $reff->{cualobjele}->{$iden};
  if ($cualobjele) {
      my @listaobj;
      $cualobjele =~ /^ARRAY/ and @listaobj = @{$cualobjele} or
          @listaobj = ($cualobjele);
      my @listadescr;
      foreach my $obj (@listaobj) {
          push @listadescr, "$idenn:   " . descripcion_objeto($obj)  ;
       };
       $listadescrip = join "\n",@listadescr;
  } else {
       $listadescrip .= "\n        No hay datos para describir a $iden\n";
  }; 
  #comfin('finG descripcion_iden_reff');
  return $listadescrip;
}#descripcion_iden_ref
# ---------------------------------------------------------------------------
sub descripcion_objeto{
#describe a un objeto dado por su numero de objeto que le toco
#objeto que aparecio en el archivo_diagrama
  #comfin('comG descripcion_objeto', @_);
  my ($obj,$completo) = @_;
  my ($cod,$codvalor,$texto) 
      = ($codlista->[$obj],$codvalorlista->[$obj], $textolista->[$obj]);
  #impr_debug(__LINE__.' Glob desc._objeto ',[$cod,$codvalor,$texto]);
  my ($cosa,$iden) = ('','');
  if ($cod eq 'N') { #para 'O' se usa descrip_cuadro
      $cosa = 'nodo simple'; $iden = $texto;
  } elsif ($cod eq 'n') { 
      $cosa ='nodo doble'; $iden = $texto;
  } elsif ($cod eq 't') {
      $cosa = 'tierra'; $iden =''; 
  } elsif ($cod =~ /^[CEJLRcejlr]$/) {
      $cosa = 'elemento'; $iden = $cod . $texto;
  } elsif ($cod eq 'T') {
      $cosa = 'modelo'; $iden = $cod . $texto;
  } elsif ($cod eq 'O') {
      $cosa = 'cuadro'; $iden = $texto;
  } else {
      error_progr(0,__LINE__.' Glob codigo de objeto desconocido');
  };
  my ($capa,$lug);
  my ($pl,$sh) =($plantillalista->[$obj], $shapelista->[$obj]);
  my $nombre= '"'.$nombreshape->[$sh].'"';
  if (defined $nombre_menu_Dia->{$pl .'c'. $sh}) {
      $nombre .= ' '. $nombre_menu_Dia->{$pl .'c' . $sh};
  } elsif (defined $quenombre{$cod}) {
      $nombre .= " $quenombre{$cod}";
  };
  $lug = $lugarlista->[$obj]; 
  $lug =~ s/\s*$//; $lug =~ s/^\s*//; 
  my $numcapa = $laylista->[$obj];  
  my $completo_capa = '';
  if ($completo) {
      $capa = $nombrelay->[$laylista->[$obj]];
      ($capa,my $arch) = ($capa =~ /.*\((\d+) \- (.+)\)/); 
      my $clasecapa = $reflayers[$numcapa]->{clasecapa};
      $completo_capa = ", capa $capa - $arch, clasecapa $clasecapa";
  };
  my $lugar =  "$lug$completo_capa";
#  my $retorno = sprintf "obj %-3s %8s %-6s en %12s %1s"
#    ,$obj, $cosa, $iden, $lugar,$nombre;
  my $retorno = sprintf "%8s %-6s en %12s %1s",$cosa, $iden, $lugar,$nombre;
  #comfin('finG descripcion_objeto');
  return $retorno;
}#descripcion_objeto
# ---------------------------------------------------------------------------
sub descripcion_rama{
  #comfin('comG descripcion_rama',@_);
  defined $_[0] or return "rama no definida";
  my $rama = my $obj = $_[0];
  # impr_debug(__LINE__.' Glob $obj',$obj);
  my ($pl,$sh) =($plantillalista->[$obj], $shapelista->[$obj]);
  my $nombre= '"'.$nombreshape->[$sh].'"';
  my ($cod,$codvalor,$texto) 
      = ($codlista->[$obj],$codvalorlista->[$obj], $textolista->[$obj]);
  if (defined $nombre_menu_Dia->{$pl .'c'. $sh}) {
      $nombre .= ' '. $nombre_menu_Dia->{$pl .'c' . $sh}. " $texto";
  } elsif (defined $quenombre{$cod}) {
      $nombre .= " $quenombre{$cod} $texto";
  };
  my $refgraf = $refgrafers[$reflayers[$laylista->[$obj]]];
  my $lay = $laylista->[$obj];
  my $nomcapa = $nombrelay->[$lay];
  # impr_debug(__LINE__.' Glob $nomcapa',$nomcapa);
  (my $capaDia,my $arch) = ($nomcapa =~ /.*\((\d+) \- (.+)\)/); 
  my $clasecapa = $reflayers[$lay]->{clasecapa};
  # comfin('finG descripcion_rama');
  if ($refgraf->{lughandles}->{$rama}) {
      $texto = "@{$refgraf->{lughandles}->{$rama}}";
      $texto =~ s/\s+/ /g;
      $texto = " con handles en lugares ".$texto;
  } else {
      $texto = " no tiene enganches ";
  };
  my $desc_capa = "";
  my $descripcion = descripcion_capa($lay);
  $desc_capa = "($descripcion )" 
      if $descripcion;
  #comfin('comG descripcion_rama',"rama: $rama  $texto  $desc_capa");
  return "rama: $rama  $texto  $desc_capa";
}#descripcion_rama
# ---------------------------------------------------------------------------
sub error_progr{
  my ($ref,$mensaje) = @_; #ambos necesarios
  $opt_hash{d} and $opt_hash{d} = '';
  print STDERR (" ===== error de programación:  line $mensaje\n");
  #pongo line  para que sim_logear lo encuentre
  parar1(2,$ref);
}#error_progr
# ---------------------------------------------------------------------------
sub expandir_datos_que{
#  comfin('comG expandir_datos_que',@_);
  my ($ref,$que) = @_;my $lisque = []; my $msg = "  Pedido '$que'; ";
  my $raro= '';
  if ($que eq 'TODOS') {
      $lisque = [qw(DPARAMETROS DINICIALES RDINICIALES
                PPARAMETROS RPPARAMETROS
                DATOS VIINICIALES RVIINICIALES
                FUNCIONES TABLAS ZTABLAS
                TIEMPOS YPARAMETROS CONTROLES PEDIDOS)];
  } elsif ($que eq 'DADOS') {
      $lisque  = [qw(DPARAMETROS DINICIALES RDINICIALES
                PPARAMETROS RPPARAMETROS
                DATOS VIINICIALES RVIINICIALES)];
  } elsif ($que eq 'RERUNS') {
      $lisque  = [qw(RDINICIALES RVIINICIALES RPPARAMETROS
           RTIEMPOS)]; 
  } elsif ($que eq 'INICIALES') {
      $lisque  = [qw(DINICIALES RDINICIALES VIINICIALES RVIINICIALES)];
  } elsif ($que eq 'PRINCIPALES') {
      $lisque=[qw(DPARAMETROS DINICIALES RDINICIALES PPARAMETROS
                RPPARAMETROS DATOS VIINICIALES RVIINICIALES)];
  } elsif ($que eq 'MUYPRINCIPALES') {
      $lisque = [qw(DPARAMETROS PPARAMETROS RPPARAMETROS DATOS)]
  } elsif ($que eq 'PARAMETROS') {
     $lisque = [qw(DPARAMETROS DINICIALES RDINICIALES PPARAMETROS RPPARAMETRO)];
  } elsif ($que eq 'DATOS') {
      $lisque = [qw(DATOS VIINICIALES RVIINICIALES)]
  } elsif ($que eq 'TABLAS') {
      $lisque = [qw(TABLAS ZPARAMETROS)];
  } elsif ($que eq 'FUNCIONES') {
      $lisque = [qw(FUNCIONES)];
  } elsif ($que eq 'TIEMPOS') {
      $lisque = [qw(TIEMPOS YPARAMETROS RTIEMPOS parametrosTIEMPOS)];
  } elsif ($que eq 'CONTROLES') {
      $lisque = [qw(CONTROLES RCONTROLES parametrosCONTROLES)]; 
  } elsif ($que =~ /^(.+)_(.+)$/) {
      my ($aspecto,$vv) = ($1,$2);
      if ($ref->{$aspecto}) {
          my %hash = %{$ref->{$aspecto}};
          my @lista =  grep (do{valor($ref,$aspecto,$_) eq $vv},keys %hash);
          @{$ref->{"lista$que"}} = @lista;
          $lisque = [$que];
      };
      my $raro = 1;  
  } else {
      $lisque = [$que];
  };
  if (not $raro) {
      my @lista = grep(do{$ref->{"lista$_"} and @{$ref->{"lista$_"}}}
                      ,@$lisque);
      if (@lista == 0) { $msg = ' no hay nada'
      } elsif (@lista > 1) {$msg .= " hay @lista";
      };
      @$lisque = @lista;
  } 
#  comfin('finG expandir_datos_que',@$lisque);
  return $lisque,$msg;
}#expandir_datos_que
# ---------------------------------------------------------------------------
sub expandir_listas_que{
  comfin('comG expandir_listas_que',@_);
  my ($ref,$que) = @_;
  my ($lisque,$pre,$hay) = ([$que],'lista',''); 
  if ($que  eq 'PARAMETROS') {
      $lisque = ['PARAMETROS','PPARAMETROS','RPARAMETROS'
                 ,'DPARAMETROS','DINICIALES','RDINICIALES','cPARAMETROS'];
  } elsif ($que eq 'INICIALES') {
      $lisque = ['VIINICIALES','RVIINICIALES','DINICIALES','RDINICIALES'
                 ,'cINICIALES'];
  } elsif ($que eq 'DATOS') {
      $lisque = ['DATOS','MODELOS','RVIINICIALES','cDATOS'];
  };
  foreach my $pal (@$lisque) {
      if ($ref->{"$pre$pal"} and @{$ref->{"$pre$pal"}}) {
          $hay =1; last;
      };
  };
  comfin('finG expandir_listas_que @$lisque,$pre,$hay',@$lisque,'||',$pre,$hay);
  return $lisque,$pre,$hay; 
}#expandir_listas_que
# ---------------------------------------------------------------------------
sub impr_ARCHIVOS{
  return unless $debug;
  my @refs = @_; my ($mensaje,$capassi) = ('','');
  @refs  and $refs[0] !~ /HASH/ and $mensaje = shift @refs;
  @refs  and $refs[0] !~ /HASH/ and $capassi = shift @refs;
  my @nombres =qw (archivo BASEARCH CORTO CORTOSIN PROPIO PROPIOSIN PRINCIPAL); 
  my @nombresA = qw (ARCHIVOA BASEARCHA CORTOA CORTOASIN PROPIOA
   PROPIOASIN PRINCIPAL); 
  print STDERR " Empieza impr_ARCHIVOS $mensaje\n";
  if ($NUMPRINCIPAL) {
      print STDERR '          $NUMPRINCIPAL,$CLASEPRINCIPAL '
	  ,"$NUMPRINCIPAL,$CLASEPRINCIPAL\n";
  };
  print STDERR '     Nombres registrados, @$nombrefile:'." @$nombrefile\n";
  if (@$nombrefile) {
      for (my $j=0;$j < @$nombrefile; $j++) {
	  my $arch = $nombrefile->[$j];
          my $refarch = $refarchers[$j];
          next unless $refarch;
          my $refnomb = $refnombres[$j];
          my $refgraf = $refgrafers[$j];
          my $cualescapas = '';
          print STDERR "                    _ _ _\n";
          impr_debug('  numfile: $refnomb '."$j:", Dumper $refnomb);
#          impr_debug('  numfile: $refgraf '."$j:"
#                  ,Dumper $refgraf);
          if ($refarch and $refarch->{capas}) {
              my @lista;
              foreach my $clase (keys %{$refarch->{cualcapaclase}} ) {
                  push @lista
		      ,$clase,join '||',@{$refarch->{cualcapaclase}->{$clase}};
              };
              my ($capresto,$capele,$capmod) = (0,0,0);
              $refarch->{capasresto} and $capresto = @{$refarch->{capasresto}};
              $refarch->{capasele} and $capele = @{$refarch->{capasele}};
              $refarch->{capasmod} and $capmod = @{$refarch->{capasmod}};
              impr_debug(' $j: '.
              '@$refarch{"numfile","capas","capasresto","capasele","capasmod"}'
                ,[$refarch->{numfile},'|||',@{$refarch->{capas}}
                ,'||',$capresto,'||',$capele,'||',$capmod]); 
              impr_debug(' $j: '.'@$refarch{cualcapaclase}',[@lista]);
              if ($capassi) {   
                  foreach my $ilayer (@{$refarch->{capas}} ) {
                      my $reflay = $reflayers[$ilayer];
                      if ($reflay->{refvalores}) {
                          my @keys = sort keys %{$reflay->{refvalores}};
                          impr_debug('keys de refvalores de la capa '.$ilayer
                           ,\@keys);
	              };
                     if ($reflay->{complem}) {
                          my @keys = sort keys %{$reflay->{complem}};
                          impr_debug('keys de complem de la capa '.$ilayer
                           ,\@keys);
	              };
                  };
              }; 
          };
      };
  };
  my @keys = sort keys %{$reftrabajo}; @keys = grep($_,@keys); 
  print STDERR "  Archivos procesados: ";
  my $texto = "ninguno"; @keys and $texto = "\n   ".join "\n   ",@keys;
  print STDERR "$texto\n";
  my (%cualarch,@nodefinidos);
  @cualarch{@nombresA} = ($ARCHIVOA,$BASEARCHA,$CORTOA,$CORTOASIN
       ,$PROPIOA,$PROPIOASIN,$PRINCIPAL); 
  not defined $ARCHIVOA and do{
      print STDERR " Termina impr_ARCHIVOS $mensaje\n"; 
      return;
  }; 
  if (@refs) {
      print STDERR "  Archivos 'archivo' de las referencias:\n";
      foreach my $ref (@refs) {
          my @nodefinidos;
          my $cual = $ref->{archivo};
          if (defined $cual) {
              print STDERR 'desde el $ref ',"$cual\n";
              foreach my $nombre (@nombres) {
                  my $cualn = $ref->{$nombre};
                  if (defined $cualn) {
		      print STDERR "$nombre  $cualn\n";
                  } else {
                      push @nodefinidos,$nombre;
                  };

              };
              print STDERR "  no definidos: @nodefinidos\n" if @nodefinidos;
          } else {
              print STDERR "No definido\n";
          }; 
      }; 
  };
  print STDERR " Termina impr_ARCHIVOS $mensaje\n"; 
}#impr_ARCHIVOS
# ---------------------------------------------------------------------------
sub impr_UNIDADES{
  return unless $debug;
  my ($mensaje,$ref) = @_;
  $mensaje or $mensaje = __LINE__.' Glob';
  my $ya = '';
  print STDERR "impr_UNIDADES $mensaje\n";
  if (defined $ref->{DEFIuni}) {
      impr_debug($mensaje.' DEFIuni',Dumper $ref->{DEFIuni});
      $ya = 1;
  };
  if (defined $ref->{DEFIcalculo}) {
      impr_debug($mensaje.' DEFIcalculo',Dumper $ref->{DEFIcalculo});
      $ya = 1;
  };
  $ya and return;
  my $origen = 'cuadros';
  $ref eq $refglobal and $origen = 'refglobal';
  print STDERR " Empieza impr_UNIDADES $origen\n";
  my @numplantillas = keys %{$ref->{tieneplantillas}};
  map (do{$_ = nompl2numpl($_)},@numplantillas);
  foreach my $numpl (@numplantillas) {
      my $refpl = $ref->{DEFIcqalculo}->{$numpl};
      print STDERR ' 'x12, "impr_UNIDADES     $origen $mensaje\n";
      impr_campo('  $refpl',$refpl,'DEFIcomp');
      impr_campo('  $refpl',$refpl.'DEFIabrev');
      impr_campo('  $refpl',$refpl,'DEFIequiv');
      impr_campo(' $refglobal  NODOREF',Dumper $refglobal->{NODOREF});
  };
print STDERR " Termina impr_UNIDADES\n";
  return;
}#impr_UNIDADES
# ---------------------------------------------------------------------------
sub impr_cualobjref{
   return unless $opt_hash{d};
   my ($mensaje,@lisref) = @_; 
   my %cosa; 
   impr_hashrenglon(__LINE__." Glob $mensaje ", %{$lisref[0]});
   if (defined $lisref[0]->{refcirc}) {
      $cosa{$lisref[0]} = 'capa ';
      $cosa{$lisref[0]->{refcirc}} = 'circuito';
      push (@lisref,$lisref[0]->{refcirc});
   } else {
      $cosa{$lisref[0]} = 'no es capa ';
   };
   foreach my $ref (@lisref) {    
     my @liscuales = keys %{$ref};
     @liscuales = grep (/^cualobj/,@liscuales);
     foreach my $cualque (@liscuales) {
       print STDERR "...... $mensaje $cosa{$ref}$cualque\n";
       my @lisobjetos = keys %{$ref->{$cualque}};
       foreach (@lisobjetos) {
           print STDERR "$_=> [ " .  
                  join (' ', @{$ref->{$cualque}->{$_}}) . " ]\n";
       };
     };
   };
   print "fin impr_cualobjref $mensaje\n";   
}#impr_cualobjref
# ---------------------------------------------------------------------------
sub impr_dat{
  return unless $opt_hash{d};
  # sólo se usa para depurar
#  comfin('comG impr_dat', @_);
  my ($mensaje,$cosa,$ref,$clave) = @_;
  my ($tipotok,$dato,$tipdato,$tipargdato,$refarg)=tomar_todo_datos($ref,$cosa);
  length($dato) < 20 and $dato .= ' ' x (20-length($dato));
  my $stringrefarg = '';
  if ($refarg and @$refarg) {
      my @lista = grep (defined $_,@$refarg); 
      $stringrefarg = join ' ',@lista;
      length($stringrefarg) < 15 and
        $stringrefarg .= ' ' x (15-length($stringrefarg));
  };
  printf STDERR "%6s%6s=>%1s|%1s|%6s|%20s|%15s|    $mensaje" 
   ,"$clave ",$cosa, $tipotok,$tipdato, $tipargdato,  $dato, $stringrefarg;
  if ($tipotok eq 'a') {
      defined $ref->{uniuni}->{$cosa} and print STDERR '|'
        ,$ref->{uniuni}->{$cosa};
  } elsif ($cosa =~ /^[TQ]/) {
      if (defined $ref->{defiQT} and defined $ref->{defiQT}->{$cosa}) {
          print STDERR "cuadro $ref->{defiQT}->{$cosa}";
      };
  } elsif (uc($tipotok) eq 'Q') {
      if (defined $ref->{defiQT} and defined $ref->{defiQT}->{$cosa}) {
          my $obj = $ref->{defiQT}->{$cosa};
          my $archfunc = $reflayers[$laylista->[$obj]]->{ARCHIVOCAPA};
          if ($archfunc) {
              $archfunc eq $ref->{ARCHIVO} and $archfunc = '       ';
              print STDERR '|',$archfunc;
          };
      };
  };
   print STDERR "\n";
  impr_dat_cosas($ref,[$cosa],$clave); 
#  comfin('finG impr_dat');
  return;
}#impr_dat
# ---------------------------------------------------------------------------
sub impr_dat_cosas{
  return  unless $debug;
  # comfin('comG impr_dat_cosas',@_);
  my @argus = @_;
  my ($ref,$reflistakeys,$clave) = @_;
  my (@concosa,@concosatotal);
  my @listakeys = @$reflistakeys;
  foreach my $key (@listakeys) {
      my $report = '';
      my $tipotok = valor($ref,'TIPOTOK',$key);
      my @cualaspectos = @extrasnoFUNCION;
      if ($tipotok =~ /[qQ89]/) {
          @cualaspectos = (@extraslistaFUNCION,@extrasescalarFUNCION);
      } elsif ($tipotok eq 'h') {
          @cualaspectos = ('listaargFUNCION');
      } elsif ($tipotok =~ /w/i) {
          next;
      }; 
      my $texto = '';
      # impr_debug(__LINE__.' Glob @cualaspectos',\@cualaspectos);
      foreach my $aspecto (@cualaspectos) {
          # next unless (defined $ref->{$aspecto} and
          #              defined $ref->{$aspecto}->{$key});
          my $refkey = valor($ref,$aspecto,$key);
          next unless $refkey;
          my $textito = '';
          if ($refkey =~/ARRAY/) {
              $textito = join ' ',@$refkey;
          } elsif ($refkey =~/HASH/) {
              # impr_debug(__LINE__
              #   .' Glob $aspecto imprevisto para impr_dat_cosas',$aspecto);
              next;
          } else {
              $textito = $refkey;
         #  impr_debug(__LINE__.' Glob $aspecto $textito',[$aspecto,$textito]); 
          }; 
          if (defined $textito) {
              $texto and $texto = $texto .'|';
              $texto  .= "$aspecto=$textito";
          };
          # impr_debug(__LINE__.' Glob $texto',$texto);
      };#my $aspecto
      if ($texto) {
          $report and $report = "$report|";
          # impr_debug(__LINE__.' Glob $report',$report);
          $report = "$key>=$report$texto";
          # impr_debug(__LINE__.' Glob $report',$report);
          if (valor($ref,'listacom',$key) ) {
              # impr_debug(__LINE__.' Glob',Dumper valor($ref,'listacom',$key));
              # impr_debug(__LINE__.' Glob',$ref->{listacom}->{$key});
              $report .= "|listacom=@{valor($ref,'listacom',$key)}";
              # impr_debug(__LINE__.' Glob $report',$report);
          };
      };
      # impr_debug(__LINE__.' Glob $report',$report);
      # impr_debug(__LINE__.' Glob $report',$report);
      print STDERR "$clave $report\n" if $report;
  };#my $key
  # comfin('finG impr_dat_cosas');
  return ;
}#impr_dat_cosas
# ---------------------------------------------------------------------------
sub impr_datos{
  # sólo se usa para depurar
  return unless $debug;
#  impr_debug(__LINE__.' Glob %cortoarchivo',\%cortoarchivo);
  my ($mensaje, $reflisque, $ref, $nombre) = (@_,'');
  if (@_ < 3 or not $ref or $ref !~ /HASH/) {
      print STDERR 'pedido impr_datos inválido',"\n";
      return;
  };
  not $nombre and $nombre = $ref->{nombre};
  if (not $nombre and defined $ref->{numobj}) { 
      $nombre = descripcion_cuadro($ref->{numobj});
  };
  if (not $nombre and defined  $ref->{numcapa}) {
      $nombre = descripcion_capa($ref->{numcapa});
  };
  if ($nombre and $nombre eq '()') {
      $nombre = " capa de $ref->{ARCHIVOCAPA}";
  };
  my $numfile = $ref->{numfile};
  not $numfile and do {
     impr_debug(__LINE__.' Glob', Dumper $ref);
  };
  not $nombre and $nombre = $refnombres[$ref->{numfile}]->{CORTO};
  not $nombre and $nombre = 'sin nombre';
  if ($nombre eq 'sin_nombre') {
      impr_debug(__LINE__.' Glob $ref',Dumper $ref);
  };
  my ($lisque,$liskey) = ([],[]);
  if (not $reflisque or  @$reflisque == 0) {
      $lisque = ['TODOS'];
  } else {
      @$lisque = @$reflisque;
  };
#  impr_debug(__LINE__.' Glob $lisque',$lisque);
#      impr_debug(__LINE__.' Glob $lisque->[0]',$lisque->[0]);
  my $msg = '';
  my $lista0 = '';
  if (@$lisque == 1) {
      $lista0 = "$lisque->[0]: ";
      ($lisque,$msg) = expandir_datos_que($ref,$lisque->[0]);
  } else {
      $msg = "  Pedido '".join(' ',@$lisque)."';";
      @$lisque = grep(do{$ref->{"lista$_"} and @{$ref->{"lista$_"}}}
		      ,@$lisque);
      @$lisque and $msg.= " hay @$lisque" or $msg .= "no hay nada"; 
  };
#  print STDERR "$msg\n";  
  my $lista = $lista0 . join ' ',@$lisque;
   
  print STDERR " impr_datos ( $mensaje) $lista \n";
  print STDERR "           para $nombre  " .'=' x 15,"\n";
  if (not @$lisque) {
      print STDERR " Termina impr_datos $lista ( $mensaje)\n";
      return '';
  };    
  my @nohay;
  for (my $i= 0; $i < @$lisque; $i++) {
      if (defined $ref->{"lista$lisque->[$i]"} and 
          @{$ref->{"lista$lisque->[$i]"}}){
      } elsif ($lisque->[$i] eq'TEMP') {
          my @lista = grep(/^VNODOCIRC/,keys %{$ref->{VALOR}});
          if (@lista) {
              $ref->{"lista$lisque->[$i]"}= \@lista;
          } else {
              delete $lisque->[$i];
          };
      } else {
          push @nohay, $lisque->[$i]; 
          $lisque->[$i] = undef;
          next;
      };
  };
  my $refextras = \@extrasnoFUNCION;
  foreach my $que (@$lisque) { 
      my @listakeys = sort @{$ref->{"lista$que"}};
      impr_datos_principal($ref,$que); 
       if ($que eq 'FUNCIONES') {
          my @extras = (@extraslistaFUNCION,@extrasescalarFUNCION);
          $refextras = \@extras;
      };
      impr_dat_cosas($ref,\@listakeys,"i.d:i.d");
      my $texto ='';# no se está imprimiendo
      if ($que eq 'PARAMETROS' and @listakeys) {
          my @nohay;
          foreach my $palabra('sustituidos') {
              if (defined $ref->{"pars$palabra"} 
                   and scalar keys %{$ref->{"pars$palabra"}}) {
                   $texto .= "     Si hay pars$palabra: ".
                       join (' ', keys %{$ref->{"pars$palabra"}})."\n";
              } else {
                  push @nohay, "pars$palabra";
              };
          };
          @nohay and print STDERR "     No hay @nohay\n"; 
          $texto .= hashrenglon('   Glob valuespar: ', %{$ref->{valuespar}})
            if defined $ref->{valuespar};
          $texto .= '   Glob parámetros usados: '.
                    join (' ', keys %{$ref->{USAp}})."\n"
           if defined $ref->{USAp} and scalar  %{$ref->{USAp}}; 
      } elsif ($que eq 'RESULTADOS' or $que eq 'temp') {
          $texto .= hashrenglon('   Glob TEMP ', %{$ref->{TEMP}});
          $texto .= hashrenglon('   Glob temp ', %{$ref->{temp}});
          $texto .= 'listapedidos ' . "@{$ref->{listapedidos}}\n" 
              if $ref->{listapedidos};
      };
      print STDERR __LINE__.' Glob',"$texto\n" if $texto;
  }; #$que 
  impr_debug($mensaje . ' {pendientes}',Dumper $ref->{pendientes})
      if $ref->{pendientes};
#  impr_debug($mensaje .' {valor2cual}',Dumper $ref->{valor2cual})
#      if scalar keys %{$ref->{valor2cual}};
#  impr_debug($mensaje.' {parscreados}',Dumper $ref->{parscreados}) 
#      if  keys %{$ref->{parscreados}};
  impr_debug($mensaje.' {uniuni}',Dumper $ref->{uniuni}) 
      if  keys %{$ref->{uniuni}};
  print STDERR " Termina impr_datos $lista  ( $mensaje)\n";
  return '';
}#impr_datos
# ---------------------------------------------------------------------------
sub impr_datos_principal{
  return unless $debug;
  my($ref,$que) = @_;
  print STDERR "    lista$que:    ". join ' ', @{$ref->{"lista$que"}},"\n" 
      if defined $ref->{"lista$que"}; 
  print STDERR "          valores de $que\n";
 if ($que eq 'DATOS') {
     print STDERR 
       "=>(TIPOTOK|TIPO|  TIPARG  |     VALOR      |REFARG|   uniones)\n";
 } elsif ($que eq 'FUNCIONES') {
     print STDERR 
 "=>(TIPOTOK|TIPO|  TIPARG  |     VALOR      |  REFARG | archivo o comillas)\n";
 } else {
          print STDERR 
             "=>(TIPOTOK|TIPO|  TIPARG  |     VALOR       |REFARG      )\n";
 }; 
# $que eq 'INICIALES' and $pre = 'INICIAL';
  foreach my $key (@{$ref->{"lista$que"}}) {
      my ($tipotok,$dato,$tipdato,$tipargdato,$refarg) = tomar_todo_datos(
       $ref,$key);
#     impr_debug(__LINE__.' Glob',[$key,$tipotok,$dato,$tipdato,$tipargdato
#      ,'||',@$refarg]);
#     $dato = 'no definido' unless defined $dato and $dato ne '';
      length($dato) < 20 and $dato .= ' ' x (20-length($dato));
      my $stringrefarg = '';
      if ($refarg) {
          my @lista = grep (defined $_,@$refarg); 
          $stringrefarg = join ' ',@lista;
          length($stringrefarg) < 15 and
            $stringrefarg .= ' ' x (15-length($stringrefarg));
      }; 
      printf STDERR "%12s=>%1s|%1s|%6s|%20s|%15s" 
        ,$key, $tipotok,$tipdato, $tipargdato,  $dato, $stringrefarg;
      if ($tipotok eq 'a') {
          defined $ref->{uniuni}->{$key} and print STDERR '|'
            ,$ref->{uniuni}->{$key};
      } elsif ($key =~ /^[TQ]/) {
          if (defined $ref->{defiQT} and defined $ref->{defiQT}->{$key}) {
               print STDERR "cuadro $ref->{defiQT}->$key";
          };
      } elsif (uc($tipotok) eq 'Q') {
          if (defined $ref->{defiQT} and defined $ref->{defiQT}->{$key}) {
              my $obj = $ref->{defiQT}->{$key};
              my $archfunc =$reflayers[$laylista->[$obj]]->{ARCHIVOCAPA};
              if ($archfunc) {
                  $archfunc eq $ref->{ARCHIVO} and $archfunc = '       ';
                  print STDERR '|',$archfunc;
              };
          };  
      };    
      print STDERR "\n";
#      next if $key =~ /^output/; 
  }; #@listakeys
 return;
}#impr_datos_principal
# ---------------------------------------------------------------------------
sub impr_identi{
   # sólo se usa para depurar
   my ($mensaje,$refarch) = @_; 
   return unless $opt_hash{d};
   print STDERR "----------------------- com Glob impr_identi: $mensaje
                   a pedido de archivo $refarch->{CORTO}\n";
   impr_debug(__LINE__.' Glob cuallay',Dumper $cuallay);
   impr_debug(__LINE__.' Glob cualplantilla', Dumper $cualplantilla);
   impr_debug(__LINE__.' Glob cualshape', Dumper $cualshape);
   impr_debug(__LINE__.' Glob nombre_menu_Dia', Dumper $nombre_menu_Dia);
   impr_debug(__LINE__.' Glob comocod', Dumper $comocod);
   impr_debug(__LINE__.' Glob comocodvalor', Dumper $comocodvalor);
#   impr_objs($mensaje,'[CEJLRcejlrZT]',$refarch->{capas});
  print STDERR " ----------------------- fin Glob impr_identi: $mensaje\n";
}#impr_identi
# ---------------------------------------------------------------------------
sub impr_listas_que{
  # comfin('comG impr_listas_que',@_);
  return unless $opt_hash{d};
  my ($mensaje, $ref,$lisque,$pre) = @_; my $hay = 1; my $que;
  my $liskey;
  $pre or $pre = 'lista';  
  if (not defined $lisque and $mensaje) {
      ($que = $mensaje) =~ s/^(\w+).*$/$1/;
      impr_debug(__LINE__.' Glob $que',$que);     
      ($lisque) = expandir_datos_que($ref,$que);
  } elsif (defined $lisque) {
      impr_debug(__LINE__.' Glob $lisque',Dumper $lisque);
       if ($lisque->[0] eq 'TODOS' and $pre eq 'lista') {
           $lisque = ['DATOS','PPARAMETROS','DPARAMETROS'
           ,'DINICIALES','VIINICIALES','FUNCIONES','TABLAS',
		      'CONTROLES','PEDIDOS'];
       } elsif ($lisque->[0] eq 'TODOS' and $pre eq 'lis') {
            ($lisque,$liskey) = expandir_datos_que($ref,$lisque->[0]);
       } elsif (@$lisque == 1){
            ($lisque) = expandir_datos_que($ref,$lisque->[0]);
       };
  };
  impr_debug(__LINE__.' Glob $lisque,$pre,$hay',[@$lisque,'||',$pre,$hay]);
  $mensaje or $mensaje = __LINE__.' Glob';
  print STDERR ' 'x20, "impr_listas_que    $mensaje\n";
  $hay and @$lisque or do{
       print STDERR " No hay esas listas\n";
       # comfin('finG impr_listas_que');
       return;
  };
  my $nohay = ''; my $sindefinir ='';
  foreach my $pal (@$lisque) {
      if ($ref->{"$pre$pal"}) {
          my $refcual = $ref->{"$pre$pal"}; 
          my @lista = @$refcual;
          if (@lista) { 
              map (do{not defined $_ and $_ ='nodefin';
                           /^\s*$/ and $_ = 'blancos'}
                      ,@lista);
              print STDERR "  $pre$pal: ", join '   ',@lista,"\n";
          } else {
              $nohay .= ",$pre$pal";
          };
      } else {
          $sindefinir .= ",$pre$pal";
      };
  };
  if ($nohay) {
      $nohay =~ s/^,//;
      print STDERR "Listas vacías: $nohay\n";
  };
  if($sindefinir) {
      $sindefinir =~ s/^,//;
      print STDERR "Lista sin definir: $sindefinir\n";
  };
  # comfin('finG impr_listas_que');
  return;
}#impr_listas_que
# ---------------------------------------------------------------------------
sub impr_objs{
  comfin('comG impr_objs',@_); 
  # datos de objetos cuyo numero esta en la lista y cumplen reg y lay.   
  # sólo se usa para depurar
  return unless $debug;
  my ($mens,$ref,$reg,$lislay,$lisobj) = (@_,'','','');
  # $ref y $reg obligatorios
  # $mens mensaje
  # $reg expresion regular
  # $lislay ref. a lista de num. de layers
  # $lisobj ref. a lista de num. de objetos; sera selec. bajo $reg y $lislay 
  # $ref con toda la informacion de iconos y barras que interese
  my ($formato,$largo,$numfile);
#  impr_debug(__LINE__.' Glob $ref',Dumper $ref);
  if ($ref->{numcapa}) {
      $lislay = [$ref->{numcapa}];
  } elsif ($ref->{capas} and not $lislay) {
      $lislay = $ref->{capas};
      impr_debug(__LINE__.' Glob $lislay',$lislay) if @{$lislay}; 
#  } else {
#      mensajear(' \$ref no se refiere a archivo ni a capa');
#      comfin('finG impr_objs',@_); 
#      return;
  };
  my %silay;
  map ($silay{$_} = 1,@$lislay);
  if (not $lisobj) {
      $lisobj = [1..scalar @$codlista - 1];
  };
  @$lisobj = grep ($silay{$laylista->[$_]},@$lisobj);        
  impr_debug(__LINE__.' Glob $lisobj',$lisobj) if @$lisobj; 
  $largo = 6;
  if ($reg and $reg eq '[O]') {
      $largo = 20;
  };
  if ($reg) {
      @$lisobj = grep (do {$codlista->[$_] =~ /^$reg$/},@$lisobj);
  };
  impr_debug(__LINE__.' Glob $lisobj',$lisobj) if @$lisobj;
  $formato =  "%3s %" . $largo ."s %7s %12s %1s";
  if ($lisobj and @$lisobj) { 
       printf STDERR $formato 
         ,'#' , 'iden','placsha','lugar  '
         ,' objobj uniuni ____________datos______ iniciales';
       print STDERR "\n";
  } else {
      print STDERR "   No hay objetos en las condiciones pedidas\n";
      comfin('finG impr_objs');
      return ''
  };
  $numfile = $ref->{numfile};
  my @renglones;
  my $refarch = $refarchers[$numfile];
  my $refgraf = $refgrafers[$numfile];
#  impr_debug(__LINE__.' Glob los ref $ref,$refarch,$refgraf'
#	   ,[$ref,$refarch,$refgraf]);
  foreach my $ij (@$lisobj) {
      my $cod = $codlista->[$ij];
      my $iden = $cod . $textolista->[$ij];
      my $plantillacshape = $plantillalista->[$ij]. 'c' .$shapelista->[$ij];
      my $lugar = $lugarlista->[$ij];
      my $identif = $nombre_menu_Dia->{$plantillacshape};
      defined $identif or $identif = $nombreshape->[$shapelista->[$ij]];
      my ($uniuni,$objobj,$datosiden,$inicialesiden,$textohandles); 
      if ($cod =~ /^[ONntXxu]$/) {
          ($uniuni,$objobj,$datosiden,$inicialesiden) = ('','','','');
          if ($cod =~ /^[Xxu]$/) { 
#              $lugar = join '',@{$refgraf->{lughandles}->{$ij}};
          };
     } else {
          $objobj = $refgraf->{objobj}->{$ij};
          my $capa = $laylista->[$ij];
          my $reflay = $reflayers[$capa];
           if ($reflay->{cualnumclasenum}->{elementos}) {
              $uniuni = $reflay->{uniuni}->{$iden};
              defined $uniuni and $uniuni
                = join ' ',@{$reflay->{uniuni}->{$iden}};
          } else {
              $uniuni = $refarch->{uniuni}->{$iden};
	  };
          $datosiden = valor($refgraf->{refarch},'VALOR',$iden); 
          not defined $objobj and $objobj = 'unini';
          not defined $uniuni and $uniuni = 'unini';
          not $datosiden  and $datosiden = 'unini';
          if (uc($cod) =~ /^[CL]$/) {
              uc($cod) eq 'C' and
                 $inicialesiden = valor($refgraf,'INICIALES','V'.$iden);
              uc($cod) eq 'L' and
                 $inicialesiden = valor($refgraf,'INICIALES','I'.$iden);
              not defined $inicialesiden or $inicialesiden = '---';
          } else {
              $inicialesiden = ' ---';
          };
      };
      my $renglon = sprintf $formato, $ij, substr($iden,0,$largo)
        , $plantillacshape, $lugar,'';  
      $renglon 
       .= sprintf "%6s %6s %20s %6s",$objobj,$uniuni,$datosiden,$inicialesiden; 
      push @renglones,$renglon;  
  };#foreach $ij
  print STDERR join ("\n",sort @renglones);
  print STDERR "\n",'=' x 15, "\n";
  comfin('finG impr_objs',@_);
  return; 
}#impr_objs
# ---------------------------------------------------------------------------
sub impr_par{
  return unless $debug;
#  comfin('comG impr_par',@_);
  my ($mensaje,$tiparg,$refarg) = @_;
  $tiparg  =~ tr/JK/+-/;
  # J K aparecen en evaluar_terms
  (my $letras = $tiparg) =~ s/\W+//g;
  if ($refarg !~ /ARRAY/ or length ($letras) != @$refarg or $tiparg =~ /\w\w/) {
      print STDERR "impr_par $mensaje ERROR:\n"; 
      print STDERR '    Dumper $tiparg ',Dumper $tiparg;
      print STDERR '    Dumper $refarg ',Dumper $refarg;
      error_progr($reftrabajo,__LINE__.' Glob impr_par $mensaje '
           . $mensaje);
  };
  my $tipargm = $tiparg;
  not $tiparg and $tipargm = 'vacio';
  printf STDERR "impr_par %26s||%20s","$mensaje ttr  ", $tipargm;
  my $refargm = '';
  if (@$refarg) { 
      $refargm = join ' ',@$refarg;
  } else {
      $refargm = 'vacio';
  };
  print STDERR "   $refargm \n";
  # comfin('finG impr_par');
  return;
}#impr_par
# ---------------------------------------------------------------------------
sub impr_detallado{
#  comfin('comG impr_detallado',@_);
  my($mensaje,$reftiparg,$refrefarg,$refsep,$refult) = @_;
  print STDERR " Empieza impr_detallado $mensaje\n";
#  impr_debug(__LINE__.' Glob',Dumper $refrefarg);
  my ($tiparg,$refarg) = ($refsep->[0],[]);
  for (my $ip = 0; $ip < @$reftiparg; $ip ++) {
      $tiparg .= $reftiparg->[$ip]. $refsep->[$ip+1];
      push @$refarg,@{$refrefarg->[$ip]};
      my ($ultant,$tokenant) = ('','');
      if ($ip != 0) {
         $ultant = $refult->[$ip-1];
 #        if ($ultant =~ /\w/) {
 #            $tokenant = $refrefarg->[$ip-1]->[-1];
 #        } else {
 #            $tokenant = $ultant;
 #        };
      };
      printf STDERR 
        "%2i:  %8s   %6s %10s %6s  valores %1s\n",$ip,$ultant,$refsep->[$ip],
	  ,$reftiparg->[$ip],$refsep->[$ip+1]," @{$refrefarg->[$ip]}";
  };
  print STDERR '$tiparg || $refarg ',$tiparg,'||',join (' ',@$refarg),"\n";
  impr_par($mensaje,$tiparg,$refarg);  
  print STDERR " Termina impr_detallado $mensaje\n";
#  comfin('finG impr_detallado');
}#impr_detallado;
# ---------------------------------------------------------------------------
sub impr_detal_ip{
   my($ip,$reftiparg,$refrefarg,$refsep,$refult) = @_;
   my $tiparg = $reftiparg->[$ip];
   $tiparg .= $refsep->[$ip+1] if $refsep->[$ip+1];
   my ($ultant,$tokenant) = ('','');
   if ($ip != 0) {
       $ultant = $refult->[$ip-1];
   };
   printf STDERR 
        "%2i:  %8s   %6s %10s %6s  valores %1s\n",$ip,$ultant,$refsep->[$ip],
	  ,$reftiparg->[$ip],$refsep->[$ip+1]," @{$refrefarg->[$ip]}";
   return;
}#impr_detal_ip
# ---------------------------------------------------------------------------
sub impr_refall{
  #comfin('comG impr_refall',@_);
  my ($mensaje) = (@_,'');
  $opt_hash{d} or return;
  print STDERR " comG impr_refall $mensaje: ";
  foreach my $palabra (qw (archivos capas capasele)) {
      print STDERR " $palabra = ["."@{$refall->{$palabra}}".']';
  }; print STDERR "\n";
  foreach my $palabra (qw (capasmod capascir capasgra capasresto)) {
      print STDERR " $palabra = ["."@{$refall->{$palabra}}".']';
  }; print STDERR "\n";
  print STDERR 'ARCHIVO2extras ',Dumper $refall->{ARCHIVO2extras};
  print STDERR '$refall->{cualnumclasenum} ',Dumper $refall->{cualnumclasenum};
  print STDERR '$refall->{hashclasegr} ',Dumper $refall->{hashclasegr};  
  print STDERR __LINE__.' Glob refnombres ',Dumper \@refnombres;
  foreach my $numfile (@{$refall->{archivos}}) {
      my $arch = $refnombres[$numfile]->{ARCHIVO};
      my $refarch = $refarchers[$numfile];     
      my $clasearch = $refarch->{clasearch};$clasearch or $clasearch = 'no def';
      print STDERR "$arch: clasearch $clasearch\n"; 
 };
  print STDERR " finG impr_refall $mensaje\n";
  #comfin('finG impr_refall');
  return;
}#impr_refall
# ---------------------------------------------------------------------------
sub impr_refes{
  # comfin('comG impr_refes,@_);
  my $mensaje = $_[0];
  $opt_hash{d} or return;
  print STDERR "impr_refes $mensaje keys %\$refall: ",scalar (keys %$refall),
  ' @refarchers: ',scalar @refarchers,' @refgrafers: ',scalar @refgrafers,"\n"; 
  #  comfin('finG impr_refes);
  return
}#impr_refes,@_);
# ---------------------------------------------------------------------------
sub impr_tipotok_valor_ori_num_master_que{
  # comfin('comG impr_tipotok_valor,ori_num_master_que',@_);
  $opt_hash{d} or return;
  my ($mensaje,$ref) = @_;
  print STDERR " impr_tipotok_valor_ori_num_master_que  $mensaje \n";
  foreach my $refprop (@{$ref->{listaTIPOTOK}}) {
      my ($cosa,$tipotok,$ori,$numobj,$master,$que,$coment) = @$refprop;
      printf STDERR " %13s=>%1s|%-24s|%8s|%10s|%1s\n",
        $cosa,$tipotok,$ori,$numobj,$master,$que,$coment
  };
  # comfin('finG impr_tipotok_valor_ori_num_master_que');
  return;
}#impr_tipotok_valor_ori_num_master_que 
# ---------------------------------------------------------------------------
sub impr_SUST{
  return unless $opt_hash{d};
  my ($mensaje,$ref) = @_;
  print STDERR "impr_SUST $mensaje ",'$ref',"\n";
  foreach my $post (qw(N no Ss noSs adp noSsadp)) {
      if($ref->{"SUST$post"} and scalar keys %{$ref->{"SUST$post"}}) {
          my @lista; 
          foreach my $key (sort keys %{$ref->{"SUST$post"}}) {   
              push @lista, $key;
	  };
          print STDERR "    SUST$post: @lista\n";
      };
  };  
}#impr_SUST
# ---------------------------------------------------------------------------
sub impr_resultados{
   return unless $opt_hash{d};
   my ($mensaje, $ref) = @_;
   print STDERR '   Comienza impr_resultados $ref',"\n";
   impr_datos($mensaje, ['PEDIDOS'], $ref);
   if ($ref->{listaPEDIDOS} and @{$ref->{listaPEDIDOS}}) {
       my @sinnada;
       foreach my $pal (qw (indicebueno hashdeparnum)) {
           if ($ref->{indicebueno} and scalar keys %{$ref->{indicebueno}}) {
               impr_campo($pal,$ref,$pal);
           } else {
               push @sinnada,$pal;
           };
       };
       foreach my $pal (qw (lispares lissceptres
        lispropias lismagnitudes lisunidades lisresultadosmalos lisrepetidos)) {
           if ($ref->{$pal} and @{$ref->{$pal}}) { 
               impr_campo($pal,$ref,$pal);
           } else {
               push @sinnada,$pal;
           };
       };
       print STDERR "Campos is nada para:
        @sinnada\n";
   };
   print STDERR '   Termina impr_resultados $ref',"\n";
   return;
}#impr_resultados
# ---------------------------------------------------------------------------
sub impr_unionesobj{
  return unless $opt_hash{d};
  comfin('comG impr_unionesobj',@_);
  my ($mensaje,$refgraf) = @_;
  my $refun = $refgraf->{unionesobj};
  not defined $refun and do{
      print STDERR "$mensaje : no hay nada\n";
      comfin('finG impr_unionesobj');
      return};
  foreach my $obj(sort keys %$refun) {
      my $tira;
      $tira =  "@{$refun->{$obj}}"; 
      printf STDERR "%4i %20s %7s  %1s\n", $obj, $lugarlista->[$obj], 
        "$codlista->[$obj]$textolista->[$obj]", $tira;
  };
  comfin('finG impr_unionesobj');
  return;
}#impr_unionesobj    
# ---------------------------------------------------------------------------
sub mover_datos{
  comfin('comG mover_datos',@_);
  #se confia que nunca el nombre descartado haya entrado de nuevo
  my ($refo, $queo, $nombreo,$refd, $qued, $nombred,$mensaje) = @_;
  if ($refo eq $refd and $queo eq $qued and $nombreo eq $nombred) {
      comfin('finG mover_datos');
      return;
  };
  $refd->{$qued}->{$nombred} = $refo->{$queo}->{$nombreo};
  $refd->{TIPO}->{$nombred} = $refo->{TIPO}->{$nombreo};
  $refd->{TIPARG}->{$nombred} = $refo->{TIPARG}->{$nombreo};
  @{$refd->{REFARG}->{$nombred}} = @{$refo->{REFARG}->{$nombreo}};
  delete $refo->{$queo}->{$nombreo};
  delete $refo->{TIPO}->{$nombreo};
  delete $refo->{TIPARG}->{$nombreo}; 
  delete $refo->{REFARG}->{$nombreo}; 
  my $agre = substr($queo,0,3). "-$nombreo";
  # impr_dat_que($nombred, $qued, "$mensaje$agre", $refd, 'mv');
  @{$refo->{"lista$queo"}} = grep($_ ne $nombreo,@{$refo->{"lista$queo"}});
  push @{$refd->{"lista$qued"}}, $nombred;
  comfin('finG mover_datos');
  return; 
}#mover_datos
# ---------------------------------------------------------------------------
sub para_sceptre_num{
#  comfin('comG para_sceptre_num', @_);
  my $valor = $_[0];
  $valor = sprintf("%6G", $valor);$valor =~ s/^\s*//;
  if ($valor =~ /E/ and $valor !~ /\./) { 
      $valor =~ s/E/.E/;
  };
#  comfin('finG para_sceptre_num', $valor);
  return $valor;
}#para_sceptre_num     
# --------------------------------------------------------------------------
sub parar1{
    comfin('comG parar1',@_);
  # $mensaje se usa para errores detectados por simusol1.pl,
  # que aun no se comunicaron;
  # otros se han comunicado por avgrav,... or porparar 
  # el código será 0 (sin error para el principal) 
  # o el numero del exit .....
  # $archivo, si se da, es el nombre corto
  # $archivo o $mensaje $ref deben estar presentes 
  #impr_debug(__LINE__.' Glob reffi ', \%reffi);
  my ($codigo,$ref,$mensaje,$archivo)
    = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos
  $codigo eq '0' and $ref eq '0' and exit 250;
  my $numfile;  
  $codigo or $codigo = 0; 
  if ($mensaje) {
      mensajear($mensaje);
  };
  if ($ref and $ref ne $refglobal) {
      $numfile = $ref->{numfile};
      $numfile or impr_debug(__LINE__.' Glob',Dumper $ref);
  } elsif ($archivo) {
      $numfile = $cualfile->{$archivo};
  } elsif ($ARCHIVOA) {
      $numfile = $cualfile->{$ARCHIVOA};
  };
  my ($ARCHIVO,$BASEARCH,$PROPIO, $PROPIOSIN)
      = @{$refnombres[$numfile]}{'ARCHIVO','BASEARCH'
        ,'PROPIO' ,'PROPIOSIN'};
#  if ($codigo and scalar (keys %dirsal)) {
#      foreach my $ext (qw (res sim simul lsg)) {
#          system "rm $dirsal{$ext}/$PROPIOSIN.$ext 2>/dev/null"
#      };
#  };

  if ($codigo == 2) {#archivos no buenos
      impr_debug(__LINE__.' Glob$codigo',$codigo);
      exit $codigo;
  } elsif ($codigo > 4) {
      explic('       No hay nada mas que hacer');
  };
  impr_debug(__LINE__.' Glob $codigo',$codigo);
  if ($codigo >= 250) {
      explic('     no hay nada para registrar');
      print SALIDAls3 "código s1: $codigo\n"; close SALIDAls3;
      exit $codigo; 
  };
#  impr_debug(__LINE__.' Glob $ref', Dumper $ref);
  if($ref eq '0') {
      exit $codigo;
  }; 
  my $clasearch = $ref->{clasearch};
  impr_debug(__LINE__.' Glob $clasearch',$clasearch);
  $clasearch or $clasearch = $ref->{viejaclasearch};
  $clasearch or $clasearch = 'nada';
#  impr_debug(__LINE__.' Glob',Dumper \%dirguardar);
  my $dirg = $dirguardar{$clasearch};
  $dirg = $dirguardar{$clasearch};
#  impr_debug(__LINE__.' Glob %dirsal',Dumper \%dirsal);
#  $dirsal{caj} or $dirsal{caj} = "$outdir/$dirsalida{caj}/";   
  my $archcaj = "$dirsal{caj}$PROPIOSIN.caj";
  my $archcache = "$dirsal{cache}$PROPIOSIN.cache";
  open SALIDAcaj, ">$archcaj" or die " No pude abrir $archcaj";
  my $apartir = '';
  $apartir =
   "# a partir de ../$dirg/$PROPIO de fecha $datedia\n" if $dirg ne 'nothing';
  print SALIDAcaj "# Archivo $PROPIOSIN.caj; $marca_Simusol (simusol1.pl)\n";
  print SALIDAcaj $apartir;
  if (defined $CAJAS->{$ARCHIVO}) {
      print SALIDAcaj "$CAJAS->{$ARCHIVO}\n";   
  } else {
      print SALIDAcaj "Nada para poner aquí\n";   
  }
  close SALIDAcaj;
  my @archPARAMETROS;
  @archPARAMETROS = @{$ref->{NOUSAP}} if $ref->{NOUSAP};
      impr_debug(__LINE__.' Glob @archPARAMETROS',\@archPARAMETROS);
  @archPARAMETROS = grep(do{not $ref->{parscreados}->{$_}},@archPARAMETROS);
      impr_debug(__LINE__.' Glob @archPARAMETROS',\@archPARAMETROS);
  if (@archPARAMETROS) { 
      open SALIDApar, ">$dirsal{par}$PROPIOSIN.par";
      print SALIDApar "# Archivo $PROPIOSIN.par; $marca_Simusol (simusol1.pl)
#      a partir de ../$dirg/$PROPIO de fecha $datedia\n";
      print SALIDApar "       con opción -todas $opt_hash{todas}\n"
         if $opt_hash{todas};
      print SALIDApar
        " Parámetros o elementos sin influencia en los calculos de Sceptre;\n";
      print SALIDApar "#        no pedidos como resultados \n" 
              if $codigo ne 1;
      print SALIDApar
        "#     o ya sustituidos en ../$dirsalida{d}/$PROPIOSIN.d\n"
              if -e "$dirsal{d}/$PROPIOSIN.d";
      impr_debug(__LINE__.' Glob @archPARAMETROS',\@archPARAMETROS);
      foreach my $cosa (sort @archPARAMETROS) {
          my ($tipotok,$valor,$tipo,$tiparg,$refarg,$uni,$ori
              ,$coment,$comp,$listacom) = tomar_todo_datos($ref,$cosa);      
          $tiparg =~ /[no]/ and 
              map(do{$_ =~ /^[\+\-]\.{0,1}\d/ and 
                 $_ = para_sceptre_num($_)},@$refarg);
          $valor = tiparg_refarg_2_valor_talcual(
            $tiparg,$refarg,'Glob '.__LINE__); 
          $valor =~ s/\^/**/;$valor =~ tr/[]/()/;
          print SALIDApar "$cosa = $valor";
          if ($uni) {
              print SALIDApar " $uni";
          };
          if ($listacom) {
	      $listacom =~ s/\^/**/g;$listacom =~ tr/[]/()/;
             print SALIDApar ";  $listacom\n";
           } elsif (valor($ref,'VALOR',$valor)) {
	       my $valorc = valor($ref,'VALOR',$valor); $valorc =~ tr/[]/()/;
             print SALIDApar ";  $valorc\n";
           } else {
             print SALIDApar "\n";
           };
      };
      if ($ref->{sobreTABLAS}->{tablas}) {
          my @tablas = @{$ref->{sobreTABLAS}->{tablas}};
          foreach my $Tidtabla (@tablas) {
              next if $ref->{USATAB}->{$Tidtabla};
              (my $idtabla = $Tidtabla) =~ s/^T//;
              print SALIDApar "\n   Tabla $idtabla\n";
              print SALIDApar 
            "  abscisas: @{$ref->{sobreTABLAS}->{$Tidtabla}->{absTABLAS}}\n";
              print SALIDApar 
            " ordenadas: @{$ref->{sobreTABLAS}->{$Tidtabla}->{ordTABLAS}}\n";
          };
      };
      close SALIDApar;
  };
  $archivo or $archivo = $PROPIO;
  impr_debug(__LINE__.' Glob $archivo',$archivo);
  my $SI = 'SI';not $codigo and $codigo = 0;
  if ($codigo <5) {$SI = 'NO';};
  explic("... $progname $SI detectó errores graves en: $PROPIOA\n");
  print SALIDAls3 "código s1: $codigo\n"; close SALIDAls3;
  exit $codigo; 
}#parar1
# ---------------------------------------------------------------------------
sub porparar1{
  # lo usan subrutinas llamadas por simusol1.pl, relativas a 
  # definicion de formulas o modelos para asignar errores a archivos
  # luego se debe abandonar el tratamiento del archivo correspondiente
  # y pone en 0 el cont. de err. graves 
  comfin('comG porparar1',@_);
  my ($coderr, $ref, $mensaje) = @_;
  if ($mensaje) {
      if ($coderr >2) {avgrav($mensaje)} else { explic($mensaje)};
  }
    if ($coderr eq 0) {
     system "rm $CORTOASIN.ls3 2>/dev/null";
  };    
  #$avisosgrav = 1 if  ($avisosgrav == 0 and $coderr >2);
  # al final lo lleva a 0
  if ($ref and $ref->{refcirc}) {
      $ref = $ref->{refcirc}; 
      $ref->{errores} += $avisosgrav;
      $avisosgrav = 0;
  };
  comfin('finG  porparar1');
  return '';
}#porparar1
# ---------------------------------------------------------------------------
sub repite_nombre{ 
   my ($iden,@listita)=@_;
   print 
    "El identificador $iden está repetido para los elementos  en: \n     ";
   map (do {print "$lugarlista->[$_]  "},@listita);print "\n";
   $avisosgrav++
}#repite_nombre
# ---------------------------------------------------------------------------
sub tiparg_refarg_2_valor_talcual{#solo simplifica cosas simples; dev. $valor
#  comfin('comG tiparg_refarg_2_valor_talcual',@_);
  my ($tiparg,$refarg,$mens_cla) = @_;
#  impr_par(__LINE__.' Glob',$tiparg,$refarg);
  my ($valor,$tipargparcial,@refargg) = ('',$tiparg,@$refarg);
  while ($tipargparcial and $tipargparcial =~ s/^(\W*)(\w)//) {
      #la primera vez puede no haber \W
      my $pre = $1; my $proxvalor = shift @refargg;
      if ($2 eq 'o') {
          if  ($pre eq '' or $pre =~ /[-+,(]$/) {# luego se arregla si es - + 
              $valor .= "$pre-$proxvalor";
          } else {$valor .= "$pre(-$proxvalor)"};
      } else {$valor .= "$pre$proxvalor"};
  };
  $valor .= $tipargparcial;
  $valor =~ s/\+\-/-/g; $valor =~ s/\-\-/+/g; $valor =~ s/\-\+/-/g;
  $valor =~ s/^\+//;$valor =~ s/([\(,])\+/$1/g;
#  comfin('finG tiparg_refarg_2_valor_talcual',$valor,$mens_cla);
  return $valor;
}#tiparg_refarg_2_valor_talcual
# ---------------------------------------------------------------------------
sub tiparg_refarg_2_vttr_talcual{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg
  #solo simplifica parentesis extra; pone todo en mayusculas
  comfin('comG tiparg_refarg_2_vttr_talcual',@_);
  my ($tiparg,$refarg,$mens_cla) = @_; my $coderr = '';
#  $tiparg =~ tr/[]/()/;
  impr_par(__LINE__.' Glob',$tiparg,$refarg);
  map($_ = uc($_),@$refarg); 
  while ($tiparg =~ s/^\(([^\(\)]+)\)$/$1/) {};
  my ($valor,$tipo);
  if (length($tiparg) == 1 and $tiparg !~  /[fghkqto]$/) {
      $valor = $refarg->[0]; $tipo = $tiparg;
  } elsif ($tiparg eq 'o') {
      $valor = -$refarg->[0]; $tipo = 'o'; 
  } elsif ($tiparg eq '-n') {# no debiera ocurrir
      $valor = - $refarg->[0]; $tipo = 'o';$tiparg = 'o'
  } elsif (length($tiparg) == 2) {# y distinto de '-n'
      $valor = '-'.$refarg->[0]; $tipo = 'x';
  } elsif ($tiparg =~  /[fghkqt]$/) {$coderr = 9;
  } else {
      $valor = tiparg_refarg_2_valor_talcual($tiparg,$refarg,'Glob '.__LINE__);
      if ($tiparg =~  /^([fghkqt])\[(.+)\]$/) {$tipo = $1;
      } else {($coderr,my @listipargs)
	       = juntar_por_paren_rec(',',split(',',$tiparg));
          if ($coderr) {
             push @MENSAJES, $coderr; $coderr = 48;return $coderr};
          @listipargs > 1 and $tipo = ','  or   $tipo = 'x';
      }; 
  };
  comfin(
    'finG tiparg_refarg_2_vttr_talcual $coderr,$valor,$tipo,$tiparg,@$refarg'
   ,$coderr,$valor,$tipo,$tiparg,@$refarg,$mens_cla);
  return $coderr,$valor,$tipo,$tiparg,$refarg;
}#tiparg_refarg_2_vttr_talcual
# ---------------------------------------------------------------------------
sub tomar_cua_datos{# devuelve VALOR TIPO TIPARG REFARG
  #comfin('comG tomar_cua_datos',@_);
  my ($ref,$nombre) = @_;
  #comfin('finG tomar_cua_datos');
  return valor($ref,'VALOR',$nombre), valor($ref,'TIPO',$nombre)
         ,valor($ref,'TIPARG',$nombre), valor($ref,'REFARG',$nombre);
}#tomar_cua_datos
# ---------------------------------------------------------------------------
sub tomar_tiparg_refarg{
  comfin('comG tomar_tiparg_refarg',@_);
  my ($ref,$cosa) = @_;
  my $tiparg = valor($ref,'TIPARG',$cosa);
  my $refarg = valor($ref,'REFARG',$cosa);
  $refarg or $refarg = [];
  comfin('finG tomar_tiparg_refarg');
  return $tiparg,$refarg;
}#tomar_tiparg_refarg
# ---------------------------------------------------------------------------
sub tomar_todo_datos{
#  comfin('comG_tomar_todo_datos',@_);
  my ($ref,$nombre) = @_;
  my @listacoms;
#  push @listacoms,valor($ref,'uni',$nombre) if valor($ref,'uni',$nombre); 
  push @listacoms,valor($ref,'com',$nombre) if valor($ref,'com',$nombre); 
#  push @listacoms,valor($ref,'comp',$nombre) if valor($ref,'comp',$nombre);
  my $listacom = join ';  ',@listacoms; 
#  impr_debug(__LINE__
#.'Glob $tipotok,$nombre,$tipo,$tiparg,$refarg,$uni,$ori,$com,$comp,$listacom
#,$que'
#,[valor($ref,'TIPOTOK',$nombre)
#        ,valor($ref,'VALOR',$nombre), valor($ref,'TIPO',$nombre)
#        ,valor($ref,'TIPARG',$nombre), valor($ref,'REFARG',$nombre)
#        ,valor($ref,'uni',$nombre), valor($ref,'ori',$nombre) 
#        ,valor($ref,'com',$nombre),valor($ref,'comp',$nombre)
#  ,$listacom,valor($ref,'que',$nombre)]);
  if ($nombre eq 'P7') {
      impr_debug(__LINE__.' Glob',valor($ref,'TIPARG','P7').'0');
  };
  return valor($ref,'TIPOTOK',$nombre)
        ,valor($ref,'VALOR',$nombre), valor($ref,'TIPO',$nombre)
        ,valor($ref,'TIPARG',$nombre), valor($ref,'REFARG',$nombre)
        ,valor($ref,'uni',$nombre), valor($ref,'ori',$nombre) 
        ,valor($ref,'com',$nombre),valor($ref,'comp',$nombre)
        ,$listacom,valor($ref,'que',$nombre);
}#tomar_todo_datos
# ---------------------------------------------------------------------------
sub valor{
#  comfin('comG valor',@_);
  my ($ref,$aspecto,$cosa) = @_;
  if (@_ != 3) {
      die "valor no tiene dos argumentos
          @_"
  };
  $cosa or return '';
  my $posivalor;
#  impr_debug(__LINE__.' Glob'." $aspecto",$ref->{$aspecto}); 
#  impr_debug(__LINE__.' Glob'." $aspecto $cosa",$ref->{$aspecto}->{$cosa}) 
#    if defined $ref->{$aspecto}; 
#  impr_debug(__LINE__.' Glob'." $aspecto",$refglobal->{$aspecto}); 
#  impr_debug(__LINE__.' Glob'." $aspecto $cosa"
#    ,$refglobal->{$aspecto}->{$cosa}) if defined $refglobal->{$aspecto}; 
  if ($ref and $ref->{$aspecto} and defined $ref->{$aspecto}->{$cosa}) {
      $posivalor = $ref->{$aspecto}->{$cosa};    
      # impr_debug(__LINE__.' Glob $cosa,$aspecto,$posivalor'
      #   ,[$cosa,$aspecto,$posivalor]);
  } elsif ($refglobal->{$aspecto} and
            defined $refglobal->{$aspecto}->{$cosa}) {
      $posivalor = $refglobal->{$aspecto}->{$cosa};
  };
  if (not defined $posivalor) { 
      if ($aspecto =~ /^(REFARG|USA|listaargFUNCION|listacom)$/) {
          $posivalor = [];
      } else {
          $posivalor = '';
      };
  };
#  comfin('finG valor',$posivalor);
  return $posivalor; 
}#valor
# ---------------------------------------------------------------------------

1
