#Resultados.pm
# Tiene rutinas de control para simusol1.pl relacionadas con la formación
# de los pedidos de outputs para sceptre
package Simusol::Resultados;
use Simusol::Algebraico;
use Simusol::Auxiliares;
use Simusol::Tablasfuncq;
use Simusol::Termicos;
use Simusol::GlobalesSimusol;
use Simusol::Evaluaciones;
use Simusol::Evaluaciones2;
use Simusol::Ayudas; 
use Simusol::Prograf;
use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
                &compear_sceptre
                &interpretar_resultados
                &inventar_RESULTADOS_tiempo
                &poner_indices
    ); 
};
END();
#---------------------------------------------------------------------------
sub agregar_TIEMPO_primero{
  comfin('comR agregar_TIEMPO_primero',@_);
  my $ref = $_[0];
  my $compT = $ref->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  $compT or  $compT = $refglobal->{DEFIcalculo}->{0}->{DEFIcomp}->{T}; 
  impr_debug(__LINE__.' Resu $compT', $compT);
  my @lista = split ',', $compT; my $cual = "output$lista[0]";
  $ref->{TIPOTOK}->{$cual} and cambiar_TIEMPO_intermedio($ref,$lista[0]);
  cargar_datos_tipotok($ref,'PEDIDOS',$cual,'r'
       ,'TIEMPO','S','S',['TIEMPO'],'',$compT);
  impr_debug(__LINE__.' Resu', $ref->{listaPEDIDOS});
  unshift @{$ref->{listaPEDIDOS}}, $cual;
  pop @{$ref->{listaPEDIDOS}};
  unshift $ref->{lispedidos}, "TIME($lista[0],$compT)";
  impr_debug(__LINE__.' Resu', $ref->{listaPEDIDOS});
  impr_debug(__LINE__.' Resu', $ref->{lispedidos});
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);
  comfin('finR agregar_TIEMPO_primero');
  return;
}#agregar_TIEMPO_primero
#---------------------------------------------------------------------------
sub cambiar_TIEMPO_intermedio{
  comfin('comR cambiar_TIEMPO_intermedio',@_);
  my ($ref,$propia) = @_;
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);
  my $cual = "output$propia";
  my $id =1;
  while ($ref->{TIPOTOK}->{"$cual$id"}) {
      $id ++;
  };
  mensajear("Hay un pedido de RESULTADOS,que no es el primero,
         con identificacion $propia; lo cambiamos a $propia$id"); 
  foreach my $palabra ( qw (TIPOTOK VALOR TIPO TIPARG REFARG uni com ori)) {
      $ref->{$palabra}->{"$cual$id"} = $ref->{$palabra}->{$cual};
  };
#  foreach my $pal ( qw (listaPEDIDOS lispedidos)) {
  my $pal = 'listaPEDIDOS';
  impr_debug(__LINE__.' Resu $pal   antes',$ref->{$pal});
  foreach my $cual (@{$ref->{$pal}}) {
      if ($cual eq "output$propia") {
          $cual = "$cual$id"; last;
      };
  };
  impr_debug(__LINE__.' Resu $pal despues',$ref->{$pal});
  $pal = 'lispedidos';my $propiaid = "$propia$id";
  impr_debug(__LINE__.' Resu $pal   antes',$ref->{$pal});
  foreach my $cual (@{$ref->{$pal}}) {
      if ($cual =~  s/^TIEMPO\($propia/TIEMPO\($propiaid/) {
          last;
      };
  };
  impr_debug(__LINE__.' Resu $pal despues',$ref->{$pal});
 # };
  comfin('finR cambiar_TIEMPO_intermedio',@_);
}#cambiar_TIEMPO_intermedio
#---------------------------------------------------------------------------
sub interpretar_1pedido_RESULTADO{
  #analiza un solo pedido por llamada
  comfin('comR interpretar_1pedido_RESULTADO',@_);
  my ($ref,$pedido) = @_;
  impr_debug(__LINE__.' Resu $ref->{lispedidos}',$ref->{lispedidos});
  my ($coderr,$mensaje) = ('','');
  my $pedidoori = $pedido; my $detalle = '';
  my ($expre,$coment) = ($pedido,'');
  if ($pedido =~ s/\s*;\s*(.+)$//) {
       $coment = $1;
  };
  if ($pedido =~s/(\s*[:][^\(\)]*)//) {
      avnoseent("el agregado en el pedido de resultado 
         $pedidoori,   agregado $1 ");
      mensajear(" Si necesita cambiar el sentido:
          desconecte el ícono del elemento, simetrícelo y  reconéctelo");
  };
  impr_debug(__LINE__.' Resu $pedido',$pedido);
  ($coderr,my ($normal,$valor,$tipo),$pedido,$detalle,my($unip,$tipotoknormal))
    = analizar_esencial($ref,$pedido,$pedidoori,$coment,'Resu '.__LINE__);
  if ($coderr eq '1') {
      $coderr = '';#1 no fue necesario asignar
      $valor = $normal; $tipo = lc($tipotoknormal);
  };
  if ($coderr) {
      comfin('finR interpretar_1pedido_RESULTADO linea',__LINE__,$coderr);
      return $coderr;
  };
  my $nsceptre = $valor;
#  agregar_comentarios($ref,$nsceptre,$coment,'Resu '.__LINE__) if $coment; 
  $detalle or $detalle = "($normal)";
  (my $stringlisdetalle = $detalle) =~ s/^\((.+)\)$/$1/;
  impr_debug(__LINE__.' Resu $nsceptre,$stringlisdetalle'
    ,[$nsceptre,$stringlisdetalle]);
  my ($receptor,$propia,$uni,@lisdetalle);
  if ($stringlisdetalle) {
      ($coderr,@lisdetalle)
        =juntar_por_paren_cur(',',split(/\s*,\s*/,$stringlisdetalle));
      impr_debug(__LINE__.' Resu @lisdetalle',\@lisdetalle); 
      if (not $coderr) {
          if (@lisdetalle) {
             agregar_comentarios($ref,$nsceptre,($lisdetalle[0]),' Resu '.__LINE__)
		  if uc($lisdetalle[0]) ne $nsceptre;
              if (@lisdetalle !=1 and @lisdetalle != 3) {
                  mensajear("No se entiende el detalle $detalle; se ignora");
	          @lisdetalle = ();
              };
          };
      };
      if ($coderr or @lisdetalle== 0) {
         mensajear($coderr . " Se ignora el detalle $detalle");
      };
  };
  @lisdetalle or @lisdetalle = ($pedido);
  impr_debug(__LINE__.' Resu $pedido,@lisdetalle',[$pedido,'||',@lisdetalle]);
  if (@lisdetalle  == 1) {
      if ($nsceptre eq $pedido) {
          $uni = compear_sceptre($ref,$nsceptre,$unip);
      } else {
         $uni = '??,??';
         my($valor0,$tipo0,$tiparg0,$refarg0) = tomar_cua_datos($ref,$nsceptre);
         if ($tipo0  =~ /[adpSs]/) {
             $nsceptre = $valor0; $tipo = $tipo0;
         };
      };  
  } else {
      $uni = "$lisdetalle[1],$lisdetalle[2]";
  };
  $propia = $lisdetalle[0]; $receptor = "output$propia";
  if ($ref->{TIPOTOK}->{$receptor}) {
      mensajear("Hay un pedido anterior con igual identificacion: $propia;
          se ignora este $pedidoori");
      comfin('finR interpretar_1pedido_RESULTADO linea,$receptor,$coderr'
       ,__LINE__,$coderr,$receptor);
      return $coderr,$receptor;
  };
  cargar_datos_tipotok($ref,'PEDIDOS',$receptor
		 ,'r',$nsceptre,$tipo,$tipo,[$nsceptre],'',$uni);  
  agregar_comentarios($ref,$receptor,$coment,'Resu '.__LINE__) if $coment;
  push @{$ref->{lispedidos}},"$nsceptre($lisdetalle[0],$uni)";
  impr_debug(__LINE__.' Resu $ref->{lispedidos}',$ref->{lispedidos});
  impr_dat(__LINE__.' Resu',$receptor,$ref,'apR');
  comfin('finR interpretar_1pedido_RESULTADO linea',__LINE__,$coderr,$receptor);
  return $coderr,$receptor;
}#interpretar_1pedido_RESULTADO
#---------------------------------------------------------------------------
sub analizar_esencial{#devuelve $coderr,$normalpedidodes,$normalpedido
  #,$valor,$tipo,$pospedido,$posdetalle,$unip;
  # $posdetalle es el elegido por el usuario; si no esta,  ('') 
  # sale de $normalpedido
  comfin('comR analizar_esencial',@_);
  my ($ref,$pedido,$pedidoori,$coment,$mens_cla) = @_;
  my ($coderr,$mensaje) = ('','');
  my ($pospedido,$posdetalle,$unip) = ($pedido,'','');
  my $re = [];
  impr_debug(__LINE__.' Resu $pedido',$pedido);
  if ($pedido =~ /^\(.*\)$/) {
      my($cuantos,$dato,$error) = sacar_paren_ext($pedido);
      not $coderr and $pedido = $dato;
  };
  if ($pedido =~ /\)$/) {
      ($pospedido,$posdetalle,$coderr) = abrir_paren($pedido);
      impr_debug(__LINE__.' Resu $pospedido,$posdetalle,$coderr'
	     ,[$pospedido,$posdetalle,$coderr]);
      if ($coderr) {
          impr_debug(__LINE__.' Resu $coderr',$coderr);
          push @MENSAJES,
           " Apareo de paréntesis incorrecto. Se ignora el pedido de RESULTADOS
                 $pedidoori";
          $coderr = 51;
         comfin('finR analizar_esencial linea,$coderr,$mensaje',__LINE__,$coderr
           ,"$mensaje  $mens_cla");
          return $coderr,$mensaje;
      };
  };
  my($normal,$tipo) = (uc($pospedido),''); 
  my $tipotok = valor($ref,'TIPOTOK',$normal); 
  my ($normaldes,$normalpedido,$valor) = ($normal,$normal,$normal);
  impr_debug(__LINE__.' Resu $normal $tipotok',[$normal,$tipotok]);
  if ($tipotok) {
      if ( $tipotok =~ /[adp]/) {
           my $tipoped = $ref->{TIPO}->{$normal};
           if ($tipoped =~ /[adpS]/) {
	       $tipo = $tipoped; $valor = $ref->{VALOR}->{$normal};
           } else {
               $tipo = $tipotok;
           };
      } elsif ( $tipotok eq 's') {
          $tipo = $tipotok;
      } elsif ($tipotok eq 'S') {
          $tipo = $tipotok; $valor = 'TIEMPO'; 
      } elsif ($tipotok eq 'P') {
          my $valor1 = $ref->{VALOR}->{$normal};
          my $tipotok1 = valor($ref,'TIPOTOK',$valor1);
          if (not $ref->{parscreados}->{$valor1} and $tipotok1 =~ /[apd]/) {
              $valor = $valor1; $tipo = $tipotok1;
          };
      };
  } else {
  };
  if ($tipo) {
      comfin('finR analizar_esencial linea $coderr',__LINE__
       ,$coderr,$normalpedido,'||',$valor,'||',$tipo,$pospedido,$posdetalle
      ,$unip,$mens_cla);
      return $coderr,$normalpedido,$valor,$tipo,$pospedido,$posdetalle,$unip;
  };
  my $provisorio = 'PROVISORIO';
  ($coderr,$normal,$re,$unip,$normaldes,$normalpedido,my $tipotoknormal)
     = pre_limpiar($ref,'PEDIDOS',uc($pospedido),$provisorio,'Resu '.__LINE__);
  if (($coderr eq '9'  or $coderr eq '' and $re->[2] =~ /w/)  and
      $posdetalle ne '') {
      $re->[2] and $re->[2] eq 'w' and 
        mensajear(' '.uc($pospedido).' es nombre de funcion?');
      $pospedido = "$pospedido$posdetalle"; $posdetalle = '';
      impr_debug(__LINE__.' Resu $pospedido,$posdetalle,$coderr'
		     ,[$pospedido,$posdetalle,$coderr]);   
      ($coderr,$normal,$re,$unip,$normaldes,$normalpedido,$tipotoknormal)
       = pre_limpiar($ref,'PEDIDOS',uc($pospedido),$provisorio,'Resu'.__LINE__);
  };
#  not $coderr and $mensaje and mensajear ($mensaje); 
  if ($coderr eq '1') {
       impr_debug(__LINE__.' Resu $tipotoknormal',$tipotoknormal); 
       $coderr = '';
       if ($tipotoknormal ne 'P') {
           $re = [$normal,$tipotoknormal,$tipotoknormal,[$normal]];
       };
       impr_debug(__LINE__.' Resu $re',$re);
  };
  not $coderr and $re->[2] =~ /w/ and $coderr = 35;
  if ($coderr) {
      mensajear(
       " No se entiende, se ignora el pedido de Resultados: $pedidoori");
      push @{$ref->{lispedidos_no_sat}},$pedidoori; 
      comfin('finR analizar_esencial linea,$coderr'
        ,__LINE__,$coderr,$mens_cla);
      return $coderr;
  }; 
  impr_debug(__LINE__.' Resu $normalpedido,$pospedido,$re->[1]'
    ,[$normalpedido,$pospedido,$re->[1]]);
  $tipotok = valor($ref,'TIPOTOK',uc($pospedido));
  # Ahora $tipotok es '' solo si el pedido es un numero; si no es apdSs
  ($valor,$tipo,my($tiparg,$refarg)) = @$re;
  if ($tipotok eq '') {
       my ($coderr,$nsceptre,$pvalor,$ptipo,$ptiparg,$prefarg,$ntipo)
         = crear_par_con_refarg($ref,'O',$valor,$tipo,$tiparg,$refarg);
       if (not $coderr) {
	   agregar_comentarios($ref,$nsceptre,$coment,$normalpedido
           ,'Resu '.__LINE__);
           $valor = $nsceptre; $tipo = $ntipo; $refarg = [$nsceptre];
           impr_debug(__LINE__.' Resu',[$valor, $tipo,$tiparg,'||',@$refarg]);
       }
  }
  $coderr and push @{$ref->{lispedidos_no_sat}},$pedidoori;
  comfin('finR analizar_esencial linea $coderr',__LINE__
    ,$coderr,$normalpedido,'||',$valor,'||',$tipo,$pospedido,$posdetalle
    ,$unip,$mens_cla);
  return $coderr,$normalpedido,$valor,$tipo,$pospedido,$posdetalle,$unip;
}#analizar_esencial
 #---------------------------------------------------------------------------
sub compear_sceptre{#solo pasa por aqui si hubo cuadro RESULTADOS
  comfin('comR compear_sceptre',@_);
  my ($ref,$sceptre,$unip) = @_;
#  impr_debug(__LINE__.' Resu DEFIcalculo',Dumper $ref->{DEFIcalculo});
  my $comp = '';
  my $tiparg = valor($ref,'TIPARG',$sceptre);
  $tiparg =~ /^\-(.)$/ and $1 ne 'n' and 
    $sceptre = $ref->{REFARG}->{$sceptre}->[0];
  my $tipotok = valor($ref,'TIPOTOK',$sceptre);
  impr_dat(__LINE__.' Resu',$sceptre,$ref,'cs');
  if ($tipotok eq 's') {
      my ($letra0,$letra1,$resto) = ($sceptre =~ /^(.)(.)(.*)/);
      my $cosa = "$letra1$resto";
      if ($letra0 eq 'P') {
         my $ini = "INICIAL$sceptre";
         my $uni = valor($ref,'uni',$ini); $uni or $uni = '??';
         $comp = '??,' . $uni;
      } else {  
          my $obj = $ref->{cualobjele}->{$cosa}->[-1];
          my $numpl = $plantillalista->[$obj];
          my $equiv = 'E'; $letra0 eq 'I' and $equiv = 'J';  
          $comp = $ref->{DEFIcalculo}->{$numpl}->{DEFIcomp}->{$equiv};
          not $comp and completar_UNIDADES($ref,$numpl);
  impr_debug(__LINE__.' Resu $ref->{DEFIcalculo}',Dumper $ref->{DEFIcalculo});
          $comp = $ref->{DEFIcalculo}->{$numpl}->{DEFIcomp}->{$equiv};
          not $comp and $comp = '??,??';
          impr_debug(__LINE__.' Resu'
             ,[$obj,$numpl,$cosa,$equiv,$sceptre,'||',$comp]);
      };
  } elsif ($tipotok eq 'a') {
      my $letra = substr($sceptre,0,1);
      my $obj = $ref->{cualobjele}->{$sceptre}->[-1];
      my $numpl = $plantillalista->[$obj];
      $comp = $ref->{DEFIcalculo}->{$numpl}->{DEFIcomp}->{$letra};
      not $comp and $comp = '??,??';
      impr_debug(__LINE__.' Resu'
        ,[$letra,$obj,$numpl,'||',$sceptre,'||',$comp]);
  } elsif ($tipotok eq 'S') {
      $comp =  $ref->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
      $comp or $comp = $refglobal->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  } elsif (lc($tipotok) eq 'p') {
      if ($unip) {
          $comp = $unip; #$ref->{uni}->{$sceptre};
      } else {
          my $uni = valor($ref,'uni',$sceptre);
          $uni or $uni = '??';
          $comp = '??,'.$uni;
      };
  } else {
       error_progr($ref,__LINE__.' Resu deberia haber creado parametro');
  };
  comfin('finR compear_sceptre',$comp);
  return $comp;
}#compear_sceptre
#---------------------------------------------------------------------------
sub interpretar_resultados{
  comfin('comR interpretar_resultados', @_);   
  my $ref = $_[0]; my $coderr = '';
  my ($ele,$que);
  my $comienzo = $opt_hash{todas}; not $comienzo and $comienzo = '';
  impr_debug(__LINE__.' Resu $comienzo',$comienzo);
  impr_UNIDADES(__LINE__.' Resu $ref',$ref);
  my $string = $ref->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  defined $string or $string =  $refglobal->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  my ($varmagntiempo,$uniresutiempo) = ($string =~ /^(\w+)\,(.*)$/);
#  impr_resultados (__LINE__.' Resu',$ref);
  if ($comienzo) {
      impr_dat(__LINE__.' Resu',"output$varmagntiempo",$ref,'iRE');
      obedecer_opcion_RESULTADOS($ref,$comienzo);
      impr_debug(__LINE__.' Resu $comienzo',$comienzo);
  } elsif  (defined $ref->{refvalores}->{RESULTADOS}
           or defined $ref->{refvalores}->{GRAFICOS}) {
      $coderr = mirar_cuadro_RESULTADOS($ref);
  } else {
      inventar_RESULTADOS($ref);
      if ($ref->{listaPEDIDOS} and @{$ref->{listaPEDIDOS}}) {
          unshift @{$ref->{liscomeRESU}}, 'Propuestos por Simusol';
      }; 
  };
  impr_resultados (__LINE__.' Resu',$ref);
  $coderr and $coderr = 35;
   comfin('finR interpretar_resultados,$coderr',$coderr);  
   return $coderr;
}# interpretar_resultados
# ---------------------------------------------------------------------------
sub inventar_RESULTADOS{ #devuelve en $ref->{lispedido}s
  comfin('comR inventar_RESULTADOS', @_);
  # si no se ha pedido   ninguno ....
  my ($ref,$solopar) = @_;
  impr_debug(__LINE__.' Resu $ref->{NODOSPLANT}',Dumper $ref->{NODOSPLANT});
  impr_debug(__LINE__.' Resu $ref->{ELESPLANT}',Dumper $ref->{ELESPLANT});
  impr_debug(__LINE__.' Resu $ref->{cualobjtextonodo}'
     ,Dumper $ref->{cualobjtextonodo});
  my $VI;
  if ($ref->{NODOSPLANT} and defined $ref->{cualobjtextonodo}->{0}->[0]) {
      inventar_RESULTADOS_nodos($ref); # en inven.RESULTADOS
      $VI = 'E';
  };
  if (not $ref->{lispedidos} and defined $ref->{ELESPLANT}) {
      inventar_RESULTADOS_ele($ref,'I','R',''); # en inven.RESULTADOS
      #estamos pidiendo corrientes en resistencias de cualquier nombre
      $VI = 'J';
  };
  if (defined $ref->{lispedidos}) {
      impr_debug(__LINE__.' Resu $ref',$ref->{lispedidos});
      my @outputsnum;
      foreach my $key (@{$ref->{listaPEDIDOS}}) {
          next unless $ref->{TIPO}->{$key} =~/^[no]$/;
          my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$key);
          impr_dat(__LINE__.' Resu',$key,$ref,'RR');
          if ($tipo =~/^[no]$/) {
              my @sceptres = grep (/^$VI/,@{$ref->{valor2cual}->{$valor}});
              my $sceptre;
              @sceptres and $sceptre = $sceptres[0]
                  or $sceptre = $ref->{valor2cual}->{$valor}->[0];
              $tipo = $tiparg = $ref->{TIPOTOK}->{$sceptre};
              $refarg = [$sceptre]; 
              cargar_datos($ref,'',$key,$sceptre,$tipo,$tiparg,$refarg);
	  };
      };          
  };
  impr_debug(__LINE__.' Resu',$ref->{listaPPARAMETROS});
  impr_debug(__LINE__.' Resu',$ref->{listaDPARAMETROS});
  if (not $ref->{lispedidos} and 
      ($ref->{listaPPARAMETROS} or  @$ref->{listaDPARAMETROS})) {
        inventar_RESULTADOS_par($ref);
   };
  if ($ref->{lispedidos}) {
      agregar_TIEMPO_primero($ref);
  };
  return '';
} #inventar_RESULTADOS
# ---------------------------------------------------------------------------
sub inventar_RESULTADOS_ele{ #devuelve en $ref-{lispedidos}
  comfin('comR inventar_RESULTADOS_ele', @_);
  my ($ref,$VI,$tipele,$comnombre) = @_; 
  my @liseles = sort keys %{$ref->{ELESPLANT}};
  impr_debug(__LINE__.' Resu i.r_e', \@liseles);
  @liseles = grep (/^$tipele$comnombre/,@liseles);  
  impr_debug(__LINE__.' Resu i.r_e', \@liseles);  
  foreach (@liseles) {
      my $numplanti = $ref->{ELESPLANT}->{$_};
      impr_debug(__LINE__.' Resu $_,$numplanti',[$_,$numplanti]);
      my ($equiv,$abr,$comp,$masterele);
     
      $equiv = $ref->{DEFIcalculo}->{$numplanti}->{DEFIequiv}->{$VI};
      $VI eq 'V' and $masterele = 'E' or
      $VI eq 'I' and $masterele = 'J';
      $abr = $ref->{DEFIcalculo}->{$numplanti}->{DEFIabrev}->{$VI};
      $comp = $ref->{DEFIcalculo}->{$numplanti}->{DEFIcomp}->{$masterele};
      impr_debug(__LINE__.' Resu $equiv,$abr,$comp',[$equiv,$abr,$comp]);
      defined $comp or $comp = "??$VI$tipele,??"; 
      defined $abr or $abr = $VI; 
      impr_debug(__LINE__.' Resu $equiv,$abr,$comp',[$equiv,$abr,$comp]);
      my $sceptre = "$VI$_";
      my $propia = "$abr $_";
      push @{$ref->{lispedidos}},"$sceptre($propia,$comp)";
      my $tipo = $ref->{TIPOTOK}->{$sceptre};
      cargar_datos_tipotok($ref,'PEDIDOS',"output$propia",'r'   #inv..ele
         ,$sceptre,$tipo,$tipo,[$sceptre],'',"$comp");
  };
  comfin('finR inventar_RESULTADOS_ele' ,@{$ref->{lispedidos}});
  return '';
}#inventar_RESULTADOS_ele
# ---------------------------------------------------------------------------
sub inventar_RESULTADOS_nodos{ #devuelve en $ref-{lispedidos}
  comfin('comR inventar_RESULTADOS_nodos', @_);
  my $ref = $_[0]; 
  impr_debug(__LINE__.' Resu $ref->{cualidenuniuni}'
    ,Dumper $ref->{cualidenuniuni});
  my $refhash = $ref->{cero_conectado};
  impr_debug(__LINE__.' Resu $ref->{cero_conectado}'
	     ,Dumper $refhash);
  $ref->{lispedidos} = [];
  if (scalar (keys %{$refhash->{directo}})
      + scalar (keys %{$refhash->{nodirecto}})) {
      foreach my $nodo (sort keys %{$refhash->{directo}}) {
          my $sceptre = $refhash->{directo}->{$nodo};
          my ($Vequiv,$comp) = nodo2equivcomp($ref,$nodo);
          push @{$ref->{lispedidos}},"$sceptre($Vequiv $nodo,$comp)";
          cargar_datos_tipotok($ref,'PEDIDOS',"output $Vequiv$nodo",'r',
			       $sceptre,'a','a',[$sceptre],'',$comp);
      };  
      foreach my $nodo  (keys %{$refhash->{nodirecto}}) {
         my $sceptre = cerofuentear($ref,$nodo);
         my ($Vequiv,$comp) = nodo2equivcomp($ref,$nodo);
          push @{$ref->{lispedidos}},"$sceptre($Vequiv $nodo,$comp)";
          cargar_datos_tipotok($ref,'PEDIDOS',"output $Vequiv$nodo",'r',
			       $sceptre,'a','a',[$sceptre],'',$comp);
      };
  }; 
  comfin('finR inventar_RESULTADOS_nodos', @{$ref->{lispedidos}});
  return;
}
# --------------------------------------------------------------------------
sub inventar_RESULTADOS_par{ #devuelve en $ref->{lispedidos}
  comfin('comR inventar_RESULTADOS_par', @_);
  my ($ref) = @_;
  impr_datos(__LINE__.' Resu inventar_r_par',['PARAMETROS'],$ref);
  impr_debug(__LINE__.' Resu  $ref->{listaPARAMETROS}',$ref->{listaPARAMETROS});
  impr_debug(__LINE__.' Resu parscreados',Dumper $ref->{parscreados});
  my (@Ppars,@Dpars);
  my @ppars = @{$ref->{listaPPARAMETROS}} if $ref->{listaPPARAMETROS};
  foreach my $par (@ppars) {
      my ($tipo,$valor) = ($ref->{TIPO}->{$par},$ref->{VALOR}->{$par});
      next if $tipo =~ /[0noS,]/ or $ref->{parscreados}-> {$par};
      if ($tipo ne 'p' or  $ref->{parscreados}->{$valor}) {
	  push @Ppars,$par;
      };
  };
  impr_debug(__LINE__.' Resu inpar @Ppars',\@Ppars);
  @Dpars = @{$ref->{listaDPARAMETROS}} if $ref->{listaDPARAMETROS};
  map(s/^.//, @Dpars);
  my @Tpars;
  push @Tpars,@Ppars,@Dpars;
  impr_debug(__LINE__.' Resu',\@Tpars);
  impr_debug(__LINE__.' Resu fin inv,RESUL_par',\@Tpars);
  foreach my $sceptre (@Tpars) {
      my ($uni,$magn) = ('??','??');
      my $tipotok = $ref->{TIPOTOK}->{$sceptre};
      if ($tipotok eq 'p' and  $ref->{uni}->{$sceptre}) {
          $uni = $ref->{uni}->{$sceptre};
      } elsif ($tipotok eq 's' and $ref->{uni}->{"INICIAL$sceptre"}) {
          $uni = $ref->{uni}->{"INICIAL$sceptre"};
      };
      push @{$ref->{lispedidos}},"$sceptre($sceptre,$magn,$uni)";
      cargar_datos_tipotok($ref,'PEDIDOS',"output$sceptre",'r'   #inv...par
          ,$sceptre,$tipotok,$tipotok,[$sceptre],'',"$magn,$uni");
  };
  comfin('finR inventar_RESULTADOS_par');
  return '';
}# inventar_RESULTADOS_par
# ---------------------------------------------------------------------------
sub inventar_RESULTADOS_por_opcion{ #devuelve en $ref-{lispedidos}
  comfin('comR inventar_RESULTADOS_por_opcion', @_);
  my ($ref,$preori,$claseele,$comienzo) = @_;
  my @cosas;
  impr_UNIDADES(__LINE__.' Resu',$ref);
  my $prepropia = "$preori " if $preori;
  if ($claseele =~ /[CEJLR]/) {
      @cosas = grep (do {$ref->{TIPOTOK}->{$_} eq 'a' and
                     $_ =~ /^$comienzo/}, keys %{$ref->{TIPOTOK}});
#      if ($preori !~ /^[VI]$/) {
  impr_debug(__LINE__.' Resu',\@cosas);
      foreach my $ele (@cosas) {
          my $obj = $ref->{cualobjele}->{$ele}->[0];
          my $numplanti = $plantillalista->[$obj];
          my $nomplanti = $nombreplantilla->[$numplanti];
          my ($sceptre,$propia,$string);
          my ($presceptre,$prepopia,$clasescep) = ($preori,$preori,$claseele);
          if ($preori eq '') {
          } else {
              if (defined $ref->{DEFIequiv}->{$nomplanti}->{$preori}) {
                  $presceptre = $ref->{DEFIequiv}->{$nomplanti}->{$preori};
              } elsif ($preori ne 'V' and $preori ne 'I') {
                  next;
              }; 
              $presceptre eq 'V' and $clasescep = 'E' or  $clasescep = 'J'; 
         };
          $sceptre = "$presceptre$ele";
          $sceptre =~ s/^V(E)/$1/; $sceptre =~s/^I(J)/$1/;
          $propia = "$prepropia$ele";

          $string = $ref->{DEFIcomp}->{$nomplanti}->{$clasescep}; 

          push @{$ref->{lispedidos}},"$sceptre($propia,$string)";
          impr_debug(__LINE__.' Resu',$ref->{lispedidos}->[-1]);
          cargar_datos_tipotok($ref,'PEDIDOS',"output$propia",'r'
				  ,$sceptre,'s','s',[$sceptre],'',$string);
      };
#      };  
  } elsif ($claseele eq 'P') {
      my $tipotok = 'p'; $preori eq 'D' and $tipotok = 'd';
      @cosas = grep (do {$ref->{TIPOTOK}->{$_} eq $tipotok
                         and $_ =~ /^$comienzo/}, keys %{$ref->{TIPOTOK}});
  } elsif ($claseele eq 'N') {
      $comienzo =~ s/^N//;
      @cosas = grep ($ref->{TIPOTOK}->{$_} eq 'm', keys %{$ref->{TIPOTOK}});
      @cosas = grep ($_ =~ /^$comienzo/,@cosas) if $comienzo
  };
  impr_debug(__LINE__.' Resu',\@cosas);
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);
  comfin('finR inventar_RESULTADOS_por_opcion');
  return '';
} #inventar_RESULTADOS_por_opcion
#---------------------------------------------------------------------------
sub inventar_RESULTADOS_tiempo{
  comfin('comR inventar_RESULTADOS_tiempo');
  my $ref = $_[0];
  my $compT = $ref->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  $compT or $compT = $refglobal->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
  impr_debug(__LINE__.' Resu $compT',$compT);
  my ($nombretiempo,$uniresutiempo);
  if ($compT =~ /^([^,]*),(.*)$/) {
      ($nombretiempo,$uniresutiempo) = ($1,$2);
  } else {
      error_progr($ref, __LINE__." Resu sin datos para $compT");
  };
  push @{$ref->{lispedidos}},"TIEMPO($nombretiempo,$compT)";
  push @{$ref->{lispedidos}},"TIEMPO(tiempo_extra,$compT)";
  cargar_datos_tipotok($ref,'PEDIDOS',"output$nombretiempo",'r'
                ,'TIEMPO','S','S',['TIEMPO'],'',$compT);  #inv...tiempo
  cargar_datos_tipotok($ref,'PEDIDOS',"outputtiempo_extra",'r'
                ,'TIEMPO','S','S',['TIEMPO'],'',$compT);  #inv...tiempo
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);
  return '';
}# inventar_RESULTADOS_tiempo
#---------------------------------------------------------------------------
sub mirar_cuadro_GRAFICOS{# buscando necesidad de RESULTADOS
 #lo llama mirar_cuadro_RESULTADOS
  #Si existe cuadro  no se "inventan" resultados y graficos por defecto
  #Si solo existe AGREGAR_GRAFICOS si se inventan por defecto y se agregan
  # resultadod
  comfin('comR mirar_cuadro_GRAFICOS', @_);
  my ($ref,$cual) = @_;  my $coderr = '';
  return '' unless $ref->{refvalores}->{uc($cual)};
  impr_debug(__LINE__.' Resu $ref->{refvalores}->{uc('.$cual.')}'
    ,Dumper $ref->{refvalores}->{uc($cual)});
  my %todos = %{$ref->{refvalores}->{uc($cual)}};
  my @lista_por_graf = ();
  foreach (keys %todos) {
      $coderr = '';
      my @listita  = @{$todos{$_}};
      impr_debug(__LINE__.' Resu @listita',\@listita);
      (my $coderr,@listita) = juntar_por_paren_cur(',',@listita);
      if ($coderr) {
          mensajear($coderr ." en @listita");
          next;
      };
      impr_debug(__LINE__.' Resu $coderr',$coderr); 
      map(s/(\W)CALCULADO(\W)/$1SIMULADO$2/ig, @listita);
      impr_debug(__LINE__.' Resu @listita',\@listita);
      my @lista_no_SIMULADO = grep($_ =~/^(lineas|puntos|funcion)/i,@listita);
      @lista_no_SIMULADO  = grep($_ !~ /\WSIMULADO\W/,@lista_no_SIMULADO) ; 
      impr_debug(__LINE__.' Resu @list_no_SIMULADO',\@lista_no_SIMULADO);
      @lista_no_SIMULADO and $ref->{haygrafico} = 1;
      @listita = grep(s/^.*=\s*SIMULADO\s*,\s*//,@listita);
      impr_debug(__LINE__.' Resu @listita',\@listita);
      foreach (@listita) {
          my @resu = split /[:,]+\s*/;
          @resu = grep(/^\D/,@resu);
          @resu = grep(do{uc($_) ne 'TIEMPO' and uc($_) ne 'TIME'}, @resu);
          push  @lista_por_graf,@resu;
      }; 
  };
  comfin('finR mirar_cuadro_GRAFICOS', $coderr,@lista_por_graf);
  return $coderr,@lista_por_graf ;
} #mirar_cuadro_GRAFICOS
#---------------------------------------------------------------------------
sub mirar_cuadro_RESULTADOS{
  # solo se detiene por errores groseros
  comfin('comR mirar_cuadro_RESULTADOS', @_);
  my $ref = $_[0];  my $coderr = '';
  impr_datos(__LINE__.' Resu',['PARAMETROS','DATOS'],$ref);
  my @lispedidos = ();
  if (defined $ref->{refvalores}->{RESULTADOS}) {
      impr_debug(__LINE__.' Resu RESULTADOS'
          ,Dumper $ref->{refvalores}->{RESULTADOS});
      my %todos = %{$ref->{refvalores}->{RESULTADOS}};
      #por si hay mas de un cuadro 
      scalar keys %todos >1 and
      avnograv("Más de un cuadro de RESULTADOS; orden no establecido");
      foreach (keys %todos) { 
          my @listita  = @{$todos{$_}};
          (my $coderr,@listita) = juntar_por_signos_y_paren('',@listita);
          if ($coderr) {
              mensajear($coderr);
              mensajear("Se han perdido pedidos de resultados");
          };        
          push @lispedidos, @listita;
      };
  };
  impr_debug(__LINE__.' Resu @lispedidos',\@lispedidos);
  $ref->{haygrafico} = ''; 
  foreach my $cual ('GRAFICOS','AGREGAR_GRAFICOS') {
      if (defined $ref->{refvalores}->{uc($cual)}) {
          my ($coderr,@lista) = mirar_cuadro_GRAFICOS($ref,$cual);
          if ($coderr) {
              mensajear ($coderr);
              mensajear("Se han perdido pedidos de resultados
                consecuencias de cuadro $cual");
          };
          if (@lista) {
              push @lispedidos, @lista;
          };
          impr_debug(__LINE__.' Resu @lispedidos',\@lispedidos);
      }; 
  };
  impr_debug(__LINE__.' Resu @lispedidos',\@lispedidos);
  $ref->{lispedidos} = [];
  @{$ref->{lispedidos}} = @lispedidos;
  if (not @lispedidos) {
      $coderr = 46;
      comfin('finR mirar_cuadro_RESULTADOS linea',__LINE__," $coderr");
      return $coderr;
  };
  $ref->{liscomeRESU} = [];
  # {liscomeRESU} para juntar los comentarios y los pedidos como RESULTADOS
  @{$ref->{liscomeRESU}} = grep(/^\s*;/,@lispedidos);
  map(s/s*;\s*//,@{$ref->{liscomeRESU}});
  @lispedidos = grep(do {$_ !~ /^\s*;/},@lispedidos);
  my $textolistacoma = join ',', @lispedidos;
  while ($textolistacoma =~ s/\,\s*\,+\s*/\,/) {};  
  $textolistacoma =~ s/\s+\,/\,/g; $textolistacoma =~ s/\,\s+/\,/g;
  ($coderr,@lispedidos)
     = juntar_por_signos_y_paren(',',split (/\s*,\s*/,$textolistacoma));
  impr_debug(__LINE__.' Resu $coderr '.$coderr,Dumper \@lispedidos);
  impr_debug(__LINE__.' Resu $textolistacoma ', $textolistacoma);
  # se perdona error de comas repetidas 
  if ($coderr) {
      mensajear ($coderr ." en $textolistacoma");
      $coderr = 35; 
      comfin('finR mirar_cuadro_RESULTADOS linea $coderr',__LINE__, $coderr);
      return $coderr;
  };
  foreach my $pedido (@lispedidos) {
      my($codigo,$tiparg,$refarg,$detalle)
         = interpretar_1pedido_RESULTADO($ref,$pedido);
      #si $codigo, ya se ha guardado en lispedidos_no_sat 
  };
  impr_debug(__LINE__.'todos sceptres incorporados  @lispedidos',\@lispedidos);
  if (not defined $ref->{listaPEDIDOS}) {
      $coderr = 46;
      comfin('finR mirar_cuadro_RESULTADOS',$coderr);
      return $coderr;
  };
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);
  TIEMPO_primero($ref);
  comfin('finR mirar_cuadro_RESULTADOS' ,@lispedidos );
  return $coderr; 
} #mirar_cuadro_RESULTADOS 
# ---------------------------------------------------------------------------
sub nodo2equivcomp {
  comfin('comR nodo2equivcomp',@_);
  my ($ref,$nodo) = @_;
  my $obj = $ref->{cualobjtextonodo}->{$nodo}->[0];
  my $numpl = $plantillalista->[$obj];
  impr_debug(__LINE__.' Resu $nodo,$obj,$numpl',[$nodo,$obj,$numpl]); 
  impr_debug(__LINE__.' Resu',Dumper $ref->{cualobjtextonodo});
  my ($Vequiv,$comp) = ('V','??,??');  
  if (scalar (keys %{$ref->{DEFIcalculo}->{$numpl}})) {
      $Vequiv = $ref->{DEFIcalculo}->{$numpl}->{DEFIabrev}->{V};
      $comp = $ref->{DEFIcalculo}->{$numpl}->{DEFIcomp}->{E};
  };
  comfin('comR nodo2equivcomp',$Vequiv,$comp);
  return $Vequiv,$comp;
}#nodo2equivcomp
# ---------------------------------------------------------------------------
sub obedecer_opcion_RESULTADOS { #carga $ref->{lispedidos} y {listaPEDIDOS}
  comfin('comR obedecer_opcion_RESULTADOS',@_);
  my ($ref,$comienzoori) = @_;
  my ($tipele,$que);
  push @{$ref->{liscomeRESU}}, "A pedido de opción -todas $comienzoori";
  my $refternas = [];
  my $ya = '';
  my $yacom = '';
  my $comienzo = uc($comienzoori); 
  my $pre = ''; my $claseele;
  if ($comienzo =~ /^(.+)\s+([CEJLPNR])(.*)$/) {
      $pre = $1; $claseele = $2; $comienzo = "$2$3";
  };
  impr_debug(__LINE__.' Resu $pre $comienzo',[$pre,$comienzo]); 
  if (not $pre) {
      if ($comienzo =~ /^([CELJR])/) {
          $claseele = $1;
      } elsif ($comienzo =~ /^P/) {
          $claseele = 'P';
      } elsif ($comienzo =~ s/^D(P)/$1/) {
          $pre = 'D'; $claseele = 'P'; 
      } else {
          my @lisposi;
          registrar_abrpalabras($ref);
          foreach my $pal (@{$ref->{abrpalabras}}) {
               if ($comienzo =~ s/^$pal([CEJLNR])/$1/) {
                  push @lisposi,[$pal,$1,$comienzo];
              }; 
          };
          impr_debug(__LINE__.' Resu @lisposi',\@lisposi);
          if (@lisposi == 1) { 
	      ($pre,$claseele,$comienzo) = @{$lisposi[0]};
          } elsif (@lisposi >1) {
              mensajear(
               " Más de una posiblidad para interpretar la opcion $comienzoori.
               Espcifique más con espacios y comillas");
          };
      };
  };
  impr_debug(__LINE__.' Resu $claseele',$claseele);   
  defined $claseele or  do {
      parar1(0,0,"No se puede atender la opción $comienzo"); 
  };        
  impr_debug(__LINE__.' Resu obedecer $pre,$claseele,$comienzo'
          ,[$pre,$claseele,$comienzo]  );
  inventar_RESULTADOS_por_opcion($ref,$pre,$claseele,$comienzo);

  comfin('comR obedecer_opcion_RESULTADOS');
  impr_datos(__LINE__.' Resu',['PEDIDOS'],$ref);     
  if (not $ref->{lispedidos} or not @{$ref->{lispedidos}}) {
        parar1(0,0,"De la opción \"-todas  $comienzoori\": 
                no quedó nada");
  };       
  comfin('finR obedecer_opcion_RESULTADOS','sceptre: '
        , @{$ref->{lispedidos}});
  return '';
} # obedecer_opcion_RESULTADOS
#---------------------------------------------------------------------------
sub poner_indices{#se necesitan para indicar outputs por numero
# y poder "inventar" gráficos
  my $ref= $_[0];
  comfin('comR poner_indices',@_);
  impr_campo(__LINE__.' Resu $ref',$ref,'parscreados');
  my ($indice,$i) = (1,1); 
  impr_resultados(__LINE__.' Resu',$ref);
  my %indice_sceptre;
  impr_datos(__LINE__.' Resu $ref',['PEDIDOS'],$ref);
  foreach my $pedido (@{$ref->{listaPEDIDOS}}) {
       my ($tipotok,$sceptrevar,$tipo,$tiparg,$refarg,$string)=tomar_todo_datos(
         $ref,$pedido);
      (my $propia = $pedido) =~ s/^output//;
      my ($magn,$uni) = ($string =~/^(.+)\s*,\s*(.+)$/);
      push @{$ref->{lispropias}}, $propia;
      push @{$ref->{lismagnitudes}}, $magn;
      push @{$ref->{lisunidades}}, $uni;
      push @{$ref->{lismagnunis}},$string;
      impr_debug(__LINE__.' Resu', \%indice_sceptre);
      if (not defined $indice_sceptre{$sceptrevar}) {
          push @{$ref->{lissceptres}}, $sceptrevar;
          $indice_sceptre{$sceptrevar} = $indice;
          $indice ++;
      };  
      my $indiceusado = $indice_sceptre{$sceptrevar};;
      $ref->{indicebueno}->{$propia} = $indiceusado;
      push @{$ref->{lisindicebueno}},$indiceusado;
      push @{$ref->{hashdeparnum}->{$string}}, $i;
      $i++;
  };
  impr_resultados(__LINE__.' Resu',$ref);  
  impr_campo(__LINE__.' Resu $ref',$ref,'hashdeparnum');
  $ref->{lissceptres}->[0] = 'TIME'; my $string = $ref->{lismagnunis}->[0];
  shift @{$ref->{hashdeparnum}->{$string}} if @{$ref->{listaPEDIDOS}} >1; 
  @{$ref->{lispares}} = union_conorden(@{$ref->{lismagnunis}});
  impr_resultados(__LINE__.' Resu',$ref);  
  comfin('finR poner_indices');
  return '';  
} #poner_indices
#---------------------------------------------------------------------------
sub registrar_abrpalabras{
  comfin('comR registrar_abrpalabras',@_);
  my $ref = $_[0];
  my @numplantillas = keys %{$ref->{tieneplantilla}}; 
  impr_debug(__LINE__.' Resu @numplantillas',\@numplantillas);
  @{$ref->{abrpalabras}} = ('V','I');
  foreach my $numplant (@numplantillas) {
      impr_UNIDADES(__LINE__.' Resu',$ref);
      impr_campo(__LINE__.' Resu $ref',$ref,'DEFIequiv',$numplant);
      push @{$ref->{abrpalabras}},keys %{$ref->{DEFIequiv}->{$numplant}};
  }; 
  @{$ref->{abrpalabras}} = union_conjunto( @{$ref->{abrpalabras}});
  impr_campo(__LINE__.' Resu $ref',$ref,'DEFIequiv');
  impr_campo(__LINE__.'Resu $ref',$ref,'abrpalabras');
  comfin('finR registrar_abrpalabras');
  return ''; 
}
#---------------------------------------------------------------------------
sub TIEMPO_primero{#solo pasa por aqui si hubo cuadro RESULTADOS
  comfin('comR TIEMPO_primero',@_);
  my $ref = $_[0]; my $coderr= '';
  impr_debug(__LINE__.' Resu $ref->{listaPEDIDOS}',Dumper $ref->{listaPEDIDOS});
  my $primero = $ref->{listaPEDIDOS}->[0];
  (my $propia = $primero) =~ s/^output(.+)$/$1/;
  if (uc($ref->{VALOR}->{$primero}) eq 'TIEMPO') {#
#      (my $stringdetalle) = ($ref->{lispedidos}->[0] =~ /\(([^\(\)]*)\)$/);
#      impr_debug(__LINE__.' Resu $stringdetalle',$stringdetalle);
#      my @lisdetalle = split /,/,$stringdetalle;
#      my $uniprimero = $lisdetalle[2];
#      impr_dat(__LINE__.' Resu',$primero,$ref,'Tp');
      my $compT = $ref->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
      $compT or $compT = $refglobal->{DEFIcalculo}->{0}->{DEFIcomp}->{T};
      impr_debug(__LINE__.' Resu $compT',$compT);
      my ($nombretiempo,$uniresutiempo);
      if ($compT =~ /^([^,]*),(.*)$/) {
          ($nombretiempo,$uniresutiempo) = ($1,$2);
      } else {
          error_progr($ref, __LINE__." Resu sin datos para $compT");
      };
      impr_debug(__LINE__.' Resu $nombretiempo,$uniresutiempo'
	     ,[$nombretiempo,$uniresutiempo]);
      my $unip = valor($ref,'uni',$primero);
      my ($magprimero,$uniprimero) = ($unip =~ /^(.*),(.*)$/); 
      if ($uniprimero ne $uniresutiempo) {
          if ($uniprimero ne '??') { 
              mensajear(
"La unidad para el primer TIEMPO debe ser la indicada en el cuadro UNIDADES;
              Cambiamos $uniprimero por  $uniresutiempo");
          };
          $uniprimero = $uniresutiempo;
      };
      $magprimero eq '??' and $magprimero = $nombretiempo; 
      $unip = "$magprimero,$uniprimero"; 
      $ref->{uni}->{$primero} = $unip; 
      $ref->{lispedidos}->[0]
        = "$primero($propia,$unip)";
      impr_dat(__LINE__.' Resu',$primero,$ref,'Tp');
  } else {#VALOR $primero ne TIEMPO
      agregar_TIEMPO_primero($ref)
  };
  my $cuantos = scalar @{$ref->{listaPEDIDOS}};
  $cuantos == 1 and do {
      mensajear(' No hay pedidos interesantes de resultados');
  };
  comfin('finR TIEMPO_primero');
  return;
}#TIEMPO_primero
1;
