package Simusol::Sceptre;
use Simusol::Ayudas;
use Simusol::Auxiliares;
use Simusol::Termicos;
use Simusol::Ampliaciones;
use Simusol::Evaluaciones;
use Simusol::Evaluaciones2;
use Simusol::GlobalesSimusol;
use Simusol::Tablasfuncq;
use Simusol::TraAbrev;
use warnings;
use strict;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
our $Xiden = 0; # para identificar las expresiones
# ---------------------------------------------------------------------------
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&imprs_lis_obj_sceptre
                &imprs_lis_obj_sceptre_elementos
                &imprs_archivo_mod
                &impr_res
                &para_sceptre
       );  
};
END();
#----------------------------------------------------------------------------
sub imprs_CONTROLES_sceptre{
  my $ref = $_[0];
  comfin('comS imprs_CONTROLES_sceptre', @_);
  impr_datos(__LINE__.' Scep',['TIEMPOS'],$ref);
  impr_datos(__LINE__.' Scep',['CONTROLES'],$ref);
  defined $ref->{VALOR}->{XPLOTDIMENSION} or
  do {$ref->{VALOR}->{XPLOTDIMENSION} = 0;
      $ref->{ori}->{'XPLOTDIMENSION'} = 'X PLOT DIMENSION';
  };
  defined $ref->{VALOR}->{INTEGRATIONROUTINE} or
  do {$ref->{VALOR}->{INTEGRATIONROUTINE} = 'TRAP';
      $ref->{ori}->{'INTEGRATIONROUTINE'} = 'INTEGRATION ROUTINE';
  };
  #algunas de las siguientes podrian estar ya definidas
  # si no se pone el renglon X PLOT DIMENSION, o se da un valor no nulo
  # hay una pausa luego de la ejecucion de la traduccion de sceptre de Novender
  # y si no se escribe go no se produce el archivo xxx.dirac
 # impr_debug(__LINE__.' Scep', $ref->{listaCONTROLES});
  my @controleskeys = union_conorden(  'XPLOTDIMENSION'
      , 'STARTTIEMPO', 'STOPTIEMPO'
      , @{$ref->{listaCONTROLES}}
      ,'INTEGRATIONROUTINE');
#  impr_debug(__LINE__.' Scep @controleskeys', Dumper \@controleskeys);
  print SALIDAd "\nRUN CONTROLS\n";
  my %VALORES = %{$ref->{VALOR}};
  impr_debug(__LINE__.' Scep %valores',\%VALORES);
  foreach (@controleskeys) {
      impr_debug(__LINE__.' Scep @controleskey',$_);
#      next if $_ =~ /^(TIEMPO|STARTTABLAS|STOPTABLAS)$/; 
      my $texto;
      /^;/ and  do {imprimir_fortran($_); next};
      if (not defined $VALORES{$_}) {
          error_progr($ref,__LINE__." Scep $_" .' no def. en $ref->{VALOR}');
      };
      $texto = uc($ref->{ori}->{$_});
      $texto =~ s/TIEMPO/TIME/;
      not defined $texto and $texto = $_;
      impr_debug(__LINE__.' Scep @controleskey $texto ',$texto);
      my $coment ='';
      if ($VALORES{$_} ne 'AAAAAAAA') {
          $texto .= " = ".uc($ref->{VALOR}->{$_});
          $coment = depurar_comentarios($ref,$_); 
          impr_debug(__LINE__.' Scep $texto,$coment',[$texto,$coment]);
      };
      impr_debug(__LINE__.' Scep $texto,$coment',[$texto,$coment]);
      imprimir_fortran($texto,$coment);
  };
  impr_debug(__LINE__.' Scep $ref->{nrerun}',$ref->{nrerun}); 
  if ($ref->{nrerun}) {
      imprs_rerun($ref);
  };
  print SALIDAd "END\n";
  comfin('finS imprs_CONTROLES_sceptre');
}#imprs_CONTROLES_sceptre
#-----------------------------------------------------------------------------
sub imprs_PARAMETROS{
  my ($ref, $clase) = @_;my $coderr = '';
  comfin('comS imprs_PARAMETROS',@_);
  impr_listas_que(__LINE__.' Scep',$ref,['PARAMETROS'],'lista');
  impr_debug(__LINE__.' Scep listaarchPARAMETROS',$ref->{listaarchPARAMETROS});
  print SALIDAd "\nDEFINED PARAMETERS\n";
  if ($ref->{NOUSAP}) {
      @{$ref->{NOUSAP}} = grep (do{not $ref->{parscreados}->{$_}}
				,@{$ref->{NOUSAP}});
      @{$ref->{NOUSAP}} and do{
          imprimir_fortran('',
      "Hay parámetros ya sustituidos o sin influencia en los 
      cálculos;   ver arch. ../$dirsalida{par}/$PROPIOASIN.par");
      };
  };
  my (@Dpars,@Rpars,@Ppars);
  @Dpars = grep ($ref->{USA}->{$_}, @{$ref->{listaDPARAMETROS}})
     if $ref->{listaDPARAMETROS};
  @Rpars = grep ($ref->{USAb}->{$_}, @{$ref->{listaPPARAMETROS}})
     if $ref->{listaPPARAMETROS};
  @Ppars = grep (do{$ref->{USA}->{$_} and not $ref->{USAb}->{$_}}
     , @{$ref->{listaPPARAMETROS}}) if $ref->{listaPPARAMETROS};
  impr_debug(__LINE__.' Scep @Dpars,@Rpars,@Ppars'
         ,[@Dpars,'||',@Rpars,'||',@Ppars]); 
  foreach (@{$ref->{listacPARAMETROS}}) {
      imprimir_fortran('',$_);
  };
  impr_datos(__LINE__.' Scep',['PARAMETROS'],$ref);
  foreach (@Rpars,@Ppars) {
      if (/^;/) {
          imprimir_fortran($_,'');
      } else { 
          impr_debug(__LINE__.' Scep $_',$_);
          my ($tipotok,$valor,$tipo,$tiparg,$refarg
            ,$uni,$ori,$coment,$comp,$listacom) = tomar_todo_datos($ref,$_);
          if (not defined $valor) {
              imprimir_fortran("; $_ no definido",'');
          } else {
              $coment = depurar_comentarios($ref,$_);
              $uni  and do {$coment = $uni .";  $coment";$coment =~ s/;  $//}; 
              $coment =~ tr/[]/()/;
              impr_debug(__LINE__.' Scep $valor',$valor);
              ($coderr,$valor)
                = para_sceptre_expr($ref,$tipotok,$valor,$tipo,$tiparg,$refarg);
              if (not $coderr) {
                  imprimir_fortran("$_ = $valor" ,$coment);
              } else {
                  imprimir_fortran("$_ ",'con errores' . $coment);
              }; 
          };
      }; 
  };
  impr_debug(__LINE__.' Scep @Dpars',\@Dpars);
  foreach (@Dpars) {
      my ($tipotok,$valorreal,$tipo,$tiparg,$refarg
        ,$uni,$ori,$comreal,$comp,$listacom) = tomar_todo_datos($ref,$_);
      impr_dat(__LINE__.' Scep',$_,$ref,'iPs'); 
      if (defined $valorreal) {
          if($tipo =~ /[no]/) {
              $valorreal = para_sceptre_num($valorreal);
              $Xiden++;
              $valorreal = "X$Xiden($valorreal)";
          } else { 
              impr_par(__LINE__.' Scep',$tiparg,$refarg);
              ($coderr,$valorreal) = para_sceptre_expr(
                 $ref,$tipotok,$valorreal,$tipo,$tiparg,$refarg);
          };     
          my $coment = depurar_comentarios($ref,$_);
          not $coderr and imprimir_fortran("$_ = $valorreal",$coment);
      };
      (my $parreal = $_) =~ s/^D//;
      impr_debug(__LINE__.' Scep $parreal',$parreal);
#      if ($ref->{USA}->{$parreal}) {
      ($tipotok,my $valorinicial,$tipo,$tiparg,$refarg
        ,$uni,$ori,$comreal,$comp,$listacom) = tomar_todo_datos(
          $ref,"INICIAL$parreal");
          impr_dat(__LINE__.' Scep',"INICIAL$parreal",$ref,'iPs'); 
          if ($tipo =~ /[no]/) {
              $valorinicial = para_sceptre_num($valorinicial);
              my $coment = depurar_comentarios($ref,"INICIAL$parreal");
              $uni  and do {$coment = $uni .";  $coment";$coment =~ s/;  $//}; 
              imprimir_fortran("$parreal = $valorinicial",$coment);
          } else {
              imprimir_fortran("; $parreal, valor inicial, no definido",'');
              mensajear(
                " Falta valor inicial para $parreal; No haremos simulacion");
              $coderr = 10;
          };
#      };
  };
#  impr_debug(__LINE__.' Scep avisosgrav',$avisosgrav);
  comfin('finS imprs_PARAMETROS',$coderr);
  return $coderr;
}#imprs_PARAMETROS
#-----------------------------------------------------------------------------
sub imprs_TABLAS{
  comfin('comS imprs_TABLAS',@_);
  my ($ref,$reftablas,$numrerun) = @_; 
  impr_debug(__LINE__.' Scep $ref->{sobreTABLAS}',Dumper $ref->{sobreTABLAS});
  my $sobre = $ref->{sobreTABLAS};
  my ($prifila,$ultfila); my $coderr = '';
#  impr_TABLAS(__LINE__.' Scep refcirc', $ref);
#  impr_TABLAS(__LINE__.' Scep refglobal', $refglobal);
  my @tablas = @$reftablas;
  impr_debug(__LINE__.' Scep @tablas',\@tablas);
  foreach my $Tidtabla (sort @tablas) {
      my $sobreT = $sobre->{$Tidtabla};
      my($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$Tidtabla);
      my $reftabla = $ref->{sobreTABLAS}->{$Tidtabla};
      my $numobj = $reftabla->{numobj}->[0];
      (my $idtabla = $Tidtabla) =~ s/^T//;
      print SALIDAd "\n";
      my $identabla = "TABLE $idtabla";
      if ($tipo eq '0') {
          imprimir_fortran("; $identabla no bien definida");
	  next;
      };
      if ($valor eq 'archivo') {
	  my $nombarch = $ref->{VALOR}->{$Tidtabla .'_ARC'};
          my $simusolarch = $ref->{sobrearchivos}->{$nombarch}->{ARC}->[0];
          administrar_archivo($simusolarch,$dirsalida{dat},'d');
          # 'd' no es 'copiar'
          $identabla .= "; tomada de archivo $simusolarch";
      };
      imprimir_fortran ($identabla);
      impr_debug(__LINE__.' Sceptre',Dumper $reftabla);
      impr_debug(__LINE__.' Scep $numrerun',$numrerun);
      next if $numrerun >= @{$sobreT->{priTABLAS}} ;
      $prifila = $sobreT->{priTABLAS}->[$numrerun]; 
      $ultfila = $sobreT->{ultTABLAS}->[$numrerun];
      impr_debug(__LINE__. ' Scep $prifila,$ultfila',[$prifila,$ultfila]);
      my ($abscisas,$ordenadas)= 
          ($sobreT->{absTABLAS},$sobreT->{ordTABLAS});
      for (my $ifila = $prifila; $ifila <= $ultfila; $ifila ++) {
          my ($absc,$orde) = ($abscisas->[$ifila],$ordenadas->[$ifila]);
          my $vabsc = para_sceptre_num($absc);
          my $vorde = para_sceptre_num($orde);  
          print SALIDAd  "$vabsc,$vorde\n"; 
      };
      print SALIDAd join ("\n"
         ,@{$sobreT->{comTABLAS}}),"\n"
		   if defined $sobre->{comTABLAS};
  }; #foreach
  comfin('finS imprs_TABLAS',$coderr);
  return $coderr;
}#imprs_TABLAS
# ---------------------------------------------------------------------------
sub imprs_VIINICIALES{
  comfin('comS imprs_VIINICIALES', @_); 
  my ($ref,$refCs,$refLs) = @_; my $coderr = '';
  impr_datos(__LINE__.' Scep ',['VIINICIALES'],$ref);
  print SALIDAd "\nINITIAL CONDITIONS\n";
  foreach my $cual (@$refCs,@$refLs) {
      my $pre = 'V'; $cual =~ /^L/ and $pre = 'I';
      my $valor = valor($ref,'VALOR',"INICIAL$pre$cual");
      my $coment = valor($ref,'com',"INICIAL$pre$cual");
      my $todo;
      impr_debug(__LINE__.' Scep $pre $cual $valor $coment'
		 ,[$pre,$cual,$valor,$coment]);
      if ($valor ne '') { 
          $todo = "$pre$cual = $valor";
      } else {
          $todo = ";  $pre$cual Falta valor inicial para $pre$cual";
          mensajear (" Falta valor inicial para $pre$cual");
          $coderr = 10;
      };
      imprimir_fortran($todo,$coment);
  };
  comfin('finS imprs_VIINICIALES');
  return $coderr;
}#imprs_VIINICIALES
#---------------------------------------------------------------------------
sub controlar_uso_def_parametros{#produce avisos y marca errores# eliminado
  comfin('comS controlar_uso_def_parametros    eliminado', @_);
  my $ref = $_[0];
  return;
  #my @lisvar = keys %{$ref->{USAVAR}};
  impr_datos(__LINE__.' Scep', ['PARAMETROS'], $ref);
  my (@parnousados,@parusados);
#  foreach my $dpar (@{$ref->{listaDPARAMETROS}}) {
#      impr_debug(__LINE__.' Scep $dpar',$dpar);
#      impr_dat(__LINE__.' Scep',$dpar,$ref,'cup');
#      $ref->{TIPO}->{$dpar} =~ /[no]/ and do{
#	  $ref->{VALOR}->{$dpar} = "XXX($ref->{VALOR}->{$dpar})";
#          $ref->{TIPO}->{$dpar} ='x';
#          impr_dat(__LINE__.' Scep',$dpar,$ref,'cup');
#      };
#  };
  foreach my $cosa (@{$ref->{listaDPARAMETROS}})  {
      impr_debug(__LINE__.' Scep $dpar',$cosa);
      impr_dat(__LINE__.' Scep',$cosa,$ref,'cup');
     
     $ref->{TIPO}->{$cosa} eq 's' and
	  $ref->{VALOR}->{$cosa} =~ /^[VI]/ and  do {
	  $ref->{VALOR}->{$cosa} =  "XXX($ref->{VALOR}->{$cosa})";
          $ref->{TIPO}->{$cosa} ='x';
      impr_dat(__LINE__.' Scep',$cosa,$ref,'cup');
     };
  };     
  
  comfin('finS controlar_uso_def_parametros');
  return '';
} #controlar_uso_def_parametros
#----------------------------------------------------------------------------
sub imprimir_fortran{
  # comfin('comS imprimir_fortran',@_);
  my ($texto,$comentario) = @_;
  $opt_hash{nocoment} and $comentario = '';
  my $todo = $texto; 
  if (defined $comentario and $comentario =~ /\n/) {
      my @lista = split /\n/, $comentario;grep ($_ =~ /\S/,@lista);
      my $com = shift @lista;
      imprimir_fortran($texto,$com); 
      foreach (@lista) {
          imprimir_fortran('',$_);
      };
      return;
  };
  $todo = "$texto;  $comentario" if $comentario;
  my $nooperparcoma = '[^\(\)\+\-\*\/\,\s]';
  my $operparcoma = '[\(\)\+\-\*\/\,\s]';
  #los TIEMPO se cambian por TIME
  # por la limitación de renglon de fortran
  # no hay garantia de que quede bonito si justo 
  # pesca un numero con muchos digitos, pero Sceptre
  # lo entendera bien
  $todo or return;
  my $coment = '';
  while (length($todo) > 60) {
      $todo =~ s/^(.{1,59}$nooperparcoma*$operparcoma*)//; 
      my $propu = "$1";
      $propu =~ s/^(.{1,65})//;
      my $ya = $1;
      print SALIDAd "$ya\n";
      $ya =~ /;/ and $coment = '; ';
      $todo  = $propu . $todo;
      $todo  = $coment . $todo if $todo;
  };
  print SALIDAd "$todo\n" if $todo;
  # comfin('finS imprimir_fortran');
  return;
}#imprimir_fortran
# ---------------------------------------------------------------------------
sub impr_rerun{
  return unless $debug;
  my ($mensaje,$ref) = @_;
  print STDERR "impr_rerun para $mensaje:\n";
  print STDERR '   $ref->{nrerun} ',"$ref->{nrerun}\n";
  print STDERR '   $ref->{archrerun} ',Dumper $ref->{archrerun};
  print STDERR '   ICFORRERUNS ',valor($ref,'VALOR','ICFORRERUNS'),"\n";
  print STDERR '   tiempos ',valor($ref,'VALOR','tiempos'),"\n";
  print STDERR '   $ref->{rerun} ',Dumper $ref->{rerun};
  foreach my $palabra ('RPPARAMETROS','RDINICIALES','RVIINICIALES'
                       ,'RCONTROLES') {
      my $cosa = "lista$palabra"; my $valor = '';
      defined $ref->{$cosa} and $valor = $ref->{$cosa};

      print STDERR "   $cosa: ",Dumper $valor;
  };
  my @reruns = grep ($_ =~ /^rerun/,sort keys %{$ref->{TIPOTOK}});
  print STDERR "   variables con rerun: @reruns\n";
  print STDERR "       final impr_.... para $mensaje:\n";
}#impr_rerun
# ---------------------------------------------------------------------------
sub imprs_archivo_mod{
  comfin('comS imprs_archivo_mod', @_); 
  my ($ref) = $_[0];
  map(cargar_datos($ref,'PARAMETROS',$_,$_,'g','',0
              ,__LINE__.' Scep imprs_arch_mod')
      ,@{$ref->{listaarg}});
  my $coderr = desplegar_ele($ref,'modelo');#para impr...mod
  $coderr and return $coderr;
  completar_nodos($ref);# para mod
  temperaturas($ref); #para imprimir mod
  interpretar_values_termico(['DATOS','PARAMETROS'],$ref);#para impr...mod 
  tratar_funciones($ref);#para imprimir modelos
  #impr_debug(__LINE__.' Scep USAFUN', Dumper $ref->{USAFUN});
  realizar_ajustes($ref,'modelo');
  parar1(66,$ref) if $avisosgrav;
  $coderr = resumir_fun_par_tab_var_funx($ref,'modelo');
  $coderr and parar1($coderr,$ref,'');
  controlar_uso_def_parametros($ref);#en imprs_archivo_mod
  controlar_uso_funciones($ref);#en imprs_archivo_mod
  #impr_debug(__LINE__.' Scep USAFUN', $ref->{USAFUN});
  imprs_lis_obj_sceptre($ref, 'modelo'); 
  comfin('finS imprs_archivo_mod'); 
}#imprs_archivo_mod
#-----------------------------------------------------------------------------
sub imprs_elementos{
  comfin('comS imprs_elementos',@_); 
  my ($ref,$clase) = @_; my $coderr = ''; 
  # foreach my $obj ( @{$ref->{lisobjelemTs}}) {
  # lo anterior pondria los elementos en el archivo .d en el orden de archivo
  # diagram }
  #    foreach my $nombreele (sort keys %{$ref->{cualobjele}}) {
  # lo anterior ordenaria en orden alfabetico }
  #          my $nombreele = "$codlista->[$obj]$textolista->[$obj]"; 
  # asi aparecen en el orden que dio el usuario
  my $que = 'DATOS'; 
  #$que = 'DEFINICION' if $clase eq 'modelo'; 
  #impr_hash(__LINE__.' Scep',%{$ref->{$que}});
  #impr_hash(__LINE__.' Scep',%{$ref->{uni}});
  my %hay_sindato;
  # Revisar: mejor que eleminar repetidos es no incorporar repetidos
  my (%norepetidos, @listaque);
  defined $ref->{"lista$que"}
     and @listaque = @{$ref->{"lista$que"}}
    or @listaque =();
  for (my $j = 0; $j< @listaque; $j++) {
      defined $norepetidos{$listaque[$j]} and delete $listaque[$j]
      or $norepetidos{$listaque[$j]} = 1 
  };
  impr_debug(__LINE__.' Scep @listaque',\@listaque);
  impr_campo(__LINE__.' Scep $ref',$ref,'uniuni');
  return '' unless @listaque;
  print SALIDAd  "\nELEMENTS\n";
  my $cuantos = 0;
  foreach my $nombreele (@listaque) {
      next unless defined $nombreele;
      next if $nombreele =~ /^[TtZ]/;
      if ($nombreele =~ /^;/) {
          print SALIDAd "$nombreele\n";
          next;
      };
      my $union = $ref->{uniuni}->{$nombreele};
      impr_debug(__LINE__.' Scep $union',$union);
      my $nodocoment = '';
      if (defined $union) { 
          if ($union=~ s/^([^;]+)(;.+)$/$1/) {$nodocoment = $2}; 
	  impr_debug(__LINE__.' Scep $union',$union);
	  my $nodo = ($union =~ /^(.+)\-/);
          if (defined $nodo and $union eq "$nodo-$nodo") {
              if ($nombreele =~ /^E/) {
                  printf SALIDAd "; lo siguiente no tiene sentido fisico\n";
	      };   
	      printf SALIDAd "; el siguiente elemento cortocircuitado\n; ";
	  };
      };
      $clase ne 'elementos' and not defined $ref->{cualobjele}->{$nombreele} 
          and $nombreele !~ /^M/ and next;
      my $sindato = 'sin dato';
      if (not defined $union) {
          $union = $sindato. ' union'; $hay_sindato{union} = 1;
      };
      my ($tipotok,$dato,$tipo,$tiparg,$refarg,$uni,$ori
        ,$coment,$comp,$listacom) = tomar_todo_datos($ref,$nombreele);  
      $dato =~ tr/[]/()/;    
      impr_dat(__LINE__.' Scep ',$nombreele,$ref,'sce');
      impr_par(__LINE__.' Scep',$tiparg,$refarg); 
      impr_debug(__LINE__.' Scep $dato,$union',[$dato,$union]);
      if (not defined $dato or $dato eq '') {
          $dato = $sindato.' valores';$hay_sindato{valor} = 1;
      } else {
          ($coderr,$dato)
             = para_sceptre_expr($ref,$tipotok,$dato,$tipo,$tiparg,$refarg);
      };
      $dato .= $nodocoment; #el comentario por dato lo puso quien ?
      my $renglon = sprintf "%6s,%13s = %1s", $nombreele,$union,$dato;
      imprimir_fortran($renglon,$listacom); $cuantos ++;
  }; #for
  my @mensajes;
  if ($cuantos < 2) {
      my $mensaje =  " Hay  $cuantos elemento; Sceptre no funciona asi"; 
      push @mensajes,$mensaje;
      imprimir_fortran('',$mensaje);
      $coderr = 186;
  };
  foreach my $palabra ('valor','union') {
      if ($hay_sindato{$palabra}) {
          push @mensajes," Hay elementos sin datos para $palabra";
          $coderr = 185;
      };
  
  };
  if ($coderr) {
      mensajear (join "\n", @mensajes);
  };
  comfin('finS imprs_elementos',$coderr);
  return $coderr;
}#imprs_elementos
#-----------------------------------------------------------------------------
sub imprs_errores_cuadro{
  comfin('comS imprs_errores_cuadro',@_);
  my $refcuadro = $_[0]; my $coderr = '';
  if ($refcuadro->{errores} and @{$refcuadro->{errores}}) {
      print SALIDAd ";     errores\n";   
      print SALIDAd join("\n;",@{$refcuadro->{errores}}),"\n"; 
      $coderr = 5; 
  };
  comfin('comS imprs_errores_cuadro',$coderr);
  return $coderr;
}#imprs_errores_cuadro
#-----------------------------------------------------------------------------
sub imprs_funciones{
  comfin('comS imprs_funciones',@_);
  my ($ref,$refUSAq) = @_;
  impr_debug(__LINE__.' Scep USAq',$refUSAq);
  impr_datos(__LINE__.' Scep',['FUNCIONES'],$ref);  
  foreach my $qfun (@{$refUSAq}) {
      my @listaargs = @{$ref->{listaargFUNCION}->{$qfun}};
      my $todo = "$qfun(".join(',',@listaargs).')=(';
      $todo .= $ref->{VALOR}->{$qfun} .')';
      my ($nada,$coment);
     ($nada,$nada,$nada,$nada,$nada,$nada,$nada,$nada,$nada,$coment)
       = tomar_todo_datos(
        $ref,$qfun);
      imprimir_fortran($todo,$coment);
  };
  comfin('finS imprs_funciones');
  return;
};#imprs_funciones
#----------------------------------------------------------------------------
sub imprs_lis_obj_sceptre{  
  comfin('comS imprs_lis_obj_sceptre',@_);
  my ($ref,$clase) = @_;
  my $icoderr = 0; my @coderrs; my $coderr = '';
  controlar_uso_def_parametros($ref);
  imprs_pre_DATOS_PAR($ref,$clase,$NUMPRINCIPAL);
  $coderrs[$icoderr] = imprs_elementos($ref,$clase); $icoderr++;
  if (@{$ref->{listaPPARAMETROS}} or @{$ref->{listaDPARAMETROS}}) {
      $coderrs[$icoderr] = imprs_PARAMETROS($ref,$clase);$icoderr++;
     #si los parametros viene de resultados 
        #podria ser $error_cuadros{PARAMETROS}= 1;
  };
  my @Cs = grep(/^C/,sort keys %{$ref->{TIPOTOK}});
  my @Ls = grep(/^L/,sort keys %{$ref->{TIPOTOK}});
  impr_debug(__LINE__.' Scep @Cs,@Ls',[@Cs,'||',@Ls]);
  if (@Cs or @Ls) {
      $coderrs[$icoderr] = imprs_VIINICIALES($ref,\@Cs,\@Ls);
      $icoderr ++;
  }; 
  if ($clase eq 'circuito') {
      $coderrs[$icoderr] = imprs_outputs($ref,$CORTOA,$CORTOASIN);$icoderr++; 
  };
  impr_debug(__LINE__.' Scep USA',Dumper $ref->{USA});
  my @USA = sort keys %{$ref->{USA}};
  impr_debug(__LINE__.' Scep @USA',\@USA);
  my @USAk = grep(do{valor($ref,'TIPOTOK',$_) eq 'k'},@USA);
  my @USAq = grep(do{lc(valor($ref,'TIPOTOK',$_)) eq 'q'},@USA);
#  push @USAq,keys %{$ref->{FUNCIONESsustituidas}}
#    if $ref->{FUNCIONESsustituidas}; 
  my @USAt = grep(do{lc(valor($ref,'TIPOTOK',$_))  eq 't'},@USA);
#  push @USAt,keys %{$ref->{TABLASsustituidas}} if $ref->{TABLASsustituidas}; 
#  impr_debug(__LINE__ . ' Scep USAk,USAq,USAt',[@USAk,'||',@USAq,'||',@USAt]);
  my (@archs,@arch_fors,@fk_sinfors);
  if (@USAk) {
      @archs = map ($_ ."= $PROPIOASIN.for"
                      ,($diadir,$dirsal{for}));
      unshift @archs, $diadir . 'funciones.for'; 
      $propio_copiar{$diadir . 'funciones.for'} = 1;
      impr_debug(__LINE__.' Scep @archs',\@archs);
      @arch_fors = grep (do {-e $_},@archs);
      impr_debug(__LINE__.' Scep @arch_fors',Dumper \@arch_fors);
      foreach my $archfor (@arch_fors) { 
          system "cp $archfor $dirsal{d}";
          system "cp $archfor $dirsal{for}";
          foreach my $funck (@USAk) {
              if (system "grep -i FUNCTION $dirsal{d}funciones.for") {
		  push @fk_sinfors,$funck;
              } else {
                  $ref->{ARCHIVO}->{$funck}
                     = "../$dirsalida{for}/funciones.for";
              };
          };
      };
      if (@arch_fors ==0) {
         push @fk_sinfors,@USAk;
      };
      impr_debug(__LINE__.' Scep @fk_sinfors',\@fk_sinfors);
  };
  if (@USAq or @USAt or @fk_sinfors) {
      print SALIDAd "\nFUNCTIONS\n";
      if (@USAq) {
	  @USAq = union_conjunto(@USAq);
           $coderrs[$icoderr] = imprs_funciones($ref,\@USAq,0); $icoderr++;
      };   
      if (@USAt) {
	  @USAt = union_conjunto(@USAt);
          $coderrs[$icoderr] = imprs_TABLAS($ref,\@USAt,0); $icoderr++;
      };
      if (@fk_sinfors) {
          my $mensaje = "No hay definicion FORTRAN para: @fk_sinfors";
          imprimir_fortran('',$mensaje);
          mensajear(" $mensaje");
      } else {
          foreach my $funck (@fk_sinfors) {
	      defined $ref->{ARCHIVO}->{$funck} and 
              imprimir_fortran(''
                ,"$funck definida en $ref->{ARCHIVO}->{$funck}");
          };
      };   
  };   
  if ($clase eq 'modelo') {
     comfin('finS imprs_lis_obj_sceptre');   
     return;
  } else {
      $coderrs[$icoderr] = imprs_CONTROLES_sceptre($ref);$icoderr++;
  };
  close SALIDAd;
  @coderrs = grep ($_,@coderrs);
  if (@coderrs) { 
      $coderr = $coderrs[0];
      impr_debug(__LINE__.' Scep todos errores',\@coderrs);
  };
  comfin('finS imprs_lis_obj_sceptre',$coderr);
  return $coderr;
}#imprs_lis_obj_sceptre  
# ---------------------------------------------------------------------------
sub imprs_lis_obj_sceptre_elementos{ #para clase elementos,complementario,mod
  #no hay chances de cambiar los tipos w
  comfin('comS imprs_lis_obj_sceptre_elementos',@_);
#  my ($refall,$refgraf) = @_;
#  impr_datos(__LINE__.' Scep $refall',['TODOS'],$refall);
  my $coderr = '';
  my $CORTOSINGUARDAR = "$dirsal{d}$PROPIOSINGUARDAR.d";
  open SALIDAd, ">$CORTOSINGUARDAR.d" or 
     die " No pude abrir >$CORTOSINGUARDAR";
  print SALIDAd "# Archivo $PROPIOSINGUARDAR; $marca_Simusol (simusol1.pl)\n";
  my $date = $refnombres[$NUMPRINCIPAL]->{DATE};
  my $viejaclasearch = $refall->{viejaclasearch};
  my $dirg = $dirguardar{$CLASEPRINCIPAL};
  $refall->{clasearch} eq 'nada' and $dirg = $dirguardar{$viejaclasearch};
  print SALIDAd
 "# a partir del archivo $mutuodir$dirg/$PROPIO  de fecha $date\n";
  print SALIDAd "#        auxiliar para Simusol, no ejecutable por Sceptre\n";
  if ($CLASEPRINCIPAL =~ /elementos|modelo/) {
      if ($refall->{sobreformulas}) {
          imprs_sobreformulas($refall);
          $coderr = 1;
      } else {
          print SALIDAd ";     Nada para registrar\n";
          $coderr = 6;
      };
  } else {
      $coderr = 0;
  };
  impr_debug(__LINE__.' Scep $coderr', $coderr);
  if (not $coderr or $coderr eq 1){
      impr_debug(__LINE__.' Scep', Dumper $refall->{cualnumclasenum});
      my ($queda_algo,$queda_algo1,$queda_algo2,$queda_algo3) = ('','','','');
      my ($coderr1,$coderr2,$coderr3) = ('','','');
      if ($refall->{cualnumclasenum}->{funciones}) {
          $queda_algo1 = imprs_sueltos_FUNCIONES();
      };
      if ($refall->{cualnumclasenum}->{tablas}) {
          $queda_algo2 = imprs_sueltos_TABLAS();
      };
      if ($refall->{cualnumclasenum}->{unidades}) {
          $queda_algo3 = imprs_sueltos_UNIDADES(); 
      };
      impr_debug(__LINE__.' Scep',[$queda_algo1,$queda_algo2,$queda_algo3]);
      ($queda_algo1 or $queda_algo2 or $queda_algo3) and $queda_algo = 1;
      if (not $coderr) {
           if ($queda_algo) {
               $coderr = 4;
           } else {
               print SALIDAd ";     Nada para registrar\n";
               $coderr = 5;
           };
      };
  };
  comfin('finS imprs_lis_obj_sceptre_elementos',$coderr);
  return $coderr;
#lo siguiente esta anulado
  my $refgraf;
  if ($refall->{defiuni} and scalar keys %{$refgraf->{defiuni}}) {
      print SALIDAd '# ' . '-'x20 . " UNIDADES DEFINIDAS\n";
      foreach my $numplantilla (sort keys %{$refgraf->{defiuni}->{comp}}) {
          my $nomplantilla = $nombreplantilla->[$numplantilla];
          print SALIDAd "plantilla = $nomplantilla:\n";
          my $refhashcosas = $refgraf->{defiuni}->{comp}->{$numplantilla};
          $refhashcosas or next;
          map( do{print SALIDAd "$_: $refhashcosas->{$_}\n"}
	       ,sort keys %$refhashcosas);
      };
  }; 
#  impr_debug(__LINE__.' Scep',[keys %{$refall->{sobreTABLAS}}]);
  impr_debug(__LINE__.' Scep $refall->{sobreFUNCIONES}'
    ,[keys %{$refall->{sobreFUNCIONES}}]);
  my (@defiQTT,@defiQTQ);
  impr_datos(__LINE__.' Scep',['FUNCIONES','TABLAS'],$refall);
  my @cualesTQ = grep($refall->{TIPOTOK}->{$_} =~ /^[TQ]$/
     ,sort keys %{$refall->{TIPOTOK}});  
  if (@cualesTQ) {
      @defiQTT = grep($refall->{TIPOTOK}->{$_} eq 'T', @cualesTQ);
      @defiQTQ =  grep(uc($refall->{TIPOTOK}->{$_}) eq 'Q', @cualesTQ);
     impr_debug(__LINE__.' Scep @defiQTT @defiQTQ', [@defiQTQ,'aaa',@defiQTT]);
  };
  if (@defiQTQ + @defiQTT) {
      print SALIDAd "#     FUNCIONES y/o TABLAS DEFINIDAS\n";
      my $codQ = imprs_funciones($refall) if @defiQTQ;
      my $codT = imprs_TABLAS($refall,0) if @defiQTT;  # para elementos
      ($codQ or $codT) and $coderr = 5;
  };
  impr_ARCHIVOS(__LINE__.'  Scep');
  if ($refall->{capasele}) {
      impr_debug(__LINE__.' Scep $refall->{capasele}', $refall->{capasele});
  };
  comfin('finS imprs_lis_obj_sceptre_elementos',$coderr);
  return $coderr;
}#imprs_lis_obj_sceptre_elementos
#----------------------------------------------------------------------------
sub imprs_pre_DATOS_PAR{  
  comfin('comS imprs_pre_DATOS_PAR',@_);
  my ($ref,$clase,$numfile) = @_; my $coderr= '';
  impr_debug(__LINE__.' Scep $refnombres[$numfile]'
    ,Dumper $refnombres[$numfile]);
  impr_debug(__LINE__.' Scep $mutuodir || $dirsal{d}'
	     ,[$mutuodir,'||',$dirsal{d}]);
  impr_datos(__LINE__.' Scep', ['TODOS']
     , $ref);
  my $no_outputs = '';
  $PROPIOSINGUARDAR = $refnombres[$numfile]->{PROPIOSINGUARDAR};
  open SALIDAd, ">$dirsal{d}$PROPIOSINGUARDAR.d" or parar1( 80,$ref
     , " No pude guardar $PROPIOSINGUARDAR.d"); 
#     or ($clase eq 'modelo' and return);  
     #para posibles modelos guardados por root
  if ($clase eq 'modelo') {
	print SALIDAd "MODEL DESCRIPTION\n$ref->{nombremod}\n";
  } else {
	print SALIDAd "CIRCUIT DESCRIPTION\n";
  };
  my $date = $refnombres[$ref->{numfile}]->{DATE};
  $PROPIO = $refnombres[$numfile]->{'PROPIO'};
  print SALIDAd 
      "   Archivo $PROPIOSINGUARDAR.d 
     $marca_Simusol (simusol1.pl) para S C E P T R E 
     a partir del archivo-diagrama ../cprojects/$PROPIO
      de fecha:  ", $date,"\n";
  print SALIDAd "       con opción -todas $opt_hash{todas}\n"
    if $opt_hash{todas};
  if ($ref->{USAARCHIVOS}) {
      my @lista = union_conjunto(@{$ref->{USAARCHIVOS}});
      print SALIDAd ";     y archivos: @lista\n"
 #       , ";           (Ver archivo $reftrabajo->{$archv}->{PROPIO}.caj)\n";
  };
  my %deplantilla;
  impr_datos(__LINE__.' Scep',['DATOS'],$ref);
  foreach  my $nombreele (@{$ref->{listaDATOS}}) {
      next unless defined $nombreele and $nombreele =~ /^[RLCJE]/;
      next unless defined $ref->{cualobjele}->{$nombreele}; 
      my $obj = $ref->{cualobjele}->{$nombreele}->[-1];
      my $planti = $plantillalista->[$obj];
      push @{$deplantilla{$planti}}, $nombreele;
  }; 
  my @lisplanti = sort keys  %deplantilla;
  impr_debug(__LINE__.' Scep',\%deplantilla);
  @lisplanti = grep ($_ >= 5, @lisplanti);
  my %mensuni = ();
  if (defined $ref->{DEFIuni}) {
 # $ref->{DEFIuni} esta definido si hay elementos
      foreach my $planti (@lisplanti) {
          $mensuni{$planti} = '';
          my $file = $ref->{DEFIuni}->{$planti}->{archivouni};
          if (defined $file) {
               $mensuni{$planti} 
                 = "; Unidades:\n;     $file,\n;           de fecha " 
                 . scalar localtime((stat "$file")[9])."\n";
          };
      }; 
  };
  impr_debug(__LINE__.' Scep @lisplanti', \@lisplanti);
#  impr_debug(__LINE__.' Scep $nombreplantilla', Dumper $nombreplantilla);
  impr_debug(__LINE__.' Scep %mensuni', Dumper \%mensuni);
  if (@lisplanti == 1) {
      my $mens0;
      $mens0 =  $mensuni{$lisplanti[0]} or $mens0 = '';
      print SALIDAd
        "; Plantilla Circuito $nombreplantilla->[$lisplanti[0]];" 
          ,  " todos los elementos\n"
          , $mens0;
  } else { 
      foreach my $planti (@lisplanti) {
         my $textotodos = " Plantilla Circuito $nombreplantilla->[$planti]: ";
          if (@{$deplantilla{$planti}} >10) {
              $textotodos = scalar @{$deplantilla{$planti}} . ' elementos';
	  } else {
              $textotodos .= join ', ',@{$deplantilla{$planti}};   
          };
          imprimir_fortran($textotodos,";");
	  print SALIDAd $mensuni{$planti} if $mensuni{$planti};
    };
  };
  if ($ref->{USAELE}) {
      my @eles = sort keys %{$ref->{USAELE}};
      print SALIDAd "; Elementos:\n" if @eles;
      foreach my $file (sort keys %{$ref->{USAELE}}) {
          print SALIDAd ";     $file,\n;           de fecha ",
            scalar localtime((stat "$file")[9]),"\n";
      }; #foreach
  };
  if ($ref->{USAMODELOS}) {
#      impr_debug(__LINE__.' Scep USAMODELOS 
#      , $ref->{USAMODELOS});
      foreach my $plancshape (sort keys %{$ref->{USAMODELOS}}) {
          my @listamod 
            = sort keys %{$ref->{USAMODELOS}->{$plancshape}};
          foreach my $modelito (@listamod) {#importa el orden
              my $refcircm  = $DEFIMOD->{$plancshape}->{$modelito};
              my $file = $refcircm->{archivo};
              print SALIDAd "; Modelo: ";
              print SALIDAd  "$file, (" .
	        descripcion_icono($plancshape). ": $modelito )\n;", 
 "           de fecha ",  scalar localtime((stat "$file")[9]),"\n";
          };
      };
  };
  if ($clase eq 'modelo') {
      print SALIDAd "\n;   Uso de este modelo:\n;     ",
        " $ref->{uso}\n";
      print SALIDAd ";   Nodos exteriores de este modelo: "
        , " $ref->{nodos}\n";
  };
  print SALIDAd "; ***** Hubo $avisosgrav problema(s) grave(s)\n"
    if $avisosgrav;
  print SALIDAd 
    "; ***** Hubo  $avisosnograv aviso(s) \"no grave(s)\" \n"
     if $avisosnograv;
  print SALIDAd 
     "; ***** Hubo $avisosnoseent cosa(s) que no se entendieron \n"
     if $avisosnoseent;  
  print SALIDAd 
   "; ***** Vea los mensajes en el archivo ../$dirsalida{ls3}/$PROPIOSIN.ls3\n"
     if $avisosgrav or $avisosnograv or $avisosnoseent;
  comfin('finS imprs_pre_DATOS_PAR','');
  return '';
}#imprs_pre_DATOS_PAR 
#------------------------------------------------------------------------------
sub imprs_outputs{
  my $ref = $_[0];
  comfin('comS imprs_outputs',@_);
#  impr_datos(__LINE__.' Scep',['TODOS'],$ref);
  my $outputssceptre = "\n";
  print SALIDAd "\nOUTPUTS\n";
  if (@{$ref->{lissceptres}}) {
      my @lisouts = @{$ref->{lissceptres}};
      impr_debug(__LINE__.' Scep @lisouts',\@lisouts);
      if ($ref->{liscomeRESU} and @{$ref->{liscomeRESU}}) {
          foreach (@{$ref->{liscomeRESU}}) {
              imprimir_fortran('',$_);
          };  
      };
      system "rm $BASEARCHA$PROPIOASIN.par"
        if -e   "$BASEARCHA$PROPIOASIN.par";

      if ($ref->{lispedidos_no_sat} and @{$ref->{lispedidos_no_sat}}) {
          impr_debug(__LINE__.' Scep $ref->{lispedidos_no_sat}'
                     ,$ref->{lispedidos_no_sat});
          imprimir_fortran('','Pedidos no satisfechos:');
          map (do{imprimir_fortran('',$_)},@{$ref->{lispedidos_no_sat}});
      };
      @lisouts == 0 and return;
      @lisouts >1 and shift @lisouts; 
      # no se necesita pedir TIME a Sceptre,aunque no pasa nada malo si se pide
      # pero solo lo pedimos cuando es el único pedido
      $outputssceptre = join (',',  @lisouts) . "\n"; 
      impr_debug(__LINE__.' Scep @liisouts',\@lisouts);
      $outputssceptre  =~ s/([^,]+,[^,]+,[^,]+,[^,]+,[^,]+),/$1\n/g;
      #no mas de cinco pedidos por renglon
      $outputssceptre  =~ s/\n\n$/\n/;
      print SALIDAd $outputssceptre;
  };
  comfin('finS imprs_outputs');
}#imprs_outputs
#----------------------------------------------------------------------------
sub imprs_rerun{
  my $ref = $_[0];
  comfin('comS imprs_rerun', @_);
#  controlar_dpar_tiempos($ref);
  impr_rerun(__LINE__.' Scep',$ref);
  my $refrerun = $ref->{rerun};
  my $cuantos = $ref->{nrerun}; my $texto = '';
  if (defined $ref->{VALOR}->{ICFORRERUNS}) {
      my @lista = @{$ref->{REFARG}->{tiempos}};
      for (my $numrerun = 1; $numrerun < $cuantos ; $numrerun ++) {
           print SALIDAd "\nRERUN DESCRIPTION\n";
           if (scalar keys %{$ref->{USAt}}) {
               print SALIDAd "FUNCTIONS";
               print SALIDAd $texto; $texto ='';
              imprs_TABLAS($ref, $numrerun) if %{$ref->{USAt}}; #en imprs_rerun
           };
           print SALIDAd "RUN CONTROLS\nSTART TIME=$lista[$numrerun]\n";
           print SALIDAd "STOP TIME=$lista[$numrerun+1]\n"
      };
  };
  my @reruns = grep ($_ =~ /^rerun/,sort keys %{$ref->{TIPOTOK}});
  impr_debug(__LINE__.' Scep RDINICIALES',$ref->{listaRDINICIALES});

  my %identis = ('DPARAMETROS'=>'DEFINED PARAMETERS'
                ,'PPARAMETROS'=>'DEFINED PARAMETERS'
                ,'RPPARAMETROS'=>'DEFINED PARAMETERS'
                ,'RDINICIALES'=>'DEFINED PARAMETERS'
                ,'RVIINICIALES'=>'INITIAL CONDITIONS'
                ,'RCONTROLES'=>'RUN CONTROLS');
  my @dondes = (qw(RDINICIALES RPPARAMETROS RVIINICIALES RCONTROLES));
  my $nuevotexto = '';
  foreach my $que (@dondes) {
      next unless   $ref->{"lista$que"} and @{$ref->{"lista$que"}};
      if ($nuevotexto ne  $identis{$que}) {
          $nuevotexto = $identis{$que};  $texto.= "$identis{$que}";
      };
      impr_debug(__LINE__.' Scep $que $texto',[$que,$texto]); 
      foreach my $key (@{$ref->{"lista$que"}}) {
          my $valor = $ref->{VALOR}->{$key};$valor =~ s/^[^,]+,//; 
          (my $purakey = $key) =~ s/^rerun//; $purakey =~ s/^INICIAL//;
          $texto .= "\n$purakey = $valor"; 
      };
      $texto .= "\n";
  };
  if ($texto) {
      print SALIDAd "RERUN DESCRIPTION (". ($cuantos - 1) . ")\n"
         .$texto;
  } else {
      %$refrerun = ();
  };
  comfin('finS imprs_rerun');
}#imprs_rerun
#----------------------------------------------------------------------------
sub imprs_sobreformulas{  
  comfin('comS imprs_sobreformulas',@_);
  my $refarch = $_[0];my $coderr = '';
  my $rdf = $refarch->{sobreformulas};
  impr_debug(__LINE__.' Scep $rdf', Dumper $rdf);
  my $descr = descripcion_clasepcs($refarch);
  $descr and print SALIDAd "$descr\n";       
  foreach my $nombre (sort keys %{$rdf->{nombre}}) {
      my $rdfnn = $rdf->{nombre}->{$nombre};
      print SALIDAd  
        '# ' . '-'x2 . " FORMULAS DEFINIDAS para nombre $nombre\n";
      foreach my $formula (sort keys %{$rdfnn->{formula}}) {
          my $rdfnnff = $rdfnn->{formula}->{$formula};
          if ($formula eq '') {
              print SALIDAd "  Definicion de TIERRA; sin formula\n";
              print SALIDAd 
                "   OTROSNODOS: $rdfnnff->{otrosnodos}\n";
              next;
          }; 
          print SALIDAd "# ------------ FORMULA $formula\n";
          impr_debug(__LINE__.' Scep $formula',$formula);
          impr_datos(__LINE__.' Scep',['TODOS'],$rdfnnff);
          impr_debug(__LINE__.' ',"Scep DEF. DE FORMULA $formula para");
          impr_debug(__LINE__. ' Scep $rdfnnff',Dumper $rdfnnff);
#              impr_debug(__LINE__.' ',"Scep iconos: $descri");
          print SALIDAd "             uso:  $rdfnnff->{uso}\n"
            if defined $rdfnnff->{uso};
          if (defined $rdfnnff->{definicion}) {
              print SALIDAd "      definicion:\n";
              my @renglones;
              if ($rdfnnff->{listaPARAMETROS} and 
                  @{$rdfnnff->{listaPARAMETROS}}) {
                  foreach my $par (@{$rdfnnff->{listaPARAMETROS}}) { 
                      my $valor =  $rdfnnff->{VALOR}->{$par};
                      push @renglones,"$par=$valor";
                   };
              };
              push @renglones, @{$rdfnnff->{definicion}};
              print SALIDAd '   ',join ("   \n",@renglones),"\n";
              my $comodin = $rdfnnff->{comodin};
              my $uniuni = $rdfnnff->{uniuni}->{$comodin};
              print SALIDAd "      nodos de $comodin: $uniuni\n"; 
              print SALIDAd "   OTROSNODOS: $rdfnnff->{otrosnodos}\n"
                 unless $rdfnnff->{otrosnodos} eq '? - ?'; 
              if ( defined $rdfnnff->{condicion}) {
                  print SALIDAd "CONDICIONES\n";
                  map(do{print SALIDAd "   $_\n"},@{$rdfnnff->{condicion}});
              };
	  };
      };#formula
          print SALIDAd "# --------------------------------------------\n"; 
  };#nombre
}#imprs_sobreformulas
#----------------------------------------------------------------------------
sub imprs_sueltos_FUNCIONES{#sin argumentos 
  comfin('comS imprs_sueltos_FUNCIONES',@_);
#  my $texto = 'FUNCIONES';
  my $queda_algo = ''; 
#  impr_debug(__LINE__.' Scep funciones $refall'
#    ,Dumper $refall->{cualnumclasenum}->{funciones});
#  foreach my $numobj (@{$refall->{cualnumclasenum}->{funciones}}) {
#      impr_debug(__LINE__.' Scep',Dumper $refboxes{$numobj});
#  };
  impr_debug(__LINE__.' Scep sobreFUNCIONES',Dumper $refall->{sobreFUNCIONES}); 
  my @numobjs;
  my %numobj2func; 
  foreach my $nombrefunc (sort keys %{$refall->{sobreFUNCIONES}}) {
      my $numobj =$refall->{sobreFUNCIONES}->{$nombrefunc}->[0];
      push @{$numobj2func{$numobj}},$nombrefunc;
  };
  foreach my $numobj (sort keys %numobj2func) { 
      my $refcuadro = $refboxes{$numobj}; 
      impr_debug(__LINE__.' Scep $refcuadro',Dumper $refcuadro);
      print SALIDAd '; ','-'x44,"\n";            
      print SALIDAd ';      ',descripcion_cuadro($numobj),"\n";
      foreach my $nombrefunc (@{$numobj2func{$numobj}}) {
          my ($tipotok,$valor,$tipo,$tiparg,$refarg,$uni,$ori
              ,$com,$comp,$listacom)
            = tomar_todo_datos($refcuadro,$nombrefunc);
#            impr_debug(__LINE__.' Scep $tipotok,$valor,$tipo,$tiparg'
#                  .',$refarg,$uni,$ori,$com,$comp,$listacom'
#                  ,[$tipotok,$valor,$tipo,$tiparg,'||',@$refarg,$uni,$ori
#                  ,$com,$comp,$listacom]);
          my $stringargs = '';  
          if ($tipotok =~ /^[qQ89]$/) {
              my @listaargs
                = @{$refcuadro->{listaargFUNCION}->{$nombrefunc}};
              $stringargs = '(' .join(',',@listaargs).')';
                  $valor = "($valor)"; $queda_algo = 1;
          };
          my $todo = "$nombrefunc$stringargs = $valor";
          my $coment = " tipotok = $tipotok";
          $coment .= ";  $listacom" if $listacom;
          imprimir_fortran($todo,$coment);
      };#foreach $nombrefun
  };#$numobj
  comfin('finS imprs_sueltos_FUNCIONES',$queda_algo);
  return $queda_algo;
}#imprs_sueltos_FUNCIONES     
#----------------------------------------------------------------------------
sub imprs_sueltos_UNIDADES{#sin argumentos 
  comfin('comS imprs_sueltos_UNIDADES',@_);
  my $queda_algo = ''; 
  impr_debug(__LINE__.' Scep sobreUNIDADES',Dumper $refall->{sobreUNIDADES});
  foreach my $numobj (sort @{$refall->{sobreUNIDADES}}) {
      my $refcuadro = $refboxes{$numobj}; 
      if (scalar keys %{$refcuadro->{stringnumpl}} ) {
          my @keys =  sort keys %{$refcuadro->{stringnumpl}};
          @keys = grep(do {$_ and $_ ne 'numobj'},@keys);
          if (@keys) {
              print SALIDAd '; ','-'x44,"\n";            
              print SALIDAd ';      ',descripcion_cuadro($numobj),"\n";
              foreach my $numpl (@keys) {
                  next unless $numpl;
                  $queda_algo = 1;
                  my $nompl = $nombreplantilla->[$numpl];
                  print SALIDAd " Plantilla = $nompl\n";
                  my $refplDEFI= $refcuadro->{stringnumpl}->{$numpl}->{DEFIuni};
                  foreach my $claseel (sort keys %$refplDEFI) { 
                      print SALIDAd " $claseel : $refplDEFI->{$claseel}->[0]\n";
                  };
              };
          };
      }; 
  };#my $numobj
  comfin('finS imprs_sueltos_UNIDADES',$queda_algo);
  return $queda_algo;
}#imprs_sueltos_UNIDADES');
#----------------------------------------------------------------------------
sub imprs_sueltos_TABLAS{#sin argumentos
  comfin('comS imprs_sueltos_TABLAS',@_);
  my ($coderr,$queda_algo) = ('','');
  my %extenso = ('ARC'=>'archivo','COL'=>'columnas','ORD'=>'orden'
      ,'LIS'=>'lista','REP'=>'repeticiones','RAN'=>'rangox','FAC'=>'factores');
  my %sobre = %{$refall->{sobreTABLAS}};
  impr_debug(__LINE__.' Scep %sobreTABLAS}',Dumper \%sobre);
  if (scalar keys %sobre == 0) {
      comfin('finS imprs_sueltos_TABLAS',$queda_algo);
      return $queda_algo;
  } else {
      $queda_algo = 1;
  };
  foreach my $Tidtabla (sort keys %sobre) {
      my $idtabla = substr($Tidtabla,1); 
      my $numcapa = $sobre{$Tidtabla}->{numcapa};
      my $reflay = $reflayers[$numcapa];
      my $tipotok = $reflay->{TIPOTOK}->{$Tidtabla};
      my (@numobjs,@textos);
      push @textos,"     Tabla $idtabla;  tipotok = $tipotok";
      my $refpares = $sobre{$Tidtabla}->{refpares};
      my $tipo = $sobre{$Tidtabla}->{tipo};
      my ($agrearch,$agretabla) = ('','');
      if ($tipo eq 'arch') {
          $agretabla = " $Tidtabla";
#          impr_debug(__LINE__.' Scep',Dumper  $refpares->{ARC});
          my $Aidarchivo = $refpares->{ARC}->[1]->[0];
#          impr_debug(__LINE__.' Scep',Dumper  $Aidarchivo);
          my $refa = $refall->{sobreARCHS}->{$Aidarchivo};
          $agrearch = "$refa->{simbarchori}";
          my $archreal = $refa->{ARC}->[1];
          push @textos,"archivo $agrearch = $archreal";
          push @numobjs,$refa->{ARC}->[0];
      }; 
      my @comandos = (qw(COL ORD REP RAN FAC LIS));
      foreach my $comando (@comandos) {
          next unless $reflay->{REFLISTAVALOR}->{$Tidtabla."_$comando"};
          my $numobj = $refpares->{$comando}->[0];
          my $reflista =  $reflay->{REFLISTAVALOR}->{$Tidtabla."_$comando"}; 
#          my ($numobj,$reflista) = @{$refpares->{$comando}};
#          my $reflay = $reflayers[$refboxes{$numobj}->{numcapa}];
          push @numobjs,$numobj;
          if ($comando eq 'LIS') {
             my @listita = para_sceptre_listadatos($reflay,$Tidtabla."_LIS");
	     impr_debug(__LINE__.' Scep @listita',Dumper \@listita);
               for(my $i = 0; $i < @listita-1; $i +=2) {
                  push @textos,"$listita[$i] $listita[$i+1]";  
              };next;
          };  
          my $derecha = join ',',@$reflista;
          $comando eq 'COL' and $derecha = join(',',$agrearch,@$reflista);  
          my $texto = "$extenso{$comando}$agretabla = $derecha"; 
          push @textos,$texto;
      };
      impr_debug(__LINE__.' Scep final @numobj',\@numobjs);
      impr_debug(__LINE__.' Scep @textos',Dumper \@textos);
      @numobjs = union_conjunto(@numobjs); 
      foreach my $numobj (@numobjs) {
          print SALIDAd ";     ",descripcion_cuadro($numobj),"\n";
      };
      foreach my $renglon (@textos) {
          print SALIDAd $renglon,"\n";
      }; 
      if ($tipotok eq 'T') {
          print SALIDAd "      Resulta ";
          my $reffes = $reflay->{sobreTABLAS}->{$Tidtabla};
          my $cuantos = @{$reffes->{absTABLAS}};my $cuales = 20;
	  if ($cuantos > 2*$cuales) {
              print SALIDAd "(comienzo y final):\n";
              my $cuantos1 = $cuales; my $cuantos2 = $cuantos - $cuales;
              for(my $i = 0; $i < $cuantos1; $i ++) {
                  my ($uno,$dos)
                    = ($reffes->{absTABLAS}->[$i],$reffes->{ordTABLAS}->[$i]);
	          printf SALIDAd "%6G,%6G\n",$uno,$dos;
              };
              print SALIDAd "      ...\n";        
              for (my $i = $cuantos2; $i <$cuantos; $i ++) {
                  my ($uno,$dos)
                    = ($reffes->{absTABLAS}->[$i],$reffes->{ordTABLAS}->[$i]);
	          printf SALIDAd "%6G,%6G\n",$uno,$dos;
              };
          } else {
              print SALIDAd ":\n";
              for (my $i = 0; $i <$cuantos; $i ++) {
                  my ($uno,$dos)
                    = ($reffes->{absTABLAS}->[$i],$reffes->{ordTABLAS}->[$i]);
	          printf SALIDAd "%6G,%6G\n",$uno,$dos;
              };
          };
      };  
  };#Tidtabla
  comfin('comS imprs_sueltos_TABLAS',@_);
  return $queda_algo;
}#imprs_sueltos_TABLAS
# ----------------------------------------------------------------------------
sub para_sceptre_expr{
  comfin('comS para_sceptre_expr', @_);
  my ($ref,$tipotok,$expr,$tipo,$tiparg,$refarg) = @_; my $coderr = '';
  my @listat = @$refarg; my $tipargori = $tiparg; my $newexpr ='';
  map(do{$_ eq 'TIEMPO' and $_ = 'TIME'
         or $_ =~ /^[\d\.]/ and $_ = para_sceptre_num($_)},@listat); 
  $tiparg =~ s/\^/**/g;
  impr_par(__LINE__.' Scep',$tiparg,$refarg);
  $newexpr = tiparg_refarg_2_valor_talcual($tiparg,\@listat);
  $newexpr =~ tr/[]/()/;
  if ($tiparg =~ /^([fkqt])\[([,\w]+)\]$/) {
      my ($tipfunc,$tipargu) = ($1,$2);
      my $func = $listat[0];
      impr_debug(__LINE__.' Scep',\@listat);
      $newexpr = tiparg_refarg_2_valor_talcual($tiparg,\@listat);
      $newexpr =~ tr/[]/()/;
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
      if ($tipfunc =~ /[qt]/) {
      } else {
          $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
          impr_debug(__LINE__.' Scep $newexpr',$newexpr);
      };
      comfin('finS para_sceptre_expr', $coderr,$newexpr);
      return $coderr,$newexpr;
  } elsif (($tipo =~ /[no]/ and $tipotok eq 'd') or $tipo eq 'S') {
      $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
  } elsif ($tipo eq 's') {
      if (substr($newexpr,0,1) ne 'P') {
          $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
      };
  } elsif ($tipo =~ /[ad]/) {
      $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
  } elsif ($tipo eq 'x' and $tiparg !~ /t/) {
      $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
  } else {
      $newexpr = '';
      while ($tiparg =~ s/^(\W*)(\w)//) {
          my ($pretipito,$tipito) = ($1,$2);
          $newexpr .= $pretipito;
          $tipito eq 'o' and $newexpr .= '-';
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
          my $token = shift @listat;
          if ($tipito ne 't') {
              if ($tipito eq 'S') {
	          $newexpr .= 'TIME';
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
              } elsif ($tipito =~ /[no]/) {
                  $newexpr .= para_sceptre_num($token);
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
              } else {
                  $newexpr .= $token;
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
              };
          } elsif ($tiparg =~ s/\((\w)\)(.*)/$2/) {
              my $tipargu = $1;  my $argu = shift @listat; 
              $tipargu eq 'S' and $argu = 'TIEMPO';
              if ($tipargu =~ /[no]/ or valor($ref,'TIPOTOK',$token) ne 'T'
                  or $tipargu !~ /[adpsS]/) {
                  error_progr($ref,"no es aceptable para Sceptre, en:
                     $expr");
              } else{
                  $newexpr .= "XTABLE($token,$argu)";
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
              };
          };
      };# while
      if (defined $newexpr) {
          $newexpr .= $tiparg;
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
          $newexpr =~ s/\+\-/-/g; $newexpr =~ s/\-\-/+/g;
          if (length $tipargori > 1 or $tipargori !~/[nopSs]/) {
              $Xiden ++; $newexpr = 'X' . $Xiden ."($newexpr)";
      impr_debug(__LINE__.' Scep $newexpr',$newexpr);
          };
      } else {
          $coderr = 70;
      };
  };
  comfin('finS para_sceptre_expr', $coderr,$newexpr);
  return $coderr,$newexpr;
}#para_sceptre_expr
# ----------------------------------------------------------------------------
sub para_sceptre_listadatos{
  comfin('comG para_sceptre_listadatos', @_);
  my ($ref,$cosa) = @_;
  my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$cosa);
  my @listiparg = split ',',$tiparg; my @listexto;
   foreach my $letra (@listiparg) {
      my $parte = shift @$refarg; my $texto= ''; 
      if ($letra eq 'n') { $texto = sprintf "%6G", $parte;
      } elsif ($letra eq 'o') {$texto = sprintf "%6G",-$parte;
      } else { $texto = sprintf "%-6s",$parte;
      };
      push @listexto,$texto;
   };
  comfin('finG para_sceptre_listadatos',@listexto);
  return @listexto;
}#para_sceptre_listadatos  
# ---------------------------------------------------------------------------
1
