package Simusol::Termicos;
#Para circuitos termicos
#usados por simusol1.pl
use Data::Dumper;
use Simusol::Ayudas;
use Simusol::GlobalesSimusol;
use Simusol::Tablasfuncq;
use Simusol::Algebraico;
use Simusol::Auxiliares;

use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(
         &buscar_abreviaturas
         &cerofuentear
	 &interpretar_values_termico
	 &interpretar_values_iniciales
         &interpretar_var_termica
         &nodos_0conectados
         &normalizar_abreviaturas
         &registrar_equivalencias
         &temperaturas 
         &tipear_cosa

     )
}
END();
# ----------------------------------------------------------------------------
sub buscar_abreviaturas{
  comfin('comr buscar_abreviaturas',@_);
  my ($refcirc, $pal1, $cont00,$quien) = (@_,'');
  #$cont00 es contenido del primer parentesis; si no se usa,
  #se devuelve tal cual si no se usa;
  #si se usa se devuelve ''
  my (@listacont0,$refcuaternas,$refpar);
  my ($hashpalabras,$equivpalabra,$plantipalabra) =
       ($refcirc->{hashpalabras},$refcirc->{equivpalabra}
        ,$refcirc->{plantipalabra});  
  $hashpalabras->{''} = 1; $equivpalabra->{''} = ''; 
  #si no se ejecuto registrar_equivalencias ..., se necesita lo anterior
  $refpar = [];
  #buscamos dif. de tension entre dos nodos o ....:
  $cont00 =~ s/^\s*//; $cont00 =~ s/\s*$//;
  my @liscont00 = split /\s*\-\s*/,uc($cont00); my $nombre;
  impr_debug(__LINE__.' Term @liscont00 ', \@liscont00);
  impr_debug(__LINE__.' Term $equivpalabra ', $equivpalabra);
  impr_debug(__LINE__.' Term $hashpalabras ', $hashpalabras);
  impr_debug(__LINE__.' Term $refcirc->{DEFIabrev} '
       , Dumper $refcirc->{DEFIabrev});

  my ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio);
  if ($quien ne 'INICIALES' and  defined $hashpalabras->{$pal1}
          and @liscont00 == 2 and $equivpalabra->{$pal1} eq 'V'
          and defined $refcirc->{cualobjtextonodo}->{$liscont00[0]}
          and defined $refcirc->{cualobjtextonodo}->{$liscont00[1]}) {
      $nombre =  $refcirc->{TEMP}->{"$liscont00[0]-$liscont00[1]"};
      defined $nombre or        
          $nombre = cerofuentear($refcirc,$liscont00[0],$liscont00[1]);
      $propio = "$pal1($cont00)";
      $cont00='';
      $tipo = 'a'; 
      $nombre =~ /^E/ and $eleparnodo = $nombre 
          or $eleparnodo = substr($nombre,1); 
      $cont0 = $eleparnodo;
      my $obj = $refcirc->{cualobjtextonodo}->{$liscont00[0]}->[0];
      $plantilla = $plantillalista->[$obj]; 
      impr_debug(__LINE__.' Term $plantilla',$plantilla);
      $palequiv = 'V'; $pala = $pal1;  
  } else {  
      foreach my $palabra (keys %$hashpalabras) {
          $palequiv = $equivpalabra->{$palabra};
          if ($pal1 =~ /^$palabra(.*)$/i) {
              my $cont0 = $1; $cont0 =~ s/^\s*//; $cont0 =~ s/\s*$//;
              # next if (($cont0  ne '' and $cont00 ne '')
              #          or ($cont0 eq '' and $cont00 eq '')); 
              my $propio;
              if ($cont0 eq '') {
	          $cont0 = $cont00; $cont00 = '';
                  ($cont00 eq '' and $propio = $pal1) 
                              or $propio = "$pal1($cont00)"; 
              } else {
                  $propio = $pal1; 
              }; 
              push @$refpar, [$palabra, $cont0];    
              push @$refcuaternas, [$palequiv,$palabra,$propio,$cont00];
              push @listacont0, uc($cont0);
          };
      };
      impr_debug(__LINE__.' Term @listacont0', Dumper \@listacont0);
      impr_debug(__LINE__.' Term $refcuaternas', Dumper $refcuaternas);
      impr_debug(__LINE__.' Term $refpar', Dumper $refpar);
      my $reflista = tipear_cosa($refcirc,@listacont0);
      impr_debug(__LINE__.' Term $reflista', Dumper $reflista); 
      if (@$reflista == 0) {
          $reflista =[['e',0,'??','']];      
      } elsif (@$reflista == 1) {
          my ($tipo,$plantilla,$eleparnodo, $i) = @{$reflista->[0]};
          my $abr = ''; 
          if ($tipo eq 'm') {
              $abr = $refcirc->{DEFIabrev}->{$plantilla}->{E};
          }; 
          not $abr or ($abr and $abr eq $refpar->[$i]->[0]) or 
          do{ avnograv("Sería mejor hacer el pedido de resultado 
                $pal1    como    $abr $eleparnodo"); 
          };  
          #$plantipalabra->{$refpar->[0]->[0]}->{$plantilla} or
      } elsif (@$reflista >1) {
          my @reducida;
          foreach my $reflistita (@$reflista) {
              ($plantilla,my $i) = ($reflistita->[1],$reflistita->[3]);
              if ($plantipalabra->{$refpar->[$i]->[0]}->{$plantilla}) {
                  push @reducida, $reflistita;
              }; 
          };  
          @reducida == 1 and $reflista = \@reducida
              or  do{
              foreach my $par (@$refpar) {
                  push @{$refcirc->{confuso}},"$par->[0] $par->[1]";
              };
              parar1(75,$refcirc,"Hay ambigüedad en $quien:
               $pal1$cont00; separe con espacios o utilice paréntesis
               @{$refcirc->{confuso}}");
	  };   
      };
      ($tipo,$plantilla,$eleparnodo,my $i) = @{$reflista->[0]};
      impr_debug(__LINE__.' Term $plantilla',$plantilla);
      if ($tipo eq 'e') {
          $eleparnodo = '??'; $cont00 = '??,??,??'; $cont0 ='';
          ($palequiv, $pala,$propio) = ('??','??','??');
      } else {
          $cont0 = $listacont0[$i]; my $refcua = $refcuaternas->[$i] ;
          ($palequiv, $pala,  $propio, $cont00) = @$refcua; 
      };
      if ($tipo eq 'a' and $pala eq '') {
          $eleparnodo =~ /^J/  and $palequiv = 'I'
            or 
          $eleparnodo =~ /^E/  and $palequiv = 'V';
      };
  }; #if else 
  comfin('finr buscar_abreviaturas',':::',
     , ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio,$cont00)); 
  return ($tipo,$plantilla,$eleparnodo,$cont0,$palequiv,$pala,$propio,$cont00);
}#buscar_abreviaturas 
# ---------------------------------------------------------------------------
sub cerofuentear{ 
  #agrega una fuente de corriente nula al circuito y devuelve
  #  VJ...." , pronto para referirse al voltaje de esa fuente   
  comfin('comr cerofuentear',@_);
  my ($refcirc,$nodo,$otronodo) = (@_); my ($pre,$texto,$quien);
  if (not defined $otronodo) {
      $otronodo = '0';
      $pre = 'JN';
      $texto = $nodo;
  } else {
      $pre = 'JNN';
      $texto = "$nodo$otronodo";
  }; 
  if (length("$pre$texto") > 5 or  defined $nombresusados{uc("$pre$texto")}) {
      $texto = 1;
      $texto ++ while defined $nombresusados{uc("$pre$texto")} 
  };    
  $quien="$pre$texto";
  $nombresusados{uc($quien)} = 1;
  my $obj = $refcirc->{cualobjtextonodo}->{$nodo}->[0];
  push(@$laylista,$laylista->[$obj]); 
  push(@$plantillalista,$plantillalista->[$obj]);
  push(@$shapelista,$cualshape->{'flujod'}); #no importa si esta indefinido
  push(@$codlista,"J");
  push(@$textolista,"N$texto");
  push(@$codvalorlista,"J");
  push(@$lugarlista,$lugarlista->[$obj]);
  $refcirc->{uniuni}->{$quien} = "$nodo-$otronodo"; 
  cargar_datos($refcirc, 'DATOS', $quien, '0', 'n','n',[0]
    ,__LINE__.' Term cerofuentear');
  agregar_comentarios($refcirc,$quien,"para determinar caida $nodo-$otronodo"
    ,'Term '.__LINE__);
  $refcirc->{cualobjele}->{$quien} = [scalar @$codlista - 1];
  push(@{$refcirc->{lisobjelemTs}},scalar @$codlista - 1);
#  if ($otronodo eq '0') {
#      cargar_datos($refcirc, 'temp', $nodo,"V$quien",'a','',0
#        ,__LINE__.' Term cerofuentear'); 
#      cargar_datos($refcirc, 'TEMP', $nodo,"V$quien",'a','',0
#        ,__LINE__.' Term cerofuentear'); 
#  } else {
#      cargar_datos($refcirc, 'temp', "$nodo-$otronodo","V$quien",'a','',0
#        ,__LINE__.' Term cerofuentear'); 
#      cargar_datos($refcirc, 'TEMP', "$nodo-$otronodo","V$quien",'a','',0
#        ,__LINE__.' Term cerofuentear'); 
#  };
  push @{$refcirc->{listaDATOS}}, "$quien"; # en cerofuentear
  $refcirc->{ELESPLANT}->{$quien} = $plantillalista->[$obj];
  $refcirc->{cero_conectado}->{directo}->{$nodo} = "V$quien";
  delete $refcirc->{ceroconectado}->{nodirecto}->{$nodo}; 
  $refcirc->{cualidenuniuni}->{$nodo} = ["V$quien"];  
  comfin('finr cerofuentear',"V$quien");
  return "V$quien";
};#cerofuentear
# ---------------------------------------------------------------------------
sub interpretar_var_termica{
  comfin('comr interpretar_var_termica',@_);
  #interpreta las variables termicas de una expresion,
  #cambiandolas por las correspondientes electricas
  #$dado es la exprexion a interpretar
  #$refcirc debe admitir ->{cualobjele} y {cualobjtextonodo} y {temp}
  # TEMP de un elemento significa la diferencia de temperaturas 
  # entre sus bornes
  # FLUJO de un elemento significa la corriente a traves del elemento
  #para marcar, durante los cambios, usa \[ \[
  my ($dado,$refcirc,$temp) = @_;
  my $sust; # desde key_iniciales se llama con TEMP
  if (not defined $temp) {
      error_progr($refcirc, 
                  'Term '. __LINE__ .'no se ha indicado temp ni TEMP');
  };
  #impr_debug(__LINE__.' Term $refcirc->{TEMP}', $refcirc->{TEMP});  
  #impr_debug(__LINE__.' Term $refcirc->{temp}', $refcirc->{temp});  
  # para que no haya constantes en pedido de OUTPUTS a Sceptre o para
  # la identificacion de los valores iniciales 
   
  my ($objeto,$nodoobj,$categ,$cual);
  my $cambiado = $dado;
  my $dato  = ';'.$dado.';';
  #impr_debug(__LINE__.' Term $dato', $dato);
  $dato =~ s/(\W)TEMP/$1&TEMP/g;$dato =~ s/(\W)FLUJO/$1&FLUJO/g;
  while (
         $dato =~ s/(\W+)\s*&(TEMP)_(\w+)(\W+)/$1\[$3\[$4/ 
         or $dato =~ s/(\W+)\s*&(TEMP)\s*(\w+)(\W+)/$1\[$3\[$4/ 
	 or $dato =~ s/(\W+)\s*&(FLUJO)_(\w+)(\W+)/$1\[$3\[$4/ 
	 or $dato =~ s/(\W+)\s*&(FLUJO)\s*(\w+)(\W+)/$1\[$3\[$4/ 
        ) {
            ($categ,$cual)=(uc($2),$3); $sust = $categ . '_' . $cual;
            my ($objeto,$nodoobj);
	    my $biencual = 1;
	    if (defined $refcirc->{cualobjele}->{$cual}) {
	        $objeto = $refcirc->{cualobjele}->{$cual}->[-1];
            };
	    if (defined $refcirc->{cualobjtextonodo}->{uc($cual)}) {
	        $nodoobj=$refcirc->{cualobjtextonodo}->{uc($cual)}->[-1];   
            };
            if (uc($categ) eq 'FLUJO'){
                if (defined ($objeto)){
                    $cual =~ /^[RCEL]/i and $sust = "I$cual"  
	          or  $cual =~ /^J/i and $sust = $cual
	          or do{
		   $biencual = 0;
		  };
	        } else {
		   $biencual = 0;
		}
            } elsif (defined ($objeto)) {  #  TEMP
	        $cual =~ /^E/i  and $sust = $cual
		or $cual =~ /^[CRJL]/i  and $sust = "V$cual"
		or $biencual = 0;
            } elsif (defined $nodoobj) { 
                 if (defined($refcirc->{$temp}->{uc($cual)})) { 
                        $sust = $refcirc->{$temp}->{uc($cual)}
		 } else {
		      $sust=cerofuentear($refcirc,uc($cual));
		 };
            } else {
	         $biencual = 0;
	    }; 	  
            unless ($biencual) {
                avnoseent($dato);
	    };
            if ($sust =~ /^\-/) {
                $dato =~ s/\[$cual\[/\[$sust\[/;
                $dato =~ s/\-\[\-(.+)\[/+$1/ or  $dato =~ s/\+\[\-(.+)\[/-$1/
		    or $dato =~ s/\[(.*)\[/($1)/;
	    } else {
                $dato =~ s/\[$cual\[/$sust/ ;
            };
    }
  $dato =~ s/^;(.*);$/$1/;
  #impr_debug(__LINE__.' Term nuevovalor',$dato);
  comfin('finr interpretar_var_termica',$dato);
    return ($dato) ;
}#interpretar_var_termica
# ---------------------------------------------------------------------------
sub interpretar_values_termico{ 
  comfin('comr interpretar_values_termico',@_);
  my ($lisque,$ref)=@_; 
  for my $que (@$lisque) {
     my $dummy; #unidad
     my $cuantasdefi = 0;;
     foreach my $key (keys %{$ref->{$que}}){#no importa el orden (casi)
	 my ($valor,$tipo,$tiparg,$refarg) = tomar_datos($ref,$que,$key);
#impr_debug(__LINE__.' Term $valor,$tipo,$tiparg,$refarg '
#	   ,[$valor,$tipo,$tiparg,$refarg]);
	 next if $tipo =~ /[npebzIvij;]/;
         my $temp = 'temp';
         if ($tipo eq 'a') {
             my $nuevovalor
                 = interpretar_var_termica($valor,$ref,$temp);
             next if $nuevovalor eq 'NOSEENTIENDE' 
                     or $nuevovalor eq $valor;
             $nuevovalor !~ /^\D/ and $tipo = 'n';   
             cargar_datos($ref, $que, $key, $nuevovalor,$tipo,'',0
                         ,__LINE__.' Term int_val_term');
             next;
         };
         #impr_dat_que($key,$que,__LINE__.' Term ',$ref,'ivt');
         if (not defined $refarg) {
               ($tipo,my $argus,my $nfunc,$tiparg,$valor,$refarg) 
                   = Tablasfuncq::tipear($valor,1);
               cargar_datos($ref,$que,$key,$valor,$tipo,$tiparg,$refarg
                         ,__LINE__. ' Term ');
         };
         my @listaarg = @$refarg;
         #impr_debug(__LINE__.' Term REFARG',$refarg);
         my $cambio =''; my $tipargv = $tiparg;
         foreach my $argu (@listaarg) {
             $tipargv =~ s/^(.)//;  
             my $tipito = $1; 
             next if $tipito =~ /[np]/;
             my $nuevoargu = interpretar_var_termica($argu,$ref,$temp);
             next if $nuevoargu eq 'NOSEENTIENDE' or $nuevoargu eq $argu;
             $nuevoargu !~ /^\D/ and $tipo = 'n';
             #impr_debug(__LINE__.' Term $que $key $argu $nuevoargu '
             #               ,"$que $key $argu $nuevoargu");
             $cambio = 1; my $cuan = 0;
             while ($valor =~ s/(\W)$argu(\W)/$1$nuevoargu$2/ and $cuan <5){
                  $cuan ++
             };
             $argu = $nuevoargu;
         };
        
        next unless $cambio;
        #impr_debug(__LINE__.' Term $que $key $valor $nuevovalor', 
        #  "$que $key $valor");  
        #impr_debug(__LINE__.' Term $valor REFARG '
        #     , ,$ref->{"REFARG$que"}->{$key}); 
        cargar_datos($ref, $que, $key, $valor,$tipo,$tiparg
                         ,\@listaarg
                         ,__LINE__.' Term int_val_term');
   };#$key
  }; #$que
  comfin('finr interpretar_values_termico');
  return '';
}#interpretar_values_termicos     
# ----------------------------------------------------------------------------
sub interpretar_values_iniciales{ #creo que ya no hace falta
  #en relacion con valores iniciales para VC...
    return '';
  comfin('comr interpretar_values_iniciales',@_);
  my $refcirc = $_[0]; 
  #impr_datos(__LINE__.' Term', ['INICIALES'], $refcirc);
  my ($refini, $tiprefini);
  $refini = $refcirc->{INICIALES}; 
  scalar keys %$refini or return 0;
  $tiprefini = $refcirc->{TIPINICIALES} or $tiprefini = {}; 
  my @parsn = grep(lc($refcirc->{TIPPARAMETROS}->{$_}) eq 'n'
		   ,keys %{$refcirc->{PARAMETROS}});
  #impr_debug(__LINE__.' Term @parsn',\@parsn); 
  my %INICIALESORI = %$refini; 
  #impr_debug(__LINE__.' Term @$refini',Dumper $refini); 
  my @nonum = grep(do{$tiprefini->{$_} !~ /[\;n]/}
           , keys %$tiprefini); 
  #impr_debug(__LINE__.' Term @nonum',\@nonum); 
  map (impr_dat(__LINE__.' Term',$_,$refcirc,'ivi'),@nonum);
  for my $key (@nonum) {
      my $valor = $refini->{$key};
      #print 'Term ' . __LINE__ . " $valor\n";
      if ($valor =~ /^QPRODUCTO.*\W0\W/ ) { 
          cargar_datos($refcirc, 'INICIALES', $key, '0.', 'n', '',0
                       ,__LINE__.' Term' ,__LINE__.' Term int.keys_ini');
      } else {avgrav("El valor inicial para $key, $refini->{$key},
            no es una constante"); $refini->{$key} .= '; no es constante';
          cargar_datos($refcirc, 'INICIALES', $key,
	              $valor . 'no es una constante', 'e', '',0
                       ,__LINE__.' Term int.keys_ini');
          next;   
      };
  };   
  my (%hashesiniciales); 
  my $listaIN;
  @$listaIN = @{$refcirc->{listaINICIALES}}; 
  #impr_debug(__LINE__.' Term', Dumper $refcirc->{INICIALES});
  #impr_debug(__LINE__.' Term', $listaIN);
  foreach my $cosa ( keys %{$refcirc->{INICIALES}} ) {
      next unless $cosa =~ /^V/;
      my $dosnodos = $refcirc->{uni}->{substr($cosa,1)}; 
      $hashesiniciales{$dosnodos}->{$refcirc->{INICIALES}->{$cosa}}++ ;
  };
  my $rerunini = $refcirc->{rerun}->{INICIALES}; 
  #impr_debug(__LINE__.' Term $rerunini',$rerunini)
  #    if defined $rerunini;
  my $refcualesC = {};
  foreach my $nodo  (keys %{$refcirc->{cualesEC}}) {
      my @prolista =  @{$refcirc->{cualesEC}->{$nodo}};
      @prolista = grep(/^C/,@prolista);
      $refcualesC->{$nodo} = [@prolista];
  };

  foreach my $nodo (keys %{$refcualesC}) {
      my @prolista =  @{$refcualesC->{$nodo}};
      my @listaCno = grep (do{/^C/
                             and not defined $refcirc->{INICIALES}->{"V$_"}}
                         , @prolista);
      next unless @listaCno;
      my @listaCsi = grep (do{/^C/ 
                             and defined $refcirc->{INICIALES}->{"V$_"}}
                         , @prolista);
      my $valor = $refcirc->{INICIALES}->{"V$listaCsi[0]"};
      foreach my $iden (@listaCno) {
          cargar_datos($refcirc,'INICIALES',"V$iden", $valor, 'n','',0
                     ,__LINE__.' Term int.keys_ini');
          push @{$refcirc->{listaINICIALES}}, "V$iden";
      };
      foreach my $iden (@listaCsi) {
          $hashesiniciales{$nodo}->{$refcirc->{INICIALES}->{"V$iden"}}++;
      };
  };
  my @listakeys = keys %$refini;
  #impr_debug(__LINE__.' Term @listakeys',Dumper $refini);
  for(my $i = 0; $i < @listakeys; $i++) {
      my $key = $listakeys[$i];
      $key =~ s/^INICIAL//;
      next if $tiprefini->{$key} =~ /^;/; 
      if ($key =~  /^V([RLCJ].+)/ or $key =~ /^I([RLCE].+)/) {
          defined $refcirc->{cualobjele}->{$1}
	  or do{avgrav("$key ha recibido valor inicial, pero $1 no existe");
              $refini->{$key}.= "; $1 no existe"; next
          };
      } elsif ($key =~ /^P/) {
          defined $refcirc->{PARAMETROS}->{"D$key"} 
	  or do{avgrav("$key no es un parámetro a integrar; no aparece D$key;
	      no necesita valor inicial"); 
              $refini->{$key} .= "; $key no es un integrable"; 
              next;
	  };   
      } elsif ($key =~ /^V(E.*)/ or $key =~ /^I(J.*)/ 
               or  $key =~ /^(E.*)/ or $key =~ /^(J.+)/) {
          avgrav("La fuente $1 no necesita un valor inicial; es el mismo para
             " . join '  ',$refcirc->{INIorig}->{$key}); 
          $refini->{$key} .= '; no tiene sentido'; 
          next;
      } else {
          avgrav("No se entiende dar valor inicial para $key");
          $refini->{$key} .= '; no se entiende'; next;
      }; 
  };
  my @nodosparainiciales = grep( scalar @{$refcualesC->{$_}}, 
                                   keys %{$refcualesC});
  my @nodossinvalor =  grep(do{scalar keys %{$hashesiniciales{$_}} == 0},
                            @nodosparainiciales);
  my @repes = grep(do{scalar keys %{$hashesiniciales{$_}} > 1},
                   @nodosparainiciales);
  @repes and do{
      avgrav("Hay valores iniciales distintos que debieran ser iguales");
     map (mensajear("      V" . join (' V',@{$refcualesC->{$_}}) 
	          .': ' . join (' ',keys %{$hashesiniciales{$_}})),
          @repes);
  };
   #impr_debug(__LINE__.' Term @nodossinvalor', "@nodossinvalor");   
  @nodossinvalor and do{
      my @acussininicial;
     map (push(@acussininicial, @{$refcualesC->{$_}}),@nodossinvalor);
      avgrav("Faltan valores iniciales para nodo(s): "
           . join (' ', @nodossinvalor));   
     map (do{$refini->{"V$_"} = 'no definido';
	    mensajear(descripcion_iden_ref($_,$refcirc) 
		  . ":  V$_"),"\n"
	         },
          @acussininicial);		 
  };
  if ($avisosgrav) {
      my $texto = impr_hash('',%INICIALESORI,13); # 13 espacios; y no escribe
      mensajear(
      "Errores, incompatibilidades o faltantes en los valores iniciales\n" .
           $texto);
  };
  comfin('finr interpretar_values_iniciales');
  return 0;    
}#interpretar_values_iniciales     
# ----------------------------------------------------------------------------
sub nodos_0conectados{
  comfin('comr nodos_0conectados', @_);
  my $refarch = $_[0];
  impr_debug(__LINE__.' Term cualidenuniuni'
	       ,Dumper $refarch->{cualidenuniuni}); 
  my @nodos = sort keys %{$refarch->{cualobjtextonodo}};
  impr_debug(__LINE__.' Term @nodos',\@nodos);
  my @enganches = keys %{$refarch->{cualidenuniuni}};
  impr_debug(__LINE__.' Term @enganches',\@enganches);
  my (%hash,%directo,%nodirecto,@pares,%aislado,%nodo_0conectado);
  my @enganchesdesde0 = grep (/^0\-(.+)$/,@enganches);
  foreach my $enganche (@enganchesdesde0) {
      $enganche =~ /^0\-(.+)$/; my $nodo = $1;
      $nodo_0conectado{$nodo} = 1;
      my $priele = $refarch->{cualidenuniuni}->{$enganche}->[0];
      if ($priele =~ /^E/) {
          $directo{$nodo} = $priele;
      };
  }    
  my @engancheshasta0 = grep (/^(.+)\-0$/,@enganches);
  foreach my $enganche (@engancheshasta0) {
      $enganche =~ /^(.+)\-0$/; my $nodo = $1;
      next if $directo{$nodo};
      $nodo_0conectado{$nodo} = 1;
      my $priele = $refarch->{cualidenuniuni}->{$enganche}->[-1];
      if ($priele !~ /^E/) {
          $directo{$nodo} = "V$priele";
      };
  };
  my $cambio = 1;
  while ($cambio) {
      $cambio = '';    
      foreach my $enganche (@enganches) {
          next if $enganche !~ /\-/;
          my @listanodos = split '-',$enganche;
          my ($nodo0,$nodo1) = @listanodos;
          if ($nodo_0conectado{$nodo0}) {
              $nodo_0conectado{$nodo1} = 1;$cambio = 1;$enganche = undef;
          } elsif ($nodo_0conectado{$nodo1}) {
              $nodo_0conectado{$nodo0} = 1; $cambio = 1; $enganche = undef
          };
      };
      @enganches = grep($_,@enganches);
  };
  impr_debug(__LINE__.' Term %nodo_0conectado',Dumper \%nodo_0conectado);
  my @enganchessin0 = grep(do {/^(.+)\-(.+)$/ and $1 ne '0' and $2 ne '0'}
			   , @enganches);
  my @nodossin0 = grep (do{$_ ne '0'},@nodos);
  foreach my $nodo (@nodossin0) {
      next if $directo{$nodo};
      if (not $nodo_0conectado{$nodo}) {
          $aislado{$nodo} = 1;
      };
  };
  impr_debug(__LINE__.' Term %directo',Dumper \%directo);
  impr_debug(__LINE__.' Term %nodirecto',Dumper \%nodirecto);
  impr_debug(__LINE__.' Term %aislado',Dumper \%aislado);
  map (do{$directo{$_} or $aislado{$_} or $nodirecto{$_} = 1}
    ,@nodossin0);
  $refarch->{cero_conectado}->{directo} = \%directo;
  $refarch->{cero_conectado}->{nodirecto} = \%nodirecto;
  $refarch->{cero_conectado}->{aislado} = \%aislado;
  impr_debug(__LINE__.' Term $refarch->{cero_conectado}'
    ,Dumper $refarch->{cero_conectado});
  comfin('finr nodos_0conectados');
  return;
}#nodos_0conectados
# ----------------------------------------------------------------------------
sub normalizar_abreviaturas{
  #normaliza abreviaturas relacionadas con TEMP, FLUJO ...
  comfin('comr normalizar_abreviaturas', @_);
  my ($listaque, $ref) = @_; 
  my ($hashpalabras,$equivpalabra) = 
      ($ref->{'hashpalabras'},$ref->{'equivpalabra'});
  my @lista = keys %{$ref->{equivpalabra}};
  #impr_debug(__LINE__.' Term equivalencias',\@lista);
  #Hay que detectar primero los pedidos equivalentes a V(xx-yy)
  foreach my $que (@$listaque) {
      my $refque = $ref->{$que};
      my $VAR1;
      my $total = Dumper $refque;
      #impr_debug(__LINE__.' Term $total '. $que,$total);
      foreach my $pal1 (keys %$hashpalabras) {
          next if $pal1 eq ''; #de otro modo puede haber loop infinito
          while 
           ($total=~ s/(\W)$pal1\((\w+\-\w+)\)(\W)/$1$pal1&\($2\)$3/) {
              my @octeto = buscar_abreviaturas($ref,$pal1,$2,'normal');
              impr_debug(__LINE__.' Term $octeto[0]',$octeto[0]);
              $octeto[0] ne 'a' and next;
              my ($tipo, $plantilla, $cosa, $cont0, $palequiv,$pala
                         ,$propio, $cont00)  = @octeto;
              my $sust = "V$cosa"; $sust =~ s/^VE/E/;
              $total =~ s/(\W)$pal1&\((\w+\-\w+)\)(\W)/$1$sust$3/;
	  };
          $total =~ s/&//g;         
      };
      #impr_debug(__LINE__.' Term $total '. $que,$total);
      $refque = eval($total);
      #impr_datos(__LINE__.' Term', [$que], $ref);
      foreach my $key (keys %{$ref->{$que}}) {
          next if lc($ref->{"TIP$que"}->{$key}) =~ /[;pne]/;
          #impr_dat_que($key,$que,__LINE__.' Term normalizar_ab',$ref,'na');
          #las expresiones son las partes de lista 
          #que aparecen en DATOS; o  valores para PARAMETROS, INICIALES ...
          #la expresion comenzara y terminara con ';'; 
          #solos o junto a otro separadores
          my $expresionori = $refque->{$key};
          if ($que eq 'temp') {
             if ($expresionori =~ /^TEMP/) {
                 my $valor = $ref->{TEMP}->{$key}; 
                 my $tipoval = $ref->{TIPTEMP}->{$key};
                 while (defined $ref->{TEMP}->{$valor}
                        and $valor ne $ref->{TEMP}->{$valor}) {
                     $tipoval =  $ref->{TIPTEMP}->{$valor};
                     $valor = $ref->{TEMP}->{$valor}; 
                     #impr_debug(__LINE__.' Term ',[$key,$valor,$tipoval]); 
                 };
                 $ref->{temp}->{$key} = $valor;
                 $ref->{TIPtemp}->{$key} = $tipoval; 
                 #impr_dat_que($key,'temp',__LINE__.' Termq normalizar_ab'
                 #            ,$ref,'nac');  
	      };
	     next;
	  };
          my $tipo = $ref->{"TIP$que"}->{$key};
          my $xfun; $tipo eq 'x' and do{
             $expresionori =~ s/^(X\w+)\((.+)\)$/$2/;
             $xfun = $1;               
          }; 
          my $expresion = ';' . $expresionori .';';      
          my @listamezcla = $expresion =~ /([\w\.]+)/g; #lista de palabras 
          my @listasepa = split /[\w\.]+/, $expresion; #lista de separadores
          if (@listamezcla + 1 != @listasepa)  {
              error_progr($ref,"No se esperaba una expresión así
                $expresion 
              ". __LINE__.' Term'); 
	  }; 
	  my $expresionnueva = $listasepa[0]; my $cambio ='';
          for(my $i = 0; $i < @listamezcla; $i++) {
              my $pal1 = uc($listamezcla[$i]); my $sepa = $listasepa[$i+1];
              my $sepamenos = $listasepa[$i];
              my $deltai= 0; my $sepa1;
              if ($pal1 !~ /^\w/ or $pal1 =~ /^\d/) {
              } else {
                  my $cont = ''; 
                  my $pal2 = uc($listamezcla[$i+1]); 
                  $sepa1 = $listasepa[$i+2];
                  if(defined $pal2 
	              and $sepa =~ /^\s*\(\s*$/ and $sepa1 =~ s/^\s*\)//)  {
	              $cont = $pal2; $deltai = 1;
                  } else { 
                      $pal2 = ''
                  };
                  my @octeto = buscar_abreviaturas($ref,$pal1,$pal2,'normal');
                      #norm._abrev
                  if (@octeto == 0 or $octeto[0] eq 'e') {
                      $deltai = 0;
                  } else {
                      $cambio = 1;  
                      my ($tipo, $plantilla, $cosa, $cont0, $palequiv,$pala
                         ,$propio, $cont00)  = @octeto;
                         if ($tipo eq 'a') {
                           if ($cosa =~ /^E/ and $palequiv eq 'V' 
                                or $cosa =~ /^J/ and $palequiv eq 'I') { 
	        		   $pal1 = $cosa;
                           } else { 
                               $palequiv =~ /[VI]/   
                                    and $pal1 = "$palequiv$cosa";
                          };
                      } elsif ($palequiv eq 'V' and $tipo eq 'm') {# 'm',  nodo
                               # n por nodo
                          my  $ped = $ref->{temp}->{$cosa};
                          my $tipped = $ref->{TIPtemp}->{$cosa};
                          #if ($tipped !~ /[anp]/ and $sepamenos =~ /\($/) {
                          #    $ped = $ref->{TEMP}->{$cosa};
                          #    $tipped = $ref->{TIPTEMP}->{$cosa};
                          #};
			  #impr_debug(__LINE__
                          #    . ' Term $key $ped $sepamenos $sepa $sepa1'
                          #    , [$key,$ped,$sepamenos,$sepa,$sepa1]);
                          if (defined $tipped and $tipped eq 'n' 
                                   #n  por numerico
                                and $ped < 0) {
                              $expresionnueva =~ s/(.)$//; my $pre = $1;
                           ($pre, $ped) 
                                = simpl_expre_negnum($pre,$ped);
                             $expresionnueva .= "$pre"; 
                          };                     
                          defined $ped or $ped = $ref->{TEMP}->{$cosa};
                          if (defined $ped) {
                              $pal1 = $ped 
		          } else {
	                      $pal1 = cerofuentear($ref, $cosa);
		          };
                     }; 
                  };
                  if ($pal1 =~ /^[EJ]/ and defined $ref->{DATOS}->{$pal1}){
		      my $tipopal1 = $ref->{TIPDATOS}->{$pal1};
                      my $valorpal1 = $ref->{DATOS}->{$pal1};
                      if ($tipopal1 eq 'n' and $valorpal1 < 0) {
			   $pal1 = $valorpal1;
                           $expresionnueva =~ s/(.)$//; my $pre = $1;
                           ($pre, $pal1) 
                              = simpl_expre_negnum($pre,$pal1);
                           $expresionnueva .= "$pre";        
		      };
                  }
              }; # if  $pal1 else
              if ($deltai) {
                  $expresionnueva .= "$pal1$sepa1";
                  $i ++;
              } else {
                  $expresionnueva .= "$pal1$sepa";
              };  
         }; #for $i
         next unless $cambio;
	 $expresionnueva eq ";$expresionori;" and next;
	 impr_debug(__LINE__.' Term $cambio,$expresionnueva'
                  ,[$cambio,$expresionnueva]);
         $expresionnueva =~ s/^\;(.+)\;$/$1/;
         my ($tipon, $argus, $func, $listatiparg, $nvalor, $reflistaargus) 
             = Tablasfuncq::tipear($expresionnueva,1);
	 $tipon eq 'x' and defined $xfun and $xfun ne $func and do{
             $nvalor =~ s/^$func\(/$xfun\(/;
         };    
         cargar_datos($ref,$que,$key,$nvalor,$tipon,$listatiparg
                        , $reflistaargus, __LINE__.' Term normalizar_ab'); 
     }; #for $key
  }; #for $que
  my $lisque; @$lisque = (@$listaque,'TEMP');  
  comfin('finr normalizar_abreviaturas',$lisque,$ref);
  return '';
}#normalizar_abreviaturas 
# ----------------------------------------------------------------------------
sub registrar_equivalencias{
  comfin('comr registrar_equivalencias', @_);
  my ($ref) = $_[0];
  # impr_debug(__LINE__.' Term $ref->{DEFIabrev}', Dumper $ref->{DEFIabrev});
  # impr_debug(__LINE__.' Term $ref->{DEFIequiv}', Dumper $ref->{DEFIequiv});
  my ($hashpalabras, $equivpalabra, $plantipalabra);
  foreach my $plantilla (5 .. @$nombreplantilla -1) {
      my $nomplantilla = $nombreplantilla->[$plantilla];
      # impr_debug(__LINE__.' Term $ref->{DEFIabrev} $plantilla'
      #   , Dumper $ref->{DEFIabrev}->{$plantilla});
      # impr_debug(__LINE__.' Term $ref->{DEFIequiv} $nomplantilla'
      #   , Dumper $ref->{DEFIequiv}->{$nomplantilla});
      $plantipalabra->{V}->{$plantilla} = 1;
      $plantipalabra->{I}->{$plantilla} = 1;
      $plantipalabra->{''}->{$plantilla} = 1;
      $hashpalabras->{V} = $hashpalabras->{I} = $hashpalabras->{''} = 1;
      $equivpalabra->{V}='V'; $equivpalabra->{I}='I';$equivpalabra->{''} ='';
      foreach my $key (keys %{$ref->{DEFIabrev}->{$plantilla}}) {
          my $abr = $ref->{DEFIabrev}->{$plantilla}->{$key};
	  $hashpalabras->{$abr} = 1;
          my $nuevo = $ref->{DEFIequiv}->{$nomplantilla}->{$abr};
          my $viejo = $equivpalabra->{$abr};
          if (defined $viejo and $viejo ne $nuevo) {
                 parar1(66,$ref,"Ambigüedad proveniente de cuadros UNIDADES
                      equivalencias para $abr: $viejo $nuevo");
          };
          $equivpalabra->{$abr} = $nuevo;
          $plantipalabra->{$abr}->{$plantilla} = 1; 
      };
  }; 
  %{$ref->{hashpalabras}} = %{$hashpalabras}; 
  %{$ref->{equivpalabra}} = %{$equivpalabra};
  %{$ref->{plantipalabra}} = %{$plantipalabra};
  comfin('finr registrar_equivalencias', $ref, keys %$equivpalabra);
  return '';
}#registrar_equivalencias
# ---------------------------------------------------------------------------
sub temperaturos{ #elementos con una sola conexion (la otra a 0) 
  #tienen temperatura de ella
  #se tiene temp en los nodos y temp de esos elementos con un solo nodo
  #ya se habrá controlado que no hay fuentes de tension en paralelo
  comfin('comr temperaturos',@_);
  my $refcirc = $_[0];
  my @nodos0conectados = nodos_0conectados($refcirc);
  foreach my $nodo (@nodos0conectados) {
      $refcirc->{TIPOTOK}->{"VNODOCIRC$nodo"} = 's';
  };
  impr_debug(__LINE__.' Term @nodosconectados',\@nodos0conectados);
  my $uni = $refcirc->{uniuni};
  impr_datos(__LINE__.' Term',['TODOS'],$refcirc);
  impr_debug(__LINE__.' Term', Dumper $uni);
  (defined $uni and scalar keys %$uni) or
     parar1(220,$refcirc,' No hay nodos utilizados');
  cargar_datos_tipotok(
    $refcirc,'TEMP',"VNODOCIRC0",'s',0,'n','n',[0],__LINE__.'Term');
  my @listadedos = grep(do{($uni->{$_} =~ tr/-//) == 1}
                       , keys  %{$refcirc->{cualobjele}});
  impr_debug(__LINE__.' Term @listadedos',\@listadedos);
  impr_debug(__LINE__.' Term TIPOTOK',$refcirc->{TIPOTOK});
  my @uniones2nodos;
  foreach my $iden (@listadedos) {
      my $union = $uni->{$iden};
      if ($union =~ /^(.+)\-(.+)$/){
          $1 lt $2 or $union = "$2-$1";
      };
      my $numplant = $plantillalista->[$refcirc->{cualobjele}->{$iden}->[0]];
      $refcirc->{hayparanodonumplant}->{$1}->{$numplant} = 1;
      $refcirc->{hayparanodonumplant}->{$2}->{$numplant} = 1;
      push @uniones2nodos, $union; 
  };
  impr_debug(__LINE__.' Term hayparanodonumplant'
          ,Dumper $refcirc->{hayparanodonumplant});
  @uniones2nodos = union_conjunto(@uniones2nodos);
  impr_debug(__LINE__.' Term @uniones2nodos',\@uniones2nodos);
  my @listaECs = grep(/^[CE]/,@listadedos);
  foreach my $nodonodo (@uniones2nodos) {
      (my $odonodon = $nodonodo) =~ s/^(\w+)\-(\w+)$/$2-$1/;
      my (@eles,@Celes,@Eeles); 
      foreach my $ele (@listadedos) {
          next if $ele !~ /^[CE]/;
          if ($uni->{$ele} eq $nodonodo or $uni->{$ele} eq $odonodon) {
              push @eles, $ele;
          };
      };
      @Eeles = grep(/^E/,@eles); @Celes = grep (/^C/,@eles);
      impr_debug(__LINE__.' Term $nodonodo,@Eeles'
         ,\@Eeles);
      impr_debug(__LINE__.' Term $nodonodo,@Celes'
         ,\@Celes);
       
      if (@Eeles >1) {
          parar1(66,$refcirc,"No puede haber elementos E en paralelo, como 
              @Eeles    entre nodos $nodonodo");
       } elsif (@Eeles == 1 and @Celes >0) {
          parar1(66,$refcirc,
         "Sceptre no acepta elemento E en paralelo con elementos C; 
                 $Eeles[0]   @Celes   entre nodos  $nodonodo"); 
       };
};
  my @listadesde0E = grep(do{$uni->{$_} =~ /^0\-\w+$/ and /^E/}
                         ,@listadedos);
  my @listanoE = sort grep(do{$uni->{$_} =~ /^\w+\-0$/ 
                              and $_ !~ /^E/}, @listadedos);
  my @listanodesde0E = grep(do{$uni->{$_} !~ /^0\-\w+$/ and /^E/}
                           , @listadedos); 
  impr_debug(__LINE__.' Term TEMP. @listadesde0E', \@listadesde0E); 
  impr_debug(__LINE__.' Term TEMP. @listadedos', \@listadedos); 
  foreach my $iden (@listadesde0E) {
      # no debe haber fuentes E en paralelo;
      # ni condensadores en paralelo con fuente
      (my $nodo = my $dosnodos = $uni->{$iden}) =~ s/^0\-(\w+)$/$1/;
      my $refarg = [sort grep (do {$uni->{$_} eq "$nodo-0"},keys %$uni)];
      impr_debug(__LINE__.' Term $iden,$refarg',[$iden,@$refarg]);
      cargar_datos_tipotok($refcirc,'TEMP',"VNODOCIRC$nodo",'s'
 #        , $iden, 'a','a',[$iden,@$refarg],__LINE__.' Term');
        , $iden, 'a','a',[$iden],__LINE__.' Term');
      (my $nodosdos = $dosnodos) =~ s/^(.+)\-(.+)$/$2\-$1/; 
      impr_debug(__LINE__.' Term $nodo $dosnodos $nodosdos'
             , [$nodo,$dosnodos,$nodosdos]);
      copiar_datos($refcirc,"VNODOCIRC$nodo"
                   ,$refcirc,'TEMP',"VNODOCIRC$nodosdos"); 
      $refcirc->{TIPOTOK}->{"VNODOCIRC$nodosdos"} = 's'; 
  };
  impr_debug(__LINE__.' Term TEMP. @listanodesde0E',\@listanodesde0E);
  impr_debug(__LINE__.' Term temp. @listanoE',\@listanoE);
  foreach my $iden (sort @listanoE) {
      my $dosnodos = $uni->{$iden}; my $nodo; 
      $dosnodos =~ /^(\w+)\-0$/ and $nodo = $1;
      impr_debug(__LINE__.' Term $iden,$dosnodos',[$iden,$dosnodos]);
      if (not defined $refcirc->{VALOR}->{"VNODOCIRC$dosnodos"}) {
          my $refarg = [sort grep (do {$uni->{$_} eq "$nodo-0"},@listanoE)];
          $refarg->[0] = 'V' .$refarg->[0]; 
          cargar_datos_tipotok($refcirc,'TEMP',"VNODOCIRC$dosnodos",'s'
                       ,"V$iden",'s','s',$refarg,__LINE__.' Term'); 
      };
      if (defined $nodo) {
          copiar_datos($refcirc,"VNODOCIRC$dosnodos"
                   ,$refcirc,'TEMP',"VNODOCIRC$nodo");
          $refcirc->{TIPOTOK}->{"VNODOCIRC$nodo"} = 's';
      };
  }; 
  impr_datos(__LINE__.' Term',['TEMP'],$refcirc);
  impr_datos(__LINE__.' Term H',['TODOS'], $refcirc); 
  comfin('finr temperaturos');
  if ($avisosgrav) {
      parar1(220,$refcirc);
      return 220;
  };
  return '';   
}#temperaturos
# ---------------------------------------------------------------------------
sub temperaturas{ #elementos con una sola conexion tienen temperatura de ella
  # y parecido para conexiones 0-? o ?-0
  #se tiene temp en los nodos y temp de esos elementos con un solo nodo
  #ya se habrá controlado que no hay fuentes de tension en paralelo
  comfin('comr temperaturas',@_);
  my $refarch = $_[0]; my $coderr = '';
  impr_debug(__LINE__.' Term cualidenuniuni'
	       ,Dumper $refarch->{cualidenuniuni}); 
  my @textonodos = grep (do {$_ ne '0'},keys %{$refarch->{cualobjtextonodo}});
  impr_debug(__LINE__.' Term @nodos',\@textonodos);
  impr_objs(__LINE__.' Term elementos',$refarch,'^[CEJLRcejlr]$');
  impr_objs(__LINE__.' Term nodos',$refarch,'^[Nnt]$');
  my @uniunis = keys %{$refarch->{cualidenuniuni}};
  my @uniunis1 = grep (do { tr /-// == 0},@uniunis);
  foreach my $uni (@uniunis1) {
      if (defined $refarch->{cualidenuniuni}->{$uni}) {
          my @eles = sort @{$refarch->{cualidenuniuni}->{$uni}};
          for (my $i = 0; $i < @eles; $i ++) {  
              if ($eles[$i] =~ /^e/i) {
                  unshift @{$refarch->{uni2TEMP}->{$uni}},$eles[$i];
              } else {
                  push @{$refarch->{uni2TEMP}->{$uni}}, "V$eles[$i]";
	      };
	  };
      }; 
  };
  impr_debug(__LINE__.' Term $refarch',Dumper $refarch->{uni2TEMP});
  foreach my $nodo (@textonodos) {
      if (defined $refarch->{cualidenuniuni}->{'0-' . $nodo}) {
          my @eles = grep (do {$_ =~ /^E/}
                    , @{$refarch->{cualidenuniuni}->{'0-' . $nodo}});
          if (@eles) {
              unshift @{$refarch->{uni2TEMP}->{$nodo}},$eles[0];
          };
      };       
      if (defined $refarch->{cualidenuniuni}->{$nodo . '-0'}) {
          my @eles = grep ( do {$_ !~ /^E/}
                     ,@{$refarch->{cualidenuniuni}->{$nodo . '-0'}});
          if (@eles) {
              map ($_ = "V$_",@eles);
              push @{$refarch->{uni2TEMP}->{$nodo}},@eles;
          };
      };       
  };
  impr_debug(__LINE__.' Term $refarch',Dumper $refarch->{uni2TEMP});
  my @uniunis2 = grep (do { tr /-// == 1},@uniunis);
  impr_debug(__LINE__.' Term @uniunis2',\@uniunis2);    
  foreach my $uniuni (@uniunis2) {
      my @eles = @{$refarch->{cualidenuniuni}->{$uniuni}};
      foreach my $ele (@eles) {
          if ($ele =~ /^E/) {
              unshift @{$refarch->{uni2TEMP}->{$uniuni}}, $ele;
          } else {
              push @{$refarch->{uni2TEMP}->{$uniuni}},"V$ele";
          };
      };
  };
  impr_debug(__LINE__.' Term $refarch',Dumper $refarch->{uni2TEMP});
  return '';
} 
#----------------------------------------------------------------------------
sub tipear_cosa{
  # devuelve  lista con las características del pedido; 
  # $tipo, $plantilla,$eleparnodo,$i
  #con tipo E si hay anbiguedad
  #lista vacia si no encontro acuerdo 
  # 
  # y plantilla (0 cuando no corresponde)
  # comfin('comr tipear_cosa',@_);
  my ($ref,@listacont0) = @_; my @lista;
  #impr_debug(__LINE__.' Term @listacont0', Dumper \@listacont0);
  for(my $i = 0; $i < @listacont0; $i ++) {
      my $cont0  = $listacont0[$i];
      my $eleparnodo = uc($cont0); my ($tipo,$plantilla);
      $eleparnodo =~ s/^_//;
      # impr_debug(__LINE__.' Term  $eleparnodo', "'$eleparnodo'");
      # impr_debug(__LINE__.' Term NODOSPLANT', Dumper $ref->{NODOSPLANT});
      # impr_debug(__LINE__.' Term ELESPLANT', Dumper $ref->{ELESPLANT});   
      if (defined  $ref->{ELESPLANT}->{$eleparnodo} 
                 and $ref->{ELESPLANT}->{$eleparnodo}
            and $eleparnodo !~ /^T/) { #no corresponden modelos
          $tipo = 'a'; $plantilla = $ref->{ELESPLANT}->{$eleparnodo};
	  #impr_debug(__LINE__.' Term  $eleparnodo $plantilla'
          #           ,[$eleparnodo, $plantilla]);  
      } elsif ($eleparnodo eq 0) { #nodo tierra
          $tipo = 'm'; $plantilla = 0;
      } elsif (defined $ref->{NODOSPLANT}->{$eleparnodo}) {
          $tipo = 'm'; $plantilla =  $ref->{NODOSPLANT}->{$eleparnodo};
      } elsif (defined $ref->{PARAMETROS}->{$eleparnodo} or
                 defined $ref->{PARAMETROS}->{"D$eleparnodo"}) {
          $tipo = 'p'; $plantilla = 0; 
      } elsif ($eleparnodo eq 'TIME' or $eleparnodo eq 'TIEMPO') {
          $tipo = 't'; $plantilla = 0;
      } else {
          $tipo = 'e'; $plantilla = 0;
      };
      push @lista, [$tipo,$plantilla, $eleparnodo,$i];
  }; #foreach
  @lista = grep($_->[0] ne 'e',@lista);
  # comfin('finr tipear_cosa', @lista);
  # impr_debug(__LINE__.' Term @lista', Dumper \@lista);
  #Luego, solo se perdonará 'equivocarse' de abreviatura si no resultan ambig. 
  return \@lista;
}#tipear_cosa
1
 
