# Usado por SIMUSOL: simusol1.pl 
package Simusol::TraAbrev;
use Simusol::Ayudas;
use Simusol::GlobalesSimusol;
use strict;
use warnings;
use Data::Dumper;
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA = qw(Exporter);
     @EXPORT = qw(
             %locale
             %tra_a
             %tra_t
             %tra_t_a
             &preparar_nombres_cuadros
     );
} 
END();
our %tra_a = (
'ARC' => 'ARCHIVO ARCH = '
);


 
our %tra_t = (
  'REP' => 'REPETICIONES ='
  ,'ORD' => 'ORDEN DE FILAS ='
  ,'RAN' => 'RANGOX ='
  ,'FAC' =>  'FACTORES ='
  ,'LIS' => ' '
);
our %tra_t_a = (
  'REP,TABLA' => 'REPETICIONES TABLA ='
  ,'ORD,TABLA' => 'ORDEN DE FILAS TABLA ='
  ,'RAN,TABLA' => 'RANGOX TABLA ='
  ,'FAC,TABLA' => 'FACTORES TABLA ='
  ,'COL,TABLA' => 'COLUMNAS TABLA ='
  ,'ARC,TABLA' => 'ARCHIVO ='
);
sub preparar_nombres_cuadros{
  my @ident_cuadros = qw(
  AGREGAR_GRAFICOS ARCHIVOS
  CONTROLES COMENTARIOS DATOS DEFINICION FUNCIONES GRAFICOS
  INICIALES PARAMETROS RESULTADOS TABLA TABLAS_ARCHIVOS 
  TIEMPO UNIDADES USO USO_DEF MODELOS_ARCHIVOS
  ARCHIVOS_COMPLEMENTARIOS  DIAGRAMAS_COMPLEMENTARIOS
  ); 
  push @ident_cuadros,'';
  # keys: palabras completas en castellano, y/o en el idioma del lugar
  # values: palabras_clave para simusol
  # pares key value
  our %locale = qw(
     OUTPUTS RESULTADOS
     SALIDAS RESULTADOS
     TIME TIEMPO
     TIMES TIEMPO
     TIEMPOS TIEMPO
  ); 
  foreach (@ident_cuadros) {
     my $ori = $_;
     if ($ori =~ /^(.*)_(.*)$/) {
	 my $uno =$1; my $dos = $2; 
	 (my $unoc = $uno) =~ s/(ES|S)$//;
         (my $dosc = $dos) =~ s/(ES|S)$//;
         foreach my $nuevo("$unoc-$dos","$unoc $dos","$unoc-$dosc","$unoc $dosc"
            ,"$uno-$dosc","$uno $dosc","$uno-$dos","$uno $dos"
            ,$unoc."_$dos",$unoc."_$dosc",$uno."_$dosc") {
	     $nuevo ne $ori and $locale{$nuevo} = $ori;
         }
      } elsif ( s/(ES|S)$//) {
         $locale{$_} = $ori;
      } elsif (s/DEFINICION/DEF/) {
         $locale{$_} = $ori;
     }; 
  };        
  # print STDERR  __LINE__.' TraAbrev locale',Dumper \%locale;
  # a lo anterio se le pueden agregar otros pares:  key value
  # los values no pueden ser nuevos
}
 # ------------------------------------------------------------------------
 1
    
